﻿#ifndef LIBRETRO_CORE_OPTIONS_INTL_H__
#define LIBRETRO_CORE_OPTIONS_INTL_H__

#if defined(_MSC_VER) && (_MSC_VER >= 1500 && _MSC_VER < 1900)
/* https://support.microsoft.com/en-us/kb/980263 */
#pragma execution_character_set("utf-8")
#pragma warning(disable:4566)
#endif

#include <libretro.h>

/*
 ********************************
 * VERSION: 2.0
 ********************************
 *
 * - 2.0: Add support for core options v2 interface
 * - 1.3: Move translations to libretro_core_options_intl.h
 *        - libretro_core_options_intl.h includes BOM and utf-8
 *          fix for MSVC 2010-2013
 *        - Added HAVE_NO_LANGEXTRA flag to disable translations
 *          on platforms/compilers without BOM support
 * - 1.2: Use core options v1 interface when
 *        RETRO_ENVIRONMENT_GET_CORE_OPTIONS_VERSION is >= 1
 *        (previously required RETRO_ENVIRONMENT_GET_CORE_OPTIONS_VERSION == 1)
 * - 1.1: Support generation of core options v0 retro_core_option_value
 *        arrays containing options with a single value
 * - 1.0: First commit
*/

#ifdef __cplusplus
extern "C" {
#endif

/*
 ********************************
 * Core Option Definitions
 ********************************
*/
/* RETRO_LANGUAGE_AR */

#define CATEGORY_GB_LINK_LABEL_AR NULL
#define CATEGORY_GB_LINK_INFO_0_AR NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_AR "تلوين GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_AR NULL
#define OPTION_VAL_AUTO_AR "تلقائي"
#define OPTION_VAL_GBC_AR NULL
#define OPTION_VAL_SGB_AR NULL
#define OPTION_VAL_INTERNAL_AR "داخلي"
#define OPTION_VAL_CUSTOM_AR "مخصص"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_AR NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_AR NULL
#define OPTION_VAL_GB_DMG_AR NULL
#define OPTION_VAL_GB_POCKET_AR "GB - الجيب"
#define OPTION_VAL_GB_LIGHT_AR NULL
#define OPTION_VAL_GBC_BLUE_AR "GBC - أزرق"
#define OPTION_VAL_GBC_BROWN_AR "GBC - بني"
#define OPTION_VAL_GBC_DARK_BLUE_AR "GBC - أزرق غامق"
#define OPTION_VAL_GBC_DARK_BROWN_AR NULL
#define OPTION_VAL_GBC_DARK_GREEN_AR NULL
#define OPTION_VAL_GBC_GRAYSCALE_AR NULL
#define OPTION_VAL_GBC_GREEN_AR NULL
#define OPTION_VAL_GBC_INVERTED_AR NULL
#define OPTION_VAL_GBC_ORANGE_AR NULL
#define OPTION_VAL_GBC_PASTEL_MIX_AR NULL
#define OPTION_VAL_GBC_RED_AR NULL
#define OPTION_VAL_GBC_YELLOW_AR NULL
#define OPTION_VAL_SGB_1A_AR NULL
#define OPTION_VAL_SGB_1B_AR NULL
#define OPTION_VAL_SGB_1C_AR NULL
#define OPTION_VAL_SGB_1D_AR NULL
#define OPTION_VAL_SGB_1E_AR NULL
#define OPTION_VAL_SGB_1F_AR NULL
#define OPTION_VAL_SGB_1G_AR NULL
#define OPTION_VAL_SGB_1H_AR NULL
#define OPTION_VAL_SGB_2A_AR NULL
#define OPTION_VAL_SGB_2B_AR NULL
#define OPTION_VAL_SGB_2C_AR NULL
#define OPTION_VAL_SGB_2D_AR NULL
#define OPTION_VAL_SGB_2E_AR NULL
#define OPTION_VAL_SGB_2F_AR NULL
#define OPTION_VAL_SGB_2G_AR NULL
#define OPTION_VAL_SGB_2H_AR NULL
#define OPTION_VAL_SGB_3A_AR NULL
#define OPTION_VAL_SGB_3B_AR NULL
#define OPTION_VAL_SGB_3C_AR NULL
#define OPTION_VAL_SGB_3D_AR NULL
#define OPTION_VAL_SGB_3E_AR NULL
#define OPTION_VAL_SGB_3F_AR NULL
#define OPTION_VAL_SGB_3G_AR NULL
#define OPTION_VAL_SGB_3H_AR NULL
#define OPTION_VAL_SGB_4A_AR NULL
#define OPTION_VAL_SGB_4B_AR NULL
#define OPTION_VAL_SGB_4C_AR NULL
#define OPTION_VAL_SGB_4D_AR NULL
#define OPTION_VAL_SGB_4E_AR NULL
#define OPTION_VAL_SGB_4F_AR NULL
#define OPTION_VAL_SGB_4G_AR NULL
#define OPTION_VAL_SGB_4H_AR NULL
#define OPTION_VAL_SPECIAL_1_AR NULL
#define OPTION_VAL_SPECIAL_2_AR NULL
#define OPTION_VAL_SPECIAL_3_AR NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_AR NULL
#define OPTION_VAL_TWB64_PACK_1_AR NULL
#define OPTION_VAL_TWB64_PACK_2_AR NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_AR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_AR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_AR NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_AR NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_AR NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_AR NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_AR NULL
#define OPTION_VAL_TWB64_005_NEON_RED_AR NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_AR NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_AR NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_AR NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_AR NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_AR NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_AR NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_AR NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_AR NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_AR NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_AR NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_AR NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_AR NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_AR NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_AR NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_AR NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_AR NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_AR NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_AR NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_AR NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_AR NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_AR NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_AR NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_AR NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_AR NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_AR NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_AR NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_AR NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_AR NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_AR NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_AR NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_AR NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_AR NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_AR NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_AR NULL
#define OPTION_VAL_TWB64_040_DMG_VER_AR NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_AR NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_AR NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_AR NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_AR NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_AR NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_AR NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_AR NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_AR NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_AR NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_AR NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_AR NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_AR NULL
#define OPTION_VAL_TWB64_053_VMU_VER_AR NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_AR NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_AR NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_AR NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_AR NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_AR NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_AR NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_AR NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_AR NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_AR NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_AR NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_AR NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_AR NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_AR NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_AR NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_AR NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_AR NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_AR NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_AR NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_AR NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_AR NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_AR NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_AR NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_AR NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_AR NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_AR NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_AR NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_AR NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_AR NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_AR NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_AR NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_AR NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_AR NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_AR NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_AR NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_AR NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_AR NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_AR NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_AR NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_AR NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_AR NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_AR NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_AR NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_AR NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_AR NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_AR NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_AR NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_AR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_AR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_AR NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_AR NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_AR NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_AR NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_AR NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_AR NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_AR NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_AR NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_AR NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_AR NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_AR NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_AR NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_AR NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_AR NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_AR NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_AR NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_AR NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_AR NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_AR NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_AR NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_AR NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_AR NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_AR NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_AR NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_AR NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_AR NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_AR NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_AR NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_AR NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_AR NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_AR NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_AR NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_AR NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_AR NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_AR NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_AR NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_AR NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_AR NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_AR NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_AR NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_AR NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_AR NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_AR NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_AR NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_AR NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_AR NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_AR NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_AR NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_AR NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_AR NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_AR NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_AR NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_AR NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_AR NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_AR NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_AR NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_AR NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_AR NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_AR NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_AR NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_AR NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_AR NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_AR NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_AR NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_AR NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_AR NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_AR NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_AR NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_AR NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_AR NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_AR NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_AR NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_AR NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_AR NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_AR NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_AR NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_AR NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_AR NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_AR NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_AR NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_AR NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_AR NULL
#define OPTION_VAL_TWB64_182_PINK109_AR NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_AR NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_AR NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_AR NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_AR NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_AR NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_AR NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_AR NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_AR NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_AR NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_AR NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_AR NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_AR NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_AR NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_AR NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_AR NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_AR NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_AR NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_AR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_AR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_AR NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_AR NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_AR NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_AR NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_AR NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_AR NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_AR NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_AR NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_AR NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_AR NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_AR NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_AR NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_AR NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_AR NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_AR NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_AR NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_AR NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_AR NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__AR NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_AR NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_AR NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_AR NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_AR NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_AR NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_AR NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_AR NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_AR NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_AR NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_AR NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_AR NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_AR NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_AR NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_AR NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_AR NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_AR NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_AR NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_AR NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_AR NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_AR NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_AR NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_AR NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_AR NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_AR NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_AR NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_AR NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_AR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_AR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_AR NULL
#define OPTION_VAL_GBC_ONLY_AR NULL
#define OPTION_VAL_ALWAYS_AR "دائما"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_AR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_AR NULL
#define OPTION_VAL_ACCURATE_AR NULL
#define OPTION_VAL_FAST_AR "سريع"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_AR NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_AR NULL
#define OPTION_VAL_CENTRAL_AR NULL
#define OPTION_VAL_ABOVE_SCREEN_AR NULL
#define OPTION_VAL_BELOW_SCREEN_AR NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_AR NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_AR NULL
#define GAMBATTE_MIX_FRAMES_LABEL_AR NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_AR NULL
#define OPTION_VAL_MIX_AR NULL
#define OPTION_VAL_LCD_GHOSTING_AR NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_AR NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_AR "إعادة تشغيل الصوت"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_AR NULL
#define OPTION_VAL_SINC_AR NULL
#define OPTION_VAL_CC_AR NULL
#define GAMBATTE_GB_HWMODE_LABEL_AR NULL
#define GAMBATTE_GB_HWMODE_INFO_0_AR NULL
#define OPTION_VAL_GB_AR NULL
#define OPTION_VAL_GBA_AR NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_AR NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_AR NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_AR NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_AR NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_AR NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_AR NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_AR NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_AR NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_AR NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_AR NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_AR NULL
#define OPTION_VAL_NOT_CONNECTED_AR NULL
#define OPTION_VAL_NETWORK_SERVER_AR NULL
#define OPTION_VAL_NETWORK_CLIENT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_AR "المنفذ"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_AR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_AR NULL

struct retro_core_option_v2_category option_cats_ar[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_AR,
      CATEGORY_GB_LINK_INFO_0_AR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ar[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_AR,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_AR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_AR },
         { "GBC",      OPTION_VAL_GBC_AR },
         { "SGB",      OPTION_VAL_SGB_AR },
         { "internal", OPTION_VAL_INTERNAL_AR },
         { "custom",   OPTION_VAL_CUSTOM_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_AR,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_AR,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_AR },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_AR },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_AR },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_AR },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_AR },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_AR },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_AR },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_AR },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_AR },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_AR },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_AR },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_AR },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_AR },
         { "GBC - Red",                OPTION_VAL_GBC_RED_AR },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_AR },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_AR },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_AR },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_AR },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_AR },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_AR },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_AR },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_AR },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_AR },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_AR },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_AR },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_AR },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_AR },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_AR },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_AR },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_AR },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_AR },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_AR },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_AR },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_AR },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_AR },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_AR },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_AR },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_AR },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_AR },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_AR },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_AR },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_AR },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_AR },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_AR },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_AR },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_AR },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_AR },
         { "Special 1",                OPTION_VAL_SPECIAL_1_AR },
         { "Special 2",                OPTION_VAL_SPECIAL_2_AR },
         { "Special 3",                OPTION_VAL_SPECIAL_3_AR },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_AR },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_AR },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_AR },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_AR },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_AR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_AR,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_AR },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_AR },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_AR },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_AR },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_AR },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_AR },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_AR },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_AR },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_AR },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_AR },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_AR },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_AR },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_AR },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_AR },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_AR },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_AR },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_AR },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_AR },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_AR },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_AR },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_AR },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_AR },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_AR },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_AR },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_AR },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_AR },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_AR },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_AR },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_AR },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_AR },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_AR },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_AR },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_AR },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_AR },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_AR },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_AR },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_AR },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_AR },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_AR },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_AR },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_AR },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_AR },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_AR },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_AR },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_AR },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_AR },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_AR },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_AR },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_AR },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_AR },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_AR },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_AR },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_AR },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_AR },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_AR },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_AR },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_AR },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_AR },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_AR },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_AR },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_AR },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_AR },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_AR },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_AR },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_AR },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_AR },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_AR },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_AR },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_AR },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_AR },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_AR },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_AR },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_AR },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_AR },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_AR },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_AR },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_AR },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_AR },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_AR },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_AR },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_AR },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_AR },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_AR },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_AR },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_AR },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_AR },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_AR },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_AR },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_AR },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_AR },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_AR },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_AR },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_AR },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_AR },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_AR },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_AR },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_AR },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_AR },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_AR },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_AR },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_AR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_AR,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_AR },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_AR },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_AR },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_AR },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_AR },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_AR },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_AR },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_AR },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_AR },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_AR },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_AR },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_AR },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_AR },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_AR },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_AR },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_AR },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_AR },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_AR },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_AR },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_AR },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_AR },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_AR },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_AR },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_AR },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_AR },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_AR },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_AR },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_AR },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_AR },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_AR },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_AR },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_AR },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_AR },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_AR },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_AR },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_AR },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_AR },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_AR },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_AR },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_AR },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_AR },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_AR },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_AR },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_AR },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_AR },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_AR },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_AR },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_AR },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_AR },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_AR },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_AR },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_AR },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_AR },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_AR },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_AR },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_AR },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_AR },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_AR },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_AR },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_AR },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_AR },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_AR },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_AR },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_AR },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_AR },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_AR },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_AR },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_AR },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_AR },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_AR },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_AR },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_AR },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_AR },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_AR },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_AR },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_AR },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_AR },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_AR },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_AR },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_AR },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_AR },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_AR },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_AR },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_AR },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_AR },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_AR },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_AR },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_AR },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_AR },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_AR },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_AR },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_AR },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_AR },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_AR },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_AR },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_AR },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_AR },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_AR },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_AR },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_AR },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_AR,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_AR,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_AR },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_AR },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_AR },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_AR },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_AR },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_AR },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_AR },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_AR },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_AR },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_AR },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_AR },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_AR },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_AR },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_AR },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_AR },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_AR },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_AR },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__AR },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_AR },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_AR },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_AR },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_AR },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_AR },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_AR },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_AR },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_AR },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_AR },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_AR },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_AR },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_AR },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_AR },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_AR },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_AR },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_AR },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_AR },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_AR },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_AR },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_AR },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_AR },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_AR },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_AR },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_AR },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_AR },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_AR },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_AR },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_AR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_AR,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_AR },
         { "always",   OPTION_VAL_ALWAYS_AR },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_AR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_AR,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_AR },
         { "fast",     OPTION_VAL_FAST_AR },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_AR,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_AR,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_AR },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_AR },
         { "below screen", OPTION_VAL_BELOW_SCREEN_AR },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_AR,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_AR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_AR,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_AR,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_AR },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_AR },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_AR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_AR,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_AR,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_AR },
         { "cc",   OPTION_VAL_CC_AR },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_AR,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_AR,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_AR },
         { "GB",   OPTION_VAL_GB_AR },
         { "GBC",  OPTION_VAL_GBC_AR },
         { "GBA",  OPTION_VAL_GBA_AR },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_AR,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_AR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_AR,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_AR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_AR,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_AR,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_AR,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_AR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_AR,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_AR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_AR,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_MODE_INFO_0_AR,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_AR },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_AR },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_AR },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_AR,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_AR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_AR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ar = {
   option_cats_ar,
   option_defs_ar
};

/* RETRO_LANGUAGE_AST */

#define CATEGORY_GB_LINK_LABEL_AST NULL
#define CATEGORY_GB_LINK_INFO_0_AST NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_AST NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_AST NULL
#define OPTION_VAL_AUTO_AST NULL
#define OPTION_VAL_GBC_AST NULL
#define OPTION_VAL_SGB_AST NULL
#define OPTION_VAL_INTERNAL_AST NULL
#define OPTION_VAL_CUSTOM_AST NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_AST "Paleta interna"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_AST NULL
#define OPTION_VAL_GB_DMG_AST NULL
#define OPTION_VAL_GB_POCKET_AST NULL
#define OPTION_VAL_GB_LIGHT_AST NULL
#define OPTION_VAL_GBC_BLUE_AST "GBC - Azul"
#define OPTION_VAL_GBC_BROWN_AST "GBC - Marrón"
#define OPTION_VAL_GBC_DARK_BLUE_AST "GBC - Azul escuro"
#define OPTION_VAL_GBC_DARK_BROWN_AST "GBC - Marrón escuro"
#define OPTION_VAL_GBC_DARK_GREEN_AST "GBC - Verde escuro"
#define OPTION_VAL_GBC_GRAYSCALE_AST "GBC - Escala de buxos"
#define OPTION_VAL_GBC_GREEN_AST "GBC - Verde"
#define OPTION_VAL_GBC_INVERTED_AST NULL
#define OPTION_VAL_GBC_ORANGE_AST "GBC - Naranxa"
#define OPTION_VAL_GBC_PASTEL_MIX_AST NULL
#define OPTION_VAL_GBC_RED_AST "GBC - Coloráu"
#define OPTION_VAL_GBC_YELLOW_AST "GBC - Mariellu"
#define OPTION_VAL_SGB_1A_AST NULL
#define OPTION_VAL_SGB_1B_AST NULL
#define OPTION_VAL_SGB_1C_AST NULL
#define OPTION_VAL_SGB_1D_AST NULL
#define OPTION_VAL_SGB_1E_AST NULL
#define OPTION_VAL_SGB_1F_AST NULL
#define OPTION_VAL_SGB_1G_AST NULL
#define OPTION_VAL_SGB_1H_AST NULL
#define OPTION_VAL_SGB_2A_AST NULL
#define OPTION_VAL_SGB_2B_AST NULL
#define OPTION_VAL_SGB_2C_AST NULL
#define OPTION_VAL_SGB_2D_AST NULL
#define OPTION_VAL_SGB_2E_AST NULL
#define OPTION_VAL_SGB_2F_AST NULL
#define OPTION_VAL_SGB_2G_AST NULL
#define OPTION_VAL_SGB_2H_AST NULL
#define OPTION_VAL_SGB_3A_AST NULL
#define OPTION_VAL_SGB_3B_AST NULL
#define OPTION_VAL_SGB_3C_AST NULL
#define OPTION_VAL_SGB_3D_AST NULL
#define OPTION_VAL_SGB_3E_AST NULL
#define OPTION_VAL_SGB_3F_AST NULL
#define OPTION_VAL_SGB_3G_AST NULL
#define OPTION_VAL_SGB_3H_AST NULL
#define OPTION_VAL_SGB_4A_AST NULL
#define OPTION_VAL_SGB_4B_AST NULL
#define OPTION_VAL_SGB_4C_AST NULL
#define OPTION_VAL_SGB_4D_AST NULL
#define OPTION_VAL_SGB_4E_AST NULL
#define OPTION_VAL_SGB_4F_AST NULL
#define OPTION_VAL_SGB_4G_AST NULL
#define OPTION_VAL_SGB_4H_AST NULL
#define OPTION_VAL_SPECIAL_1_AST "Especial 1"
#define OPTION_VAL_SPECIAL_2_AST "Especial 2"
#define OPTION_VAL_SPECIAL_3_AST "Especial 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_AST NULL
#define OPTION_VAL_TWB64_PACK_1_AST "TWB64 - Paquete 1"
#define OPTION_VAL_TWB64_PACK_2_AST "TWB64 - Paquete 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_AST NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_AST NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_AST NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_AST NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_AST NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_AST NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_AST NULL
#define OPTION_VAL_TWB64_005_NEON_RED_AST "TWB64 005 - Coloráu neón"
#define OPTION_VAL_TWB64_006_NEON_BLUE_AST "TWB64 006 - Azul neón"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_AST "TWB64 007 - Mariellu neón"
#define OPTION_VAL_TWB64_008_NEON_GREEN_AST "TWB64 008 - Verde neón"
#define OPTION_VAL_TWB64_009_NEON_PINK_AST "TWB64 009 - Rosa neón"
#define OPTION_VAL_TWB64_010_MARIO_RED_AST NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_AST NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_AST NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_AST NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_AST NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_AST NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_AST NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_AST NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_AST NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_AST NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_AST NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_AST NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_AST NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_AST NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_AST NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_AST NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_AST NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_AST NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_AST NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_AST NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_AST NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_AST NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_AST NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_AST NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_AST NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_AST NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_AST NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_AST NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_AST NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_AST NULL
#define OPTION_VAL_TWB64_040_DMG_VER_AST NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_AST NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_AST NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_AST NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_AST NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_AST "TWB64 045 - Mariellu Pikachu"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_AST "TWB64 046 - Marrón Eevee"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_AST NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_AST NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_AST NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_AST NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_AST NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_AST NULL
#define OPTION_VAL_TWB64_053_VMU_VER_AST NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_AST NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_AST "TWB64 055 - Verde Android"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_AST NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_AST "TWB64 057 - Coloráu Google"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_AST "TWB64 058 - Azul Google"
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_AST "TWB64 059 - Mariellu Google"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_AST "TWB64 060 - Verde Google"
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_AST NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_AST NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_AST NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_AST "TWB64 064 - Coloráu Coca-Cola"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_AST NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_AST NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_AST NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_AST NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_AST NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_AST NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_AST NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_AST NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_AST NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_AST NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_AST NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_AST NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_AST NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_AST NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_AST NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_AST NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_AST NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_AST NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_AST NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_AST NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_AST NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_AST NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_AST NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_AST NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_AST NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_AST NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_AST NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_AST NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_AST NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_AST NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_AST NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_AST NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_AST NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_AST NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_AST NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_AST NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_AST NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_AST NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_AST "TWB64 101 - Rosa 765PRO"
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_AST "TWB64 102 - Azul CINDERELLA"
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_AST NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_AST "TWB64 104 - Verde SideM"
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_AST NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_AST NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_AST "TWB64 107 - Rosa Yo-kai"
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_AST "TWB64 108 - Verde Yo-kai"
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_AST "TWB64 109 - Azul Yo-kai"
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_AST "TWB64 110 - Moráu Yo-kai"
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_AST NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_AST NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_AST NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_AST NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_AST NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_AST NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_AST NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_AST NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_AST "TWB64 119 - Rosa AKB48"
#define OPTION_VAL_TWB64_120_MIKU_BLUE_AST "TWB64 120 - Azul Miku"
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_AST NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_AST NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_AST NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_AST NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_AST NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_AST NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_AST NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_AST NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_AST NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_AST NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_AST "TWB64 131 - Moráu neón"
#define OPTION_VAL_TWB64_132_NEON_ORANGE_AST "TWB64 132 - Naranxa neón"
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_AST NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_AST "TWB64 134 - Coloráu Tokíu"
#define OPTION_VAL_TWB64_135_PARIS_GOLD_AST NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_AST "TWB64 136 - Azul Beixín"
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_AST "TWB64 137 - Mariellu Pac-Man"
#define OPTION_VAL_TWB64_138_IRISH_GREEN_AST "TWB64 138 - Verde irlandés"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_AST NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_AST NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_AST NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_AST NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_AST NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_AST NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_AST NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_AST NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_AST NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_AST NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_AST NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_AST NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_AST NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_AST NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_AST NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_AST NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_AST NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_AST "TWB64 156 - Coloráu Pokédex"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_AST NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_AST "TWB64 158 - Verde Xbox"
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_AST NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_AST "TWB64 160 - Naranxa G4"
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_AST NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_AST NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_AST NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_AST NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_AST NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_AST NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_AST "TWB64 167 - Azul pitufo"
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_AST NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_AST NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_AST NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_AST NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_AST NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_AST NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_AST "TWB64 174 - Rosa Barbie"
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_AST NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_AST NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_AST NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_AST NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_AST NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_AST NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_AST NULL
#define OPTION_VAL_TWB64_182_PINK109_AST NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_AST "TWB64 183 - Azul Doraemon"
#define OPTION_VAL_TWB64_184_FURY_BLUE_AST NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_AST NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_AST NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_AST NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_AST "TWB64 188 - Coloráu Pizza Hut"
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_AST NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_AST NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_AST NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_AST "TWB64 192 - Azul SEGA Tokiu"
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_AST NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_AST NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_AST NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_AST "TWB64 196 - Moráu ecuestre"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_AST NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_AST NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_AST NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_AST NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_AST NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_AST NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_AST NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_AST NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_AST NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_AST NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_AST NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_AST NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_AST NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_AST NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_AST NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_AST NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_AST NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_AST NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_AST NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_AST NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_AST NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_AST NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_AST NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__AST NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_AST NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_AST NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_AST NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_AST NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_AST NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_AST NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_AST NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_AST NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_AST NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_AST NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_AST NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_AST NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_AST NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_AST NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_AST NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_AST NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_AST NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_AST NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_AST NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_AST NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_AST NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_AST NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_AST NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_AST NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_AST NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_AST NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_AST NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_AST NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_AST NULL
#define OPTION_VAL_GBC_ONLY_AST NULL
#define OPTION_VAL_ALWAYS_AST "Siempres"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_AST NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_AST NULL
#define OPTION_VAL_ACCURATE_AST NULL
#define OPTION_VAL_FAST_AST NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_AST NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_AST NULL
#define OPTION_VAL_CENTRAL_AST NULL
#define OPTION_VAL_ABOVE_SCREEN_AST NULL
#define OPTION_VAL_BELOW_SCREEN_AST NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_AST NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_AST NULL
#define GAMBATTE_MIX_FRAMES_LABEL_AST NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_AST NULL
#define OPTION_VAL_MIX_AST NULL
#define OPTION_VAL_LCD_GHOSTING_AST NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_AST NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_AST NULL
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_AST NULL
#define OPTION_VAL_SINC_AST NULL
#define OPTION_VAL_CC_AST NULL
#define GAMBATTE_GB_HWMODE_LABEL_AST NULL
#define GAMBATTE_GB_HWMODE_INFO_0_AST NULL
#define OPTION_VAL_GB_AST NULL
#define OPTION_VAL_GBA_AST NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_AST NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_AST "Activa la compatibilidá colos xestores d'arrinque de Game Boy y Game Boy Color xunto colos sos logos animaos del aniciu."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_AST "Permitir les direiciones opuestes"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_AST NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_AST NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_AST NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_AST "Fuercia del vibrador del mandu"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_AST NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_AST NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_AST NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_AST NULL
#define OPTION_VAL_NOT_CONNECTED_AST NULL
#define OPTION_VAL_NETWORK_SERVER_AST NULL
#define OPTION_VAL_NETWORK_CLIENT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_AST "Puertu"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_AST NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_AST NULL

struct retro_core_option_v2_category option_cats_ast[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_AST,
      CATEGORY_GB_LINK_INFO_0_AST
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ast[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_AST,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_AST,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_AST },
         { "GBC",      OPTION_VAL_GBC_AST },
         { "SGB",      OPTION_VAL_SGB_AST },
         { "internal", OPTION_VAL_INTERNAL_AST },
         { "custom",   OPTION_VAL_CUSTOM_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_AST,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_AST,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_AST },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_AST },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_AST },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_AST },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_AST },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_AST },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_AST },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_AST },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_AST },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_AST },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_AST },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_AST },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_AST },
         { "GBC - Red",                OPTION_VAL_GBC_RED_AST },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_AST },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_AST },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_AST },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_AST },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_AST },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_AST },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_AST },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_AST },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_AST },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_AST },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_AST },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_AST },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_AST },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_AST },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_AST },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_AST },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_AST },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_AST },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_AST },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_AST },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_AST },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_AST },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_AST },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_AST },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_AST },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_AST },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_AST },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_AST },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_AST },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_AST },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_AST },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_AST },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_AST },
         { "Special 1",                OPTION_VAL_SPECIAL_1_AST },
         { "Special 2",                OPTION_VAL_SPECIAL_2_AST },
         { "Special 3",                OPTION_VAL_SPECIAL_3_AST },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_AST },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_AST },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_AST },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_AST },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_AST,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_AST,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_AST },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_AST },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_AST },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_AST },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_AST },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_AST },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_AST },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_AST },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_AST },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_AST },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_AST },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_AST },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_AST },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_AST },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_AST },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_AST },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_AST },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_AST },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_AST },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_AST },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_AST },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_AST },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_AST },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_AST },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_AST },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_AST },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_AST },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_AST },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_AST },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_AST },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_AST },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_AST },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_AST },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_AST },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_AST },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_AST },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_AST },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_AST },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_AST },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_AST },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_AST },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_AST },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_AST },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_AST },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_AST },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_AST },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_AST },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_AST },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_AST },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_AST },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_AST },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_AST },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_AST },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_AST },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_AST },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_AST },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_AST },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_AST },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_AST },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_AST },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_AST },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_AST },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_AST },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_AST },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_AST },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_AST },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_AST },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_AST },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_AST },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_AST },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_AST },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_AST },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_AST },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_AST },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_AST },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_AST },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_AST },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_AST },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_AST },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_AST },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_AST },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_AST },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_AST },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_AST },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_AST },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_AST },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_AST },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_AST },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_AST },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_AST },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_AST },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_AST },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_AST },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_AST },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_AST },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_AST },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_AST },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_AST },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_AST },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_AST },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_AST,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_AST,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_AST },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_AST },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_AST },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_AST },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_AST },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_AST },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_AST },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_AST },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_AST },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_AST },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_AST },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_AST },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_AST },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_AST },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_AST },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_AST },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_AST },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_AST },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_AST },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_AST },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_AST },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_AST },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_AST },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_AST },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_AST },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_AST },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_AST },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_AST },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_AST },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_AST },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_AST },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_AST },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_AST },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_AST },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_AST },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_AST },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_AST },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_AST },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_AST },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_AST },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_AST },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_AST },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_AST },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_AST },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_AST },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_AST },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_AST },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_AST },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_AST },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_AST },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_AST },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_AST },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_AST },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_AST },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_AST },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_AST },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_AST },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_AST },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_AST },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_AST },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_AST },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_AST },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_AST },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_AST },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_AST },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_AST },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_AST },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_AST },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_AST },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_AST },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_AST },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_AST },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_AST },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_AST },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_AST },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_AST },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_AST },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_AST },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_AST },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_AST },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_AST },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_AST },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_AST },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_AST },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_AST },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_AST },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_AST },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_AST },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_AST },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_AST },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_AST },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_AST },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_AST },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_AST },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_AST },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_AST },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_AST },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_AST },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_AST },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_AST },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_AST,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_AST,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_AST },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_AST },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_AST },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_AST },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_AST },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_AST },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_AST },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_AST },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_AST },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_AST },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_AST },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_AST },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_AST },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_AST },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_AST },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_AST },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_AST },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__AST },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_AST },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_AST },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_AST },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_AST },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_AST },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_AST },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_AST },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_AST },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_AST },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_AST },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_AST },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_AST },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_AST },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_AST },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_AST },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_AST },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_AST },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_AST },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_AST },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_AST },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_AST },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_AST },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_AST },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_AST },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_AST },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_AST },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_AST },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_AST,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_AST,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_AST },
         { "always",   OPTION_VAL_ALWAYS_AST },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_AST,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_AST,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_AST },
         { "fast",     OPTION_VAL_FAST_AST },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_AST,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_AST,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_AST },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_AST },
         { "below screen", OPTION_VAL_BELOW_SCREEN_AST },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_AST,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_AST,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_AST,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_AST,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_AST },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_AST },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_AST },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_AST,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_AST,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_AST },
         { "cc",   OPTION_VAL_CC_AST },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_AST,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_AST,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_AST },
         { "GB",   OPTION_VAL_GB_AST },
         { "GBC",  OPTION_VAL_GBC_AST },
         { "GBA",  OPTION_VAL_GBA_AST },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_AST,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_AST,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_AST,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_AST,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_AST,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_AST,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_AST,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_AST,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_AST,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_AST,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_AST,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_MODE_INFO_0_AST,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_AST },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_AST },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_AST },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_AST,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_AST,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_AST,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ast = {
   option_cats_ast,
   option_defs_ast
};

/* RETRO_LANGUAGE_CA */

#define CATEGORY_GB_LINK_LABEL_CA NULL
#define CATEGORY_GB_LINK_INFO_0_CA NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_CA NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_CA NULL
#define OPTION_VAL_AUTO_CA "Automàtic"
#define OPTION_VAL_GBC_CA NULL
#define OPTION_VAL_SGB_CA NULL
#define OPTION_VAL_INTERNAL_CA NULL
#define OPTION_VAL_CUSTOM_CA "Personalitzat"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CA NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CA NULL
#define OPTION_VAL_GB_DMG_CA NULL
#define OPTION_VAL_GB_POCKET_CA NULL
#define OPTION_VAL_GB_LIGHT_CA NULL
#define OPTION_VAL_GBC_BLUE_CA NULL
#define OPTION_VAL_GBC_BROWN_CA NULL
#define OPTION_VAL_GBC_DARK_BLUE_CA NULL
#define OPTION_VAL_GBC_DARK_BROWN_CA NULL
#define OPTION_VAL_GBC_DARK_GREEN_CA NULL
#define OPTION_VAL_GBC_GRAYSCALE_CA NULL
#define OPTION_VAL_GBC_GREEN_CA NULL
#define OPTION_VAL_GBC_INVERTED_CA NULL
#define OPTION_VAL_GBC_ORANGE_CA NULL
#define OPTION_VAL_GBC_PASTEL_MIX_CA NULL
#define OPTION_VAL_GBC_RED_CA NULL
#define OPTION_VAL_GBC_YELLOW_CA NULL
#define OPTION_VAL_SGB_1A_CA NULL
#define OPTION_VAL_SGB_1B_CA NULL
#define OPTION_VAL_SGB_1C_CA NULL
#define OPTION_VAL_SGB_1D_CA NULL
#define OPTION_VAL_SGB_1E_CA NULL
#define OPTION_VAL_SGB_1F_CA NULL
#define OPTION_VAL_SGB_1G_CA NULL
#define OPTION_VAL_SGB_1H_CA NULL
#define OPTION_VAL_SGB_2A_CA NULL
#define OPTION_VAL_SGB_2B_CA NULL
#define OPTION_VAL_SGB_2C_CA NULL
#define OPTION_VAL_SGB_2D_CA NULL
#define OPTION_VAL_SGB_2E_CA NULL
#define OPTION_VAL_SGB_2F_CA NULL
#define OPTION_VAL_SGB_2G_CA NULL
#define OPTION_VAL_SGB_2H_CA NULL
#define OPTION_VAL_SGB_3A_CA NULL
#define OPTION_VAL_SGB_3B_CA NULL
#define OPTION_VAL_SGB_3C_CA NULL
#define OPTION_VAL_SGB_3D_CA NULL
#define OPTION_VAL_SGB_3E_CA NULL
#define OPTION_VAL_SGB_3F_CA NULL
#define OPTION_VAL_SGB_3G_CA NULL
#define OPTION_VAL_SGB_3H_CA NULL
#define OPTION_VAL_SGB_4A_CA NULL
#define OPTION_VAL_SGB_4B_CA NULL
#define OPTION_VAL_SGB_4C_CA NULL
#define OPTION_VAL_SGB_4D_CA NULL
#define OPTION_VAL_SGB_4E_CA NULL
#define OPTION_VAL_SGB_4F_CA NULL
#define OPTION_VAL_SGB_4G_CA NULL
#define OPTION_VAL_SGB_4H_CA NULL
#define OPTION_VAL_SPECIAL_1_CA NULL
#define OPTION_VAL_SPECIAL_2_CA NULL
#define OPTION_VAL_SPECIAL_3_CA NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CA NULL
#define OPTION_VAL_TWB64_PACK_1_CA NULL
#define OPTION_VAL_TWB64_PACK_2_CA NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_CA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CA NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_CA NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CA NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CA NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CA NULL
#define OPTION_VAL_TWB64_005_NEON_RED_CA NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_CA NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_CA NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_CA NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_CA NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_CA NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_CA NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CA NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_CA NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_CA NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CA NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CA NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CA NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CA NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_CA NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CA NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_CA NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_CA NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CA NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CA NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CA NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_CA NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CA NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_CA NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_CA NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CA NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_CA NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_CA NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CA NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_CA NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_CA NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CA NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CA NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CA NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_CA NULL
#define OPTION_VAL_TWB64_040_DMG_VER_CA NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_CA NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_CA NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CA NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_CA NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CA NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_CA NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_CA NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_CA NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_CA NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_CA NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CA NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CA NULL
#define OPTION_VAL_TWB64_053_VMU_VER_CA NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_CA NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_CA NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CA NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_CA NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_CA NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CA NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_CA NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_CA NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CA NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_CA NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_CA NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_CA NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CA NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_CA NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CA NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_CA NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_CA NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CA NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_CA NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CA NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CA NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CA NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_CA NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_CA NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_CA NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CA NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CA NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CA NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CA NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CA NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_CA NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CA NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CA NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_CA NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_CA NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CA NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CA NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_CA NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CA NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CA NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CA NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CA NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_CA NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CA NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CA NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CA NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_CA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CA NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_CA NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CA NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_CA NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_CA NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CA NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CA NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_CA NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_CA NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_CA NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CA NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_CA NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_CA NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_CA NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CA NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_CA NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CA NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_CA NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_CA NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_CA NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_CA NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CA NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CA NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_CA NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CA NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CA NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_CA NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_CA NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_CA NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_CA NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_CA NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_CA NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_CA NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CA NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_CA NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_CA NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_CA NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CA NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_CA NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CA NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CA NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CA NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CA NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CA NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CA NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CA NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CA NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_CA NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_CA NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CA NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CA NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CA NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CA NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_CA NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_CA NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CA NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_CA NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CA NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_CA NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CA NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_CA NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_CA NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_CA NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_CA NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CA NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_CA NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_CA NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_CA NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CA NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CA NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_CA NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_CA NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CA NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CA NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_CA NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CA NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_CA NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_CA NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_CA NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CA NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CA NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CA NULL
#define OPTION_VAL_TWB64_182_PINK109_CA NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_CA NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_CA NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CA NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CA NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_CA NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CA NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CA NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_CA NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_CA NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CA NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_CA NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CA NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_CA NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CA NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_CA NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CA NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_CA NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CA NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CA NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CA NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CA NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CA NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CA NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_CA NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CA NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CA NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_CA NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CA NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CA NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CA NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CA NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CA NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CA NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CA NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CA NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CA NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CA NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CA NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CA NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CA NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CA NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_CA NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CA NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_CA NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CA NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CA NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_CA NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CA NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CA NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CA NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CA NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CA NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_CA NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CA NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CA NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CA NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CA NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_CA NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CA NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_CA NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CA NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CA NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_CA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CA NULL
#define OPTION_VAL_GBC_ONLY_CA NULL
#define OPTION_VAL_ALWAYS_CA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CA NULL
#define OPTION_VAL_ACCURATE_CA NULL
#define OPTION_VAL_FAST_CA "Ràpida"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CA NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CA NULL
#define OPTION_VAL_CENTRAL_CA NULL
#define OPTION_VAL_ABOVE_SCREEN_CA NULL
#define OPTION_VAL_BELOW_SCREEN_CA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_CA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CA NULL
#define GAMBATTE_MIX_FRAMES_LABEL_CA NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_CA NULL
#define OPTION_VAL_MIX_CA NULL
#define OPTION_VAL_LCD_GHOSTING_CA NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_CA NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_CA "Remostreig d'àudio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_CA NULL
#define OPTION_VAL_SINC_CA NULL
#define OPTION_VAL_CC_CA NULL
#define GAMBATTE_GB_HWMODE_LABEL_CA NULL
#define GAMBATTE_GB_HWMODE_INFO_0_CA NULL
#define OPTION_VAL_GB_CA NULL
#define OPTION_VAL_GBA_CA NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_CA NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_CA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_CA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CA NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_CA NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_CA NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_CA NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_CA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_CA NULL
#define OPTION_VAL_NOT_CONNECTED_CA NULL
#define OPTION_VAL_NETWORK_SERVER_CA NULL
#define OPTION_VAL_NETWORK_CLIENT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CA NULL

struct retro_core_option_v2_category option_cats_ca[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_CA,
      CATEGORY_GB_LINK_INFO_0_CA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ca[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_CA,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_CA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_CA },
         { "GBC",      OPTION_VAL_GBC_CA },
         { "SGB",      OPTION_VAL_SGB_CA },
         { "internal", OPTION_VAL_INTERNAL_CA },
         { "custom",   OPTION_VAL_CUSTOM_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CA,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CA,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_CA },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_CA },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_CA },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_CA },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_CA },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_CA },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_CA },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_CA },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_CA },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_CA },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_CA },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_CA },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_CA },
         { "GBC - Red",                OPTION_VAL_GBC_RED_CA },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_CA },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_CA },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_CA },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_CA },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_CA },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_CA },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_CA },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_CA },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_CA },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_CA },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_CA },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_CA },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_CA },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_CA },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_CA },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_CA },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_CA },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_CA },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_CA },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_CA },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_CA },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_CA },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_CA },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_CA },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_CA },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_CA },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_CA },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_CA },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_CA },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_CA },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_CA },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_CA },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_CA },
         { "Special 1",                OPTION_VAL_SPECIAL_1_CA },
         { "Special 2",                OPTION_VAL_SPECIAL_2_CA },
         { "Special 3",                OPTION_VAL_SPECIAL_3_CA },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CA },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_CA },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_CA },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_CA },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CA,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_CA },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CA },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CA },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CA },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_CA },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_CA },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_CA },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_CA },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_CA },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_CA },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_CA },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CA },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_CA },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_CA },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CA },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CA },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CA },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CA },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_CA },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CA },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_CA },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_CA },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CA },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CA },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CA },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_CA },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CA },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_CA },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_CA },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CA },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_CA },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_CA },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CA },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_CA },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_CA },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CA },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CA },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CA },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_CA },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_CA },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_CA },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_CA },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CA },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_CA },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CA },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_CA },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_CA },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_CA },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_CA },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_CA },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CA },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CA },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_CA },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_CA },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_CA },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CA },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_CA },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_CA },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CA },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_CA },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_CA },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CA },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_CA },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_CA },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_CA },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CA },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_CA },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CA },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_CA },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_CA },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CA },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_CA },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CA },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CA },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CA },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_CA },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_CA },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_CA },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CA },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CA },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CA },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CA },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CA },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_CA },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CA },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CA },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_CA },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_CA },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CA },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CA },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_CA },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CA },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CA },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CA },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CA },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_CA },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CA },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CA },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CA },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_CA },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CA,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_CA },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CA },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_CA },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_CA },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CA },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CA },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_CA },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_CA },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_CA },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CA },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_CA },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_CA },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_CA },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CA },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_CA },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CA },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_CA },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_CA },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_CA },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_CA },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CA },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CA },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_CA },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CA },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CA },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_CA },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_CA },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_CA },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_CA },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_CA },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_CA },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_CA },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CA },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_CA },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_CA },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_CA },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CA },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_CA },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CA },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CA },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CA },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CA },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CA },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CA },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CA },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CA },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_CA },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_CA },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CA },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CA },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CA },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CA },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_CA },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_CA },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CA },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_CA },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CA },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_CA },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CA },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_CA },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_CA },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_CA },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_CA },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CA },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_CA },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_CA },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_CA },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CA },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CA },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_CA },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_CA },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CA },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CA },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_CA },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CA },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_CA },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_CA },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_CA },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CA },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CA },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CA },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_CA },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_CA },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_CA },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CA },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CA },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_CA },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CA },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CA },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_CA },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_CA },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CA },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_CA },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CA },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_CA },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CA },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_CA },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CA },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_CA },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CA },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CA,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CA,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CA },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CA },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CA },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CA },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CA },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_CA },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CA },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CA },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_CA },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CA },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CA },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CA },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CA },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CA },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CA },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CA },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CA },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CA },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CA },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CA },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CA },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CA },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CA },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_CA },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CA },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_CA },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CA },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CA },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_CA },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CA },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CA },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CA },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CA },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CA },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_CA },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CA },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CA },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CA },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CA },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_CA },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CA },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_CA },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CA },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CA },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_CA },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CA,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_CA },
         { "always",   OPTION_VAL_ALWAYS_CA },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CA,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_CA },
         { "fast",     OPTION_VAL_FAST_CA },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CA,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CA,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_CA },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_CA },
         { "below screen", OPTION_VAL_BELOW_SCREEN_CA },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_CA,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_CA,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_CA,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_CA },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_CA },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_CA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_CA,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_CA,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_CA },
         { "cc",   OPTION_VAL_CC_CA },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_CA,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_CA,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_CA },
         { "GB",   OPTION_VAL_GB_CA },
         { "GBC",  OPTION_VAL_GBC_CA },
         { "GBA",  OPTION_VAL_GBA_CA },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_CA,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_CA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_CA,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_CA,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_CA,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_CA,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_CA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CA,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_CA,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_MODE_INFO_0_CA,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_CA },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_CA },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_CA },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CA,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ca = {
   option_cats_ca,
   option_defs_ca
};

/* RETRO_LANGUAGE_CHS */

#define CATEGORY_GB_LINK_LABEL_CHS "游戏链接"
#define CATEGORY_GB_LINK_INFO_0_CHS "更改网络游戏链接 (多人)"
#define GAMBATTE_GB_COLORIZATION_LABEL_CHS "GB 调色"
#define GAMBATTE_GB_COLORIZATION_INFO_0_CHS NULL
#define OPTION_VAL_AUTO_CHS "自动"
#define OPTION_VAL_GBC_CHS NULL
#define OPTION_VAL_SGB_CHS NULL
#define OPTION_VAL_INTERNAL_CHS "内建"
#define OPTION_VAL_CUSTOM_CHS "自定义"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CHS "内部色板"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CHS "选择 'GB 色彩化' 时用于彩色游戏的调色板。'GB 色彩化' 设置为 '内部'， 或者当“GB 色彩化”设置为“自动”且游戏没有预定义的 SGB/GBC 调色板。 'GB'的调色板模拟GameBoy硬件的显示。'GBC' 色板与GameBoy颜色的内置预设相同。 'SGB'调色板与SuperGameBoy的内置预设相同。"
#define OPTION_VAL_GB_DMG_CHS NULL
#define OPTION_VAL_GB_POCKET_CHS NULL
#define OPTION_VAL_GB_LIGHT_CHS NULL
#define OPTION_VAL_GBC_BLUE_CHS NULL
#define OPTION_VAL_GBC_BROWN_CHS NULL
#define OPTION_VAL_GBC_DARK_BLUE_CHS NULL
#define OPTION_VAL_GBC_DARK_BROWN_CHS NULL
#define OPTION_VAL_GBC_DARK_GREEN_CHS NULL
#define OPTION_VAL_GBC_GRAYSCALE_CHS NULL
#define OPTION_VAL_GBC_GREEN_CHS NULL
#define OPTION_VAL_GBC_INVERTED_CHS NULL
#define OPTION_VAL_GBC_ORANGE_CHS NULL
#define OPTION_VAL_GBC_PASTEL_MIX_CHS NULL
#define OPTION_VAL_GBC_RED_CHS NULL
#define OPTION_VAL_GBC_YELLOW_CHS NULL
#define OPTION_VAL_SGB_1A_CHS NULL
#define OPTION_VAL_SGB_1B_CHS NULL
#define OPTION_VAL_SGB_1C_CHS NULL
#define OPTION_VAL_SGB_1D_CHS NULL
#define OPTION_VAL_SGB_1E_CHS NULL
#define OPTION_VAL_SGB_1F_CHS NULL
#define OPTION_VAL_SGB_1G_CHS NULL
#define OPTION_VAL_SGB_1H_CHS NULL
#define OPTION_VAL_SGB_2A_CHS NULL
#define OPTION_VAL_SGB_2B_CHS NULL
#define OPTION_VAL_SGB_2C_CHS NULL
#define OPTION_VAL_SGB_2D_CHS NULL
#define OPTION_VAL_SGB_2E_CHS NULL
#define OPTION_VAL_SGB_2F_CHS NULL
#define OPTION_VAL_SGB_2G_CHS NULL
#define OPTION_VAL_SGB_2H_CHS NULL
#define OPTION_VAL_SGB_3A_CHS NULL
#define OPTION_VAL_SGB_3B_CHS NULL
#define OPTION_VAL_SGB_3C_CHS NULL
#define OPTION_VAL_SGB_3D_CHS NULL
#define OPTION_VAL_SGB_3E_CHS NULL
#define OPTION_VAL_SGB_3F_CHS NULL
#define OPTION_VAL_SGB_3G_CHS NULL
#define OPTION_VAL_SGB_3H_CHS NULL
#define OPTION_VAL_SGB_4A_CHS NULL
#define OPTION_VAL_SGB_4B_CHS NULL
#define OPTION_VAL_SGB_4C_CHS NULL
#define OPTION_VAL_SGB_4D_CHS NULL
#define OPTION_VAL_SGB_4E_CHS NULL
#define OPTION_VAL_SGB_4F_CHS NULL
#define OPTION_VAL_SGB_4G_CHS NULL
#define OPTION_VAL_SGB_4H_CHS NULL
#define OPTION_VAL_SPECIAL_1_CHS NULL
#define OPTION_VAL_SPECIAL_2_CHS NULL
#define OPTION_VAL_SPECIAL_3_CHS NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CHS NULL
#define OPTION_VAL_TWB64_PACK_1_CHS NULL
#define OPTION_VAL_TWB64_PACK_2_CHS NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_CHS NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CHS NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CHS NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_CHS NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CHS NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CHS NULL
#define OPTION_VAL_TWB64_005_NEON_RED_CHS NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_CHS NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_CHS NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_CHS NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_CHS NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CHS NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_CHS NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CHS NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CHS NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CHS NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_CHS NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_CHS NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_CHS NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CHS NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CHS NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CHS NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_CHS NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CHS NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_CHS NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_CHS NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CHS NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_CHS NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_CHS NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CHS NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_CHS NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_CHS NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CHS NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CHS NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_CHS NULL
#define OPTION_VAL_TWB64_040_DMG_VER_CHS NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_CHS NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_CHS NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CHS NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_CHS NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_CHS NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_CHS NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_CHS NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_CHS NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_CHS NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CHS NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CHS NULL
#define OPTION_VAL_TWB64_053_VMU_VER_CHS NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_CHS NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_CHS NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CHS NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_CHS NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_CHS NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_CHS NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_CHS NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CHS NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_CHS NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_CHS NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_CHS NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CHS NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_CHS NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CHS NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_CHS NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_CHS NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CHS NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_CHS NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CHS NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CHS NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CHS NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_CHS NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_CHS NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_CHS NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CHS NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CHS NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CHS NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CHS NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CHS NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_CHS NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CHS NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CHS NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_CHS NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_CHS NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CHS NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CHS NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_CHS NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CHS NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CHS NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_CHS NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CHS NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CHS NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CHS NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_CHS NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CHS NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CHS NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_CHS NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CHS NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_CHS NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CHS NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CHS NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_CHS NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_CHS NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_CHS NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CHS NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_CHS NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_CHS NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_CHS NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CHS NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_CHS NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CHS NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_CHS NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_CHS NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_CHS NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CHS NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CHS NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_CHS NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CHS NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CHS NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_CHS NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_CHS NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_CHS NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_CHS NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_CHS NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_CHS NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CHS NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_CHS NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_CHS NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_CHS NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_CHS NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CHS NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CHS NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CHS NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CHS NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CHS NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CHS NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_CHS NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CHS NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CHS NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CHS NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_CHS NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_CHS NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CHS NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_CHS NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CHS NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_CHS NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CHS NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_CHS NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_CHS NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_CHS NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CHS NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_CHS NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_CHS NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_CHS NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CHS NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CHS NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_CHS NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_CHS NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CHS NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CHS NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_CHS NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CHS NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_CHS NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_CHS NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CHS NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CHS NULL
#define OPTION_VAL_TWB64_182_PINK109_CHS NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_CHS NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_CHS NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CHS NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CHS NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_CHS NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CHS NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CHS NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_CHS NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_CHS NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CHS NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_CHS NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CHS NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_CHS NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CHS NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_CHS NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CHS NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_CHS NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CHS NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CHS NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CHS NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CHS NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CHS NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CHS NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CHS NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CHS NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_CHS NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CHS NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CHS NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_CHS NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CHS NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CHS NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CHS NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CHS NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CHS NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CHS NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CHS NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CHS NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CHS NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CHS NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CHS NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CHS NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CHS NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CHS NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_CHS NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CHS NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_CHS NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CHS NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CHS NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_CHS NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CHS NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CHS NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CHS NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CHS NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CHS NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_CHS NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CHS NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CHS NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CHS NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CHS NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_CHS NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CHS NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_CHS NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CHS NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CHS NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_CHS NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CHS "色彩校正"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CHS NULL
#define OPTION_VAL_GBC_ONLY_CHS NULL
#define OPTION_VAL_ALWAYS_CHS "总是"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CHS NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CHS NULL
#define OPTION_VAL_ACCURATE_CHS "精确"
#define OPTION_VAL_FAST_CHS "快"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CHS NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CHS NULL
#define OPTION_VAL_CENTRAL_CHS "中央"
#define OPTION_VAL_ABOVE_SCREEN_CHS NULL
#define OPTION_VAL_BELOW_SCREEN_CHS NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_CHS NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CHS NULL
#define GAMBATTE_MIX_FRAMES_LABEL_CHS NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_CHS NULL
#define OPTION_VAL_MIX_CHS "简单"
#define OPTION_VAL_LCD_GHOSTING_CHS NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_CHS NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_CHS "音频重采样器"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_CHS NULL
#define OPTION_VAL_SINC_CHS NULL
#define OPTION_VAL_CC_CHS NULL
#define GAMBATTE_GB_HWMODE_LABEL_CHS NULL
#define GAMBATTE_GB_HWMODE_INFO_0_CHS NULL
#define OPTION_VAL_GB_CHS NULL
#define OPTION_VAL_GBA_CHS NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_CHS NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_CHS NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_CHS NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CHS NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_CHS NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_CHS NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_CHS NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_CHS NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CHS NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_CHS NULL
#define OPTION_VAL_NOT_CONNECTED_CHS "未连接"
#define OPTION_VAL_NETWORK_SERVER_CHS NULL
#define OPTION_VAL_NETWORK_CLIENT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CHS "端口"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CHS NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CHS NULL

struct retro_core_option_v2_category option_cats_chs[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_CHS,
      CATEGORY_GB_LINK_INFO_0_CHS
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_chs[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_CHS,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_CHS },
         { "GBC",      OPTION_VAL_GBC_CHS },
         { "SGB",      OPTION_VAL_SGB_CHS },
         { "internal", OPTION_VAL_INTERNAL_CHS },
         { "custom",   OPTION_VAL_CUSTOM_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CHS,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_CHS },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_CHS },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_CHS },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_CHS },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_CHS },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_CHS },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_CHS },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_CHS },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_CHS },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_CHS },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_CHS },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_CHS },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_CHS },
         { "GBC - Red",                OPTION_VAL_GBC_RED_CHS },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_CHS },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_CHS },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_CHS },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_CHS },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_CHS },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_CHS },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_CHS },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_CHS },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_CHS },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_CHS },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_CHS },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_CHS },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_CHS },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_CHS },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_CHS },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_CHS },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_CHS },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_CHS },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_CHS },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_CHS },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_CHS },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_CHS },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_CHS },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_CHS },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_CHS },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_CHS },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_CHS },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_CHS },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_CHS },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_CHS },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_CHS },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_CHS },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_CHS },
         { "Special 1",                OPTION_VAL_SPECIAL_1_CHS },
         { "Special 2",                OPTION_VAL_SPECIAL_2_CHS },
         { "Special 3",                OPTION_VAL_SPECIAL_3_CHS },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CHS },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_CHS },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_CHS },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_CHS },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CHS,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_CHS },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CHS },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CHS },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CHS },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_CHS },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_CHS },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_CHS },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_CHS },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_CHS },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_CHS },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_CHS },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CHS },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_CHS },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_CHS },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CHS },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CHS },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CHS },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CHS },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_CHS },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CHS },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_CHS },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_CHS },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CHS },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CHS },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CHS },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_CHS },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CHS },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_CHS },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_CHS },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CHS },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_CHS },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_CHS },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CHS },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_CHS },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_CHS },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CHS },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CHS },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CHS },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_CHS },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_CHS },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_CHS },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_CHS },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CHS },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_CHS },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CHS },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_CHS },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_CHS },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_CHS },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_CHS },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_CHS },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CHS },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CHS },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_CHS },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_CHS },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_CHS },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CHS },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_CHS },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_CHS },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CHS },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_CHS },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_CHS },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CHS },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_CHS },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_CHS },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_CHS },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CHS },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_CHS },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CHS },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_CHS },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_CHS },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CHS },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_CHS },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CHS },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CHS },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CHS },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_CHS },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_CHS },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_CHS },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CHS },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CHS },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CHS },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CHS },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CHS },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_CHS },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CHS },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CHS },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_CHS },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_CHS },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CHS },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CHS },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_CHS },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CHS },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CHS },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CHS },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CHS },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_CHS },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CHS },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CHS },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CHS },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_CHS },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CHS,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_CHS },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CHS },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_CHS },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_CHS },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CHS },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CHS },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_CHS },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_CHS },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_CHS },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CHS },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_CHS },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_CHS },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_CHS },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CHS },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_CHS },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CHS },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_CHS },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_CHS },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_CHS },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_CHS },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CHS },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CHS },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_CHS },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CHS },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CHS },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_CHS },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_CHS },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_CHS },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_CHS },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_CHS },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_CHS },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_CHS },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CHS },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_CHS },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_CHS },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_CHS },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CHS },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_CHS },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CHS },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CHS },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CHS },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CHS },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CHS },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CHS },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CHS },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CHS },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_CHS },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_CHS },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CHS },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CHS },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CHS },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CHS },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_CHS },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_CHS },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CHS },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_CHS },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CHS },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_CHS },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CHS },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_CHS },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_CHS },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_CHS },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_CHS },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CHS },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_CHS },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_CHS },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_CHS },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CHS },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CHS },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_CHS },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_CHS },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CHS },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CHS },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_CHS },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CHS },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_CHS },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_CHS },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_CHS },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CHS },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CHS },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CHS },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_CHS },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_CHS },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_CHS },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CHS },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CHS },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_CHS },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CHS },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CHS },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_CHS },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_CHS },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CHS },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_CHS },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CHS },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_CHS },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CHS },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_CHS },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CHS },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_CHS },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CHS },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CHS,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CHS },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CHS },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CHS },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CHS },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CHS },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_CHS },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CHS },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CHS },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_CHS },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CHS },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CHS },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CHS },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CHS },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CHS },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CHS },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CHS },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CHS },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CHS },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CHS },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CHS },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CHS },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CHS },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CHS },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_CHS },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CHS },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_CHS },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CHS },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CHS },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_CHS },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CHS },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CHS },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CHS },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CHS },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CHS },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_CHS },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CHS },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CHS },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CHS },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CHS },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_CHS },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CHS },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_CHS },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CHS },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CHS },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_CHS },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CHS,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_CHS },
         { "always",   OPTION_VAL_ALWAYS_CHS },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CHS,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_CHS },
         { "fast",     OPTION_VAL_FAST_CHS },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CHS,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_CHS },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_CHS },
         { "below screen", OPTION_VAL_BELOW_SCREEN_CHS },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_CHS,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_CHS,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_CHS },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_CHS },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_CHS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_CHS,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_CHS },
         { "cc",   OPTION_VAL_CC_CHS },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_CHS,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_CHS },
         { "GB",   OPTION_VAL_GB_CHS },
         { "GBC",  OPTION_VAL_GBC_CHS },
         { "GBA",  OPTION_VAL_GBA_CHS },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_CHS,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_CHS,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_CHS,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_CHS,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CHS,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CHS,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_CHS,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_MODE_INFO_0_CHS,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_CHS },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_CHS },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_CHS },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CHS,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CHS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CHS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_chs = {
   option_cats_chs,
   option_defs_chs
};

/* RETRO_LANGUAGE_CHT */

#define CATEGORY_GB_LINK_LABEL_CHT "連線主機連接"
#define CATEGORY_GB_LINK_INFO_0_CHT "變更連線對戰時主機連接的設定。"
#define GAMBATTE_GB_COLORIZATION_LABEL_CHT "Game Boy著色"
#define GAMBATTE_GB_COLORIZATION_INFO_0_CHT "設定Game Boy遊戲的著色模式, 設定<自動>時為核心定義的最佳配色效果, 當遊戲未定義配色時套用「影像配色」的設定, 設定<GBC>時為GBC配色, 未定義則用深綠, 設定<SGB>時為SGB配色, 未定義則用1A, 設定<影像配色>時套用「影像配色」的設定, 設定<自訂>時從系統資料夾中載入自訂調色板。"
#define OPTION_VAL_AUTO_CHT "自動"
#define OPTION_VAL_GBC_CHT "GBC (Game Boy Color主機)"
#define OPTION_VAL_SGB_CHT "SGB (Super Game Boy介面卡)"
#define OPTION_VAL_INTERNAL_CHT "影像配色"
#define OPTION_VAL_CUSTOM_CHT "自訂"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CHT "影像配色"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CHT "「Game Boy著色」設定為<影像配色>時, 或<自動>且未定義配色時使用, 此選項GB類別為主機畫面擬真顯示, GBC類別為主機內建顏色, SGB類別為介面卡內建顏色, 調色師類別有 狼兔64(TheWolfBunny64) 和 PixelShift(像素偏移) 提供的配色, 設定為調色師時依設定套用其他選項。"
#define OPTION_VAL_GB_DMG_CHT "GB - 初版主機"
#define OPTION_VAL_GB_POCKET_CHT "GB - 輕薄型主機"
#define OPTION_VAL_GB_LIGHT_CHT "GB - 背光型主機"
#define OPTION_VAL_GBC_BLUE_CHT "GBC - 內建藍色 (左鍵)"
#define OPTION_VAL_GBC_BROWN_CHT "GBC - 內建褐色 (上鍵)"
#define OPTION_VAL_GBC_DARK_BLUE_CHT "GBC - 內建深藍 (左+A)"
#define OPTION_VAL_GBC_DARK_BROWN_CHT "GBC - 內建深褐 (上+B)"
#define OPTION_VAL_GBC_DARK_GREEN_CHT "GBC - 內建深綠 (右+A)"
#define OPTION_VAL_GBC_GRAYSCALE_CHT "GBC - 內建灰階 (左+B)"
#define OPTION_VAL_GBC_GREEN_CHT "GBC - 內建綠色 (右鍵)"
#define OPTION_VAL_GBC_INVERTED_CHT "GBC - 內建反轉 (右+B)"
#define OPTION_VAL_GBC_ORANGE_CHT "GBC - 內建橘色 (下+A)"
#define OPTION_VAL_GBC_PASTEL_MIX_CHT "GBC - 內建粉彩 (下鍵)"
#define OPTION_VAL_GBC_RED_CHT "GBC - 內建紅色 (上+A)"
#define OPTION_VAL_GBC_YELLOW_CHT "GBC - 內建黃色 (下+B)"
#define OPTION_VAL_SGB_1A_CHT "SGB - 內建顏色 [1-A]"
#define OPTION_VAL_SGB_1B_CHT "SGB - 內建顏色 [1-B]"
#define OPTION_VAL_SGB_1C_CHT "SGB - 內建顏色 [1-C]"
#define OPTION_VAL_SGB_1D_CHT "SGB - 內建顏色 [1-D]"
#define OPTION_VAL_SGB_1E_CHT "SGB - 內建顏色 [1-E]"
#define OPTION_VAL_SGB_1F_CHT "SGB - 內建顏色 [1-F]"
#define OPTION_VAL_SGB_1G_CHT "SGB - 內建顏色 [1-G]"
#define OPTION_VAL_SGB_1H_CHT "SGB - 內建顏色 [1-H]"
#define OPTION_VAL_SGB_2A_CHT "SGB - 內建顏色 [2-A]"
#define OPTION_VAL_SGB_2B_CHT "SGB - 內建顏色 [2-B]"
#define OPTION_VAL_SGB_2C_CHT "SGB - 內建顏色 [2-C]"
#define OPTION_VAL_SGB_2D_CHT "SGB - 內建顏色 [2-D]"
#define OPTION_VAL_SGB_2E_CHT "SGB - 內建顏色 [2-E]"
#define OPTION_VAL_SGB_2F_CHT "SGB - 內建顏色 [2-F]"
#define OPTION_VAL_SGB_2G_CHT "SGB - 內建顏色 [2-G]"
#define OPTION_VAL_SGB_2H_CHT "SGB - 內建顏色 [2-H]"
#define OPTION_VAL_SGB_3A_CHT "SGB - 內建顏色 [3-A]"
#define OPTION_VAL_SGB_3B_CHT "SGB - 內建顏色 [3-B]"
#define OPTION_VAL_SGB_3C_CHT "SGB - 內建顏色 [3-C]"
#define OPTION_VAL_SGB_3D_CHT "SGB - 內建顏色 [3-D]"
#define OPTION_VAL_SGB_3E_CHT "SGB - 內建顏色 [3-E]"
#define OPTION_VAL_SGB_3F_CHT "SGB - 內建顏色 [3-F]"
#define OPTION_VAL_SGB_3G_CHT "SGB - 內建顏色 [3-G]"
#define OPTION_VAL_SGB_3H_CHT "SGB - 內建顏色 [3-H]"
#define OPTION_VAL_SGB_4A_CHT "SGB - 內建顏色 [4-A]"
#define OPTION_VAL_SGB_4B_CHT "SGB - 內建顏色 [4-B]"
#define OPTION_VAL_SGB_4C_CHT "SGB - 內建顏色 [4-C]"
#define OPTION_VAL_SGB_4D_CHT "SGB - 內建顏色 [4-D]"
#define OPTION_VAL_SGB_4E_CHT "SGB - 內建顏色 [4-E]"
#define OPTION_VAL_SGB_4F_CHT "SGB - 內建顏色 [4-F]"
#define OPTION_VAL_SGB_4G_CHT "SGB - 內建顏色 [4-G]"
#define OPTION_VAL_SGB_4H_CHT "SGB - 內建顏色 [4-H]"
#define OPTION_VAL_SPECIAL_1_CHT "特調 1"
#define OPTION_VAL_SPECIAL_2_CHT "特調 2"
#define OPTION_VAL_SPECIAL_3_CHT "特調 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CHT "特調 4 (TI-83工程計算機)"
#define OPTION_VAL_TWB64_PACK_1_CHT "調色師 - 狼兔64 (1)"
#define OPTION_VAL_TWB64_PACK_2_CHT "調色師 - 狼兔64 (2)"
#define OPTION_VAL_PIXELSHIFT_PACK_1_CHT "調色師 - 像素偏移 (1)"
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CHT "> 狼兔64 - 配色包 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CHT "僅限「影像配色」設定為<狼兔64(1)>時套用。"
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_CHT "狼兔64 001 - 水團藍"
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CHT "狼兔64 002 - 漫畫展版 (白黑)"
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CHT "狼兔64 003 - 海綿寶寶黃"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CHT "狼兔64 004 - 派大星粉紅"
#define OPTION_VAL_TWB64_005_NEON_RED_CHT "狼兔64 005 - 紅色霓虹燈"
#define OPTION_VAL_TWB64_006_NEON_BLUE_CHT "狼兔64 006 - 藍色霓虹燈"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_CHT "狼兔64 007 - 黃色霓虹燈"
#define OPTION_VAL_TWB64_008_NEON_GREEN_CHT "狼兔64 008 - 綠色霓虹燈"
#define OPTION_VAL_TWB64_009_NEON_PINK_CHT "狼兔64 009 - 粉紅霓虹燈"
#define OPTION_VAL_TWB64_010_MARIO_RED_CHT "狼兔64 010 - 瑪利歐紅"
#define OPTION_VAL_TWB64_011_NICK_ORANGE_CHT "狼兔64 011 - 尼克兒童頻道橘"
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CHT "狼兔64 012 - Virtual Boy主機 (紅黑)"
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_CHT "狼兔64 013 - 薩爾達傳說曠野金"
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_CHT "狼兔64 014 - 瑪利歐創作家工程黃"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CHT "狼兔64 015 - Discord商標藍紫"
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CHT "狼兔64 016 - 765偶像藍紫"
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CHT "狼兔64 017 - 瑪利歐創作家超級球黃"
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CHT "狼兔64 018 - Crunchyroll商標橘"
#define OPTION_VAL_TWB64_019_MUSE_PINK_CHT "狼兔64 019 - 學園偶像計畫繆斯粉色"
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CHT "狼兔64 020 - 虹咲學園黃"
#define OPTION_VAL_TWB64_021_GAMATE_VER_CHT "狼兔64 021 - 超級小子主機 (Gamate)"
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_CHT "狼兔64 022 - 綠色階"
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CHT "狼兔64 023 - 奧德賽金幣 (金黃)"
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CHT "狼兔64 024 - 超級賽亞人之神 (紅光)"
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CHT "狼兔64 025 - 超級賽亞人藍 (藍光)"
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_CHT "狼兔64 026 - JoJo的奇妙冒險標題桃紅"
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CHT "狼兔64 027 - Switch輕量版外殼 (黃藍)"
#define OPTION_VAL_TWB64_028_GAME_COM_VER_CHT NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_CHT NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CHT NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_CHT NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_CHT NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CHT NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_CHT NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_CHT NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CHT NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CHT NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_CHT NULL
#define OPTION_VAL_TWB64_040_DMG_VER_CHT NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_CHT NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_CHT NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CHT NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_CHT NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_CHT NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_CHT NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_CHT NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_CHT NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_CHT NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CHT NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CHT NULL
#define OPTION_VAL_TWB64_053_VMU_VER_CHT NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_CHT NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_CHT NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CHT NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_CHT NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_CHT NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_CHT NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_CHT NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CHT NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_CHT NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_CHT NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_CHT NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CHT NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_CHT NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CHT NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_CHT "狼兔64 069 - 飛天小女警花花粉"
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_CHT "狼兔64 070 - 飛天小女警泡泡藍"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CHT "狼兔64 071 - 飛天小女警毛毛綠"
#define OPTION_VAL_TWB64_072_NASCAR_VER_CHT NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CHT NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CHT NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CHT NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_CHT NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_CHT NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_CHT NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CHT NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CHT NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CHT NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CHT NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CHT NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_CHT NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CHT NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CHT NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_CHT NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_CHT NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CHT NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CHT NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_CHT NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CHT NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CHT NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_CHT NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CHT NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CHT NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CHT NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_CHT NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CHT "> 狼兔64 - 配色包 2"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CHT "僅限「影像配色」設定為<狼兔64(2)>時套用。"
#define OPTION_VAL_TWB64_101_765PRO_PINK_CHT NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CHT NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_CHT NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CHT NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CHT NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_CHT NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_CHT NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_CHT NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CHT NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_CHT NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_CHT NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_CHT NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CHT NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_CHT NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CHT NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_CHT NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_CHT NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_CHT NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CHT NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CHT NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_CHT NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CHT NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CHT NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_CHT NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_CHT NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_CHT NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_CHT NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_CHT NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_CHT NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CHT NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_CHT NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_CHT NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_CHT NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_CHT NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CHT NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CHT NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CHT NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CHT NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CHT NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CHT NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_CHT NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CHT NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CHT NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CHT NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_CHT NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_CHT NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CHT NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_CHT NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CHT NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_CHT NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CHT NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_CHT NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_CHT NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_CHT NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CHT NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_CHT NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_CHT NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_CHT NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CHT NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CHT NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_CHT NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_CHT NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CHT NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CHT NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_CHT NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CHT NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_CHT NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_CHT NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CHT NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CHT NULL
#define OPTION_VAL_TWB64_182_PINK109_CHT NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_CHT NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_CHT NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CHT NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CHT NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_CHT NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CHT NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CHT NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_CHT NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_CHT NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CHT NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_CHT NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CHT NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_CHT NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CHT NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_CHT NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CHT NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_CHT NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CHT NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CHT "> 像素偏移 - 配色包 1"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CHT "僅限「影像配色」設定為<像素偏移(1)>時套用。"
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CHT "像素偏移 01 - 薄荷綠"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CHT "像素偏移 02 - Arduboy主機 (黑白)"
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CHT "像素偏移 03 - BGB模擬器0.3版 (翠綠)"
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CHT "像素偏移 04 - 黃綠迷彩色"
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CHT "像素偏移 05 - 牛奶巧克力"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_CHT "像素偏移 06 - 印刷四色"
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CHT "像素偏移 07 - 棉花糖"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CHT "像素偏移 08 - 簡單綠"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_CHT "像素偏移 09 - 超級小子主機 (綠光)"
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CHT "像素偏移 10 - Game Boy Light主機 (綠光)"
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CHT "像素偏移 11 - Game Boy Pocket主機 (橄欖綠)"
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CHT "像素偏移 12 - Game Boy Pocket主機 (羅勒綠)"
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CHT "像素偏移 13 - Game Pocket Computer主機 (白黑)"
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CHT "像素偏移 14 - Game & Watch Ball主機 (深灰綠)"
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CHT "像素偏移 15 - 藍色背光液晶"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CHT "像素偏移 16 - 白色背光液晶"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CHT "像素偏移 17 - 橘色背光液晶"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CHT "像素偏移 18 - 亮藍背光液晶"
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CHT "像素偏移 19 - 暗黃背光液晶"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CHT "像素偏移 20 - 偽GB主機 (淡藍)"
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CHT "像素偏移 21 - 仿製GB主機 (灰黑)"
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CHT "像素偏移 22 - BGB-001展示機 (亮綠)"
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CHT "像素偏移 23 - NESM92V展示機 (亮黃)"
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_CHT "像素偏移 24 - GB新液晶 (綠色)"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CHT "像素偏移 25 - GB微調 (藍綠色)"
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_CHT "像素偏移 26 - GB舊液晶 (黃綠色)"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CHT "像素偏移 27 - GBP反相器藍背光"
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CHT "像素偏移 28 - GB水洗黃背光"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_CHT "像素偏移 29 - 粉紅幽靈"
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CHT "像素偏移 30 - 暗綠光"
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CHT "像素偏移 31 - 金條"
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CHT "像素偏移 32 - 葡萄柚"
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CHT "像素偏移 33 - 灰綠混合"
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CHT "像素偏移 34 - 寶可夢遺失號碼 (白黃)"
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_CHT "像素偏移 35 - 微軟磁碟作業系統 (黑綠)"
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CHT "像素偏移 36 - 報紙 (深灰色)"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CHT "像素偏移 37 - 嗶嗶小子 (黑綠)"
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CHT "像素偏移 38 - 口袋少女 (黃粉)"
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CHT "像素偏移 39 - 黑色輪廓"
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_CHT "像素偏移 40 - 太陽爆炸 (淡黃)"
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CHT "像素偏移 41 - 鮮艷 (淡粉紅色)"
#define OPTION_VAL_PIXELSHIFT_42_TRON_CHT "像素偏移 42 - 電子世界爭霸戰 (黑紫)"
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CHT "像素偏移 43 - 蒸汽波藍"
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CHT "像素偏移 44 - Virtual Boy主機 (紅黑)"
#define OPTION_VAL_PIXELSHIFT_45_WISH_CHT "像素偏移 45 - 期望藍"
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CHT "色彩校正"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CHT NULL
#define OPTION_VAL_GBC_ONLY_CHT "僅限GBC"
#define OPTION_VAL_ALWAYS_CHT "全部類型"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CHT "色彩校正模式"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CHT NULL
#define OPTION_VAL_ACCURATE_CHT "準確"
#define OPTION_VAL_FAST_CHT "快速"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CHT "色彩校正 - 前光位置"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CHT NULL
#define OPTION_VAL_CENTRAL_CHT "中間"
#define OPTION_VAL_ABOVE_SCREEN_CHT "螢幕上方"
#define OPTION_VAL_BELOW_SCREEN_CHT "螢幕下方"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_CHT "亮度降低 (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CHT NULL
#define GAMBATTE_MIX_FRAMES_LABEL_CHT "模擬殘影"
#define GAMBATTE_MIX_FRAMES_INFO_0_CHT NULL
#define OPTION_VAL_MIX_CHT "簡易"
#define OPTION_VAL_LCD_GHOSTING_CHT "液晶顯示器 (準確)"
#define OPTION_VAL_LCD_GHOSTING_FAST_CHT "液晶顯示器 (快速)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_CHT "音訊重新取樣器"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_CHT NULL
#define OPTION_VAL_SINC_CHT "正弦波"
#define OPTION_VAL_CC_CHT "餘弦波"
#define GAMBATTE_GB_HWMODE_LABEL_CHT "模擬主機硬體 (需要重新啟動)"
#define GAMBATTE_GB_HWMODE_INFO_0_CHT NULL
#define OPTION_VAL_GB_CHT "GB (Game Boy主機)"
#define OPTION_VAL_GBA_CHT "GBA (Game Boy Advance主機)"
#define GAMBATTE_GB_BOOTLOADER_LABEL_CHT "主機開機畫面 (需要重新啟動)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_CHT NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_CHT "允許反向操作"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CHT "允許控制器反方向快速操作, 可同時按左右或上下的方向, 可能導致遊戲的移動架構出錯。"
#define GAMBATTE_TURBO_PERIOD_LABEL_CHT "連發間隔"
#define GAMBATTE_TURBO_PERIOD_INFO_0_CHT NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_CHT "模擬震動強度"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_CHT "設定遊戲支援震動的震動強度, 模擬內建振動模組的卡帶, 例如「寶可夢彈珠臺(Pokemon Pinball)」。"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CHT "顯示連線主機連接選項"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CHT "顯示連線對戰時主機連接相關的選項。\n注意: 此選項變更時需要重新進入核心選項才能生效。"
#define GAMBATTE_GB_LINK_MODE_LABEL_CHT "主機連接模式"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_CHT "主機連接模式"
#define GAMBATTE_GB_LINK_MODE_INFO_0_CHT "設定連線對戰時核心的連接模式, 必須在未建立連線之前設定完成, <用戶端>需要設定主機端IP位址。"
#define OPTION_VAL_NOT_CONNECTED_CHT "不連接"
#define OPTION_VAL_NETWORK_SERVER_CHT "主機端"
#define OPTION_VAL_NETWORK_CLIENT_CHT "用戶端"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CHT "連接通訊埠號"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CHT "連接通訊埠號"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CHT "設定主機連接時使用的通訊埠號。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CHT "連線主機位址(01): #__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CHT "連線主機位址(01): #__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CHT "設定連線主機IP位址第1碼, 例如「192.168.1.1」不滿12個數字, 設定方式為「192.168.001.001」。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CHT "設定連線主機IP位址第1碼, 例如「192.168.1.1」不滿12個數字, 設定方式為「192.168.001.001」。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CHT "連線主機位址(02): _#_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CHT "連線主機位址(02): _#_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CHT "設定連線主機IP位址第2碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CHT "設定連線主機IP位址第2碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CHT "連線主機位址(03): __#.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CHT "連線主機位址(03): __#.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CHT "設定連線主機IP位址第3碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CHT "設定連線主機IP位址第3碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CHT "連線主機位址(04): ___.#__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CHT "連線主機位址(04): ___.#__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CHT "設定連線主機IP位址第4碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CHT "設定連線主機IP位址第4碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CHT "連線主機位址(05): ___._#_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CHT "連線主機位址(05): ___._#_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CHT "設定連線主機IP位址第5碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CHT "設定連線主機IP位址第5碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CHT "連線主機位址(06): ___.__#.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CHT "連線主機位址(06): ___.__#.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CHT "設定連線主機IP位址第6碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CHT "設定連線主機IP位址第6碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CHT "連線主機位址(07): ___.___.#__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CHT "連線主機位址(07): ___.___.#__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CHT "設定連線主機IP位址第7碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CHT "設定連線主機IP位址第7碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CHT "連線主機位址(08): ___.___._#_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CHT "連線主機位址(08): ___.___._#_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CHT "設定連線主機IP位址第8碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CHT "設定連線主機IP位址第8碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CHT "連線主機位址(09): ___.___.__#.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CHT "連線主機位址(09): ___.___.__#.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CHT "設定連線主機IP位址第9碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CHT "設定連線主機IP位址第9碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CHT "連線主機位址(10): ___.___.___.#__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CHT "連線主機位址(10): ___.___.___.#__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CHT "設定連線主機IP位址第10碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CHT "設定連線主機IP位址第10碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CHT "連線主機位址(11): ___.___.___._#_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CHT "連線主機位址(11): ___.___.___._#_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CHT "設定連線主機IP位址第11碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CHT "設定連線主機IP位址第11碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CHT "連線主機位址(12): ___.___.___.__#"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CHT "連線主機位址(12): ___.___.___.__#"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CHT "設定連線主機IP位址第12碼, 僅限「主機連接模式」設定為<用戶端>時使用。"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CHT "設定連線主機IP位址第12碼, 僅限「主機連接模式」設定為<用戶端>時使用。"

struct retro_core_option_v2_category option_cats_cht[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_CHT,
      CATEGORY_GB_LINK_INFO_0_CHT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_cht[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_CHT,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_CHT },
         { "GBC",      OPTION_VAL_GBC_CHT },
         { "SGB",      OPTION_VAL_SGB_CHT },
         { "internal", OPTION_VAL_INTERNAL_CHT },
         { "custom",   OPTION_VAL_CUSTOM_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CHT,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_CHT },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_CHT },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_CHT },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_CHT },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_CHT },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_CHT },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_CHT },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_CHT },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_CHT },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_CHT },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_CHT },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_CHT },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_CHT },
         { "GBC - Red",                OPTION_VAL_GBC_RED_CHT },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_CHT },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_CHT },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_CHT },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_CHT },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_CHT },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_CHT },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_CHT },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_CHT },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_CHT },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_CHT },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_CHT },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_CHT },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_CHT },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_CHT },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_CHT },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_CHT },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_CHT },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_CHT },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_CHT },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_CHT },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_CHT },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_CHT },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_CHT },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_CHT },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_CHT },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_CHT },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_CHT },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_CHT },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_CHT },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_CHT },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_CHT },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_CHT },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_CHT },
         { "Special 1",                OPTION_VAL_SPECIAL_1_CHT },
         { "Special 2",                OPTION_VAL_SPECIAL_2_CHT },
         { "Special 3",                OPTION_VAL_SPECIAL_3_CHT },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CHT },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_CHT },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_CHT },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_CHT },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CHT,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_CHT },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CHT },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CHT },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CHT },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_CHT },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_CHT },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_CHT },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_CHT },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_CHT },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_CHT },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_CHT },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CHT },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_CHT },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_CHT },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CHT },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CHT },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CHT },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CHT },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_CHT },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CHT },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_CHT },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_CHT },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CHT },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CHT },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CHT },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_CHT },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CHT },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_CHT },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_CHT },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CHT },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_CHT },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_CHT },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CHT },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_CHT },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_CHT },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CHT },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CHT },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CHT },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_CHT },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_CHT },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_CHT },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_CHT },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CHT },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_CHT },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CHT },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_CHT },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_CHT },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_CHT },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_CHT },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_CHT },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CHT },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CHT },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_CHT },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_CHT },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_CHT },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CHT },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_CHT },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_CHT },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CHT },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_CHT },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_CHT },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CHT },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_CHT },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_CHT },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_CHT },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CHT },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_CHT },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CHT },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_CHT },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_CHT },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CHT },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_CHT },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CHT },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CHT },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CHT },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_CHT },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_CHT },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_CHT },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CHT },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CHT },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CHT },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CHT },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CHT },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_CHT },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CHT },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CHT },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_CHT },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_CHT },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CHT },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CHT },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_CHT },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CHT },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CHT },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CHT },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CHT },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_CHT },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CHT },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CHT },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CHT },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_CHT },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CHT,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_CHT },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CHT },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_CHT },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_CHT },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CHT },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CHT },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_CHT },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_CHT },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_CHT },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CHT },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_CHT },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_CHT },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_CHT },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CHT },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_CHT },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CHT },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_CHT },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_CHT },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_CHT },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_CHT },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CHT },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CHT },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_CHT },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CHT },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CHT },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_CHT },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_CHT },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_CHT },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_CHT },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_CHT },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_CHT },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_CHT },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CHT },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_CHT },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_CHT },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_CHT },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CHT },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_CHT },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CHT },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CHT },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CHT },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CHT },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CHT },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CHT },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CHT },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CHT },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_CHT },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_CHT },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CHT },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CHT },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CHT },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CHT },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_CHT },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_CHT },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CHT },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_CHT },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CHT },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_CHT },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CHT },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_CHT },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_CHT },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_CHT },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_CHT },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CHT },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_CHT },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_CHT },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_CHT },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CHT },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CHT },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_CHT },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_CHT },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CHT },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CHT },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_CHT },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CHT },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_CHT },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_CHT },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_CHT },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CHT },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CHT },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CHT },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_CHT },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_CHT },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_CHT },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CHT },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CHT },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_CHT },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CHT },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CHT },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_CHT },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_CHT },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CHT },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_CHT },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CHT },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_CHT },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CHT },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_CHT },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CHT },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_CHT },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CHT },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CHT,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CHT },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CHT },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CHT },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CHT },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CHT },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_CHT },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CHT },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CHT },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_CHT },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CHT },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CHT },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CHT },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CHT },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CHT },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CHT },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CHT },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CHT },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CHT },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CHT },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CHT },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CHT },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CHT },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CHT },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_CHT },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CHT },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_CHT },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CHT },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CHT },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_CHT },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CHT },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CHT },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CHT },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CHT },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CHT },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_CHT },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CHT },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CHT },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CHT },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CHT },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_CHT },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CHT },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_CHT },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CHT },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CHT },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_CHT },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CHT,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_CHT },
         { "always",   OPTION_VAL_ALWAYS_CHT },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CHT,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_CHT },
         { "fast",     OPTION_VAL_FAST_CHT },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CHT,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_CHT },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_CHT },
         { "below screen", OPTION_VAL_BELOW_SCREEN_CHT },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_CHT,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_CHT,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_CHT },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_CHT },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_CHT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_CHT,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_CHT },
         { "cc",   OPTION_VAL_CC_CHT },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_CHT,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_CHT },
         { "GB",   OPTION_VAL_GB_CHT },
         { "GBC",  OPTION_VAL_GBC_CHT },
         { "GBA",  OPTION_VAL_GBA_CHT },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_CHT,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_CHT,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_CHT,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_CHT,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CHT,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CHT,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_CHT,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_MODE_INFO_0_CHT,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_CHT },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_CHT },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_CHT },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CHT,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CHT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CHT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_cht = {
   option_cats_cht,
   option_defs_cht
};

/* RETRO_LANGUAGE_CS */

#define CATEGORY_GB_LINK_LABEL_CS "Odkaz na Hru"
#define CATEGORY_GB_LINK_INFO_0_CS "Změna nastavení funkce Game Link (multiplayer) v síti."
#define GAMBATTE_GB_COLORIZATION_LABEL_CS "GB Barevná"
#define GAMBATTE_GB_COLORIZATION_INFO_0_CS "Umožňuje kolorování her pro Game Boy. 'Auto' vybere 'nejlepší' (nejbarevnější/vhodnější) paletu. 'GBC' vybere paletu specifickou pro hru Game Boy Color, pokud je definována, jinak 'GBC - tmavě zelená'. 'SGB' vybere paletu specifickou pro hru Super Game Boy, pokud je definována, jinak 'SGB - 1A'. 'Internal' používá základní volbu 'Internal Palette'. 'Vlastní' načte paletu vytvořenou uživatelem ze systémového adresáře."
#define OPTION_VAL_AUTO_CS NULL
#define OPTION_VAL_GBC_CS NULL
#define OPTION_VAL_SGB_CS NULL
#define OPTION_VAL_INTERNAL_CS "Interní"
#define OPTION_VAL_CUSTOM_CS "Vlastní"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CS "Interní Paleta"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CS "Vybere paletu použitou pro kolorování her pro Game Boy, pokud je položka 'GB Colorization' nastavena na 'Internal' nebo pokud je položka 'GB Colorization' nastavena na 'Auto' a hra nemá předdefinovanou paletu SGB/GBC. Palety 'GB' napodobují zobrazení původního hardwaru Game Boy. Palety 'GBC' jsou totožné s vestavěnými předvolbami Game Boy Color. Palety 'SGB' jsou totožné s vestavěnými předvolbami zařízení Super Game Boy."
#define OPTION_VAL_GB_DMG_CS "GB – DMG"
#define OPTION_VAL_GB_POCKET_CS NULL
#define OPTION_VAL_GB_LIGHT_CS NULL
#define OPTION_VAL_GBC_BLUE_CS "GBC - Modrá"
#define OPTION_VAL_GBC_BROWN_CS "GBC - Hnědá"
#define OPTION_VAL_GBC_DARK_BLUE_CS "GBC - Tmavě Modrá"
#define OPTION_VAL_GBC_DARK_BROWN_CS "GBC - Tmavě Hnědá"
#define OPTION_VAL_GBC_DARK_GREEN_CS "GBC - Tmavě Zelená"
#define OPTION_VAL_GBC_GRAYSCALE_CS NULL
#define OPTION_VAL_GBC_GREEN_CS "GBC - Zelená"
#define OPTION_VAL_GBC_INVERTED_CS "GBC - Invertované"
#define OPTION_VAL_GBC_ORANGE_CS "GBC - Oranžová"
#define OPTION_VAL_GBC_PASTEL_MIX_CS NULL
#define OPTION_VAL_GBC_RED_CS "GBC - Červená"
#define OPTION_VAL_GBC_YELLOW_CS "GBC - Žlutá"
#define OPTION_VAL_SGB_1A_CS NULL
#define OPTION_VAL_SGB_1B_CS NULL
#define OPTION_VAL_SGB_1C_CS NULL
#define OPTION_VAL_SGB_1D_CS NULL
#define OPTION_VAL_SGB_1E_CS NULL
#define OPTION_VAL_SGB_1F_CS NULL
#define OPTION_VAL_SGB_1G_CS NULL
#define OPTION_VAL_SGB_1H_CS NULL
#define OPTION_VAL_SGB_2A_CS NULL
#define OPTION_VAL_SGB_2B_CS NULL
#define OPTION_VAL_SGB_2C_CS NULL
#define OPTION_VAL_SGB_2D_CS NULL
#define OPTION_VAL_SGB_2E_CS NULL
#define OPTION_VAL_SGB_2F_CS NULL
#define OPTION_VAL_SGB_2G_CS NULL
#define OPTION_VAL_SGB_2H_CS NULL
#define OPTION_VAL_SGB_3A_CS NULL
#define OPTION_VAL_SGB_3B_CS NULL
#define OPTION_VAL_SGB_3C_CS NULL
#define OPTION_VAL_SGB_3D_CS NULL
#define OPTION_VAL_SGB_3E_CS NULL
#define OPTION_VAL_SGB_3F_CS NULL
#define OPTION_VAL_SGB_3G_CS NULL
#define OPTION_VAL_SGB_3H_CS NULL
#define OPTION_VAL_SGB_4A_CS NULL
#define OPTION_VAL_SGB_4B_CS NULL
#define OPTION_VAL_SGB_4C_CS NULL
#define OPTION_VAL_SGB_4D_CS NULL
#define OPTION_VAL_SGB_4E_CS NULL
#define OPTION_VAL_SGB_4F_CS NULL
#define OPTION_VAL_SGB_4G_CS NULL
#define OPTION_VAL_SGB_4H_CS NULL
#define OPTION_VAL_SPECIAL_1_CS "Speciální 1"
#define OPTION_VAL_SPECIAL_2_CS "Speciální 2"
#define OPTION_VAL_SPECIAL_3_CS "Speciální 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CS "Speciální 4 (TI-83 Legát)"
#define OPTION_VAL_TWB64_PACK_1_CS "TWB64 - Balíček 1"
#define OPTION_VAL_TWB64_PACK_2_CS "TWB64 - Balíček 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_CS "PixelShift - Balíček 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CS "> TWB64 - Balíček Palety 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CS "Vybere interní barevnou paletu, pokud je položka 'Interní Paleta' nastavena na hodnotu 'TWB64 - Balíček 1'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_CS "TWB64 001 - Modrá Aqours"
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CS "TWB64 002 - Animovaná Expo Ver."
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CS "TWB64 003 - SpongeBob Žlutá"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CS "TWB64 004 - Patrick Hvězdně Růžová"
#define OPTION_VAL_TWB64_005_NEON_RED_CS "TWB64 005 - Neonově Červená"
#define OPTION_VAL_TWB64_006_NEON_BLUE_CS "TWB64 006 - Neonově Modrá"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_CS "TWB64 007 - Neonově Žlutá"
#define OPTION_VAL_TWB64_008_NEON_GREEN_CS "TWB64 008 - Neonově Zelená"
#define OPTION_VAL_TWB64_009_NEON_PINK_CS "TWB64 009 - Neonově Růžová"
#define OPTION_VAL_TWB64_010_MARIO_RED_CS "TWB64 010 - Mario Červená"
#define OPTION_VAL_TWB64_011_NICK_ORANGE_CS "TWB64 011 - Nick Oranžový"
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CS NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_CS "TWB64 013 - Zlatý Wild"
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_CS "TWB64 014 - Builder Žlutý"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CS NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CS NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CS NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CS "TWB64 018 - Crunchyroll Oranžový"
#define OPTION_VAL_TWB64_019_MUSE_PINK_CS "TWB64 019 - Muse Růžový"
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CS "TWB64 020 - Nijigasaki Žlutý"
#define OPTION_VAL_TWB64_021_GAMATE_VER_CS NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_CS NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CS "TWB64 023 - Odyssey Zlatý"
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CS NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CS "TWB64 025 - Super Saiyan Modrý"
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_CS "TWB64 026 - Bizarre Růžový"
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CS NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_CS NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_CS "TWB64 029 - Sanrio Růžová"
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CS NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_CS "TWB64 031 - Cosmo Zelená"
#define OPTION_VAL_TWB64_032_WANDA_PINK_CS "TWB64 032 - Wanda Růžová"
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CS NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_CS NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_CS NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CS "TWB64 036 - Game Grump Oranžová"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CS NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CS NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_CS NULL
#define OPTION_VAL_TWB64_040_DMG_VER_CS NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_CS NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_CS NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CS "TWB64 043 - Miraitowa Modrá"
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_CS "TWB64 044 - Someity Růžová"
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CS "TWB64 045 - Pikachu Žlutá"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_CS "TWB64 046 - Eevee Hnědá"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_CS NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_CS NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_CS NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_CS NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CS NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CS NULL
#define OPTION_VAL_TWB64_053_VMU_VER_CS NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_CS NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_CS "TWB64 055 - Android Zelená"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CS "TWB64 056 - Ticketmaster Azurová"
#define OPTION_VAL_TWB64_057_GOOGLE_RED_CS "TWB64 057 - Google Červená"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_CS "TWB64 058 - Google Modrá"
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CS "TWB64 059 - Google Žlutá"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_CS "TWB64 060 - Google Zelená"
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_CS NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CS NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_CS NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_CS "TWB64 064 - Coca-Cola Červená"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_CS NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CS NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_CS NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CS NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_CS "TWB64 069 - Blossom Růžová"
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_CS "TWB64 070 - Bubbles Modrá"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CS "TWB64 071 - Buttercup Zelená"
#define OPTION_VAL_TWB64_072_NASCAR_VER_CS NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CS "TWB64 073 - Lemon-Lime Zelená"
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CS NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CS NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_CS "TWB64 076 - Phantom Červená"
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_CS NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_CS NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CS "TWB64 079 - Cardcaptor Růžová"
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CS "TWB64 080 - Pretty Guardian Zlatá"
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CS NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CS NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CS NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_CS NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CS "TWB64 085 - Zdokonalený ultra instinkt"
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CS "TWB64 086 - Saint Snow Červená"
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_CS "Banánově Žlutá"
#define OPTION_VAL_TWB64_088_GREEN_BANANA_CS "Banánově Zelená"
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CS NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CS "TWB64 090 - Super Saiyan Modrá Evolved"
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_CS NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CS "TWB64 092 - Investigation Žlutá"
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CS "TWB64 093 - S.E.E.S. Modrá"
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CS "TWB64 094 - Game Awards Azurová"
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CS "TWB64 095 - Hokage Oranžová"
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_CS "TWB64 096 - Straw Hat Červená"
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CS "TWB64 097 - Sword Art Azurová"
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CS "TWB64 098 - Deku Alpha Smaragdová"
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CS "TWB64 099 - Modrá Stripes Ver."
#define OPTION_VAL_TWB64_100_STONE_ORANGE_CS "TWB64 100 - Stone Oranžová"
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CS "> TWB64 - Balíček Palety 2"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CS "Vybere interní barevnou paletu, pokud je položka 'Interní Paleta' nastavena na hodnotu 'TWB64 - Pack 2'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_CS "TWB64 101 - 765PRO Růžová"
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CS "TWB64 102 - CINDERELLA Modrá"
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_CS "TWB64 103 - MILLION Žlutá!"
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_CS "TWB64 104 - SideM Zelená"
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CS "TWB64 105 - SHINY Nebesky Modrá"
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CS NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_CS "TWB64 107 - Yo-kai Růžová"
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_CS "TWB64 108 - Yo-kai Zelená"
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_CS "TWB64 109 - Yo-kai Modrá"
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CS "TWB64 110 - Yo-kai Fialová"
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_CS NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_CS NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_CS "TWB64 113 - Sakura Růžová"
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CS NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_CS NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CS "TWB64 116 - Zlatá Kiiro"
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_CS "TWB64 117 - Stříbrná Shiro"
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_CS "TWB64 118 - Fruity Oranžová"
#define OPTION_VAL_TWB64_119_AKB48_PINK_CS "TWB64 119 - AKB48 Růžová"
#define OPTION_VAL_TWB64_120_MIKU_BLUE_CS "TWB64 120 - Miku Modrá"
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CS "TWB64 121 - Fairy Tail Červená"
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CS "TWB64 122 - Survey Corps Hnědá"
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_CS "TWB64 123 - Island Zelená"
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CS "TWB64 124 - Mania Plus Zelená"
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CS "TWB64 125 - Ninja Turtle Zelená"
#define OPTION_VAL_TWB64_126_SLIME_BLUE_CS "TWB64 126 - Slime Modrá"
#define OPTION_VAL_TWB64_127_LIME_MIDORI_CS NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_CS NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_CS NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_CS "TWB64 130 - Royal Modrá"
#define OPTION_VAL_TWB64_131_NEON_PURPLE_CS "TWB64 131 - Neon Fialová"
#define OPTION_VAL_TWB64_132_NEON_ORANGE_CS "TWB64 132 - Neon Oranžová"
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CS NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_CS "TWB64 134 - Tokyo Červená"
#define OPTION_VAL_TWB64_135_PARIS_GOLD_CS "TWB64 135 - Paris Zlatá"
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_CS "TWB64 136 - Beijing Modrá"
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CS "TWB64 137 - Pac-Man Žlutá"
#define OPTION_VAL_TWB64_138_IRISH_GREEN_CS "TWB64 138 - Irish Zelená"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CS "TWB64 139 - Kakarot Oranžová"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CS "TWB64 140 - Dragon Ball Oranžová"
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CS "TWB64 141 - Christmas Zlatá"
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CS "TWB64 142 - Pepsi-Cola Modrá"
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CS "TWB64 143 - Bubblun Zelená"
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CS "TWB64 144 - Bobblun Modrá"
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CS NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CS "TWB64 146 - Olympic Zlatá"
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_CS "TWB64 147 - Value Oranžová"
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_CS "TWB64 148 - Liella Fialová!"
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CS "TWB64 149 - Olympic Stříbrná"
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CS "TWB64 150 - Olympic Bronzová"
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CS "TWB64 151 - ANA Nebesky Modrá"
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CS "TWB64 152 - Nijigasaki Oranžová"
#define OPTION_VAL_TWB64_153_HOLOBLUE_CS "TWB64 153 - HoloModrá"
#define OPTION_VAL_TWB64_154_WRESTLING_RED_CS "TWB64 154 - Wrestling Červená"
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CS "TWB64 155 - Yoshi Egg Zelená"
#define OPTION_VAL_TWB64_156_POKEDEX_RED_CS "TWB64 156 - Pokedex Červená"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CS "TWB64 157 - Disney Dream Modrá"
#define OPTION_VAL_TWB64_158_XBOX_GREEN_CS "TWB64 158 - Xbox Zelená"
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CS "TWB64 159 - Sonic Mega Modrá"
#define OPTION_VAL_TWB64_160_G4_ORANGE_CS "TWB64 160 - G4 Oranžová"
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_CS "TWB64 161 - Scarlett Zelená"
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_CS "TWB64 162 - Glitchy Modrá"
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_CS NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CS NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_CS NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_CS "TWB64 166 - Game and Zlatá"
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_CS "TWB64 167 - Smurfy Modrá"
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CS "TWB64 168 - Swampy Ogre Zelená"
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CS "TWB64 169 - Sailor Spinach Zelená"
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_CS "TWB64 170 - Shenron Zelená"
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_CS "TWB64 171 - Berserk Krvavá"
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CS "TWB64 172 - Super Star Růžová"
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CS NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_CS "TWB64 174 - Barbie Růžová"
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CS "TWB64 175 - Star Command Zelená"
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_CS NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_CS "TWB64 177 - Clover Zelená"
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_CS "TWB64 178 - Crash Oranžová"
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CS "TWB64 179 - Famicom Disk Žlutá"
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CS "TWB64 180 - Team Rocket Červená"
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CS "TWB64 181 - SEIKO Timer Žlutá"
#define OPTION_VAL_TWB64_182_PINK109_CS "TWB64 182 - RŮŽOVÁ109"
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_CS "TWB64 183 - Doraemon Modrá"
#define OPTION_VAL_TWB64_184_FURY_BLUE_CS "TWB64 184 - Fury Modrá"
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CS "TWB64 185 - Rockstar Oranžová"
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CS "TWB64 186 - Puyo Puyo Zelená"
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_CS "TWB64 187 - Susan G. Růžová"
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CS "TWB64 188 - Pizza Hut Červená"
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CS "TWB64 189 - Plumbob Zelená"
#define OPTION_VAL_TWB64_190_GRAND_IVORY_CS NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_CS "TWB64 191 - Demon's Zlatá"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CS "TWB64 192 - SEGA Tokyo Modrá"
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_CS "TWB64 193 - Champion Modrá"
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CS "TWB64 194 - DK Barrel Hnědá"
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_CS "TWB64 195 - Evangelion Zelená"
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CS "TWB64 196 - Equestrian Fialová"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_CS "TWB64 197 - Autobot Červená"
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CS "TWB64 198 - Niconico Sea Zelená"
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_CS "TWB64 199 - Duracell Měděná"
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CS "TWB64 200 - TOKYO SKYTREE CLOUDY MODRÁ"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CS "> PixelShift - Balíček Paleta 1"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CS "Vybere interní barevnou paletu, pokud je položka 'Interní paleta' nastavena na hodnotu 'PixelShift - Balíček 1'."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CS "PixelShift 01 - Arktická zelená"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CS NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CS NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CS "PixelShift 04 - Kamufláž"
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CS "PixelShift 05 - Čokoládová tyčinka"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_CS NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CS "PixelShift 07 - Cukrová vata"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CS "PixelShift 08 - Lehce zelená"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_CS "PixelShift 09 - Hračská"
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CS "PixelShift 10 - Světelný Game Boy"
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CS "PixelShift 11 - Kapesní Game Boy"
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CS "PixelShift 12 - Kapesní Game Boy Alt"
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CS "PixelShift 13 - Herní kapesní počítač"
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CS "PixelShift 14 - Hra a Sledovací míč"
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CS "PixelShift 15 - Modré podsvícení GB"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CS "PixelShift 16 - Vybledlé podsvícení GB"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CS "PixelShift 17 - Oranžové podsvícení GB"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CS "PixelShift 18 - Bílé podsvícení GB "
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CS "PixelShift 19 - Žlutotmavé podsvícení GB"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CS NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CS "PixelShift 21 - Lovec GB"
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CS "PixelShift 22 - Kiosek GB"
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CS "PixelShift 23 - Kiosek 2 GB"
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_CS "PixelShift 24 - Nový GB"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CS "PixelShift 25 - Zničený GB"
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_CS "PixelShift 26 - Starý GB"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CS NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CS "PixelShift 28 - Žluté vyprané podsvícení GB"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_CS "PixelShift 29 - Duch"
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CS "PixelShift 30 - Záře ve tmě"
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CS "PixelShift 31 - Zlatá lišta"
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CS NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CS "PixelShift 33 - Šedozelený mix"
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CS "PixelShift 34 - Chybějící"
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_CS NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CS "PixelShift 36 - Zpravodajství"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CS NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CS "PixelShift 38 - Kapesní dívka"
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CS "PixelShift 39 - Silueta"
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_CS "PixelShift 40 - Sluneční záře"
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CS "PixelShift 41 - Technické barvy"
#define OPTION_VAL_PIXELSHIFT_42_TRON_CS NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CS "PixelShift 43 - Vlnobití"
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CS NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_CS "PixelShift 45 - Přání"
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CS "Korekce Barev"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CS "Upraví výstupní barvy tak, aby odpovídaly zobrazení skutečného hardwaru Game Boy Color. 'Pouze GBC' zajišťuje, že korekce bude použita pouze při hraní her Game Boy Color nebo při použití palety Game Boy Color k barevné úpravě hry Game Boy. 'Vždy' aplikuje korekci barev na veškerý obsah a při použití interních barevných palet 'GB' nebo 'SGB' přinese neočekávané/podoptimální výsledky."
#define OPTION_VAL_GBC_ONLY_CS "Pouze GBC"
#define OPTION_VAL_ALWAYS_CS "Vždy"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CS "Režim Korekce Barev"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CS "Určuje metodu použitou při provádění korekce barev. 'Přesná' vytváří výstup téměř nerozeznatelný od skutečného LCD panelu Game Boy Color. 'Rychlá' pouze ztmavuje barvy a snižuje sytost a může být použita na hardwaru nižší třídy, pokud je metoda 'Přesná' příliš pomalá."
#define OPTION_VAL_ACCURATE_CS "Přesné"
#define OPTION_VAL_FAST_CS "Rychle"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CS "Korekce Barev - Pozice Čelního Světla"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CS "Simuluje fyzickou odezvu LCD panelu Game Boy Color při osvětlení z různých úhlů. 'Centrální' představuje standardní reprodukci barev. 'Nad Obrazovkou' zvyšuje jas. 'Pod Obrazovkou' snižuje jas. Toto nastavení se použije pouze tehdy, když je položka 'Režim Korekce Barev' nastavena na hodnotu 'Přesná'."
#define OPTION_VAL_CENTRAL_CS "Centrální"
#define OPTION_VAL_ABOVE_SCREEN_CS "Nad Obrazovkou"
#define OPTION_VAL_BELOW_SCREEN_CS "Pod Obrazovkou"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_CS "Úroveň Tmavého Filtru (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CS "Povolení snížení jasu na základě svítivosti. Lze použít k zamezení oslnění/únavy očí při hraní her s bílým pozadím, které jsou určeny pro zobrazení na nepodsvícené obrazovce Game Boy Color, a proto se mohou při zobrazení na moderní podsvícené obrazovce jevit jako nepříjemně jasné."
#define GAMBATTE_MIX_FRAMES_LABEL_CS "Prolínání Mezi-Snímku"
#define GAMBATTE_MIX_FRAMES_INFO_0_CS "Simuluje efekty duchů na LCD. 'Jednoduchý' provede mix aktuálního a předchozího snímku v poměru 50:50. 'LCD Ghosting' napodobuje přirozenou dobu odezvy LCD kombinací více vyrovnávací paměti snímků. Prolínání 'Jednoduchý' je nutné při hraní her, které se spoléhají na efekty průhlednosti LCD ghosting (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_CS "Jednoduchá"
#define OPTION_VAL_LCD_GHOSTING_CS "LCD Ghosting (Přesný)"
#define OPTION_VAL_LCD_GHOSTING_FAST_CS "LCD Ghosting (Rychlý)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_CS "Převzorkování Zvuku"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_CS "Určete, který algoritmus se má použít při převzorkování generovaného zvuku (rychlost zvuku Game Boy je omezena pouze rychlostí zápisu procesoru, takže \"nativní\" frekvence jsou na moderních zvukových zařízeních nepraktické a musí se snížit). Nejvyšší kvalitu poskytuje 'Sinus'. 'Kosinus' zlepšuje výkon na méně náročném hardwaru."
#define OPTION_VAL_SINC_CS "Sinus"
#define OPTION_VAL_CC_CS "Kosinus"
#define GAMBATTE_GB_HWMODE_LABEL_CS "Emulovaný Hardware (Vyžaduje Restart)"
#define GAMBATTE_GB_HWMODE_INFO_0_CS "Zadejte, který typ hardwaru se má emulovat. Doporučuje se 'Auto'. Výběrem možnosti 'GBA' se odemknou dodatečné funkce v některých hrách pro Game Boy Color s funkcí 'GBA Enhanced' (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_CS NULL
#define OPTION_VAL_GBA_CS NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_CS "Použít Oficiální Bootloader (Vyžaduje Restart)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_CS "Povolení podpory oficiálních zavaděčů Game Boy a Game Boy Color s odpovídajícími animacemi spouštěcího loga."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_CS NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CS "Povolení této funkce umožní střídavé stisknutí/rychlé podržení směru doleva a doprava (nebo nahoru a dolů) současně. To může způsobit závady založené na pohybu."
#define GAMBATTE_TURBO_PERIOD_LABEL_CS "Doba Turba Tlačítka"
#define GAMBATTE_TURBO_PERIOD_INFO_0_CS "Zadejte interval opakování (ve snímcích) při podržení tlačítek Turbo A/B."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_CS "Síla Vibrace Ovladače"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_CS "Povoluje efekty haptické zpětné vazby pro podporované hry (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CS "Zobrazit Nastavení Propojení Hry"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CS "Povolení konfigurace možností síťového propojení hry (multiplayer). POZNÁMKA: Aby se toto nastavení projevilo, může být nutné přepnout Rychlé Menu."
#define GAMBATTE_GB_LINK_MODE_LABEL_CS "Režim Propojení Hry"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_CS "Režim Propojení"
#define GAMBATTE_GB_LINK_MODE_INFO_0_CS "Při povolování funkce síťového propojení her zadejte, zda má aktuální instance běžet jako server nebo klient."
#define OPTION_VAL_NOT_CONNECTED_CS "Nepřipojeno"
#define OPTION_VAL_NETWORK_SERVER_CS "Síťový Server"
#define OPTION_VAL_NETWORK_CLIENT_CS "Síťový Klient"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CS "Port Síťového Propojení"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CS NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CS "Zadejte port používaný pro síťovou komunikaci Propojení Hry."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CS "Adresa Serveru Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CS "1. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CS "1. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CS "Adresa Serveru Pt. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CS "2. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CS "2. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CS "Adresa Serveru Pt. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CS "3. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CS "3. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CS "Adresa Serveru Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CS "4. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CS "4. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CS "Adresa Serveru Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CS "5. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CS "5. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CS "Adresa Serveru Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CS "6. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CS "6. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CS "Adresa Serveru Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CS "7. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CS "7. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CS "Adresa Serveru Pt. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CS "8. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CS "8. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CS "Adresa Serveru Pt. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CS "9. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CS "9. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CS "Adresa Serveru Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CS "10. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CS "10. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CS "Adresa Serveru Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CS "11. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CS "11. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CS "Adresa Serveru Síťového Připojení Pt. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CS "Adresa Serveru Pt. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CS "12. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení Hry' nastavena na 'Síťový Klient'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CS "12. číslice IP adresy vzdáleného síťového serveru Propojení Hry. Používá se pouze v případě, že je položka 'Režim Propojení' nastavena na 'Síťový Klient'."

struct retro_core_option_v2_category option_cats_cs[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_CS,
      CATEGORY_GB_LINK_INFO_0_CS
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_cs[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_CS,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_CS,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_CS },
         { "GBC",      OPTION_VAL_GBC_CS },
         { "SGB",      OPTION_VAL_SGB_CS },
         { "internal", OPTION_VAL_INTERNAL_CS },
         { "custom",   OPTION_VAL_CUSTOM_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CS,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CS,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_CS },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_CS },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_CS },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_CS },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_CS },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_CS },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_CS },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_CS },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_CS },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_CS },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_CS },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_CS },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_CS },
         { "GBC - Red",                OPTION_VAL_GBC_RED_CS },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_CS },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_CS },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_CS },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_CS },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_CS },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_CS },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_CS },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_CS },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_CS },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_CS },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_CS },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_CS },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_CS },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_CS },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_CS },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_CS },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_CS },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_CS },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_CS },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_CS },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_CS },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_CS },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_CS },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_CS },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_CS },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_CS },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_CS },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_CS },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_CS },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_CS },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_CS },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_CS },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_CS },
         { "Special 1",                OPTION_VAL_SPECIAL_1_CS },
         { "Special 2",                OPTION_VAL_SPECIAL_2_CS },
         { "Special 3",                OPTION_VAL_SPECIAL_3_CS },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CS },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_CS },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_CS },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_CS },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CS,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CS,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_CS },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CS },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CS },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CS },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_CS },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_CS },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_CS },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_CS },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_CS },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_CS },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_CS },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CS },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_CS },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_CS },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CS },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CS },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CS },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CS },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_CS },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CS },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_CS },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_CS },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CS },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CS },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CS },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_CS },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CS },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_CS },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_CS },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CS },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_CS },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_CS },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CS },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_CS },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_CS },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CS },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CS },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CS },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_CS },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_CS },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_CS },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_CS },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CS },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_CS },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CS },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_CS },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_CS },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_CS },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_CS },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_CS },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CS },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CS },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_CS },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_CS },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_CS },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CS },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_CS },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_CS },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CS },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_CS },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_CS },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CS },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_CS },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_CS },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_CS },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CS },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_CS },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CS },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_CS },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_CS },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CS },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_CS },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CS },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CS },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CS },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_CS },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_CS },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_CS },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CS },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CS },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CS },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CS },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CS },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_CS },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CS },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CS },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_CS },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_CS },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CS },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CS },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_CS },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CS },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CS },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CS },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CS },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_CS },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CS },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CS },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CS },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_CS },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CS,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CS,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_CS },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CS },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_CS },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_CS },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CS },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CS },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_CS },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_CS },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_CS },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CS },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_CS },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_CS },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_CS },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CS },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_CS },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CS },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_CS },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_CS },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_CS },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_CS },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CS },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CS },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_CS },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CS },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CS },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_CS },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_CS },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_CS },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_CS },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_CS },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_CS },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_CS },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CS },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_CS },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_CS },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_CS },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CS },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_CS },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CS },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CS },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CS },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CS },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CS },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CS },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CS },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CS },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_CS },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_CS },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CS },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CS },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CS },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CS },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_CS },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_CS },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CS },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_CS },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CS },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_CS },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CS },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_CS },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_CS },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_CS },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_CS },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CS },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_CS },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_CS },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_CS },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CS },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CS },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_CS },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_CS },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CS },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CS },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_CS },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CS },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_CS },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_CS },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_CS },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CS },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CS },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CS },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_CS },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_CS },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_CS },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CS },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CS },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_CS },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CS },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CS },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_CS },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_CS },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CS },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_CS },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CS },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_CS },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CS },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_CS },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CS },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_CS },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CS },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CS,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CS,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CS },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CS },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CS },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CS },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CS },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_CS },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CS },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CS },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_CS },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CS },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CS },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CS },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CS },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CS },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CS },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CS },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CS },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CS },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CS },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CS },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CS },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CS },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CS },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_CS },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CS },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_CS },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CS },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CS },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_CS },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CS },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CS },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CS },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CS },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CS },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_CS },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CS },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CS },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CS },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CS },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_CS },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CS },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_CS },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CS },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CS },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_CS },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CS,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CS,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_CS },
         { "always",   OPTION_VAL_ALWAYS_CS },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CS,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CS,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_CS },
         { "fast",     OPTION_VAL_FAST_CS },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CS,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CS,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_CS },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_CS },
         { "below screen", OPTION_VAL_BELOW_SCREEN_CS },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_CS,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CS,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_CS,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_CS,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_CS },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_CS },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_CS },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_CS,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_CS,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_CS },
         { "cc",   OPTION_VAL_CC_CS },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_CS,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_CS,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_CS },
         { "GB",   OPTION_VAL_GB_CS },
         { "GBC",  OPTION_VAL_GBC_CS },
         { "GBA",  OPTION_VAL_GBA_CS },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_CS,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_CS,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_CS,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CS,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_CS,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_CS,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_CS,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_CS,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CS,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CS,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_CS,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_MODE_INFO_0_CS,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_CS },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_CS },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_CS },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CS,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CS,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CS,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_cs = {
   option_cats_cs,
   option_defs_cs
};

/* RETRO_LANGUAGE_CY */

#define CATEGORY_GB_LINK_LABEL_CY NULL
#define CATEGORY_GB_LINK_INFO_0_CY NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_CY NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_CY NULL
#define OPTION_VAL_AUTO_CY NULL
#define OPTION_VAL_GBC_CY NULL
#define OPTION_VAL_SGB_CY NULL
#define OPTION_VAL_INTERNAL_CY NULL
#define OPTION_VAL_CUSTOM_CY NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CY NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CY NULL
#define OPTION_VAL_GB_DMG_CY NULL
#define OPTION_VAL_GB_POCKET_CY NULL
#define OPTION_VAL_GB_LIGHT_CY NULL
#define OPTION_VAL_GBC_BLUE_CY NULL
#define OPTION_VAL_GBC_BROWN_CY NULL
#define OPTION_VAL_GBC_DARK_BLUE_CY NULL
#define OPTION_VAL_GBC_DARK_BROWN_CY NULL
#define OPTION_VAL_GBC_DARK_GREEN_CY NULL
#define OPTION_VAL_GBC_GRAYSCALE_CY NULL
#define OPTION_VAL_GBC_GREEN_CY NULL
#define OPTION_VAL_GBC_INVERTED_CY NULL
#define OPTION_VAL_GBC_ORANGE_CY NULL
#define OPTION_VAL_GBC_PASTEL_MIX_CY NULL
#define OPTION_VAL_GBC_RED_CY NULL
#define OPTION_VAL_GBC_YELLOW_CY NULL
#define OPTION_VAL_SGB_1A_CY NULL
#define OPTION_VAL_SGB_1B_CY NULL
#define OPTION_VAL_SGB_1C_CY NULL
#define OPTION_VAL_SGB_1D_CY NULL
#define OPTION_VAL_SGB_1E_CY NULL
#define OPTION_VAL_SGB_1F_CY NULL
#define OPTION_VAL_SGB_1G_CY NULL
#define OPTION_VAL_SGB_1H_CY NULL
#define OPTION_VAL_SGB_2A_CY NULL
#define OPTION_VAL_SGB_2B_CY NULL
#define OPTION_VAL_SGB_2C_CY NULL
#define OPTION_VAL_SGB_2D_CY NULL
#define OPTION_VAL_SGB_2E_CY NULL
#define OPTION_VAL_SGB_2F_CY NULL
#define OPTION_VAL_SGB_2G_CY NULL
#define OPTION_VAL_SGB_2H_CY NULL
#define OPTION_VAL_SGB_3A_CY NULL
#define OPTION_VAL_SGB_3B_CY NULL
#define OPTION_VAL_SGB_3C_CY NULL
#define OPTION_VAL_SGB_3D_CY NULL
#define OPTION_VAL_SGB_3E_CY NULL
#define OPTION_VAL_SGB_3F_CY NULL
#define OPTION_VAL_SGB_3G_CY NULL
#define OPTION_VAL_SGB_3H_CY NULL
#define OPTION_VAL_SGB_4A_CY NULL
#define OPTION_VAL_SGB_4B_CY NULL
#define OPTION_VAL_SGB_4C_CY NULL
#define OPTION_VAL_SGB_4D_CY NULL
#define OPTION_VAL_SGB_4E_CY NULL
#define OPTION_VAL_SGB_4F_CY NULL
#define OPTION_VAL_SGB_4G_CY NULL
#define OPTION_VAL_SGB_4H_CY NULL
#define OPTION_VAL_SPECIAL_1_CY NULL
#define OPTION_VAL_SPECIAL_2_CY NULL
#define OPTION_VAL_SPECIAL_3_CY NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CY NULL
#define OPTION_VAL_TWB64_PACK_1_CY NULL
#define OPTION_VAL_TWB64_PACK_2_CY NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_CY NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CY NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CY NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_CY NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CY NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CY NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CY NULL
#define OPTION_VAL_TWB64_005_NEON_RED_CY NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_CY NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_CY NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_CY NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_CY NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_CY NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_CY NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CY NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_CY NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_CY NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CY NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CY NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CY NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CY NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_CY NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CY NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_CY NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_CY NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CY NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CY NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CY NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_CY NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CY NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_CY NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_CY NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CY NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_CY NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_CY NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CY NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_CY NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_CY NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CY NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CY NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CY NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_CY NULL
#define OPTION_VAL_TWB64_040_DMG_VER_CY NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_CY NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_CY NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CY NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_CY NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CY NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_CY NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_CY NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_CY NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_CY NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_CY NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CY NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CY NULL
#define OPTION_VAL_TWB64_053_VMU_VER_CY NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_CY NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_CY NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CY NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_CY NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_CY NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CY NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_CY NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_CY NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CY NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_CY NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_CY NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_CY NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CY NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_CY NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CY NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_CY NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_CY NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CY NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_CY NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CY NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CY NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CY NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_CY NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_CY NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_CY NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CY NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CY NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CY NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CY NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CY NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_CY NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CY NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CY NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_CY NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_CY NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CY NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CY NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_CY NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CY NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CY NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CY NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CY NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_CY NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CY NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CY NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CY NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_CY NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CY NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CY NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_CY NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CY NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_CY NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_CY NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CY NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CY NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_CY NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_CY NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_CY NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CY NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_CY NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_CY NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_CY NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CY NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_CY NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CY NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_CY NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_CY NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_CY NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_CY NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CY NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CY NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_CY NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CY NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CY NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_CY NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_CY NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_CY NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_CY NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_CY NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_CY NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_CY NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CY NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_CY NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_CY NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_CY NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CY NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_CY NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CY NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CY NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CY NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CY NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CY NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CY NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CY NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CY NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_CY NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_CY NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CY NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CY NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CY NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CY NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_CY NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_CY NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CY NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_CY NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CY NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_CY NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CY NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_CY NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_CY NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_CY NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_CY NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CY NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_CY NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_CY NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_CY NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CY NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CY NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_CY NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_CY NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CY NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CY NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_CY NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CY NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_CY NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_CY NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_CY NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CY NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CY NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CY NULL
#define OPTION_VAL_TWB64_182_PINK109_CY NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_CY NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_CY NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CY NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CY NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_CY NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CY NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CY NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_CY NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_CY NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CY NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_CY NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CY NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_CY NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CY NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_CY NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CY NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_CY NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CY NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CY NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CY NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CY NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CY NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CY NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CY NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CY NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_CY NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CY NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CY NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_CY NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CY NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CY NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CY NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CY NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CY NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CY NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CY NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CY NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CY NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CY NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CY NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CY NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CY NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CY NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_CY NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CY NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_CY NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CY NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CY NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_CY NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CY NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CY NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CY NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CY NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CY NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_CY NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CY NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CY NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CY NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CY NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_CY NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CY NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_CY NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CY NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CY NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_CY NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CY NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CY NULL
#define OPTION_VAL_GBC_ONLY_CY NULL
#define OPTION_VAL_ALWAYS_CY NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CY NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CY NULL
#define OPTION_VAL_ACCURATE_CY NULL
#define OPTION_VAL_FAST_CY NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CY NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CY NULL
#define OPTION_VAL_CENTRAL_CY NULL
#define OPTION_VAL_ABOVE_SCREEN_CY NULL
#define OPTION_VAL_BELOW_SCREEN_CY NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_CY NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CY NULL
#define GAMBATTE_MIX_FRAMES_LABEL_CY NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_CY NULL
#define OPTION_VAL_MIX_CY NULL
#define OPTION_VAL_LCD_GHOSTING_CY NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_CY NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_CY NULL
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_CY NULL
#define OPTION_VAL_SINC_CY NULL
#define OPTION_VAL_CC_CY NULL
#define GAMBATTE_GB_HWMODE_LABEL_CY NULL
#define GAMBATTE_GB_HWMODE_INFO_0_CY NULL
#define OPTION_VAL_GB_CY NULL
#define OPTION_VAL_GBA_CY NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_CY NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_CY NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_CY NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CY NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_CY NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_CY NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_CY NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_CY NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CY NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CY NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_CY NULL
#define OPTION_VAL_NOT_CONNECTED_CY NULL
#define OPTION_VAL_NETWORK_SERVER_CY NULL
#define OPTION_VAL_NETWORK_CLIENT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CY NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CY NULL

struct retro_core_option_v2_category option_cats_cy[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_CY,
      CATEGORY_GB_LINK_INFO_0_CY
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_cy[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_CY,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_CY,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_CY },
         { "GBC",      OPTION_VAL_GBC_CY },
         { "SGB",      OPTION_VAL_SGB_CY },
         { "internal", OPTION_VAL_INTERNAL_CY },
         { "custom",   OPTION_VAL_CUSTOM_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_CY,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_CY,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_CY },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_CY },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_CY },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_CY },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_CY },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_CY },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_CY },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_CY },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_CY },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_CY },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_CY },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_CY },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_CY },
         { "GBC - Red",                OPTION_VAL_GBC_RED_CY },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_CY },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_CY },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_CY },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_CY },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_CY },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_CY },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_CY },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_CY },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_CY },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_CY },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_CY },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_CY },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_CY },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_CY },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_CY },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_CY },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_CY },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_CY },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_CY },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_CY },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_CY },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_CY },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_CY },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_CY },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_CY },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_CY },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_CY },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_CY },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_CY },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_CY },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_CY },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_CY },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_CY },
         { "Special 1",                OPTION_VAL_SPECIAL_1_CY },
         { "Special 2",                OPTION_VAL_SPECIAL_2_CY },
         { "Special 3",                OPTION_VAL_SPECIAL_3_CY },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_CY },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_CY },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_CY },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_CY },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_CY,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_CY,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_CY },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_CY },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_CY },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_CY },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_CY },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_CY },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_CY },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_CY },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_CY },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_CY },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_CY },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_CY },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_CY },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_CY },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_CY },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_CY },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_CY },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_CY },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_CY },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_CY },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_CY },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_CY },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_CY },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_CY },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_CY },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_CY },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_CY },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_CY },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_CY },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_CY },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_CY },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_CY },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_CY },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_CY },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_CY },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_CY },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_CY },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_CY },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_CY },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_CY },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_CY },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_CY },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_CY },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_CY },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_CY },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_CY },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_CY },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_CY },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_CY },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_CY },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_CY },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_CY },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_CY },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_CY },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_CY },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_CY },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_CY },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_CY },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_CY },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_CY },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_CY },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_CY },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_CY },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_CY },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_CY },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_CY },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_CY },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_CY },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_CY },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_CY },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_CY },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_CY },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_CY },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_CY },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_CY },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_CY },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_CY },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_CY },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_CY },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_CY },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_CY },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_CY },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_CY },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_CY },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_CY },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_CY },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_CY },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_CY },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_CY },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_CY },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_CY },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_CY },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_CY },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_CY },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_CY },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_CY },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_CY },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_CY },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_CY },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_CY },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_CY,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_CY,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_CY },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_CY },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_CY },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_CY },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_CY },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_CY },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_CY },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_CY },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_CY },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_CY },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_CY },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_CY },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_CY },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_CY },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_CY },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_CY },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_CY },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_CY },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_CY },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_CY },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_CY },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_CY },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_CY },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_CY },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_CY },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_CY },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_CY },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_CY },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_CY },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_CY },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_CY },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_CY },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_CY },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_CY },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_CY },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_CY },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_CY },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_CY },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_CY },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_CY },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_CY },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_CY },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_CY },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_CY },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_CY },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_CY },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_CY },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_CY },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_CY },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_CY },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_CY },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_CY },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_CY },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_CY },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_CY },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_CY },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_CY },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_CY },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_CY },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_CY },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_CY },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_CY },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_CY },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_CY },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_CY },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_CY },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_CY },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_CY },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_CY },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_CY },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_CY },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_CY },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_CY },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_CY },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_CY },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_CY },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_CY },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_CY },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_CY },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_CY },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_CY },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_CY },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_CY },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_CY },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_CY },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_CY },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_CY },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_CY },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_CY },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_CY },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_CY },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_CY },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_CY },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_CY },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_CY },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_CY },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_CY },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_CY },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_CY },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_CY },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_CY,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_CY,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_CY },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_CY },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_CY },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_CY },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_CY },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_CY },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_CY },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_CY },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_CY },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_CY },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_CY },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_CY },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_CY },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_CY },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_CY },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_CY },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_CY },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__CY },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_CY },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_CY },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_CY },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_CY },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_CY },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_CY },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_CY },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_CY },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_CY },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_CY },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_CY },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_CY },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_CY },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_CY },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_CY },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_CY },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_CY },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_CY },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_CY },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_CY },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_CY },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_CY },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_CY },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_CY },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_CY },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_CY },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_CY },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_CY,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_CY,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_CY },
         { "always",   OPTION_VAL_ALWAYS_CY },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_CY,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_CY,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_CY },
         { "fast",     OPTION_VAL_FAST_CY },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_CY,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_CY,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_CY },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_CY },
         { "below screen", OPTION_VAL_BELOW_SCREEN_CY },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_CY,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_CY,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_CY,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_CY,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_CY },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_CY },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_CY },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_CY,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_CY,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_CY },
         { "cc",   OPTION_VAL_CC_CY },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_CY,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_CY,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_CY },
         { "GB",   OPTION_VAL_GB_CY },
         { "GBC",  OPTION_VAL_GBC_CY },
         { "GBA",  OPTION_VAL_GBA_CY },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_CY,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_CY,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_CY,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_CY,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_CY,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_CY,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_CY,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_CY,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_CY,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_CY,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_CY,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_MODE_INFO_0_CY,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_CY },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_CY },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_CY },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_CY,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_CY,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_CY,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_cy = {
   option_cats_cy,
   option_defs_cy
};

/* RETRO_LANGUAGE_DA */

#define CATEGORY_GB_LINK_LABEL_DA NULL
#define CATEGORY_GB_LINK_INFO_0_DA NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_DA NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_DA NULL
#define OPTION_VAL_AUTO_DA NULL
#define OPTION_VAL_GBC_DA NULL
#define OPTION_VAL_SGB_DA NULL
#define OPTION_VAL_INTERNAL_DA NULL
#define OPTION_VAL_CUSTOM_DA NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_DA NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_DA NULL
#define OPTION_VAL_GB_DMG_DA NULL
#define OPTION_VAL_GB_POCKET_DA NULL
#define OPTION_VAL_GB_LIGHT_DA NULL
#define OPTION_VAL_GBC_BLUE_DA NULL
#define OPTION_VAL_GBC_BROWN_DA NULL
#define OPTION_VAL_GBC_DARK_BLUE_DA NULL
#define OPTION_VAL_GBC_DARK_BROWN_DA NULL
#define OPTION_VAL_GBC_DARK_GREEN_DA NULL
#define OPTION_VAL_GBC_GRAYSCALE_DA NULL
#define OPTION_VAL_GBC_GREEN_DA NULL
#define OPTION_VAL_GBC_INVERTED_DA NULL
#define OPTION_VAL_GBC_ORANGE_DA NULL
#define OPTION_VAL_GBC_PASTEL_MIX_DA NULL
#define OPTION_VAL_GBC_RED_DA NULL
#define OPTION_VAL_GBC_YELLOW_DA NULL
#define OPTION_VAL_SGB_1A_DA NULL
#define OPTION_VAL_SGB_1B_DA NULL
#define OPTION_VAL_SGB_1C_DA NULL
#define OPTION_VAL_SGB_1D_DA NULL
#define OPTION_VAL_SGB_1E_DA NULL
#define OPTION_VAL_SGB_1F_DA NULL
#define OPTION_VAL_SGB_1G_DA NULL
#define OPTION_VAL_SGB_1H_DA NULL
#define OPTION_VAL_SGB_2A_DA NULL
#define OPTION_VAL_SGB_2B_DA NULL
#define OPTION_VAL_SGB_2C_DA NULL
#define OPTION_VAL_SGB_2D_DA NULL
#define OPTION_VAL_SGB_2E_DA NULL
#define OPTION_VAL_SGB_2F_DA NULL
#define OPTION_VAL_SGB_2G_DA NULL
#define OPTION_VAL_SGB_2H_DA NULL
#define OPTION_VAL_SGB_3A_DA NULL
#define OPTION_VAL_SGB_3B_DA NULL
#define OPTION_VAL_SGB_3C_DA NULL
#define OPTION_VAL_SGB_3D_DA NULL
#define OPTION_VAL_SGB_3E_DA NULL
#define OPTION_VAL_SGB_3F_DA NULL
#define OPTION_VAL_SGB_3G_DA NULL
#define OPTION_VAL_SGB_3H_DA NULL
#define OPTION_VAL_SGB_4A_DA NULL
#define OPTION_VAL_SGB_4B_DA NULL
#define OPTION_VAL_SGB_4C_DA NULL
#define OPTION_VAL_SGB_4D_DA NULL
#define OPTION_VAL_SGB_4E_DA NULL
#define OPTION_VAL_SGB_4F_DA NULL
#define OPTION_VAL_SGB_4G_DA NULL
#define OPTION_VAL_SGB_4H_DA NULL
#define OPTION_VAL_SPECIAL_1_DA NULL
#define OPTION_VAL_SPECIAL_2_DA NULL
#define OPTION_VAL_SPECIAL_3_DA NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_DA NULL
#define OPTION_VAL_TWB64_PACK_1_DA NULL
#define OPTION_VAL_TWB64_PACK_2_DA NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_DA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_DA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_DA NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_DA NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_DA NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_DA NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_DA NULL
#define OPTION_VAL_TWB64_005_NEON_RED_DA NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_DA NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_DA NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_DA NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_DA NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_DA NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_DA NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_DA NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_DA NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_DA NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_DA NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_DA NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_DA NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_DA NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_DA NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_DA NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_DA NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_DA NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_DA NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_DA NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_DA NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_DA NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_DA NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_DA NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_DA NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_DA NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_DA NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_DA NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_DA NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_DA NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_DA NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_DA NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_DA NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_DA NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_DA NULL
#define OPTION_VAL_TWB64_040_DMG_VER_DA NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_DA NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_DA NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_DA NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_DA NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_DA NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_DA NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_DA NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_DA NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_DA NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_DA NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_DA NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_DA NULL
#define OPTION_VAL_TWB64_053_VMU_VER_DA NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_DA NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_DA NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_DA NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_DA NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_DA NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_DA NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_DA NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_DA NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_DA NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_DA NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_DA NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_DA NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_DA NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_DA NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_DA NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_DA NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_DA NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_DA NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_DA NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_DA NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_DA NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_DA NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_DA NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_DA NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_DA NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_DA NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_DA NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_DA NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_DA NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_DA NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_DA NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_DA NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_DA NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_DA NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_DA NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_DA NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_DA NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_DA NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_DA NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_DA NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_DA NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_DA NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_DA NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_DA NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_DA NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_DA NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_DA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_DA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_DA NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_DA NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_DA NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_DA NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_DA NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_DA NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_DA NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_DA NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_DA NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_DA NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_DA NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_DA NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_DA NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_DA NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_DA NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_DA NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_DA NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_DA NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_DA NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_DA NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_DA NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_DA NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_DA NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_DA NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_DA NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_DA NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_DA NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_DA NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_DA NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_DA NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_DA NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_DA NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_DA NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_DA NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_DA NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_DA NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_DA NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_DA NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_DA NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_DA NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_DA NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_DA NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_DA NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_DA NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_DA NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_DA NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_DA NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_DA NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_DA NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_DA NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_DA NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_DA NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_DA NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_DA NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_DA NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_DA NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_DA NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_DA NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_DA NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_DA NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_DA NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_DA NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_DA NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_DA NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_DA NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_DA NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_DA NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_DA NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_DA NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_DA NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_DA NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_DA NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_DA NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_DA NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_DA NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_DA NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_DA NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_DA NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_DA NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_DA NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_DA NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_DA NULL
#define OPTION_VAL_TWB64_182_PINK109_DA NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_DA NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_DA NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_DA NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_DA NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_DA NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_DA NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_DA NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_DA NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_DA NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_DA NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_DA NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_DA NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_DA NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_DA NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_DA NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_DA NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_DA NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_DA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_DA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_DA NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_DA NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_DA NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_DA NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_DA NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_DA NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_DA NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_DA NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_DA NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_DA NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_DA NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_DA NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_DA NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_DA NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_DA NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_DA NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_DA NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_DA NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__DA NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_DA NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_DA NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_DA NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_DA NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_DA NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_DA NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_DA NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_DA NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_DA NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_DA NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_DA NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_DA NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_DA NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_DA NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_DA NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_DA NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_DA NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_DA NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_DA NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_DA NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_DA NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_DA NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_DA NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_DA NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_DA NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_DA NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_DA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_DA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_DA NULL
#define OPTION_VAL_GBC_ONLY_DA NULL
#define OPTION_VAL_ALWAYS_DA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_DA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_DA NULL
#define OPTION_VAL_ACCURATE_DA NULL
#define OPTION_VAL_FAST_DA NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_DA NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_DA NULL
#define OPTION_VAL_CENTRAL_DA NULL
#define OPTION_VAL_ABOVE_SCREEN_DA NULL
#define OPTION_VAL_BELOW_SCREEN_DA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_DA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_DA NULL
#define GAMBATTE_MIX_FRAMES_LABEL_DA NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_DA NULL
#define OPTION_VAL_MIX_DA NULL
#define OPTION_VAL_LCD_GHOSTING_DA NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_DA NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_DA "Lyd resampler"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_DA NULL
#define OPTION_VAL_SINC_DA NULL
#define OPTION_VAL_CC_DA NULL
#define GAMBATTE_GB_HWMODE_LABEL_DA NULL
#define GAMBATTE_GB_HWMODE_INFO_0_DA NULL
#define OPTION_VAL_GB_DA NULL
#define OPTION_VAL_GBA_DA NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_DA NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_DA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_DA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_DA NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_DA NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_DA NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_DA NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_DA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_DA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_DA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_DA NULL
#define OPTION_VAL_NOT_CONNECTED_DA NULL
#define OPTION_VAL_NETWORK_SERVER_DA NULL
#define OPTION_VAL_NETWORK_CLIENT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_DA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_DA NULL

struct retro_core_option_v2_category option_cats_da[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_DA,
      CATEGORY_GB_LINK_INFO_0_DA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_da[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_DA,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_DA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_DA },
         { "GBC",      OPTION_VAL_GBC_DA },
         { "SGB",      OPTION_VAL_SGB_DA },
         { "internal", OPTION_VAL_INTERNAL_DA },
         { "custom",   OPTION_VAL_CUSTOM_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_DA,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_DA,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_DA },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_DA },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_DA },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_DA },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_DA },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_DA },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_DA },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_DA },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_DA },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_DA },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_DA },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_DA },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_DA },
         { "GBC - Red",                OPTION_VAL_GBC_RED_DA },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_DA },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_DA },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_DA },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_DA },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_DA },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_DA },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_DA },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_DA },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_DA },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_DA },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_DA },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_DA },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_DA },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_DA },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_DA },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_DA },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_DA },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_DA },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_DA },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_DA },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_DA },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_DA },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_DA },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_DA },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_DA },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_DA },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_DA },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_DA },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_DA },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_DA },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_DA },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_DA },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_DA },
         { "Special 1",                OPTION_VAL_SPECIAL_1_DA },
         { "Special 2",                OPTION_VAL_SPECIAL_2_DA },
         { "Special 3",                OPTION_VAL_SPECIAL_3_DA },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_DA },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_DA },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_DA },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_DA },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_DA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_DA,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_DA },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_DA },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_DA },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_DA },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_DA },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_DA },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_DA },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_DA },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_DA },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_DA },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_DA },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_DA },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_DA },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_DA },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_DA },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_DA },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_DA },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_DA },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_DA },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_DA },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_DA },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_DA },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_DA },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_DA },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_DA },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_DA },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_DA },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_DA },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_DA },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_DA },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_DA },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_DA },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_DA },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_DA },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_DA },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_DA },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_DA },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_DA },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_DA },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_DA },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_DA },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_DA },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_DA },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_DA },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_DA },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_DA },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_DA },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_DA },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_DA },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_DA },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_DA },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_DA },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_DA },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_DA },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_DA },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_DA },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_DA },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_DA },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_DA },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_DA },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_DA },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_DA },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_DA },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_DA },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_DA },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_DA },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_DA },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_DA },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_DA },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_DA },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_DA },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_DA },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_DA },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_DA },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_DA },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_DA },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_DA },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_DA },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_DA },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_DA },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_DA },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_DA },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_DA },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_DA },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_DA },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_DA },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_DA },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_DA },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_DA },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_DA },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_DA },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_DA },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_DA },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_DA },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_DA },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_DA },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_DA },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_DA },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_DA },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_DA },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_DA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_DA,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_DA },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_DA },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_DA },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_DA },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_DA },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_DA },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_DA },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_DA },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_DA },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_DA },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_DA },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_DA },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_DA },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_DA },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_DA },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_DA },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_DA },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_DA },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_DA },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_DA },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_DA },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_DA },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_DA },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_DA },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_DA },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_DA },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_DA },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_DA },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_DA },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_DA },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_DA },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_DA },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_DA },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_DA },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_DA },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_DA },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_DA },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_DA },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_DA },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_DA },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_DA },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_DA },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_DA },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_DA },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_DA },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_DA },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_DA },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_DA },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_DA },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_DA },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_DA },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_DA },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_DA },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_DA },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_DA },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_DA },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_DA },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_DA },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_DA },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_DA },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_DA },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_DA },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_DA },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_DA },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_DA },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_DA },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_DA },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_DA },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_DA },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_DA },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_DA },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_DA },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_DA },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_DA },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_DA },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_DA },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_DA },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_DA },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_DA },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_DA },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_DA },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_DA },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_DA },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_DA },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_DA },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_DA },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_DA },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_DA },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_DA },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_DA },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_DA },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_DA },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_DA },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_DA },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_DA },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_DA },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_DA },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_DA },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_DA },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_DA },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_DA,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_DA,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_DA },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_DA },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_DA },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_DA },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_DA },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_DA },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_DA },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_DA },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_DA },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_DA },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_DA },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_DA },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_DA },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_DA },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_DA },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_DA },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_DA },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__DA },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_DA },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_DA },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_DA },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_DA },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_DA },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_DA },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_DA },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_DA },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_DA },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_DA },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_DA },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_DA },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_DA },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_DA },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_DA },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_DA },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_DA },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_DA },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_DA },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_DA },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_DA },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_DA },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_DA },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_DA },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_DA },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_DA },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_DA },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_DA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_DA,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_DA },
         { "always",   OPTION_VAL_ALWAYS_DA },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_DA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_DA,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_DA },
         { "fast",     OPTION_VAL_FAST_DA },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_DA,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_DA,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_DA },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_DA },
         { "below screen", OPTION_VAL_BELOW_SCREEN_DA },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_DA,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_DA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_DA,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_DA,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_DA },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_DA },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_DA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_DA,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_DA,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_DA },
         { "cc",   OPTION_VAL_CC_DA },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_DA,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_DA,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_DA },
         { "GB",   OPTION_VAL_GB_DA },
         { "GBC",  OPTION_VAL_GBC_DA },
         { "GBA",  OPTION_VAL_GBA_DA },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_DA,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_DA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_DA,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_DA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_DA,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_DA,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_DA,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_DA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_DA,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_DA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_DA,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_MODE_INFO_0_DA,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_DA },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_DA },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_DA },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_DA,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_DA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_DA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_da = {
   option_cats_da,
   option_defs_da
};

/* RETRO_LANGUAGE_DE */

#define CATEGORY_GB_LINK_LABEL_DE "Spiel-Link"
#define CATEGORY_GB_LINK_INFO_0_DE "Konfiguriert vernetzte \"Game Boy Spiele Link\" (Mehrspieler) Optionen."
#define GAMBATTE_GB_COLORIZATION_LABEL_DE "GB-Einfärbung"
#define GAMBATTE_GB_COLORIZATION_INFO_0_DE "Aktiviert die Einfärbung von Game Boy Spielen. 'Automatisch' wählt die 'beste' (am buntesten/angemessenste) Palette. 'GBC' wählt spielspezifische Game Boy Color Palette aus, wenn sie definiert ist, ansonsten 'GBC - Dunkelgrün'. 'SGB' wählt spielspezifische Super Game Boy Palette falls definiert, ansonsten 'SGB - 1A'. 'Intern' verwendet 'Interne Farbpalette' Core-Einstellung. 'Benutzerdefiniert' lädt benutzerdefinierte Palette aus dem Systemverzeichnis."
#define OPTION_VAL_AUTO_DE NULL
#define OPTION_VAL_GBC_DE NULL
#define OPTION_VAL_SGB_DE NULL
#define OPTION_VAL_INTERNAL_DE "Intern"
#define OPTION_VAL_CUSTOM_DE "Benutzerdefiniert"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_DE "Interne Farbpalette"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_DE "Wählt die Farbpalette, die für das Einfärben von Game-Boy-Spielen genutzt wird wenn \"GB-Einfärbung\" auf \"Intern\" gestellt ist, oder wenn \"GB-Einfärbung\" auf \"Automatisch\" gestellt ist und das Spiel keine definierte SGB- oder GBC-Farbpalette besitzt. \"GB\" ahmt das Display des originalen Game Boys nach. \"GBC\" ist identisch zu den eingebauten Voreinstellungen des Game Boy Colors. \"SGB\" ist identisch zu den eingebauten Voreinstellungen des Super Game Boys."
#define OPTION_VAL_GB_DMG_DE NULL
#define OPTION_VAL_GB_POCKET_DE NULL
#define OPTION_VAL_GB_LIGHT_DE NULL
#define OPTION_VAL_GBC_BLUE_DE "GBC - Blau"
#define OPTION_VAL_GBC_BROWN_DE "GBC - Braun"
#define OPTION_VAL_GBC_DARK_BLUE_DE "GBC - Dunkelblau"
#define OPTION_VAL_GBC_DARK_BROWN_DE "GBC - Dunkelbraun"
#define OPTION_VAL_GBC_DARK_GREEN_DE "GBC - Dunkelgrün"
#define OPTION_VAL_GBC_GRAYSCALE_DE "GBC - Graustufen"
#define OPTION_VAL_GBC_GREEN_DE "GBC - Grün"
#define OPTION_VAL_GBC_INVERTED_DE "GBC - Invertiert"
#define OPTION_VAL_GBC_ORANGE_DE NULL
#define OPTION_VAL_GBC_PASTEL_MIX_DE "GBC - Pastellmischung"
#define OPTION_VAL_GBC_RED_DE "GBC - Rot"
#define OPTION_VAL_GBC_YELLOW_DE "GBC - Gelb"
#define OPTION_VAL_SGB_1A_DE NULL
#define OPTION_VAL_SGB_1B_DE NULL
#define OPTION_VAL_SGB_1C_DE NULL
#define OPTION_VAL_SGB_1D_DE NULL
#define OPTION_VAL_SGB_1E_DE NULL
#define OPTION_VAL_SGB_1F_DE NULL
#define OPTION_VAL_SGB_1G_DE NULL
#define OPTION_VAL_SGB_1H_DE NULL
#define OPTION_VAL_SGB_2A_DE NULL
#define OPTION_VAL_SGB_2B_DE NULL
#define OPTION_VAL_SGB_2C_DE NULL
#define OPTION_VAL_SGB_2D_DE NULL
#define OPTION_VAL_SGB_2E_DE NULL
#define OPTION_VAL_SGB_2F_DE NULL
#define OPTION_VAL_SGB_2G_DE NULL
#define OPTION_VAL_SGB_2H_DE NULL
#define OPTION_VAL_SGB_3A_DE NULL
#define OPTION_VAL_SGB_3B_DE NULL
#define OPTION_VAL_SGB_3C_DE NULL
#define OPTION_VAL_SGB_3D_DE NULL
#define OPTION_VAL_SGB_3E_DE NULL
#define OPTION_VAL_SGB_3F_DE NULL
#define OPTION_VAL_SGB_3G_DE NULL
#define OPTION_VAL_SGB_3H_DE NULL
#define OPTION_VAL_SGB_4A_DE NULL
#define OPTION_VAL_SGB_4B_DE NULL
#define OPTION_VAL_SGB_4C_DE NULL
#define OPTION_VAL_SGB_4D_DE NULL
#define OPTION_VAL_SGB_4E_DE NULL
#define OPTION_VAL_SGB_4F_DE NULL
#define OPTION_VAL_SGB_4G_DE NULL
#define OPTION_VAL_SGB_4H_DE NULL
#define OPTION_VAL_SPECIAL_1_DE "Spezial 1"
#define OPTION_VAL_SPECIAL_2_DE "Spezial 2"
#define OPTION_VAL_SPECIAL_3_DE "Spezial 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_DE "Spezial 4 (TI-83)"
#define OPTION_VAL_TWB64_PACK_1_DE NULL
#define OPTION_VAL_TWB64_PACK_2_DE NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_DE NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_DE "> TWB64 - Pack 1-Farbpalette"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_DE "Wählt die interne Farbpalette wenn „Interne Farbpalette“ auf „TWB64 - Pack 1“ gestellt ist."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_DE "TWB64 001 - Aqours Blau"
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_DE NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_DE "TWB64 003 - SpongeBob Gelb"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_DE NULL
#define OPTION_VAL_TWB64_005_NEON_RED_DE "TWB64 005 - Neon-Rot"
#define OPTION_VAL_TWB64_006_NEON_BLUE_DE "TWB64 006 - Neon-Blau"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_DE "TWB64 007 - Neon-Gelb"
#define OPTION_VAL_TWB64_008_NEON_GREEN_DE "TWB64 008 - Neon-Grün"
#define OPTION_VAL_TWB64_009_NEON_PINK_DE "TWB64 009 - Neon-Pink"
#define OPTION_VAL_TWB64_010_MARIO_RED_DE "TWB64 010 - Mario Rot"
#define OPTION_VAL_TWB64_011_NICK_ORANGE_DE NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_DE NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_DE "TWB64 013 - Goldene Wildnis"
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_DE "TWB64 014 - Baumeister Gelb"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_DE "TWB64 015 - Klassisches Bliolett"
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_DE NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_DE NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_DE NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_DE "TWB64 019 - Musen Pink"
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_DE "TWB64 020 - Nijigasaki Gelb"
#define OPTION_VAL_TWB64_021_GAMATE_VER_DE NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_DE "TWB64 022 - Grünstufen Ver."
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_DE NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_DE "TWB64 024 - Super-Saiyajin-Gott"
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_DE "TWB64 025 - Super-Saiyajin-Blau"
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_DE NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_DE NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_DE NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_DE NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_DE NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_DE "TWB64 031 - Cosmo Grün"
#define OPTION_VAL_TWB64_032_WANDA_PINK_DE NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_DE NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_DE "TWB64 034 - Reiseholz"
#define OPTION_VAL_TWB64_035_POKEMON_VER_DE "TWB64 035 - Pokemon-Ver."
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_DE "TWB64 036 - Game-Grump-Orange"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_DE "TWB64 037 - Scooby-Doo-Mystery-Ver."
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_DE "TWB64 038 - Pokemon-mini-Ver."
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_DE "TWB64 039 - Supervision-Ver."
#define OPTION_VAL_TWB64_040_DMG_VER_DE "TWB64 040 - DMG-Ver."
#define OPTION_VAL_TWB64_041_POCKET_VER_DE "TWB64 041 - Pocket-Ver."
#define OPTION_VAL_TWB64_042_LIGHT_VER_DE "TWB64 042 - Light-Ver."
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_DE "TWB64 043 - Miraitowa-Blau"
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_DE "TWB64 044 - Someity-Pink"
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_DE "TWB64 045 - Pikachu-Gelb"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_DE "TWB64 046 - Evoli-Braun"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_DE "TWB64 047 - Microvision-Ver."
#define OPTION_VAL_TWB64_048_TI_83_VER_DE "TWB64 048 - TI-83-Ver."
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_DE NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_DE NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_DE NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_DE NULL
#define OPTION_VAL_TWB64_053_VMU_VER_DE NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_DE NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_DE "TWB64 055 - Android-Grün"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_DE "TWB64 056 - Ticketmaster-Azur"
#define OPTION_VAL_TWB64_057_GOOGLE_RED_DE "TWB64 057 - Google-Rot"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_DE "TWB64 058 - Google-Blau"
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_DE "TWB64 059 - Google-Gelb"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_DE "TWB64 060 - Google-Grün"
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_DE NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_DE NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_DE NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_DE "TWB64 064 - Coca-Cola-Rot"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_DE NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_DE NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_DE NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_DE NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_DE NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_DE NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_DE NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_DE NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_DE NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_DE NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_DE NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_DE NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_DE NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_DE NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_DE NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_DE NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_DE NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_DE NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_DE NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_DE "TWB64 084 - Super-Saiyajin"
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_DE "TWB64 085 - Perfekter Ultrainstinkt"
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_DE "TWB64 086 - Saint Snow Rot"
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_DE "TWB64 087 - Gelbe Banane"
#define OPTION_VAL_TWB64_088_GREEN_BANANA_DE "TWB64 088 - Grüne Banane"
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_DE "TWB64 089 - Super-Saiyajin 3"
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_DE "TWB64 090 - Super Saiyajin Blue Evolved"
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_DE NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_DE "TWB64 092 - Untersuchungsgelb"
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_DE NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_DE NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_DE NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_DE "TWB64 096 - Strohhut Rot"
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_DE NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_DE "TWB64 098 - Deku Alpha Smaragd"
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_DE "TWB64 099 - Blaue Streifen Ver."
#define OPTION_VAL_TWB64_100_STONE_ORANGE_DE NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_DE "> TWB64 - Pack 2-Farbpalette"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_DE "Wählt die interne Farbpalette wenn „Interne Farbpalette“ auf „TWB64 - Pack 2“ gestellt ist."
#define OPTION_VAL_TWB64_101_765PRO_PINK_DE NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_DE NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_DE NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_DE NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_DE NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_DE NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_DE NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_DE NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_DE NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_DE NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_DE NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_DE NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_DE NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_DE NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_DE NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_DE NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_DE NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_DE NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_DE NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_DE NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_DE NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_DE NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_DE NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_DE NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_DE NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_DE NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_DE NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_DE NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_DE NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_DE NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_DE NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_DE NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_DE NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_DE NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_DE NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_DE NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_DE NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_DE "TWB64 138 - Irischgrün"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_DE "TWB64 139 - Kakarot-Orange"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_DE NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_DE "TWB64 141 - Weihnachtsgold"
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_DE "TWB64 142 - Pepsi-Cola Blau"
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_DE "TWB64 143 - Bubblun-Grün"
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_DE "TWB64 144 - Bobblun-Blau"
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_DE NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_DE "TWB64 146 - Olympisches Gold"
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_DE NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_DE NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_DE "TWB64 149 - Olympisches Silber"
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_DE "TWB64 150 - Olympische Bronze"
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_DE "TWB64 151 - ANA-Himmelblau"
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_DE "TWB64 152 - Nijigasaki-Orange"
#define OPTION_VAL_TWB64_153_HOLOBLUE_DE NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_DE "TWB64 154 - Wrestling-Rot"
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_DE NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_DE "TWB64 156 - Pokedex-Rot"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_DE NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_DE "TWB64 158 - Xbox-Grün"
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_DE NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_DE NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_DE NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_DE NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_DE NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_DE NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_DE NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_DE NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_DE NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_DE NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_DE NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_DE NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_DE NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_DE NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_DE NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_DE NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_DE NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_DE NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_DE NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_DE NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_DE NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_DE NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_DE NULL
#define OPTION_VAL_TWB64_182_PINK109_DE NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_DE NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_DE NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_DE NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_DE NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_DE NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_DE "TWB64 188 - Pizza-Hut-Rot"
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_DE "TWB64 189 - Plumbob-Grün"
#define OPTION_VAL_TWB64_190_GRAND_IVORY_DE NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_DE "TWB64 191 - Dämonengold"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_DE "TWB64 192 - SEGA-Tokyo-Blau"
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_DE "TWB64 193 - Meisterblau"
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_DE "TWB64 194 - DK-Fassbraun"
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_DE "TWB64 195 - Evangelion-Grün"
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_DE "TWB64 196 - Reiterviolett"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_DE "TWB64 197 - Autobot Rot"
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_DE "TWB64 198 - Niconico Meeresgrün"
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_DE "TWB64 199 - Duracell Kupfer"
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_DE NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_DE NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_DE "Wählt die interne Farbpalette aus, wenn 'Interne Palette' auf 'PixelShift - Pack 1' gesetzt ist."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_DE "PixelShift 01 - Arktis-Grün"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_DE NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_DE NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_DE NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_DE "PixelShift 05 - Schokoladenleiste"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_DE NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_DE "PixelShift 07 - Zuckerwatte"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_DE "PixelShift 08 - Einfache Grüne"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_DE NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_DE NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_DE NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_DE "PixelShift 12 - Game Boy Pocket alt"
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_DE NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_DE NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_DE "PixelShift 15 - GB Hintergrundbeleuchtung blau"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_DE "PixelShift 16 - GB Hintergrundbeleuchtung verblasst"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_DE "PixelShift 17 - GB Hintergrundbeleuchtung orange"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__DE "PixelShift 18 - GB Hintergrundbeleuchtung weiss "
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_DE "PixelShift 19 - GB Hintergrundbeleuchtung dunkles Gelb"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_DE NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_DE NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_DE NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_DE NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_DE "PixelShift 24 - GB neu"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_DE NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_DE "PixelShift 26 - GB alt"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_DE NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_DE "PixelShift 28 - GB Gewaschen-gelbe Hintergrundbeleuchtung"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_DE "PixelShift 29 - Geist"
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_DE "PixelShift 30 - Im Dunkeln leuchten"
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_DE "PixelShift 31 - Goldene Leiste"
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_DE NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_DE "PixelShift 33 - Grau-grüne Mischung"
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_DE NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_DE NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_DE "PixelShift 36 - Zeitung"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_DE NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_DE NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_DE "PixelShift 39 - Umriss"
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_DE "PixelShift 40 - Plötzlicher Sonnenschein"
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_DE NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_DE NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_DE NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_DE NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_DE "PixelShift 45 - Wunsch"
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_DE "Farbkorrektur"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_DE "Passt die Ausgabefarben an die Anzeige der realen Game Boy Color Hardware an. 'Nur GBC' sorgt dafür, dass die Korrektur nur beim Spielen von Game Boy Color Spielen angewendet wird oder wenn Sie eine Game Boy Color Palette verwenden, um ein Game Boy Spiel einzufärben. 'Immer' wendet die Farbkorrektur auf alle Inhalte an und liefert unerwartete/suboptimale Ergebnisse bei Verwendung von 'GB' oder 'SGB' internen Farbpaletten."
#define OPTION_VAL_GBC_ONLY_DE "Nur GBC"
#define OPTION_VAL_ALWAYS_DE "Immer"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_DE "Farbkorrekturmodus"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_DE "Bestimmt die Methode, die bei der Farbkorrektur verwendet wird. 'Genau' erzeugt Ausgabe, die kaum von einem echten LCD-Bildschirm für Game Boy zu unterscheiden ist. 'Schnell' verdunkelt lediglich die Farben und verringert die Sättigung und kann auf Low-End-Hardware verwendet werden, wenn die 'Genau'-Methode zu langsam ist."
#define OPTION_VAL_ACCURATE_DE "Genau"
#define OPTION_VAL_FAST_DE "Schnell"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_DE "Farbkorrektur – Frontlichtposition"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_DE "Simuliert die physikalische Reaktion des Game Boy Color LCD-Bildschirms, wenn es aus verschiedenen Blickwinkeln beleuchtet wird. 'Zentral' stellt die Standard-Farbwiedergabe dar. 'Über dem Bildschirm' erhöht die Helligkeit. 'Unterhalb des Bildschirms' verringert die Helligkeit. Diese Einstellung gilt nur, wenn 'Farbkorrekturmodus' auf 'Genau' gesetzt ist."
#define OPTION_VAL_CENTRAL_DE "Zentral"
#define OPTION_VAL_ABOVE_SCREEN_DE "Über dem Bildschirm"
#define OPTION_VAL_BELOW_SCREEN_DE "Unterhalb des Bildschirms"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_DE "Dunkle Filterstufe (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_DE "Helligkeitsreduzierung auf Helligkeitsbasis aktivieren. Kann verwendet werden, um Blenden/Augenbelastung zu vermeiden, wenn Spiele mit weißem Hintergrund gespielt werden, die für die Anzeige auf einem nicht-hintergrundbeleuchteten Game Boy Color bestimmt sind und daher auf einem modernen Hintergrundbeleuchtungsbildschirm unbequem hell erscheinen können."
#define GAMBATTE_MIX_FRAMES_LABEL_DE "Interframe-Blending"
#define GAMBATTE_MIX_FRAMES_INFO_0_DE "Simuliert LCD-Ghosting-Effekte. 'Einfach' führt eine 50:50-Mischung aus aktuellem und vorherigen Bild durch. 'LCD-Ghosting' ahmt die natürlichen LCD-Reaktionszeiten nach, indem mehrere gepufferte Bilder kombiniert werden. 'Einfaches' Überblenden ist bei Spielen erforderlich, die LCD-Ghosting aggressiv für Transparenzeffekte ausnutzen (Wave Race, Chikyuu Kaihou Gun ZAS, F-Zero, die Boktai-Serie…)."
#define OPTION_VAL_MIX_DE "Einfach"
#define OPTION_VAL_LCD_GHOSTING_DE "LCD-Ghosting (Genau)"
#define OPTION_VAL_LCD_GHOSTING_FAST_DE "LCD-Ghosting (Schnell)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_DE "Audio-Resampling-Treiber"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_DE "Legt fest, welcher Algorithmus beim Resampling von generierten Audio verwendet werden soll (die Audio-Rate des Game Boy ist nur durch die CPU-Schreibgeschwindigkeit begrenzt, so dass \"native\" Frequenzen auf modernen Klanggeräten unpraktisch sind und heruntergetaktet werden müssen). 'Sinus' produziert höchste Qualität. 'Kosinus' verbessert die Leistung auf Low-End-Hardware."
#define OPTION_VAL_SINC_DE "Sinus"
#define OPTION_VAL_CC_DE "Kosinus"
#define GAMBATTE_GB_HWMODE_LABEL_DE "Emulierte Hardware (Neustart erforderlich)"
#define GAMBATTE_GB_HWMODE_INFO_0_DE "Gibt an, welche Art von Hardware emuliert werden soll. 'Automatisch' wird empfohlen. Das Auswählen von 'GBA' schaltet zusätzliche Funktionen in bestimmten 'GBA Enhanced' Game Boy Color Spielen frei (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_DE NULL
#define OPTION_VAL_GBA_DE NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_DE "Offiziellen Bootloader verwenden (Neustart erforderlich)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_DE "Aktiviert Unterstützung für offizielle Game Boy und Game Boy Color Bootloader, mit entsprechenden Einschalt-Logo-Animationen."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_DE "Entgegengesetzte Richtungen zulassen"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_DE "Aktivieren erlaubt es gleichzeitig, die linke und rechte (oder nach oben und unten) Richtung zu drücken/schnell zu wechseln. Dies kann zu bewegungsbasierten Aussetzern führen."
#define GAMBATTE_TURBO_PERIOD_LABEL_DE "Turbo Tasten Intervall"
#define GAMBATTE_TURBO_PERIOD_INFO_0_DE "Legt das Wiederholungsintervall (in Bildern) fest, wenn die Turbo-Tasten A/B gedrückt gehalten werden."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_DE "Controller Vibrationsstärke"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_DE "Aktiviert haptische Feedback-Effekte für unterstützte Spiele (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_DE "Spiel-Link-Einstellungen anzeigen"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_DE "Aktiviert die Konfiguration von vernetzten Spiele-Link (Mehrspieler-Optionen). HINWEIS: Das Schnellmenü muss eingeschaltet sein, damit diese Einstellung wirksam wird."
#define GAMBATTE_GB_LINK_MODE_LABEL_DE "Spiel-Link-Modus"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_DE "Link-Modus"
#define GAMBATTE_GB_LINK_MODE_INFO_0_DE "Legt beim Aktivieren von vernetzten Spiel-Link-Funktionen fest, ob die aktuelle Instanz als Server oder Client ausgeführt werden soll."
#define OPTION_VAL_NOT_CONNECTED_DE "Nicht verbunden"
#define OPTION_VAL_NETWORK_SERVER_DE "Netzwerk-Server"
#define OPTION_VAL_NETWORK_CLIENT_DE "Netzwerk-Client"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_DE "Netzwerk-Linkport"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_DE NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_DE "Den Port angeben, der für die Kommunikation mit dem Spiele-Link verwendet wird."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_DE "Netzwerk-Linkserveradresse Teil 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_DE "Serveradresse Teil 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_DE "1. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_DE "1. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_DE "Netzwerk-Linkserveradresse Teil 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_DE "Serveradresse Teil 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_DE "2. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_DE "2. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_DE "Netzwerk-Linkserveradresse Teil 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_DE "Serveradresse Teil 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_DE "4. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_DE "3. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_DE "Netzwerk-Linkserveradresse Teil 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_DE "Serveradresse Teil 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_DE "4. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_DE "4. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_DE "Netzwerk-Linkserveradresse Teil 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_DE "Serveradresse Teil 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_DE "5. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_DE "5. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_DE "Netzwerk-Linkserveradresse Teil 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_DE "Serveradresse Teil 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_DE "6. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_DE "6. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_DE "Netzwerk-Linkserveradresse Teil 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_DE "Serveradresse Teil 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_DE "7. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_DE "7. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_DE "Netzwerk-Linkserveradresse Teil 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_DE "Serveradresse Teil 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_DE "8. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_DE "8. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_DE "Netzwerk-Linkserveradresse Teil 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_DE "Serveradresse Teil 09: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_DE "9. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_DE "9. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_DE "Netzwerk-Linkserveradresse Teil 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_DE "Serveradresse Teil 10: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_DE "10. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_DE "10. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_DE "Netzwerk-Linkserveradresse Teil 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_DE "Serveradresse Teil 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_DE "11. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_DE "11. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_DE "Netzwerk-Linkserveradresse Teil 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_DE "Serveradresse Teil 12: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_DE "12. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Game-Link-Modus“ auf „Netzwerkclient“ eingestellt ist."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_DE "12. Ziffer der IP-Adresse von entferntem Game-Link-Netzwerkserver. Wird nur verwendet, wenn „Linkmodus“ auf „Netzwerkclient“ eingestellt ist."

struct retro_core_option_v2_category option_cats_de[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_DE,
      CATEGORY_GB_LINK_INFO_0_DE
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_de[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_DE,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_DE,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_DE },
         { "GBC",      OPTION_VAL_GBC_DE },
         { "SGB",      OPTION_VAL_SGB_DE },
         { "internal", OPTION_VAL_INTERNAL_DE },
         { "custom",   OPTION_VAL_CUSTOM_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_DE,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_DE,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_DE },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_DE },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_DE },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_DE },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_DE },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_DE },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_DE },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_DE },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_DE },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_DE },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_DE },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_DE },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_DE },
         { "GBC - Red",                OPTION_VAL_GBC_RED_DE },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_DE },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_DE },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_DE },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_DE },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_DE },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_DE },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_DE },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_DE },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_DE },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_DE },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_DE },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_DE },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_DE },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_DE },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_DE },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_DE },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_DE },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_DE },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_DE },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_DE },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_DE },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_DE },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_DE },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_DE },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_DE },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_DE },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_DE },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_DE },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_DE },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_DE },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_DE },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_DE },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_DE },
         { "Special 1",                OPTION_VAL_SPECIAL_1_DE },
         { "Special 2",                OPTION_VAL_SPECIAL_2_DE },
         { "Special 3",                OPTION_VAL_SPECIAL_3_DE },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_DE },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_DE },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_DE },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_DE },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_DE,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_DE,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_DE },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_DE },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_DE },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_DE },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_DE },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_DE },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_DE },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_DE },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_DE },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_DE },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_DE },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_DE },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_DE },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_DE },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_DE },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_DE },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_DE },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_DE },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_DE },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_DE },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_DE },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_DE },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_DE },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_DE },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_DE },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_DE },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_DE },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_DE },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_DE },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_DE },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_DE },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_DE },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_DE },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_DE },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_DE },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_DE },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_DE },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_DE },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_DE },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_DE },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_DE },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_DE },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_DE },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_DE },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_DE },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_DE },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_DE },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_DE },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_DE },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_DE },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_DE },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_DE },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_DE },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_DE },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_DE },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_DE },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_DE },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_DE },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_DE },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_DE },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_DE },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_DE },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_DE },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_DE },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_DE },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_DE },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_DE },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_DE },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_DE },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_DE },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_DE },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_DE },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_DE },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_DE },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_DE },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_DE },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_DE },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_DE },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_DE },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_DE },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_DE },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_DE },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_DE },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_DE },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_DE },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_DE },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_DE },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_DE },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_DE },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_DE },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_DE },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_DE },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_DE },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_DE },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_DE },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_DE },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_DE },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_DE },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_DE },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_DE },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_DE,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_DE,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_DE },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_DE },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_DE },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_DE },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_DE },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_DE },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_DE },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_DE },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_DE },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_DE },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_DE },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_DE },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_DE },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_DE },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_DE },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_DE },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_DE },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_DE },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_DE },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_DE },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_DE },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_DE },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_DE },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_DE },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_DE },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_DE },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_DE },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_DE },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_DE },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_DE },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_DE },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_DE },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_DE },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_DE },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_DE },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_DE },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_DE },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_DE },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_DE },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_DE },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_DE },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_DE },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_DE },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_DE },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_DE },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_DE },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_DE },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_DE },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_DE },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_DE },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_DE },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_DE },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_DE },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_DE },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_DE },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_DE },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_DE },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_DE },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_DE },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_DE },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_DE },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_DE },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_DE },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_DE },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_DE },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_DE },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_DE },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_DE },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_DE },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_DE },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_DE },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_DE },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_DE },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_DE },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_DE },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_DE },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_DE },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_DE },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_DE },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_DE },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_DE },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_DE },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_DE },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_DE },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_DE },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_DE },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_DE },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_DE },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_DE },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_DE },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_DE },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_DE },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_DE },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_DE },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_DE },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_DE },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_DE },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_DE },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_DE },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_DE },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_DE,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_DE,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_DE },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_DE },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_DE },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_DE },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_DE },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_DE },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_DE },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_DE },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_DE },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_DE },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_DE },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_DE },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_DE },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_DE },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_DE },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_DE },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_DE },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__DE },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_DE },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_DE },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_DE },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_DE },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_DE },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_DE },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_DE },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_DE },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_DE },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_DE },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_DE },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_DE },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_DE },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_DE },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_DE },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_DE },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_DE },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_DE },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_DE },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_DE },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_DE },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_DE },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_DE },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_DE },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_DE },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_DE },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_DE },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_DE,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_DE,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_DE },
         { "always",   OPTION_VAL_ALWAYS_DE },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_DE,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_DE,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_DE },
         { "fast",     OPTION_VAL_FAST_DE },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_DE,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_DE,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_DE },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_DE },
         { "below screen", OPTION_VAL_BELOW_SCREEN_DE },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_DE,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_DE,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_DE,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_DE,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_DE },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_DE },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_DE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_DE,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_DE,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_DE },
         { "cc",   OPTION_VAL_CC_DE },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_DE,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_DE,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_DE },
         { "GB",   OPTION_VAL_GB_DE },
         { "GBC",  OPTION_VAL_GBC_DE },
         { "GBA",  OPTION_VAL_GBA_DE },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_DE,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_DE,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_DE,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_DE,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_DE,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_DE,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_DE,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_DE,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_DE,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_DE,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_DE,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_MODE_INFO_0_DE,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_DE },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_DE },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_DE },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_DE,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_DE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_DE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_de = {
   option_cats_de,
   option_defs_de
};

/* RETRO_LANGUAGE_EL */

#define CATEGORY_GB_LINK_LABEL_EL NULL
#define CATEGORY_GB_LINK_INFO_0_EL NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_EL "Χρωματισμός GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_EL NULL
#define OPTION_VAL_AUTO_EL "Αυτόματο"
#define OPTION_VAL_GBC_EL NULL
#define OPTION_VAL_SGB_EL NULL
#define OPTION_VAL_INTERNAL_EL NULL
#define OPTION_VAL_CUSTOM_EL NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_EL "Εσωτερική Παλέτα"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_EL NULL
#define OPTION_VAL_GB_DMG_EL NULL
#define OPTION_VAL_GB_POCKET_EL NULL
#define OPTION_VAL_GB_LIGHT_EL NULL
#define OPTION_VAL_GBC_BLUE_EL "GBC - Μπλε"
#define OPTION_VAL_GBC_BROWN_EL "GBC - Καφέ"
#define OPTION_VAL_GBC_DARK_BLUE_EL "GBC - Σκούρο Μπλε"
#define OPTION_VAL_GBC_DARK_BROWN_EL "GBC - Σκούρο Καφέ"
#define OPTION_VAL_GBC_DARK_GREEN_EL "GBC - Σκούρο Πράσινο"
#define OPTION_VAL_GBC_GRAYSCALE_EL NULL
#define OPTION_VAL_GBC_GREEN_EL "GBC - Πράσινο"
#define OPTION_VAL_GBC_INVERTED_EL NULL
#define OPTION_VAL_GBC_ORANGE_EL "GBC - Πορτοκαλί"
#define OPTION_VAL_GBC_PASTEL_MIX_EL NULL
#define OPTION_VAL_GBC_RED_EL "GBC - Κόκκινο"
#define OPTION_VAL_GBC_YELLOW_EL "GBC - Κίτρινο"
#define OPTION_VAL_SGB_1A_EL NULL
#define OPTION_VAL_SGB_1B_EL NULL
#define OPTION_VAL_SGB_1C_EL NULL
#define OPTION_VAL_SGB_1D_EL NULL
#define OPTION_VAL_SGB_1E_EL NULL
#define OPTION_VAL_SGB_1F_EL NULL
#define OPTION_VAL_SGB_1G_EL NULL
#define OPTION_VAL_SGB_1H_EL NULL
#define OPTION_VAL_SGB_2A_EL NULL
#define OPTION_VAL_SGB_2B_EL NULL
#define OPTION_VAL_SGB_2C_EL NULL
#define OPTION_VAL_SGB_2D_EL NULL
#define OPTION_VAL_SGB_2E_EL NULL
#define OPTION_VAL_SGB_2F_EL NULL
#define OPTION_VAL_SGB_2G_EL NULL
#define OPTION_VAL_SGB_2H_EL NULL
#define OPTION_VAL_SGB_3A_EL NULL
#define OPTION_VAL_SGB_3B_EL NULL
#define OPTION_VAL_SGB_3C_EL NULL
#define OPTION_VAL_SGB_3D_EL NULL
#define OPTION_VAL_SGB_3E_EL NULL
#define OPTION_VAL_SGB_3F_EL NULL
#define OPTION_VAL_SGB_3G_EL NULL
#define OPTION_VAL_SGB_3H_EL NULL
#define OPTION_VAL_SGB_4A_EL NULL
#define OPTION_VAL_SGB_4B_EL NULL
#define OPTION_VAL_SGB_4C_EL NULL
#define OPTION_VAL_SGB_4D_EL NULL
#define OPTION_VAL_SGB_4E_EL NULL
#define OPTION_VAL_SGB_4F_EL NULL
#define OPTION_VAL_SGB_4G_EL NULL
#define OPTION_VAL_SGB_4H_EL NULL
#define OPTION_VAL_SPECIAL_1_EL NULL
#define OPTION_VAL_SPECIAL_2_EL NULL
#define OPTION_VAL_SPECIAL_3_EL NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_EL NULL
#define OPTION_VAL_TWB64_PACK_1_EL NULL
#define OPTION_VAL_TWB64_PACK_2_EL NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_EL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_EL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_EL NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_EL NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_EL NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_EL NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_EL NULL
#define OPTION_VAL_TWB64_005_NEON_RED_EL NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_EL NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_EL NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_EL NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_EL NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_EL NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_EL NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_EL NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_EL NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_EL NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_EL NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_EL NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_EL NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_EL NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_EL NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_EL NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_EL NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_EL NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_EL NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_EL NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_EL NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_EL NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_EL NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_EL NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_EL NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_EL NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_EL NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_EL NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_EL NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_EL NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_EL NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_EL NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_EL NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_EL NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_EL NULL
#define OPTION_VAL_TWB64_040_DMG_VER_EL NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_EL NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_EL NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_EL NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_EL NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_EL NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_EL NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_EL NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_EL NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_EL NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_EL NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_EL NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_EL NULL
#define OPTION_VAL_TWB64_053_VMU_VER_EL NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_EL NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_EL NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_EL NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_EL NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_EL NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_EL NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_EL NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_EL NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_EL NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_EL NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_EL NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_EL NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_EL NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_EL NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_EL NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_EL NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_EL NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_EL NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_EL NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_EL NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_EL NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_EL NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_EL NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_EL NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_EL NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_EL NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_EL NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_EL NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_EL NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_EL NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_EL NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_EL NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_EL NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_EL NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_EL NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_EL NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_EL NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_EL NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_EL NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_EL NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_EL NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_EL NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_EL NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_EL NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_EL NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_EL NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_EL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_EL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_EL NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_EL NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_EL NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_EL NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_EL NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_EL NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_EL NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_EL NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_EL NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_EL NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_EL NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_EL NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_EL NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_EL NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_EL NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_EL NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_EL NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_EL NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_EL NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_EL NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_EL NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_EL NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_EL NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_EL NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_EL NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_EL NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_EL NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_EL NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_EL NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_EL NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_EL NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_EL NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_EL NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_EL NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_EL NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_EL NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_EL NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_EL NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_EL NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_EL NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_EL NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_EL NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_EL NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_EL NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_EL NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_EL NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_EL NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_EL NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_EL NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_EL NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_EL NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_EL NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_EL NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_EL NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_EL NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_EL NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_EL NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_EL NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_EL NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_EL NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_EL NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_EL NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_EL NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_EL NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_EL NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_EL NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_EL NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_EL NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_EL NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_EL NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_EL NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_EL NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_EL NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_EL NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_EL NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_EL NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_EL NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_EL NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_EL NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_EL NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_EL NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_EL NULL
#define OPTION_VAL_TWB64_182_PINK109_EL NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_EL NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_EL NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_EL NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_EL NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_EL NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_EL NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_EL NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_EL NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_EL NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_EL NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_EL NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_EL NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_EL NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_EL NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_EL NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_EL NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_EL NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_EL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_EL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_EL NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_EL NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_EL NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_EL NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_EL NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_EL NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_EL NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_EL NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_EL NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_EL NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_EL NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_EL NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_EL NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_EL NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_EL NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_EL NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_EL NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_EL NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__EL NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_EL NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_EL NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_EL NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_EL NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_EL NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_EL NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_EL NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_EL NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_EL NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_EL NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_EL NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_EL NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_EL NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_EL NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_EL NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_EL NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_EL NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_EL NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_EL NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_EL NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_EL NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_EL NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_EL NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_EL NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_EL NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_EL NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_EL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_EL "Διόρθωση Χρωμάτων"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_EL NULL
#define OPTION_VAL_GBC_ONLY_EL "Μόνο GBC"
#define OPTION_VAL_ALWAYS_EL "Πάντα"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_EL "Διόρθωση Χρωμάτων"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_EL NULL
#define OPTION_VAL_ACCURATE_EL "Ακριβής"
#define OPTION_VAL_FAST_EL "Γρήγορη Ταχύτητα"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_EL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_EL NULL
#define OPTION_VAL_CENTRAL_EL NULL
#define OPTION_VAL_ABOVE_SCREEN_EL "Πάνω Από Την Οθόνη"
#define OPTION_VAL_BELOW_SCREEN_EL "Κάτω Από Την Οθόνη"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_EL NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_EL NULL
#define GAMBATTE_MIX_FRAMES_LABEL_EL NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_EL NULL
#define OPTION_VAL_MIX_EL "Απλό"
#define OPTION_VAL_LCD_GHOSTING_EL NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_EL NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_EL "Οδηγός Επαναδειγματολήπτη Ήχου"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_EL NULL
#define OPTION_VAL_SINC_EL NULL
#define OPTION_VAL_CC_EL NULL
#define GAMBATTE_GB_HWMODE_LABEL_EL NULL
#define GAMBATTE_GB_HWMODE_INFO_0_EL NULL
#define OPTION_VAL_GB_EL NULL
#define OPTION_VAL_GBA_EL NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_EL NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_EL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_EL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_EL NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_EL NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_EL NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_EL NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_EL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_EL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_EL NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_EL NULL
#define OPTION_VAL_NOT_CONNECTED_EL NULL
#define OPTION_VAL_NETWORK_SERVER_EL "Διακομιστής Δικτύου"
#define OPTION_VAL_NETWORK_CLIENT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_EL "Θύρα"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_EL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_EL NULL

struct retro_core_option_v2_category option_cats_el[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_EL,
      CATEGORY_GB_LINK_INFO_0_EL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_el[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_EL,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_EL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_EL },
         { "GBC",      OPTION_VAL_GBC_EL },
         { "SGB",      OPTION_VAL_SGB_EL },
         { "internal", OPTION_VAL_INTERNAL_EL },
         { "custom",   OPTION_VAL_CUSTOM_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_EL,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_EL,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_EL },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_EL },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_EL },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_EL },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_EL },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_EL },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_EL },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_EL },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_EL },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_EL },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_EL },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_EL },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_EL },
         { "GBC - Red",                OPTION_VAL_GBC_RED_EL },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_EL },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_EL },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_EL },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_EL },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_EL },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_EL },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_EL },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_EL },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_EL },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_EL },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_EL },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_EL },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_EL },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_EL },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_EL },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_EL },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_EL },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_EL },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_EL },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_EL },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_EL },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_EL },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_EL },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_EL },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_EL },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_EL },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_EL },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_EL },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_EL },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_EL },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_EL },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_EL },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_EL },
         { "Special 1",                OPTION_VAL_SPECIAL_1_EL },
         { "Special 2",                OPTION_VAL_SPECIAL_2_EL },
         { "Special 3",                OPTION_VAL_SPECIAL_3_EL },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_EL },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_EL },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_EL },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_EL },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_EL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_EL,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_EL },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_EL },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_EL },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_EL },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_EL },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_EL },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_EL },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_EL },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_EL },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_EL },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_EL },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_EL },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_EL },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_EL },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_EL },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_EL },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_EL },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_EL },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_EL },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_EL },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_EL },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_EL },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_EL },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_EL },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_EL },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_EL },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_EL },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_EL },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_EL },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_EL },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_EL },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_EL },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_EL },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_EL },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_EL },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_EL },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_EL },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_EL },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_EL },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_EL },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_EL },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_EL },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_EL },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_EL },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_EL },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_EL },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_EL },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_EL },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_EL },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_EL },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_EL },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_EL },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_EL },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_EL },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_EL },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_EL },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_EL },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_EL },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_EL },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_EL },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_EL },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_EL },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_EL },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_EL },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_EL },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_EL },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_EL },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_EL },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_EL },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_EL },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_EL },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_EL },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_EL },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_EL },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_EL },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_EL },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_EL },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_EL },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_EL },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_EL },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_EL },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_EL },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_EL },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_EL },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_EL },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_EL },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_EL },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_EL },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_EL },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_EL },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_EL },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_EL },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_EL },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_EL },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_EL },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_EL },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_EL },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_EL },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_EL },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_EL },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_EL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_EL,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_EL },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_EL },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_EL },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_EL },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_EL },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_EL },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_EL },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_EL },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_EL },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_EL },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_EL },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_EL },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_EL },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_EL },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_EL },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_EL },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_EL },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_EL },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_EL },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_EL },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_EL },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_EL },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_EL },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_EL },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_EL },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_EL },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_EL },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_EL },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_EL },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_EL },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_EL },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_EL },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_EL },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_EL },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_EL },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_EL },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_EL },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_EL },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_EL },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_EL },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_EL },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_EL },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_EL },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_EL },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_EL },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_EL },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_EL },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_EL },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_EL },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_EL },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_EL },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_EL },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_EL },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_EL },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_EL },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_EL },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_EL },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_EL },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_EL },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_EL },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_EL },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_EL },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_EL },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_EL },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_EL },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_EL },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_EL },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_EL },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_EL },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_EL },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_EL },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_EL },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_EL },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_EL },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_EL },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_EL },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_EL },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_EL },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_EL },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_EL },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_EL },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_EL },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_EL },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_EL },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_EL },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_EL },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_EL },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_EL },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_EL },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_EL },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_EL },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_EL },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_EL },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_EL },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_EL },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_EL },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_EL },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_EL },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_EL },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_EL },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_EL,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_EL,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_EL },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_EL },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_EL },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_EL },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_EL },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_EL },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_EL },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_EL },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_EL },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_EL },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_EL },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_EL },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_EL },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_EL },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_EL },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_EL },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_EL },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__EL },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_EL },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_EL },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_EL },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_EL },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_EL },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_EL },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_EL },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_EL },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_EL },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_EL },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_EL },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_EL },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_EL },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_EL },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_EL },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_EL },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_EL },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_EL },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_EL },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_EL },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_EL },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_EL },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_EL },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_EL },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_EL },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_EL },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_EL },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_EL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_EL,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_EL },
         { "always",   OPTION_VAL_ALWAYS_EL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_EL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_EL,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_EL },
         { "fast",     OPTION_VAL_FAST_EL },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_EL,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_EL,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_EL },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_EL },
         { "below screen", OPTION_VAL_BELOW_SCREEN_EL },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_EL,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_EL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_EL,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_EL,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_EL },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_EL },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_EL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_EL,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_EL,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_EL },
         { "cc",   OPTION_VAL_CC_EL },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_EL,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_EL,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_EL },
         { "GB",   OPTION_VAL_GB_EL },
         { "GBC",  OPTION_VAL_GBC_EL },
         { "GBA",  OPTION_VAL_GBA_EL },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_EL,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_EL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_EL,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_EL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_EL,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_EL,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_EL,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_EL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_EL,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_EL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_EL,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_MODE_INFO_0_EL,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_EL },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_EL },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_EL },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_EL,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_EL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_EL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_el = {
   option_cats_el,
   option_defs_el
};

/* RETRO_LANGUAGE_EN */

#define CATEGORY_GB_LINK_LABEL_EN NULL
#define CATEGORY_GB_LINK_INFO_0_EN NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_EN "GB Colourisation"
#define GAMBATTE_GB_COLORIZATION_INFO_0_EN "Enables colourisation of Game Boy games. 'Auto' selects the 'best' (most colourful/appropriate) palette. 'GBC' selects a game-specific Game Boy Colour palette if defined, otherwise it's going to choose 'GBC - Dark Green'. 'SGB' selects a game-specific Super Game Boy palette if defined, otherwise 'SGB - 1A'. 'Internal' uses the 'Internal Palette' core option. 'Custom' loads a user-created palette from the system directory."
#define OPTION_VAL_AUTO_EN NULL
#define OPTION_VAL_GBC_EN NULL
#define OPTION_VAL_SGB_EN NULL
#define OPTION_VAL_INTERNAL_EN NULL
#define OPTION_VAL_CUSTOM_EN NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_EN NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_EN "Selects palette used for colourising Game Boy games when 'GB Colourisation' is set to 'Internal', or when 'GB Colourisation' is set to 'Auto' and game has no pre-defined SGB/GBC palette. 'GB' palettes mimic the display of original Game Boy hardware. 'GBC' palettes are identical to the built-in presets of the Game Boy Colour. 'SGB' palettes are identical to the built-in presets of the Super Game Boy."
#define OPTION_VAL_GB_DMG_EN NULL
#define OPTION_VAL_GB_POCKET_EN NULL
#define OPTION_VAL_GB_LIGHT_EN NULL
#define OPTION_VAL_GBC_BLUE_EN NULL
#define OPTION_VAL_GBC_BROWN_EN NULL
#define OPTION_VAL_GBC_DARK_BLUE_EN NULL
#define OPTION_VAL_GBC_DARK_BROWN_EN NULL
#define OPTION_VAL_GBC_DARK_GREEN_EN NULL
#define OPTION_VAL_GBC_GRAYSCALE_EN "GBC - Greyscale"
#define OPTION_VAL_GBC_GREEN_EN NULL
#define OPTION_VAL_GBC_INVERTED_EN NULL
#define OPTION_VAL_GBC_ORANGE_EN NULL
#define OPTION_VAL_GBC_PASTEL_MIX_EN NULL
#define OPTION_VAL_GBC_RED_EN NULL
#define OPTION_VAL_GBC_YELLOW_EN NULL
#define OPTION_VAL_SGB_1A_EN NULL
#define OPTION_VAL_SGB_1B_EN NULL
#define OPTION_VAL_SGB_1C_EN NULL
#define OPTION_VAL_SGB_1D_EN NULL
#define OPTION_VAL_SGB_1E_EN NULL
#define OPTION_VAL_SGB_1F_EN NULL
#define OPTION_VAL_SGB_1G_EN NULL
#define OPTION_VAL_SGB_1H_EN NULL
#define OPTION_VAL_SGB_2A_EN NULL
#define OPTION_VAL_SGB_2B_EN NULL
#define OPTION_VAL_SGB_2C_EN NULL
#define OPTION_VAL_SGB_2D_EN NULL
#define OPTION_VAL_SGB_2E_EN NULL
#define OPTION_VAL_SGB_2F_EN NULL
#define OPTION_VAL_SGB_2G_EN NULL
#define OPTION_VAL_SGB_2H_EN NULL
#define OPTION_VAL_SGB_3A_EN NULL
#define OPTION_VAL_SGB_3B_EN NULL
#define OPTION_VAL_SGB_3C_EN NULL
#define OPTION_VAL_SGB_3D_EN NULL
#define OPTION_VAL_SGB_3E_EN NULL
#define OPTION_VAL_SGB_3F_EN NULL
#define OPTION_VAL_SGB_3G_EN NULL
#define OPTION_VAL_SGB_3H_EN NULL
#define OPTION_VAL_SGB_4A_EN NULL
#define OPTION_VAL_SGB_4B_EN NULL
#define OPTION_VAL_SGB_4C_EN NULL
#define OPTION_VAL_SGB_4D_EN NULL
#define OPTION_VAL_SGB_4E_EN NULL
#define OPTION_VAL_SGB_4F_EN NULL
#define OPTION_VAL_SGB_4G_EN NULL
#define OPTION_VAL_SGB_4H_EN NULL
#define OPTION_VAL_SPECIAL_1_EN NULL
#define OPTION_VAL_SPECIAL_2_EN NULL
#define OPTION_VAL_SPECIAL_3_EN NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_EN NULL
#define OPTION_VAL_TWB64_PACK_1_EN NULL
#define OPTION_VAL_TWB64_PACK_2_EN NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_EN NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_EN NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_EN "Selects internal colourisation palette when 'Internal Palette' is set to 'TWB64 - Pack 1'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_EN NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_EN NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_EN NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_EN NULL
#define OPTION_VAL_TWB64_005_NEON_RED_EN NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_EN NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_EN NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_EN NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_EN NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_EN NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_EN NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_EN NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_EN NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_EN NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_EN NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_EN NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_EN "TWB64 017 - Super-ball Ivory"
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_EN NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_EN NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_EN NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_EN NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_EN NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_EN NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_EN NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_EN NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_EN NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_EN NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_EN NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_EN NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_EN NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_EN NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_EN NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_EN NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_EN NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_EN "TWB64 035 - Pokémon Ver."
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_EN NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_EN NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_EN "TWB64 038 - Pokémon mini Ver."
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_EN NULL
#define OPTION_VAL_TWB64_040_DMG_VER_EN NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_EN NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_EN NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_EN NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_EN NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_EN NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_EN NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_EN NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_EN NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_EN NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_EN NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_EN NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_EN NULL
#define OPTION_VAL_TWB64_053_VMU_VER_EN NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_EN NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_EN NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_EN "TWB64 056 - Ticket-master Azure"
#define OPTION_VAL_TWB64_057_GOOGLE_RED_EN NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_EN NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_EN NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_EN NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_EN NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_EN NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_EN NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_EN NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_EN NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_EN NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_EN NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_EN NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_EN NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_EN NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_EN NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_EN NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_EN NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_EN NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_EN NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_EN NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_EN NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_EN NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_EN "TWB64 079 - Card-captor Pink"
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_EN NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_EN NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_EN NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_EN NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_EN NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_EN NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_EN NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_EN NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_EN NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_EN NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_EN NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_EN NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_EN NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_EN NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_EN NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_EN NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_EN NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_EN NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_EN NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_EN NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_EN NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_EN NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_EN "Selects internal colourisation palette when 'Internal Palette' is set to 'TWB64 - Pack 2'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_EN NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_EN NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_EN NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_EN NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_EN NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_EN NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_EN NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_EN NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_EN NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_EN NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_EN NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_EN NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_EN NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_EN NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_EN NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_EN NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_EN NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_EN NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_EN NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_EN NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_EN NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_EN NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_EN NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_EN NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_EN NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_EN NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_EN NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_EN NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_EN NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_EN NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_EN NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_EN NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_EN NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_EN NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_EN NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_EN NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_EN NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_EN NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_EN NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_EN NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_EN NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_EN NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_EN NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_EN NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_EN NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_EN NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_EN NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_EN NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_EN NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_EN NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_EN NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_EN NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_EN NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_EN NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_EN NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_EN "TWB64 156 - Pokédex Red"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_EN NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_EN NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_EN NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_EN NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_EN NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_EN NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_EN NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_EN NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_EN NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_EN NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_EN NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_EN NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_EN NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_EN NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_EN NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_EN NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_EN NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_EN NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_EN NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_EN NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_EN NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_EN NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_EN NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_EN NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_EN NULL
#define OPTION_VAL_TWB64_182_PINK109_EN NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_EN NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_EN NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_EN NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_EN NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_EN NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_EN NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_EN "TWB64 189 - Plum-bob Green"
#define OPTION_VAL_TWB64_190_GRAND_IVORY_EN NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_EN NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_EN NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_EN NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_EN NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_EN NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_EN NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_EN NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_EN NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_EN NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_EN NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_EN NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_EN "Selects internal colourisation palette when 'Internal Palette' is set to 'PixelShift - Pack 1'."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_EN NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_EN NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_EN NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_EN NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_EN NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_EN NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_EN NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_EN NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_EN NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_EN NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_EN NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_EN NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_EN NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_EN NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_EN NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_EN NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_EN NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__EN NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_EN NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_EN NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_EN NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_EN NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_EN NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_EN NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_EN NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_EN NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_EN NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_EN NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_EN NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_EN NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_EN NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_EN NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_EN NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_EN NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_EN NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_EN NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_EN NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_EN NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_EN NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_EN NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_EN NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_EN NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_EN "PixelShift 43 - Vapourwave"
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_EN NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_EN NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_EN "Colour Correction"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_EN "Adjusts output colours to match the display of real Game Boy Colour hardware. 'GBC Only' ensures that correction will only be applied when playing Game Boy Colour games, or when using a Game Boy Colour palette to colourise a Game Boy game. 'Always' applies colour correction to all content, and will produce unexpected/suboptimal results when using 'GB' or 'SGB' internal colour palettes."
#define OPTION_VAL_GBC_ONLY_EN NULL
#define OPTION_VAL_ALWAYS_EN NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_EN "Colour Correction Mode"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_EN "Specifies method used when performing colour correction. 'Accurate' produces output almost indistinguishable from a real Game Boy Colour LCD panel. 'Fast' merely darkens colours and reduces saturation, and may be used on low-end hardware if the 'Accurate' method is too slow."
#define OPTION_VAL_ACCURATE_EN NULL
#define OPTION_VAL_FAST_EN NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_EN "Colour Correction - Front-light Position"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_EN "Simulates the physical response of the Game Boy Colour LCD panel when illuminated from different angles. 'Central' represents standard colour reproduction. 'Above Screen' increases brightness. 'Below Screen' reduces brightness. This setting only applies when 'Colour Correction Mode' is set to 'Accurate'."
#define OPTION_VAL_CENTRAL_EN NULL
#define OPTION_VAL_ABOVE_SCREEN_EN NULL
#define OPTION_VAL_BELOW_SCREEN_EN NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_EN NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_EN "Enable luminosity-based brightness reduction. May be used to avoid glare/eye strain when playing games with white backgrounds, which are intended for display on a non-backlit Game Boy Conor and can therefore appear uncomfortably bright when viewed on a modern backlit screen."
#define GAMBATTE_MIX_FRAMES_LABEL_EN "Inter-frame Blending"
#define GAMBATTE_MIX_FRAMES_INFO_0_EN NULL
#define OPTION_VAL_MIX_EN NULL
#define OPTION_VAL_LCD_GHOSTING_EN NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_EN NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_EN "Audio Re-sampler"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_EN NULL
#define OPTION_VAL_SINC_EN NULL
#define OPTION_VAL_CC_EN NULL
#define GAMBATTE_GB_HWMODE_LABEL_EN NULL
#define GAMBATTE_GB_HWMODE_INFO_0_EN "Specify which type of hardware to emulate. 'Auto' is recommended. Selecting 'GBA' unlocks extra features in certain 'GBA Enhanced' Game Boy Colour games (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_EN NULL
#define OPTION_VAL_GBA_EN NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_EN NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_EN "Enable support for official Game Boy and Game Boy Colour bootloaders, with corresponding start-up logo animations."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_EN NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_EN NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_EN NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_EN NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_EN NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_EN "Enables haptic feedback effects for supported games (Pokémon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_EN NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_EN NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_EN NULL
#define OPTION_VAL_NOT_CONNECTED_EN NULL
#define OPTION_VAL_NETWORK_SERVER_EN NULL
#define OPTION_VAL_NETWORK_CLIENT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_EN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_EN NULL

struct retro_core_option_v2_category option_cats_en[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_EN,
      CATEGORY_GB_LINK_INFO_0_EN
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_en[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_EN,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_EN,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_EN },
         { "GBC",      OPTION_VAL_GBC_EN },
         { "SGB",      OPTION_VAL_SGB_EN },
         { "internal", OPTION_VAL_INTERNAL_EN },
         { "custom",   OPTION_VAL_CUSTOM_EN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_EN,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_EN,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_EN },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_EN },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_EN },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_EN },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_EN },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_EN },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_EN },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_EN },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_EN },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_EN },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_EN },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_EN },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_EN },
         { "GBC - Red",                OPTION_VAL_GBC_RED_EN },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_EN },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_EN },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_EN },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_EN },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_EN },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_EN },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_EN },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_EN },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_EN },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_EN },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_EN },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_EN },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_EN },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_EN },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_EN },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_EN },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_EN },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_EN },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_EN },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_EN },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_EN },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_EN },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_EN },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_EN },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_EN },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_EN },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_EN },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_EN },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_EN },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_EN },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_EN },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_EN },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_EN },
         { "Special 1",                OPTION_VAL_SPECIAL_1_EN },
         { "Special 2",                OPTION_VAL_SPECIAL_2_EN },
         { "Special 3",                OPTION_VAL_SPECIAL_3_EN },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_EN },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_EN },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_EN },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_EN },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_EN,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_EN,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_EN },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_EN },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_EN },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_EN },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_EN },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_EN },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_EN },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_EN },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_EN },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_EN },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_EN },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_EN },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_EN },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_EN },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_EN },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_EN },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_EN },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_EN },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_EN },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_EN },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_EN },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_EN },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_EN },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_EN },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_EN },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_EN },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_EN },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_EN },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_EN },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_EN },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_EN },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_EN },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_EN },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_EN },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_EN },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_EN },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_EN },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_EN },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_EN },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_EN },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_EN },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_EN },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_EN },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_EN },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_EN },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_EN },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_EN },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_EN },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_EN },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_EN },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_EN },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_EN },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_EN },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_EN },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_EN },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_EN },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_EN },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_EN },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_EN },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_EN },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_EN },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_EN },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_EN },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_EN },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_EN },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_EN },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_EN },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_EN },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_EN },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_EN },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_EN },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_EN },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_EN },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_EN },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_EN },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_EN },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_EN },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_EN },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_EN },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_EN },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_EN },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_EN },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_EN },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_EN },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_EN },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_EN },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_EN },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_EN },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_EN },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_EN },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_EN },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_EN },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_EN },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_EN },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_EN },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_EN },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_EN },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_EN },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_EN },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_EN },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_EN,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_EN,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_EN },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_EN },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_EN },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_EN },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_EN },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_EN },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_EN },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_EN },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_EN },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_EN },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_EN },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_EN },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_EN },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_EN },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_EN },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_EN },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_EN },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_EN },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_EN },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_EN },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_EN },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_EN },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_EN },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_EN },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_EN },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_EN },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_EN },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_EN },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_EN },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_EN },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_EN },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_EN },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_EN },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_EN },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_EN },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_EN },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_EN },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_EN },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_EN },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_EN },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_EN },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_EN },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_EN },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_EN },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_EN },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_EN },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_EN },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_EN },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_EN },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_EN },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_EN },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_EN },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_EN },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_EN },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_EN },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_EN },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_EN },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_EN },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_EN },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_EN },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_EN },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_EN },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_EN },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_EN },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_EN },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_EN },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_EN },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_EN },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_EN },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_EN },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_EN },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_EN },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_EN },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_EN },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_EN },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_EN },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_EN },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_EN },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_EN },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_EN },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_EN },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_EN },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_EN },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_EN },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_EN },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_EN },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_EN },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_EN },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_EN },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_EN },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_EN },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_EN },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_EN },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_EN },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_EN },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_EN },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_EN },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_EN },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_EN },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_EN },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_EN,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_EN,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_EN },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_EN },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_EN },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_EN },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_EN },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_EN },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_EN },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_EN },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_EN },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_EN },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_EN },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_EN },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_EN },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_EN },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_EN },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_EN },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_EN },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__EN },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_EN },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_EN },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_EN },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_EN },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_EN },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_EN },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_EN },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_EN },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_EN },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_EN },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_EN },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_EN },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_EN },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_EN },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_EN },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_EN },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_EN },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_EN },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_EN },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_EN },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_EN },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_EN },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_EN },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_EN },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_EN },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_EN },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_EN },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_EN,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_EN,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_EN },
         { "always",   OPTION_VAL_ALWAYS_EN },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_EN,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_EN,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_EN },
         { "fast",     OPTION_VAL_FAST_EN },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_EN,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_EN,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_EN },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_EN },
         { "below screen", OPTION_VAL_BELOW_SCREEN_EN },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_EN,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_EN,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_EN,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_EN,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_EN },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_EN },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_EN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_EN,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_EN,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_EN },
         { "cc",   OPTION_VAL_CC_EN },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_EN,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_EN,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_EN },
         { "GB",   OPTION_VAL_GB_EN },
         { "GBC",  OPTION_VAL_GBC_EN },
         { "GBA",  OPTION_VAL_GBA_EN },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_EN,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_EN,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_EN,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_EN,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_EN,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_EN,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_EN,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_EN,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_EN,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_EN,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_EN,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_MODE_INFO_0_EN,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_EN },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_EN },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_EN },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_EN,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_EN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_EN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_en = {
   option_cats_en,
   option_defs_en
};

/* RETRO_LANGUAGE_EO */

#define CATEGORY_GB_LINK_LABEL_EO NULL
#define CATEGORY_GB_LINK_INFO_0_EO NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_EO NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_EO NULL
#define OPTION_VAL_AUTO_EO NULL
#define OPTION_VAL_GBC_EO NULL
#define OPTION_VAL_SGB_EO NULL
#define OPTION_VAL_INTERNAL_EO NULL
#define OPTION_VAL_CUSTOM_EO NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_EO NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_EO NULL
#define OPTION_VAL_GB_DMG_EO NULL
#define OPTION_VAL_GB_POCKET_EO NULL
#define OPTION_VAL_GB_LIGHT_EO NULL
#define OPTION_VAL_GBC_BLUE_EO NULL
#define OPTION_VAL_GBC_BROWN_EO NULL
#define OPTION_VAL_GBC_DARK_BLUE_EO NULL
#define OPTION_VAL_GBC_DARK_BROWN_EO NULL
#define OPTION_VAL_GBC_DARK_GREEN_EO NULL
#define OPTION_VAL_GBC_GRAYSCALE_EO NULL
#define OPTION_VAL_GBC_GREEN_EO NULL
#define OPTION_VAL_GBC_INVERTED_EO NULL
#define OPTION_VAL_GBC_ORANGE_EO NULL
#define OPTION_VAL_GBC_PASTEL_MIX_EO NULL
#define OPTION_VAL_GBC_RED_EO NULL
#define OPTION_VAL_GBC_YELLOW_EO NULL
#define OPTION_VAL_SGB_1A_EO NULL
#define OPTION_VAL_SGB_1B_EO NULL
#define OPTION_VAL_SGB_1C_EO NULL
#define OPTION_VAL_SGB_1D_EO NULL
#define OPTION_VAL_SGB_1E_EO NULL
#define OPTION_VAL_SGB_1F_EO NULL
#define OPTION_VAL_SGB_1G_EO NULL
#define OPTION_VAL_SGB_1H_EO NULL
#define OPTION_VAL_SGB_2A_EO NULL
#define OPTION_VAL_SGB_2B_EO NULL
#define OPTION_VAL_SGB_2C_EO NULL
#define OPTION_VAL_SGB_2D_EO NULL
#define OPTION_VAL_SGB_2E_EO NULL
#define OPTION_VAL_SGB_2F_EO NULL
#define OPTION_VAL_SGB_2G_EO NULL
#define OPTION_VAL_SGB_2H_EO NULL
#define OPTION_VAL_SGB_3A_EO NULL
#define OPTION_VAL_SGB_3B_EO NULL
#define OPTION_VAL_SGB_3C_EO NULL
#define OPTION_VAL_SGB_3D_EO NULL
#define OPTION_VAL_SGB_3E_EO NULL
#define OPTION_VAL_SGB_3F_EO NULL
#define OPTION_VAL_SGB_3G_EO NULL
#define OPTION_VAL_SGB_3H_EO NULL
#define OPTION_VAL_SGB_4A_EO NULL
#define OPTION_VAL_SGB_4B_EO NULL
#define OPTION_VAL_SGB_4C_EO NULL
#define OPTION_VAL_SGB_4D_EO NULL
#define OPTION_VAL_SGB_4E_EO NULL
#define OPTION_VAL_SGB_4F_EO NULL
#define OPTION_VAL_SGB_4G_EO NULL
#define OPTION_VAL_SGB_4H_EO NULL
#define OPTION_VAL_SPECIAL_1_EO NULL
#define OPTION_VAL_SPECIAL_2_EO NULL
#define OPTION_VAL_SPECIAL_3_EO NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_EO NULL
#define OPTION_VAL_TWB64_PACK_1_EO NULL
#define OPTION_VAL_TWB64_PACK_2_EO NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_EO NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_EO NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_EO NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_EO NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_EO NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_EO NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_EO NULL
#define OPTION_VAL_TWB64_005_NEON_RED_EO NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_EO NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_EO NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_EO NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_EO NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_EO NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_EO NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_EO NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_EO NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_EO NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_EO NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_EO NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_EO NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_EO NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_EO NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_EO NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_EO NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_EO NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_EO NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_EO NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_EO NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_EO NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_EO NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_EO NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_EO NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_EO NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_EO NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_EO NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_EO NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_EO NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_EO NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_EO NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_EO NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_EO NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_EO NULL
#define OPTION_VAL_TWB64_040_DMG_VER_EO NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_EO NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_EO NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_EO NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_EO NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_EO NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_EO NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_EO NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_EO NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_EO NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_EO NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_EO NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_EO NULL
#define OPTION_VAL_TWB64_053_VMU_VER_EO NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_EO NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_EO NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_EO NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_EO NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_EO NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_EO NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_EO NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_EO NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_EO NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_EO NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_EO NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_EO NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_EO NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_EO NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_EO NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_EO NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_EO NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_EO NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_EO NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_EO NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_EO NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_EO NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_EO NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_EO NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_EO NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_EO NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_EO NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_EO NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_EO NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_EO NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_EO NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_EO NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_EO NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_EO NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_EO NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_EO NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_EO NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_EO NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_EO NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_EO NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_EO NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_EO NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_EO NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_EO NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_EO NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_EO NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_EO NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_EO NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_EO NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_EO NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_EO NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_EO NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_EO NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_EO NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_EO NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_EO NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_EO NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_EO NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_EO NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_EO NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_EO NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_EO NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_EO NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_EO NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_EO NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_EO NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_EO NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_EO NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_EO NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_EO NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_EO NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_EO NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_EO NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_EO NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_EO NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_EO NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_EO NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_EO NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_EO NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_EO NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_EO NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_EO NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_EO NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_EO NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_EO NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_EO NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_EO NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_EO NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_EO NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_EO NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_EO NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_EO NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_EO NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_EO NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_EO NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_EO NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_EO NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_EO NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_EO NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_EO NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_EO NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_EO NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_EO NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_EO NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_EO NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_EO NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_EO NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_EO NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_EO NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_EO NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_EO NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_EO NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_EO NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_EO NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_EO NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_EO NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_EO NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_EO NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_EO NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_EO NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_EO NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_EO NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_EO NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_EO NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_EO NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_EO NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_EO NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_EO NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_EO NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_EO NULL
#define OPTION_VAL_TWB64_182_PINK109_EO NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_EO NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_EO NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_EO NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_EO NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_EO NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_EO NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_EO NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_EO NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_EO NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_EO NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_EO NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_EO NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_EO NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_EO NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_EO NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_EO NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_EO NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_EO NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_EO NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_EO NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_EO NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_EO NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_EO NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_EO NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_EO NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_EO NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_EO NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_EO NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_EO NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_EO NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_EO NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_EO NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_EO NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_EO NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_EO NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_EO NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_EO NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__EO NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_EO NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_EO NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_EO NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_EO NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_EO NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_EO NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_EO NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_EO NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_EO NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_EO NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_EO NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_EO NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_EO NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_EO NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_EO NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_EO NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_EO NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_EO NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_EO NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_EO NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_EO NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_EO NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_EO NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_EO NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_EO NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_EO NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_EO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_EO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_EO NULL
#define OPTION_VAL_GBC_ONLY_EO NULL
#define OPTION_VAL_ALWAYS_EO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_EO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_EO NULL
#define OPTION_VAL_ACCURATE_EO NULL
#define OPTION_VAL_FAST_EO NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_EO NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_EO NULL
#define OPTION_VAL_CENTRAL_EO NULL
#define OPTION_VAL_ABOVE_SCREEN_EO NULL
#define OPTION_VAL_BELOW_SCREEN_EO NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_EO NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_EO NULL
#define GAMBATTE_MIX_FRAMES_LABEL_EO NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_EO NULL
#define OPTION_VAL_MIX_EO NULL
#define OPTION_VAL_LCD_GHOSTING_EO NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_EO NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_EO "Audio Resampler Driver"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_EO NULL
#define OPTION_VAL_SINC_EO NULL
#define OPTION_VAL_CC_EO NULL
#define GAMBATTE_GB_HWMODE_LABEL_EO NULL
#define GAMBATTE_GB_HWMODE_INFO_0_EO NULL
#define OPTION_VAL_GB_EO NULL
#define OPTION_VAL_GBA_EO NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_EO NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_EO NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_EO NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_EO NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_EO NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_EO NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_EO NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_EO NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_EO NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_EO NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_EO NULL
#define OPTION_VAL_NOT_CONNECTED_EO NULL
#define OPTION_VAL_NETWORK_SERVER_EO NULL
#define OPTION_VAL_NETWORK_CLIENT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_EO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_EO NULL

struct retro_core_option_v2_category option_cats_eo[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_EO,
      CATEGORY_GB_LINK_INFO_0_EO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_eo[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_EO,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_EO,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_EO },
         { "GBC",      OPTION_VAL_GBC_EO },
         { "SGB",      OPTION_VAL_SGB_EO },
         { "internal", OPTION_VAL_INTERNAL_EO },
         { "custom",   OPTION_VAL_CUSTOM_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_EO,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_EO,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_EO },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_EO },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_EO },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_EO },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_EO },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_EO },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_EO },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_EO },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_EO },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_EO },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_EO },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_EO },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_EO },
         { "GBC - Red",                OPTION_VAL_GBC_RED_EO },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_EO },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_EO },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_EO },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_EO },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_EO },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_EO },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_EO },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_EO },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_EO },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_EO },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_EO },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_EO },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_EO },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_EO },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_EO },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_EO },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_EO },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_EO },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_EO },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_EO },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_EO },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_EO },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_EO },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_EO },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_EO },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_EO },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_EO },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_EO },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_EO },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_EO },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_EO },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_EO },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_EO },
         { "Special 1",                OPTION_VAL_SPECIAL_1_EO },
         { "Special 2",                OPTION_VAL_SPECIAL_2_EO },
         { "Special 3",                OPTION_VAL_SPECIAL_3_EO },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_EO },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_EO },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_EO },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_EO },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_EO,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_EO,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_EO },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_EO },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_EO },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_EO },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_EO },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_EO },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_EO },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_EO },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_EO },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_EO },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_EO },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_EO },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_EO },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_EO },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_EO },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_EO },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_EO },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_EO },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_EO },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_EO },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_EO },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_EO },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_EO },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_EO },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_EO },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_EO },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_EO },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_EO },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_EO },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_EO },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_EO },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_EO },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_EO },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_EO },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_EO },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_EO },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_EO },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_EO },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_EO },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_EO },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_EO },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_EO },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_EO },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_EO },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_EO },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_EO },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_EO },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_EO },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_EO },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_EO },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_EO },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_EO },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_EO },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_EO },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_EO },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_EO },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_EO },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_EO },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_EO },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_EO },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_EO },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_EO },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_EO },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_EO },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_EO },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_EO },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_EO },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_EO },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_EO },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_EO },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_EO },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_EO },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_EO },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_EO },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_EO },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_EO },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_EO },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_EO },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_EO },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_EO },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_EO },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_EO },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_EO },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_EO },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_EO },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_EO },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_EO },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_EO },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_EO },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_EO },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_EO },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_EO },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_EO },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_EO },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_EO },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_EO },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_EO },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_EO },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_EO },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_EO },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_EO,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_EO,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_EO },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_EO },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_EO },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_EO },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_EO },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_EO },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_EO },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_EO },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_EO },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_EO },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_EO },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_EO },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_EO },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_EO },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_EO },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_EO },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_EO },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_EO },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_EO },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_EO },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_EO },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_EO },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_EO },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_EO },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_EO },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_EO },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_EO },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_EO },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_EO },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_EO },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_EO },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_EO },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_EO },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_EO },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_EO },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_EO },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_EO },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_EO },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_EO },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_EO },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_EO },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_EO },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_EO },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_EO },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_EO },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_EO },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_EO },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_EO },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_EO },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_EO },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_EO },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_EO },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_EO },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_EO },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_EO },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_EO },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_EO },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_EO },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_EO },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_EO },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_EO },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_EO },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_EO },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_EO },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_EO },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_EO },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_EO },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_EO },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_EO },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_EO },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_EO },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_EO },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_EO },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_EO },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_EO },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_EO },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_EO },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_EO },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_EO },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_EO },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_EO },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_EO },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_EO },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_EO },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_EO },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_EO },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_EO },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_EO },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_EO },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_EO },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_EO },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_EO },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_EO },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_EO },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_EO },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_EO },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_EO },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_EO },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_EO },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_EO },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_EO,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_EO,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_EO },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_EO },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_EO },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_EO },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_EO },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_EO },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_EO },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_EO },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_EO },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_EO },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_EO },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_EO },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_EO },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_EO },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_EO },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_EO },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_EO },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__EO },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_EO },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_EO },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_EO },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_EO },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_EO },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_EO },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_EO },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_EO },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_EO },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_EO },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_EO },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_EO },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_EO },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_EO },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_EO },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_EO },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_EO },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_EO },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_EO },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_EO },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_EO },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_EO },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_EO },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_EO },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_EO },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_EO },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_EO },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_EO,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_EO,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_EO },
         { "always",   OPTION_VAL_ALWAYS_EO },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_EO,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_EO,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_EO },
         { "fast",     OPTION_VAL_FAST_EO },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_EO,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_EO,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_EO },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_EO },
         { "below screen", OPTION_VAL_BELOW_SCREEN_EO },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_EO,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_EO,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_EO,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_EO,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_EO },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_EO },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_EO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_EO,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_EO,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_EO },
         { "cc",   OPTION_VAL_CC_EO },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_EO,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_EO,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_EO },
         { "GB",   OPTION_VAL_GB_EO },
         { "GBC",  OPTION_VAL_GBC_EO },
         { "GBA",  OPTION_VAL_GBA_EO },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_EO,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_EO,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_EO,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_EO,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_EO,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_EO,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_EO,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_EO,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_EO,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_EO,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_EO,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_MODE_INFO_0_EO,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_EO },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_EO },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_EO },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_EO,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_EO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_EO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_eo = {
   option_cats_eo,
   option_defs_eo
};

/* RETRO_LANGUAGE_ES */

#define CATEGORY_GB_LINK_LABEL_ES NULL
#define CATEGORY_GB_LINK_INFO_0_ES "Cambia las opciones de la conexión (multijugador) mediante cable Game Link."
#define GAMBATTE_GB_COLORIZATION_LABEL_ES "Coloración de GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_ES "Permite colorear los juegos para Game Boy. «Selección automática» selecciona la paleta más colorida o adecuada. «GBC» selecciona la paleta diseñada para Game Boy Color si existe, de lo contrario utilizará «GBC verde oscuro». SGB selecciona la paleta diseñada para Super Game Boy si existe, de lo contrario utilizará «SGB 1A». «Interna» usará la opción «Paleta interna» del núcleo. «Personalizar» carga una paleta personalizada del directorio del sistema."
#define OPTION_VAL_AUTO_ES "Automático"
#define OPTION_VAL_GBC_ES NULL
#define OPTION_VAL_SGB_ES NULL
#define OPTION_VAL_INTERNAL_ES "Interna"
#define OPTION_VAL_CUSTOM_ES "Personalizado"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_ES "Paleta interna"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_ES "Selecciona la paleta con la que colorear los juegos para Game Boy cuando la opción Coloración de GB esté configurada como interna o cuando esté configurada como automática, pero el juego no tenga una paleta predefinida para SGB o GBC. Las paletas GB simulan la pantalla del hardware original de Game Boy. Las paletas GBC son idénticas a las preconfiguradas en una Game Boy Color. Las paletas SGB son idénticas a las preconfiguradas en el Super Game Boy."
#define OPTION_VAL_GB_DMG_ES "GB (DMG)"
#define OPTION_VAL_GB_POCKET_ES "GB (Pocket)"
#define OPTION_VAL_GB_LIGHT_ES "GB (Light)"
#define OPTION_VAL_GBC_BLUE_ES "GBC (azul)"
#define OPTION_VAL_GBC_BROWN_ES "GBC (marrón)"
#define OPTION_VAL_GBC_DARK_BLUE_ES "GBC (azul oscuro)"
#define OPTION_VAL_GBC_DARK_BROWN_ES "GBC (marrón oscuro)"
#define OPTION_VAL_GBC_DARK_GREEN_ES "GBC (verde oscuro)"
#define OPTION_VAL_GBC_GRAYSCALE_ES "GBC (escala de grises)"
#define OPTION_VAL_GBC_GREEN_ES "GBC (verde)"
#define OPTION_VAL_GBC_INVERTED_ES "GBC (invertido)"
#define OPTION_VAL_GBC_ORANGE_ES "GBC (naranja)"
#define OPTION_VAL_GBC_PASTEL_MIX_ES "GBC (pastel)"
#define OPTION_VAL_GBC_RED_ES "GBC (rojo)"
#define OPTION_VAL_GBC_YELLOW_ES "GBC (amarillo)"
#define OPTION_VAL_SGB_1A_ES "SGB (1A)"
#define OPTION_VAL_SGB_1B_ES "SGB (1B)"
#define OPTION_VAL_SGB_1C_ES "SGB (1C)"
#define OPTION_VAL_SGB_1D_ES "SGB (1D)"
#define OPTION_VAL_SGB_1E_ES "SGB (1E)"
#define OPTION_VAL_SGB_1F_ES "SGB (1F)"
#define OPTION_VAL_SGB_1G_ES "SGB (1G)"
#define OPTION_VAL_SGB_1H_ES "SGB (1H)"
#define OPTION_VAL_SGB_2A_ES "SGB (2A)"
#define OPTION_VAL_SGB_2B_ES "SGB (2B)"
#define OPTION_VAL_SGB_2C_ES "SGB (2C)"
#define OPTION_VAL_SGB_2D_ES "SGB (2D)"
#define OPTION_VAL_SGB_2E_ES "SGB (2E)"
#define OPTION_VAL_SGB_2F_ES "SGB (2F)"
#define OPTION_VAL_SGB_2G_ES "SGB (2G)"
#define OPTION_VAL_SGB_2H_ES "SGB (2H)"
#define OPTION_VAL_SGB_3A_ES "SGB (3A)"
#define OPTION_VAL_SGB_3B_ES "SGB (3B)"
#define OPTION_VAL_SGB_3C_ES "SGB (3C)"
#define OPTION_VAL_SGB_3D_ES "SGB (3D)"
#define OPTION_VAL_SGB_3E_ES "SGB (3E)"
#define OPTION_VAL_SGB_3F_ES "SGB (3F)"
#define OPTION_VAL_SGB_3G_ES "SGB (3G)"
#define OPTION_VAL_SGB_3H_ES "SGB (3H)"
#define OPTION_VAL_SGB_4A_ES "SGB (4A)"
#define OPTION_VAL_SGB_4B_ES "SGB (4B)"
#define OPTION_VAL_SGB_4C_ES "SGB (4C)"
#define OPTION_VAL_SGB_4D_ES "SGB (4D)"
#define OPTION_VAL_SGB_4E_ES "SGB (4E)"
#define OPTION_VAL_SGB_4F_ES "SGB (4F)"
#define OPTION_VAL_SGB_4G_ES "SGB (4G)"
#define OPTION_VAL_SGB_4H_ES "SGB (4H)"
#define OPTION_VAL_SPECIAL_1_ES "Especial 1"
#define OPTION_VAL_SPECIAL_2_ES "Especial 2"
#define OPTION_VAL_SPECIAL_3_ES "Especial 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_ES "Especial 4 (heredada de la TI-83)"
#define OPTION_VAL_TWB64_PACK_1_ES "Paquete 1 de TWB64"
#define OPTION_VAL_TWB64_PACK_2_ES "Paquete 2 de TWB64"
#define OPTION_VAL_PIXELSHIFT_PACK_1_ES "Paquete 1 de PixelShift"
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_ES "> Paquete de paletas 1 de TWB64"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_ES "Selecciona la paleta de coloración interna que se utilizará cuando se haya seleccionado el paquete 1 de TWB64 como paleta interna."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_ES "TWB64 001 (azul Aqours)"
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_ES "TWB64 002 (versión Anime Expo)"
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_ES "TWB64 003 (amarillo Bob Esponja)"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_ES "TWB64 004 (rosa Patricio Estrella)"
#define OPTION_VAL_TWB64_005_NEON_RED_ES "TWB64 005 (rojo neón)"
#define OPTION_VAL_TWB64_006_NEON_BLUE_ES "TWB64 006 (azul neón)"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_ES "TWB64 007 (amarillo neón)"
#define OPTION_VAL_TWB64_008_NEON_GREEN_ES "TWB64 008 (verde neón)"
#define OPTION_VAL_TWB64_009_NEON_PINK_ES "TWB64 009 (rosa neón)"
#define OPTION_VAL_TWB64_010_MARIO_RED_ES "TWB64 010 (rojo Mario)"
#define OPTION_VAL_TWB64_011_NICK_ORANGE_ES "TWB64 011 (naranja Nick)"
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_ES "TWB64 012 (versión Virtual Boy)"
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_ES "TWB64 013 (dorado Wild)"
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_ES "TWB64 014 (amarillo construcción)"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_ES "TWB64 015 (azul púrpura clásico)"
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_ES "TWB64 016 (ver. 765 Production)"
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_ES "TWB64 017 (marfil superbola)"
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_ES "TWB64 018 (naranja Crunchyroll)"
#define OPTION_VAL_TWB64_019_MUSE_PINK_ES "TWB64 019 (rosa Muse)"
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_ES "TWB64 020 (amarillo Nijigasaki)"
#define OPTION_VAL_TWB64_021_GAMATE_VER_ES "TWB64 021 (versión Gamate)"
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_ES "TWB64 022 (versión a escala de verdes)"
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_ES "TWB64 023 (dorado Odyssey)"
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_ES "TWB64 024 (Súper Saiyan Dios)"
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_ES "TWB64 025 (Súper Saiyan Azul)"
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_ES "TWB64 026 (rosa Bizarre)"
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_ES "TWB64 027 (versión Switch Lite)"
#define OPTION_VAL_TWB64_028_GAME_COM_VER_ES "TWB64 028 (versión Game.com)"
#define OPTION_VAL_TWB64_029_SANRIO_PINK_ES "TWB64 029 (rosa Sanrio)"
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_ES "TWB64 030 (versión BANDAI NAMCO)"
#define OPTION_VAL_TWB64_031_COSMO_GREEN_ES "TWB64 031 (verde Cosmo)"
#define OPTION_VAL_TWB64_032_WANDA_PINK_ES "TWB64 032 (rosa Wanda)"
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_ES "TWB64 033 (versión Link's Awakening DX)"
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_ES "TWB64 036 (madera de álbum de fotos)"
#define OPTION_VAL_TWB64_035_POKEMON_VER_ES "TWB64 035 (versión Pokémon)"
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_ES "TWB64 036 (naranja Game Grump)"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_ES "TWB64 037 (versión Scooby-Doo Misterios)"
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_ES "TWB64 038 (versión Pokémon mini)"
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_ES "TWB64 039 (versión Supervision)"
#define OPTION_VAL_TWB64_040_DMG_VER_ES "TWB64 040 (versión DMG)"
#define OPTION_VAL_TWB64_041_POCKET_VER_ES "TWB64 041 (versión Pocket)"
#define OPTION_VAL_TWB64_042_LIGHT_VER_ES "TWB64 042 (versión Light)"
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_ES "TWB64 043 (azul Miraitowa)"
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_ES "TWB64 044 (rosa Someity)"
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_ES "TWB64 045 (amarillo Pikachu)"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_ES "TWB64 046 (marrón Eevee)"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_ES "TWB64 047 (versión Microvision)"
#define OPTION_VAL_TWB64_048_TI_83_VER_ES "TWB64 048 (versión TI-83)"
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_ES "TWB64 049 (rojo Égida)"
#define OPTION_VAL_TWB64_050_LABO_FAWN_ES "TWB64 050 (beige Labo)"
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_ES "TWB64 051 (¡DORADO MILLION LIVE!)"
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_ES "TWB64 052 (versión Tokyo Midtown)"
#define OPTION_VAL_TWB64_053_VMU_VER_ES "TWB64 053 (versión Visual Memory)"
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_ES "TWB64 054 (versión Game Master)"
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_ES "TWB64 055 (verde Android)"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_ES "TWB64 056 (azul Ticketmaster)"
#define OPTION_VAL_TWB64_057_GOOGLE_RED_ES "TWB64 057 (rojo Google)"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_ES "TWB64 058 (azul Google)"
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_ES "TWB64 059 (amarillo Google)"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_ES "TWB64 060 (verde Google)"
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_ES "TWB64 061 (versión WonderSwan)"
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_ES "TWB64 062 (versión Neo Geo Pocket)"
#define OPTION_VAL_TWB64_063_DEW_GREEN_ES "TWB64 063 (verde Dew)"
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_ES "TWB64 064 (rojo Coca-Cola)"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_ES "TWB64 065 (versión GameKing)"
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_ES "TWB64 066 (versión Do The Dew)"
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_ES "TWB64 067 (versión Digivice)"
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_ES "TWB64 068 (versión Fondo de Bikini)"
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_ES "TWB64 069 (rosa Pétalo)"
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_ES "TWB64 070 (azul Burbuja)"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_ES "TWB64 071 (verde Cactus)"
#define OPTION_VAL_TWB64_072_NASCAR_VER_ES "TWB64 072 (versión NASCAR)"
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_ES "TWB64 073 (verde lima-limón)"
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_ES "TWB64 074 (versión Mega Man V)"
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_ES "TWB64 075 (versión Tamagotchi)"
#define OPTION_VAL_TWB64_076_PHANTOM_RED_ES "TWB64 076 (rojo Fantasma)"
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_ES "TWB64 077 (versión de Halloween)"
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_ES "TWB64 078 (versión de Navidad)"
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_ES "TWB64 079 (rosa cazadora de cartas)"
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_ES "TWB64 080 (dorado Pretty Guardian)"
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_ES "TWB64 081 (versión de camuflaje)"
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_ES "TWB64 082 (Súper Saiyan legendario)"
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_ES "TWB64 083 (Súper Saiyan Rosé)"
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_ES "TWB64 084 (Súper Saiyan)"
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_ES "TWB64 085 (Ultrainstinto perfeccionado)"
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_ES "TWB64 086 (rojo Saint Snow)"
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_ES "TWB64 087 (amarillo plátano)"
#define OPTION_VAL_TWB64_088_GREEN_BANANA_ES "TWB64 088 (verde plátano)"
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_ES "TWB64 089 (Súper Saiyan 3)"
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_ES "TWB64 090 (Súper Saiyan Azul evolucionado)"
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_ES "TWB64 091 (versión Pocket Tales)"
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_ES "TWB64 092 (amarillo investigación)"
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_ES "TWB64 093 (azul S.E.E.S.)"
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_ES "TWB64 094 (cian Game Awards)"
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_ES "TWB64 095 (naranja Hokage)"
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_ES "TWB64 096 (rojo Sombrero de paja)"
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_ES "TWB64 097 (cian Sword Art)"
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_ES "TWB64 098 (verde Deku Alpha)"
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_ES "TWB64 099 (versión Franjas azules)"
#define OPTION_VAL_TWB64_100_STONE_ORANGE_ES "TWB64 100 (naranja Stone)"
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_ES "> Paquete de paletas 2 de TWB64"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_ES "Selecciona la paleta de coloración interna que se utilizará cuando se haya seleccionado el paquete 2 de TWB64 como paleta interna."
#define OPTION_VAL_TWB64_101_765PRO_PINK_ES "TWB64 101 (rosa 765PRO)"
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_ES "TWB64 102 (azul CINDERELLA)"
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_ES "TWB64 103 (amarillo MILLION!)"
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_ES "TWB64 104 (verde SideM)"
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_ES "TWB64 105 (azul cielo SHINY)"
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_ES "TWB64 106 (versión volcán del Angry)"
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_ES "TWB64 107 (rosa Yo-kai)"
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_ES "TWB64 108 (verde Yo-kai)"
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_ES "TWB64 109 (azul Yo-kai)"
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_ES "TWB64 110 (morado Yo-kai)"
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_ES "TWB64 111 (iro agua)"
#define OPTION_VAL_TWB64_112_TEA_MIDORI_ES "TWB64 112 (midori té)"
#define OPTION_VAL_TWB64_113_SAKURA_PINK_ES "TWB64 113 (rosa sakura)"
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_ES "TWB64 114 (malva murasaki)"
#define OPTION_VAL_TWB64_115_ONI_AKA_ES "TWB64 115 (aka oni)"
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_ES "TWB64 116 (dorado kiiro)"
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_ES "TWB64 117 (plata shiro)"
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_ES "TWB64 118 (naranja frutal)"
#define OPTION_VAL_TWB64_119_AKB48_PINK_ES "TWB64 119 (rosa AKB48)"
#define OPTION_VAL_TWB64_120_MIKU_BLUE_ES "TWB64 120 (azul Miku)"
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_ES "TWB64 121 (rojo Fairy Tail)"
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_ES "TWB64 122 (marrón Cuerpo de Exploración)"
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_ES "TWB64 123 (verde isla)"
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_ES "TWB64 124 (verde Mania Plus)"
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_ES "TWB64 125 (verde tortuga ninja)"
#define OPTION_VAL_TWB64_126_SLIME_BLUE_ES "TWB64 126 (azul limo)"
#define OPTION_VAL_TWB64_127_LIME_MIDORI_ES "TWB64 127 (midori verde lima)"
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_ES "TWB64 128 (aoi espectral)"
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_ES "TWB64 129 (bazar retro)"
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_ES "TWB64 130 (azul Switch)"
#define OPTION_VAL_TWB64_131_NEON_PURPLE_ES "TWB64 131 (morado neón)"
#define OPTION_VAL_TWB64_132_NEON_ORANGE_ES "TWB64 132 (naranja neón)"
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_ES "TWB64 133 (Moonlight Vision)"
#define OPTION_VAL_TWB64_134_TOKYO_RED_ES "TWB64 134 (rojo Tokio)"
#define OPTION_VAL_TWB64_135_PARIS_GOLD_ES "TWB64 135 (dorado París)"
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_ES "TWB64 136 (azul Beijing)"
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_ES "TWB64 137 (amarillo Pac-Man)"
#define OPTION_VAL_TWB64_138_IRISH_GREEN_ES "TWB64 138 (verde irlandés)"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_ES "TWB64 139 (naranja Kakarot)"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_ES "TWB64 140 (naranja bola de dragón)"
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_ES "TWB64 141 (dorado de Navidad)"
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_ES "TWB64 142 (azul Pepsicola)"
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_ES "TWB64 143 (verde Bub)"
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_ES "TWB64 144 (azul Bob)"
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_ES "TWB64 145 (tormenta Baja Blast)"
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_ES "TWB64 146 (oro olímpico)"
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_ES "TWB64 147 (naranja premio)"
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_ES "TWB64 148 (morado Liella!)"
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_ES "TWB64 149 (plata olímpica)"
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_ES "TWB64 150 (bronce olímpico)"
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_ES "TWB64 151 (azul cielo ANA)"
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_ES "TWB64 152 (naranja Nijigasaki)"
#define OPTION_VAL_TWB64_153_HOLOBLUE_ES "TWB64 153 (Holoazul)"
#define OPTION_VAL_TWB64_154_WRESTLING_RED_ES "TWB64 154 (rojo Pressing Catch)"
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_ES "TWB64 155 (verde huevo de Yoshi)"
#define OPTION_VAL_TWB64_156_POKEDEX_RED_ES "TWB64 156 (rojo Pokédex)"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_ES "TWB64 157 (azul sueño de Disney)"
#define OPTION_VAL_TWB64_158_XBOX_GREEN_ES "TWB64 158 (verde Xbox)"
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_ES "TWB64 159 (azul Sonic Mega)"
#define OPTION_VAL_TWB64_160_G4_ORANGE_ES "TWB64 160 (naranja G4)"
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_ES "TWB64 161 (verde Scarlett)"
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_ES "TWB64 162 (azul Glitchy)"
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_ES "TWB64 163 (LCD clásico)"
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_ES "TWB64 164 (versión consola virtual de 3DS)"
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_ES "TWB64 165 (versión PocketStation)"
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_ES "TWB64 166 (Game and Oro)"
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_ES "TWB64 167 (azul pitufo)"
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_ES "TWB64 168 (verde ogro de ciénaga)"
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_ES "TWB64 169 (verde espinacas de marino)"
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_ES "TWB64 170 (verde Shen Long)"
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_ES "TWB64 171 (rojo sangre Berserk)"
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_ES "TWB64 172 (rosa Super Star)"
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_ES "TWB64 173 (versión Gamebuino Classic)"
#define OPTION_VAL_TWB64_174_BARBIE_PINK_ES "TWB64 174 (rosa Barbie)"
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_ES "TWB64 175 (verde Guardián del Espacio)"
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_ES "TWB64 176 (versión Nokia 3310)"
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_ES "TWB64 177 (verde trébol)"
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_ES "TWB64 178 (naranja Crash)"
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_ES "TWB64 179 (amarillo Famicom Disk)"
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_ES "TWB64 180 (rojo Team Rocket)"
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_ES "TWB64 181 (amarillo cronómetro SEIKO)"
#define OPTION_VAL_TWB64_182_PINK109_ES "TWB64 182 (PINK109)"
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_ES "TWB64 183 (azul Doraemon)"
#define OPTION_VAL_TWB64_184_FURY_BLUE_ES "TWB64 184 (azul Fury)"
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_ES "TWB64 185 (naranja Rockstar)"
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_ES "TWB64 186 (verde Puyo Puyo)"
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_ES "TWB64 187 (rosa Susan G.)"
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_ES "TWB64 188 (rojo Pizza Hut)"
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_ES "TWB64 189 (verde plomada)"
#define OPTION_VAL_TWB64_190_GRAND_IVORY_ES "TWB64 190 (marfil Grand)"
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_ES "TWB64 191 (dorado guardián)"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_ES "TWB64 192 (azul SEGA Tokio)"
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_ES "TWB64 193 (azul elegido)"
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_ES "TWB64 194 (marrón barril DK)"
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_ES "TWB64 195 (verde Evangelion)"
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_ES "TWB64 196 (morado Equestria)"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_ES "TWB64 197 (rojo Autobot)"
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_ES "TWB64 198 (verdemar Niconico)"
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_ES "TWB64 199 (cobre Duracell)"
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_ES "TWB64 200 (AZUL TOKYO SKYTREE)"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_ES "> Paquete de paletas 1 de PixelShift"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_ES "Selecciona la paleta de coloración interna que se utilizará cuando se haya seleccionado el paquete 1 de PixelShift como paleta interna."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_ES "PixelShift 01 (verde ártico)"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_ES "PixelShift 02 (Arduboy)"
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_ES "PixelShift 03 (Emulador BGB 0.3)"
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_ES "PixelShift 04 (Camuflaje)"
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_ES "PixelShift 05 (Tableta de chocolate)"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_ES "PixelShift 06 (CMYK)"
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_ES "PixelShift 07 (Algodón de azúcar)"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_ES "PixelShift 08 (verdes relajantes)"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_ES "PixelShift 09 (Gamate)"
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_ES "PixelShift 10 (Game Boy Light)"
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_ES "PixelShift 11 (Game Boy Pocket)"
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_ES "PixelShift 12 (Game Boy Pocket, alternativa)"
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_ES "PixelShift 13 (Game Pocket Computer)"
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_ES "PixelShift 14 (Game & Watch Ball)"
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_ES "PixelShift 15 (GB retroiluminada, azul)"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_ES "PixelShift 15 (GB retroiluminada, apagada)"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_ES "PixelShift 17 (GB retroiluminada, naranja)"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__ES "PixelShift 18 (GB retroiluminada, blanca)"
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_ES "PixelShift 19 (GB retroiluminada, amarillo oscuro)"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_ES "PixelShift 20 (GB falsificada)"
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_ES "PixelShift 21 (GB Hunter)"
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_ES "PixelShift 22 (puesto de GB)"
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_ES "PixelShift 23 (puesto de GB 2)"
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_ES "PixelShift 24 (GB nueva)"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_ES "PixelShift 25 (GB nuclear)"
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_ES "PixelShift 26 (GB antigua)"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_ES "PixelShift 27 (GBP Bivert)"
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_ES "PixelShift 28 (GB retroiluminada, amarillo apagado)"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_ES "PixelShift 29 (fantasmal)"
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_ES "PixelShift 30 (Radiactiva)"
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_ES "PixelShift 31 (Lingote de oro)"
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_ES "PixelShift 32 (Pomelo)"
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_ES "PixelShift 33 (gris verdoso)"
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_ES "PixelShift 34 (Missingno)"
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_ES "PixelShift 35 (MS-DOS)"
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_ES "PixelShift 36 (Periódico)"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_ES "PixelShift 37 (Pip-Boy)"
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_ES "PixelShift 38 (Pocket Girl)"
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_ES "PixelShift 39 (Silueta)"
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_ES "PixelShift 40 (Rayos de sol)"
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_ES "PixelShift 41 (Technicolor)"
#define OPTION_VAL_PIXELSHIFT_42_TRON_ES "PixelShift 42 (Tron)"
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_ES "PixelShift 43 (Vaporwave)"
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_ES "PixelShift 44 (Virtual Boy)"
#define OPTION_VAL_PIXELSHIFT_45_WISH_ES "PixelShift 45 (deseo)"
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_ES "Corrección de color"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_ES "Ajusta los colores de la salida de vídeo para que se asemejen a los del hardware real de una Game Boy Color. «Solo para GBC» hace que solo se aplique la corrección al ejecutar juegos de Game Boy Color o al utilizar una paleta de Game Boy Color para colorear un juego de Game Boy. «Siempre» aplicará la corrección de color a todos los contenidos, produciendo resultados inesperados o deficientes al utilizar las paletas internas de GB o SGB."
#define OPTION_VAL_GBC_ONLY_ES "Solo para GBC"
#define OPTION_VAL_ALWAYS_ES "Siempre"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_ES "Modo de corrección de color"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_ES "Especifica el método que se utilizará para corregir el color. «Preciso» producirá una imagen casi indistinguible de la pantalla LCD de una Game Boy Color real. «Rápido» se limitará a oscurecer los colores y a reducir la saturación. La opción «Rápido» puede utilizarse en hardwares de gama baja si la opción «Preciso» es demasiado lenta."
#define OPTION_VAL_ACCURATE_ES "Preciso"
#define OPTION_VAL_FAST_ES "Rápida"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_ES "Corrección de color - Posición de la luz frontal"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_ES "Simula la respuesta física del panel LCD de una Game Boy Color cuando es iluminado desde distintos ángulos. «Centrada» representa la reproducción de color estándar. «Por encima de la pantalla» aumenta su brillo y «Por debajo de la pantalla» lo disminuye. Este ajuste se aplicará únicamente cuando el modo de corrección de color esté configurado como «Preciso»."
#define OPTION_VAL_CENTRAL_ES "Centrada"
#define OPTION_VAL_ABOVE_SCREEN_ES "Por encima de la pantalla"
#define OPTION_VAL_BELOW_SCREEN_ES "Por debajo de la pantalla"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_ES "Nivel del filtro de oscuridad (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_ES "Permite reducir el brillo mediante su luminosidad. Puede evitar los reflejos o el desgaste ocular al ejecutar juegos con fondos blancos que estén pensados para una Game Boy Color sin retroiluminación y que podrían mostrarse con un brillo excesivamente fuerte en una pantalla retroiluminada moderna."
#define GAMBATTE_MIX_FRAMES_LABEL_ES "Fusión entre fotogramas"
#define GAMBATTE_MIX_FRAMES_INFO_0_ES "Simula el efecto de imagen fantasma («ghosting») de la pantalla LCD. «Sencilla» mezcla la mitad de los fotogramas anterior y siguiente. «Imagen fantasma de LCD» simula los tiempos de respuesta naturales de una pantalla LCD combinando varios fotogramas almacenados en el búfer. La fusión «Sencilla» es necesaria para aquellos juegos que necesiten este efecto para mostrar efectos de transparencias (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_ES "Sencilla"
#define OPTION_VAL_LCD_GHOSTING_ES "Imagen fantasma («ghosting») de LCD (preciso)"
#define OPTION_VAL_LCD_GHOSTING_FAST_ES "Imagen fantasma («ghosting») de LCD (rápido)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_ES "Remuestreo de audio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_ES "Especifica qué algoritmo se utilizará al remuestrear el audio generado (la frecuencia sonora de Game Boy solo está limitada por la velocidad de lectura de su CPU, por lo que esas frecuencias «nativas» no son prácticas en dispositivos modernos de sonido y deben ser submuestreadas). Seno produce la mejor calidad. Coseno mejora el rendimiento en sistemas de gama baja."
#define OPTION_VAL_SINC_ES "Seno"
#define OPTION_VAL_CC_ES "Coseno"
#define GAMBATTE_GB_HWMODE_LABEL_ES "Hardware emulado (es necesario reiniciar)"
#define GAMBATTE_GB_HWMODE_INFO_0_ES "Especifica el tipo de hardware a emular. Se recomienda usar «Selección automática». La opción GBA desbloquea ciertas características en aquellos juegos para Game Boy Color que tengan el modo GBA Enhanced (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_ES NULL
#define OPTION_VAL_GBA_ES NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_ES "Utilizar cargador de arranque oficial (es necesario reiniciar)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_ES "Activa el soporte para los cargadores de arranque oficiales de Game Boy y Game Boy Color con sus correspondientes animaciones de arranque."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_ES "Permitir direcciones opuestas"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_ES "Esta opción permitirá pulsar, alternar rápidamente o mantener las direcciones izquierda y derecha (o arriba y abajo) al mismo tiempo. Podría provocar fallos de movimiento."
#define GAMBATTE_TURBO_PERIOD_LABEL_ES "Duración del botón Turbo"
#define GAMBATTE_TURBO_PERIOD_INFO_0_ES "Especifica el intervalo (en fotogramas) con el que se repetirá la pulsación de los botones A o B al mantener pulsados sus equivalentes con turbo."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_ES "Fuerza de la vibración del mando"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_ES "Activa los efectos de respuesta háptica en aquellos juegos que sean compatibles con la misma (Pokémon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_ES "Mostrar ajustes del cable Game Link"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_ES "Permite configurar las opciones de la conexión (multijugador) en red por cable Game Link. NOTA: es necesario salir y volver a entrar del menú rápido para que el cambio surta efecto."
#define GAMBATTE_GB_LINK_MODE_LABEL_ES "Modo de cable Game Link"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_ES "Modo de conexión"
#define GAMBATTE_GB_LINK_MODE_INFO_0_ES "Cuando se active la función de red del cable Game Link, esta opción especifica qué instancia debería hacer de servidor o de cliente."
#define OPTION_VAL_NOT_CONNECTED_ES "Sin conexión"
#define OPTION_VAL_NETWORK_SERVER_ES "Servidor de red"
#define OPTION_VAL_NETWORK_CLIENT_ES "Cliente de red"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_ES "Puerto de enlace de red"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_ES "Puerto"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_ES "Especifica el puerto que se utilizará para las comunicaciones de red del cable Game Link."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_ES "Valor 01 de la dirección del servidor de red: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_ES "Valor 01 de la dirección del servidor: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_ES "El primer dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_ES "El primer dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_ES "Valor 02 de la dirección del servidor de red: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_ES "Valor 02 de la dirección del servidor: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_ES "El segundo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_ES "El segundo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_ES "Valor 03 de la dirección del servidor de red: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_ES "Valor 03 de la dirección del servidor: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_ES "El tercer dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_ES "El tercer dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_ES "Valor 04 de la dirección del servidor de red: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_ES "Valor 04 de la dirección del servidor: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_ES "El cuarto dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_ES "El cuarto dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_ES "Valor 05 de la dirección del servidor de red: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_ES "Valor 05 de la dirección del servidor: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_ES "El quinto dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_ES "El quinto dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_ES "Valor 06 de la dirección del servidor de red: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_ES "Valor 06 de la dirección del servidor: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_ES "El sexto dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_ES "El sexto dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_ES "Valor 07 de la dirección del servidor de red: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_ES "Valor 07 de la dirección del servidor: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_ES "El séptimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_ES "El séptimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_ES "Valor 08 de la dirección del servidor de red: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_ES "Valor 08 de la dirección del servidor: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_ES "El octavo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_ES "El octavo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_ES "Valor 09 de la dirección del servidor de red: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_ES "Valor 09 de la dirección del servidor: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_ES "El noveno dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_ES "El noveno dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_ES "Valor 10 de la dirección del servidor de red: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_ES "Valor 10 de la dirección del servidor: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_ES "El décimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_ES "El décimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_ES "Valor 11 de la dirección del servidor de red: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_ES "Valor 11 de la dirección del servidor: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_ES "El undécimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_ES "El undécimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_ES "Valor 12 de la dirección del servidor de red: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_ES "Valor 12 de la dirección del servidor: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_ES "El duodécimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo cable Game Link esté configurado como «Cliente de red»."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_ES "El duodécimo dígito de la dirección IP del servidor de red del cable Game Link. Solo se utilizará cuando el modo de conexión esté configurado como «Cliente de red»."

struct retro_core_option_v2_category option_cats_es[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_ES,
      CATEGORY_GB_LINK_INFO_0_ES
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_es[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_ES,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_ES,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_ES },
         { "GBC",      OPTION_VAL_GBC_ES },
         { "SGB",      OPTION_VAL_SGB_ES },
         { "internal", OPTION_VAL_INTERNAL_ES },
         { "custom",   OPTION_VAL_CUSTOM_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_ES,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_ES,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_ES },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_ES },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_ES },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_ES },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_ES },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_ES },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_ES },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_ES },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_ES },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_ES },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_ES },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_ES },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_ES },
         { "GBC - Red",                OPTION_VAL_GBC_RED_ES },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_ES },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_ES },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_ES },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_ES },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_ES },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_ES },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_ES },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_ES },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_ES },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_ES },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_ES },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_ES },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_ES },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_ES },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_ES },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_ES },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_ES },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_ES },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_ES },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_ES },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_ES },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_ES },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_ES },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_ES },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_ES },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_ES },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_ES },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_ES },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_ES },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_ES },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_ES },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_ES },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_ES },
         { "Special 1",                OPTION_VAL_SPECIAL_1_ES },
         { "Special 2",                OPTION_VAL_SPECIAL_2_ES },
         { "Special 3",                OPTION_VAL_SPECIAL_3_ES },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_ES },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_ES },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_ES },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_ES },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_ES,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_ES,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_ES },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_ES },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_ES },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_ES },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_ES },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_ES },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_ES },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_ES },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_ES },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_ES },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_ES },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_ES },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_ES },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_ES },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_ES },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_ES },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_ES },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_ES },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_ES },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_ES },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_ES },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_ES },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_ES },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_ES },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_ES },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_ES },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_ES },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_ES },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_ES },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_ES },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_ES },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_ES },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_ES },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_ES },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_ES },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_ES },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_ES },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_ES },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_ES },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_ES },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_ES },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_ES },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_ES },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_ES },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_ES },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_ES },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_ES },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_ES },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_ES },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_ES },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_ES },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_ES },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_ES },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_ES },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_ES },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_ES },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_ES },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_ES },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_ES },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_ES },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_ES },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_ES },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_ES },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_ES },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_ES },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_ES },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_ES },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_ES },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_ES },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_ES },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_ES },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_ES },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_ES },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_ES },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_ES },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_ES },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_ES },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_ES },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_ES },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_ES },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_ES },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_ES },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_ES },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_ES },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_ES },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_ES },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_ES },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_ES },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_ES },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_ES },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_ES },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_ES },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_ES },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_ES },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_ES },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_ES },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_ES },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_ES },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_ES },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_ES },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_ES,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_ES,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_ES },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_ES },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_ES },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_ES },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_ES },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_ES },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_ES },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_ES },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_ES },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_ES },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_ES },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_ES },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_ES },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_ES },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_ES },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_ES },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_ES },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_ES },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_ES },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_ES },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_ES },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_ES },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_ES },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_ES },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_ES },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_ES },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_ES },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_ES },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_ES },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_ES },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_ES },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_ES },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_ES },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_ES },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_ES },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_ES },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_ES },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_ES },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_ES },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_ES },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_ES },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_ES },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_ES },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_ES },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_ES },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_ES },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_ES },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_ES },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_ES },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_ES },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_ES },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_ES },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_ES },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_ES },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_ES },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_ES },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_ES },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_ES },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_ES },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_ES },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_ES },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_ES },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_ES },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_ES },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_ES },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_ES },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_ES },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_ES },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_ES },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_ES },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_ES },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_ES },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_ES },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_ES },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_ES },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_ES },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_ES },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_ES },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_ES },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_ES },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_ES },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_ES },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_ES },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_ES },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_ES },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_ES },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_ES },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_ES },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_ES },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_ES },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_ES },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_ES },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_ES },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_ES },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_ES },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_ES },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_ES },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_ES },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_ES },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_ES },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_ES,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_ES,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_ES },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_ES },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_ES },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_ES },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_ES },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_ES },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_ES },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_ES },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_ES },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_ES },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_ES },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_ES },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_ES },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_ES },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_ES },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_ES },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_ES },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__ES },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_ES },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_ES },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_ES },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_ES },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_ES },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_ES },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_ES },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_ES },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_ES },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_ES },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_ES },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_ES },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_ES },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_ES },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_ES },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_ES },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_ES },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_ES },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_ES },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_ES },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_ES },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_ES },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_ES },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_ES },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_ES },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_ES },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_ES },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_ES,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_ES,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_ES },
         { "always",   OPTION_VAL_ALWAYS_ES },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_ES,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_ES,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_ES },
         { "fast",     OPTION_VAL_FAST_ES },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_ES,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_ES,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_ES },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_ES },
         { "below screen", OPTION_VAL_BELOW_SCREEN_ES },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_ES,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_ES,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_ES,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_ES,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_ES },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_ES },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_ES },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_ES,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_ES,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_ES },
         { "cc",   OPTION_VAL_CC_ES },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_ES,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_ES,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_ES },
         { "GB",   OPTION_VAL_GB_ES },
         { "GBC",  OPTION_VAL_GBC_ES },
         { "GBA",  OPTION_VAL_GBA_ES },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_ES,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_ES,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_ES,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_ES,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_ES,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_ES,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_ES,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_ES,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_ES,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_ES,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_ES,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_MODE_INFO_0_ES,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_ES },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_ES },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_ES },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_ES,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_ES,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_ES,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_es = {
   option_cats_es,
   option_defs_es
};

/* RETRO_LANGUAGE_FA */

#define CATEGORY_GB_LINK_LABEL_FA NULL
#define CATEGORY_GB_LINK_INFO_0_FA NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_FA NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_FA NULL
#define OPTION_VAL_AUTO_FA "خودکار"
#define OPTION_VAL_GBC_FA NULL
#define OPTION_VAL_SGB_FA NULL
#define OPTION_VAL_INTERNAL_FA NULL
#define OPTION_VAL_CUSTOM_FA "سفارشی"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_FA NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_FA NULL
#define OPTION_VAL_GB_DMG_FA NULL
#define OPTION_VAL_GB_POCKET_FA NULL
#define OPTION_VAL_GB_LIGHT_FA NULL
#define OPTION_VAL_GBC_BLUE_FA NULL
#define OPTION_VAL_GBC_BROWN_FA NULL
#define OPTION_VAL_GBC_DARK_BLUE_FA NULL
#define OPTION_VAL_GBC_DARK_BROWN_FA NULL
#define OPTION_VAL_GBC_DARK_GREEN_FA NULL
#define OPTION_VAL_GBC_GRAYSCALE_FA NULL
#define OPTION_VAL_GBC_GREEN_FA NULL
#define OPTION_VAL_GBC_INVERTED_FA NULL
#define OPTION_VAL_GBC_ORANGE_FA NULL
#define OPTION_VAL_GBC_PASTEL_MIX_FA NULL
#define OPTION_VAL_GBC_RED_FA NULL
#define OPTION_VAL_GBC_YELLOW_FA NULL
#define OPTION_VAL_SGB_1A_FA NULL
#define OPTION_VAL_SGB_1B_FA NULL
#define OPTION_VAL_SGB_1C_FA NULL
#define OPTION_VAL_SGB_1D_FA NULL
#define OPTION_VAL_SGB_1E_FA NULL
#define OPTION_VAL_SGB_1F_FA NULL
#define OPTION_VAL_SGB_1G_FA NULL
#define OPTION_VAL_SGB_1H_FA NULL
#define OPTION_VAL_SGB_2A_FA NULL
#define OPTION_VAL_SGB_2B_FA NULL
#define OPTION_VAL_SGB_2C_FA NULL
#define OPTION_VAL_SGB_2D_FA NULL
#define OPTION_VAL_SGB_2E_FA NULL
#define OPTION_VAL_SGB_2F_FA NULL
#define OPTION_VAL_SGB_2G_FA NULL
#define OPTION_VAL_SGB_2H_FA NULL
#define OPTION_VAL_SGB_3A_FA NULL
#define OPTION_VAL_SGB_3B_FA NULL
#define OPTION_VAL_SGB_3C_FA NULL
#define OPTION_VAL_SGB_3D_FA NULL
#define OPTION_VAL_SGB_3E_FA NULL
#define OPTION_VAL_SGB_3F_FA NULL
#define OPTION_VAL_SGB_3G_FA NULL
#define OPTION_VAL_SGB_3H_FA NULL
#define OPTION_VAL_SGB_4A_FA NULL
#define OPTION_VAL_SGB_4B_FA NULL
#define OPTION_VAL_SGB_4C_FA NULL
#define OPTION_VAL_SGB_4D_FA NULL
#define OPTION_VAL_SGB_4E_FA NULL
#define OPTION_VAL_SGB_4F_FA NULL
#define OPTION_VAL_SGB_4G_FA NULL
#define OPTION_VAL_SGB_4H_FA NULL
#define OPTION_VAL_SPECIAL_1_FA NULL
#define OPTION_VAL_SPECIAL_2_FA NULL
#define OPTION_VAL_SPECIAL_3_FA NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_FA NULL
#define OPTION_VAL_TWB64_PACK_1_FA NULL
#define OPTION_VAL_TWB64_PACK_2_FA NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_FA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_FA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_FA NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_FA NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_FA NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_FA NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_FA NULL
#define OPTION_VAL_TWB64_005_NEON_RED_FA NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_FA NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_FA NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_FA NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_FA NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_FA NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_FA NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_FA NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_FA NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_FA NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_FA NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_FA NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_FA NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_FA NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_FA NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_FA NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_FA NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_FA NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_FA NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_FA NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_FA NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_FA NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_FA NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_FA NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_FA NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_FA NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_FA NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_FA NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_FA NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_FA NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_FA NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_FA NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_FA NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_FA NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_FA NULL
#define OPTION_VAL_TWB64_040_DMG_VER_FA NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_FA NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_FA NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_FA NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_FA NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_FA NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_FA NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_FA NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_FA NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_FA NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_FA NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_FA NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_FA NULL
#define OPTION_VAL_TWB64_053_VMU_VER_FA NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_FA NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_FA NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_FA NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_FA NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_FA NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_FA NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_FA NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_FA NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_FA NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_FA NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_FA NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_FA NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_FA NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_FA NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_FA NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_FA NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_FA NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_FA NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_FA NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_FA NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_FA NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_FA NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_FA NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_FA NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_FA NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_FA NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_FA NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_FA NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_FA NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_FA NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_FA NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_FA NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_FA NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_FA NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_FA NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_FA NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_FA NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_FA NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_FA NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_FA NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_FA NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_FA NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_FA NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_FA NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_FA NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_FA NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_FA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_FA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_FA NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_FA NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_FA NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_FA NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_FA NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_FA NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_FA NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_FA NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_FA NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_FA NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_FA NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_FA NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_FA NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_FA NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_FA NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_FA NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_FA NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_FA NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_FA NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_FA NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_FA NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_FA NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_FA NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_FA NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_FA NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_FA NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_FA NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_FA NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_FA NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_FA NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_FA NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_FA NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_FA NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_FA NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_FA NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_FA NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_FA NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_FA NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_FA NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_FA NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_FA NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_FA NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_FA NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_FA NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_FA NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_FA NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_FA NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_FA NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_FA NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_FA NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_FA NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_FA NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_FA NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_FA NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_FA NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_FA NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_FA NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_FA NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_FA NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_FA NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_FA NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_FA NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_FA NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_FA NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_FA NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_FA NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_FA NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_FA NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_FA NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_FA NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_FA NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_FA NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_FA NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_FA NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_FA NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_FA NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_FA NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_FA NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_FA NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_FA NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_FA NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_FA NULL
#define OPTION_VAL_TWB64_182_PINK109_FA NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_FA NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_FA NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_FA NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_FA NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_FA NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_FA NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_FA NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_FA NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_FA NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_FA NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_FA NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_FA NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_FA NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_FA NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_FA NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_FA NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_FA NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_FA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_FA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_FA NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_FA NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_FA NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_FA NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_FA NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_FA NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_FA NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_FA NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_FA NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_FA NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_FA NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_FA NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_FA NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_FA NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_FA NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_FA NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_FA NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_FA NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__FA NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_FA NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_FA NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_FA NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_FA NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_FA NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_FA NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_FA NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_FA NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_FA NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_FA NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_FA NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_FA NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_FA NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_FA NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_FA NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_FA NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_FA NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_FA NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_FA NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_FA NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_FA NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_FA NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_FA NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_FA NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_FA NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_FA NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_FA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_FA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_FA NULL
#define OPTION_VAL_GBC_ONLY_FA NULL
#define OPTION_VAL_ALWAYS_FA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_FA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_FA NULL
#define OPTION_VAL_ACCURATE_FA NULL
#define OPTION_VAL_FAST_FA NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_FA NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_FA NULL
#define OPTION_VAL_CENTRAL_FA NULL
#define OPTION_VAL_ABOVE_SCREEN_FA NULL
#define OPTION_VAL_BELOW_SCREEN_FA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_FA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_FA NULL
#define GAMBATTE_MIX_FRAMES_LABEL_FA NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_FA NULL
#define OPTION_VAL_MIX_FA NULL
#define OPTION_VAL_LCD_GHOSTING_FA NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_FA NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_FA "بازنمونه‌گیر صدا"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_FA NULL
#define OPTION_VAL_SINC_FA NULL
#define OPTION_VAL_CC_FA NULL
#define GAMBATTE_GB_HWMODE_LABEL_FA NULL
#define GAMBATTE_GB_HWMODE_INFO_0_FA NULL
#define OPTION_VAL_GB_FA NULL
#define OPTION_VAL_GBA_FA NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_FA NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_FA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_FA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_FA NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_FA NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_FA NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_FA NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_FA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_FA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_FA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_FA NULL
#define OPTION_VAL_NOT_CONNECTED_FA NULL
#define OPTION_VAL_NETWORK_SERVER_FA NULL
#define OPTION_VAL_NETWORK_CLIENT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_FA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_FA NULL

struct retro_core_option_v2_category option_cats_fa[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_FA,
      CATEGORY_GB_LINK_INFO_0_FA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_fa[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_FA,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_FA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_FA },
         { "GBC",      OPTION_VAL_GBC_FA },
         { "SGB",      OPTION_VAL_SGB_FA },
         { "internal", OPTION_VAL_INTERNAL_FA },
         { "custom",   OPTION_VAL_CUSTOM_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_FA,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_FA,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_FA },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_FA },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_FA },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_FA },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_FA },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_FA },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_FA },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_FA },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_FA },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_FA },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_FA },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_FA },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_FA },
         { "GBC - Red",                OPTION_VAL_GBC_RED_FA },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_FA },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_FA },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_FA },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_FA },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_FA },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_FA },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_FA },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_FA },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_FA },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_FA },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_FA },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_FA },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_FA },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_FA },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_FA },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_FA },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_FA },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_FA },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_FA },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_FA },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_FA },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_FA },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_FA },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_FA },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_FA },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_FA },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_FA },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_FA },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_FA },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_FA },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_FA },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_FA },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_FA },
         { "Special 1",                OPTION_VAL_SPECIAL_1_FA },
         { "Special 2",                OPTION_VAL_SPECIAL_2_FA },
         { "Special 3",                OPTION_VAL_SPECIAL_3_FA },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_FA },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_FA },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_FA },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_FA },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_FA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_FA,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_FA },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_FA },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_FA },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_FA },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_FA },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_FA },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_FA },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_FA },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_FA },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_FA },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_FA },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_FA },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_FA },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_FA },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_FA },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_FA },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_FA },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_FA },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_FA },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_FA },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_FA },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_FA },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_FA },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_FA },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_FA },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_FA },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_FA },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_FA },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_FA },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_FA },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_FA },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_FA },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_FA },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_FA },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_FA },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_FA },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_FA },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_FA },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_FA },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_FA },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_FA },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_FA },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_FA },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_FA },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_FA },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_FA },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_FA },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_FA },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_FA },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_FA },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_FA },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_FA },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_FA },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_FA },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_FA },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_FA },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_FA },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_FA },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_FA },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_FA },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_FA },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_FA },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_FA },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_FA },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_FA },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_FA },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_FA },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_FA },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_FA },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_FA },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_FA },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_FA },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_FA },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_FA },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_FA },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_FA },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_FA },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_FA },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_FA },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_FA },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_FA },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_FA },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_FA },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_FA },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_FA },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_FA },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_FA },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_FA },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_FA },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_FA },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_FA },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_FA },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_FA },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_FA },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_FA },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_FA },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_FA },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_FA },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_FA },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_FA },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_FA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_FA,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_FA },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_FA },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_FA },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_FA },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_FA },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_FA },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_FA },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_FA },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_FA },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_FA },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_FA },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_FA },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_FA },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_FA },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_FA },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_FA },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_FA },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_FA },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_FA },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_FA },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_FA },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_FA },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_FA },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_FA },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_FA },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_FA },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_FA },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_FA },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_FA },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_FA },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_FA },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_FA },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_FA },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_FA },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_FA },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_FA },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_FA },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_FA },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_FA },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_FA },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_FA },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_FA },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_FA },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_FA },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_FA },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_FA },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_FA },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_FA },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_FA },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_FA },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_FA },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_FA },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_FA },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_FA },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_FA },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_FA },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_FA },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_FA },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_FA },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_FA },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_FA },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_FA },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_FA },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_FA },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_FA },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_FA },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_FA },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_FA },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_FA },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_FA },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_FA },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_FA },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_FA },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_FA },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_FA },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_FA },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_FA },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_FA },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_FA },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_FA },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_FA },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_FA },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_FA },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_FA },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_FA },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_FA },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_FA },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_FA },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_FA },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_FA },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_FA },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_FA },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_FA },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_FA },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_FA },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_FA },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_FA },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_FA },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_FA },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_FA },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_FA,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_FA,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_FA },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_FA },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_FA },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_FA },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_FA },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_FA },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_FA },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_FA },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_FA },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_FA },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_FA },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_FA },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_FA },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_FA },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_FA },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_FA },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_FA },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__FA },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_FA },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_FA },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_FA },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_FA },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_FA },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_FA },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_FA },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_FA },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_FA },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_FA },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_FA },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_FA },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_FA },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_FA },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_FA },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_FA },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_FA },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_FA },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_FA },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_FA },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_FA },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_FA },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_FA },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_FA },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_FA },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_FA },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_FA },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_FA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_FA,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_FA },
         { "always",   OPTION_VAL_ALWAYS_FA },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_FA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_FA,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_FA },
         { "fast",     OPTION_VAL_FAST_FA },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_FA,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_FA,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_FA },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_FA },
         { "below screen", OPTION_VAL_BELOW_SCREEN_FA },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_FA,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_FA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_FA,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_FA,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_FA },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_FA },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_FA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_FA,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_FA,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_FA },
         { "cc",   OPTION_VAL_CC_FA },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_FA,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_FA,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_FA },
         { "GB",   OPTION_VAL_GB_FA },
         { "GBC",  OPTION_VAL_GBC_FA },
         { "GBA",  OPTION_VAL_GBA_FA },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_FA,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_FA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_FA,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_FA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_FA,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_FA,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_FA,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_FA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_FA,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_FA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_FA,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_MODE_INFO_0_FA,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_FA },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_FA },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_FA },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_FA,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_FA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_FA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_fa = {
   option_cats_fa,
   option_defs_fa
};

/* RETRO_LANGUAGE_FI */

#define CATEGORY_GB_LINK_LABEL_FI NULL
#define CATEGORY_GB_LINK_INFO_0_FI NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_FI "GB-väritys"
#define GAMBATTE_GB_COLORIZATION_INFO_0_FI NULL
#define OPTION_VAL_AUTO_FI "Automaattinen"
#define OPTION_VAL_GBC_FI NULL
#define OPTION_VAL_SGB_FI NULL
#define OPTION_VAL_INTERNAL_FI "Sisäinen"
#define OPTION_VAL_CUSTOM_FI "Mukautettu"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_FI "Sisäinen paletti"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_FI NULL
#define OPTION_VAL_GB_DMG_FI NULL
#define OPTION_VAL_GB_POCKET_FI NULL
#define OPTION_VAL_GB_LIGHT_FI NULL
#define OPTION_VAL_GBC_BLUE_FI NULL
#define OPTION_VAL_GBC_BROWN_FI NULL
#define OPTION_VAL_GBC_DARK_BLUE_FI NULL
#define OPTION_VAL_GBC_DARK_BROWN_FI NULL
#define OPTION_VAL_GBC_DARK_GREEN_FI NULL
#define OPTION_VAL_GBC_GRAYSCALE_FI NULL
#define OPTION_VAL_GBC_GREEN_FI NULL
#define OPTION_VAL_GBC_INVERTED_FI NULL
#define OPTION_VAL_GBC_ORANGE_FI NULL
#define OPTION_VAL_GBC_PASTEL_MIX_FI NULL
#define OPTION_VAL_GBC_RED_FI NULL
#define OPTION_VAL_GBC_YELLOW_FI NULL
#define OPTION_VAL_SGB_1A_FI NULL
#define OPTION_VAL_SGB_1B_FI NULL
#define OPTION_VAL_SGB_1C_FI NULL
#define OPTION_VAL_SGB_1D_FI NULL
#define OPTION_VAL_SGB_1E_FI NULL
#define OPTION_VAL_SGB_1F_FI NULL
#define OPTION_VAL_SGB_1G_FI NULL
#define OPTION_VAL_SGB_1H_FI NULL
#define OPTION_VAL_SGB_2A_FI NULL
#define OPTION_VAL_SGB_2B_FI NULL
#define OPTION_VAL_SGB_2C_FI NULL
#define OPTION_VAL_SGB_2D_FI NULL
#define OPTION_VAL_SGB_2E_FI NULL
#define OPTION_VAL_SGB_2F_FI NULL
#define OPTION_VAL_SGB_2G_FI NULL
#define OPTION_VAL_SGB_2H_FI NULL
#define OPTION_VAL_SGB_3A_FI NULL
#define OPTION_VAL_SGB_3B_FI NULL
#define OPTION_VAL_SGB_3C_FI NULL
#define OPTION_VAL_SGB_3D_FI NULL
#define OPTION_VAL_SGB_3E_FI NULL
#define OPTION_VAL_SGB_3F_FI NULL
#define OPTION_VAL_SGB_3G_FI NULL
#define OPTION_VAL_SGB_3H_FI NULL
#define OPTION_VAL_SGB_4A_FI NULL
#define OPTION_VAL_SGB_4B_FI NULL
#define OPTION_VAL_SGB_4C_FI NULL
#define OPTION_VAL_SGB_4D_FI NULL
#define OPTION_VAL_SGB_4E_FI NULL
#define OPTION_VAL_SGB_4F_FI NULL
#define OPTION_VAL_SGB_4G_FI NULL
#define OPTION_VAL_SGB_4H_FI NULL
#define OPTION_VAL_SPECIAL_1_FI NULL
#define OPTION_VAL_SPECIAL_2_FI NULL
#define OPTION_VAL_SPECIAL_3_FI NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_FI NULL
#define OPTION_VAL_TWB64_PACK_1_FI NULL
#define OPTION_VAL_TWB64_PACK_2_FI NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_FI NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_FI NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_FI NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_FI NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_FI NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_FI NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_FI NULL
#define OPTION_VAL_TWB64_005_NEON_RED_FI NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_FI NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_FI NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_FI NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_FI NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_FI NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_FI NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_FI NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_FI NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_FI NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_FI NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_FI NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_FI NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_FI NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_FI NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_FI NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_FI NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_FI NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_FI NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_FI NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_FI NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_FI NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_FI NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_FI NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_FI NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_FI NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_FI NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_FI NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_FI NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_FI NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_FI NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_FI NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_FI NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_FI NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_FI NULL
#define OPTION_VAL_TWB64_040_DMG_VER_FI NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_FI NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_FI NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_FI NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_FI NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_FI NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_FI NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_FI NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_FI NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_FI NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_FI NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_FI NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_FI NULL
#define OPTION_VAL_TWB64_053_VMU_VER_FI NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_FI NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_FI NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_FI NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_FI NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_FI NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_FI NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_FI NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_FI NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_FI NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_FI NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_FI NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_FI NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_FI NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_FI NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_FI NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_FI NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_FI NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_FI NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_FI NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_FI NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_FI NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_FI NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_FI NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_FI NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_FI NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_FI NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_FI NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_FI NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_FI NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_FI NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_FI NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_FI NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_FI NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_FI NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_FI NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_FI NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_FI NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_FI NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_FI NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_FI NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_FI NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_FI NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_FI NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_FI NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_FI NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_FI NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_FI NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_FI NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_FI NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_FI NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_FI NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_FI NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_FI NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_FI NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_FI NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_FI NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_FI NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_FI NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_FI NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_FI NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_FI NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_FI NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_FI NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_FI NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_FI NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_FI NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_FI NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_FI NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_FI NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_FI NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_FI NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_FI NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_FI NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_FI NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_FI NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_FI NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_FI NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_FI NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_FI NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_FI NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_FI NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_FI NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_FI NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_FI NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_FI NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_FI NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_FI NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_FI NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_FI NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_FI NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_FI NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_FI NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_FI NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_FI NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_FI NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_FI NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_FI NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_FI NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_FI NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_FI NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_FI NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_FI NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_FI NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_FI NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_FI NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_FI NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_FI NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_FI NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_FI NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_FI NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_FI NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_FI NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_FI NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_FI NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_FI NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_FI NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_FI NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_FI NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_FI NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_FI NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_FI NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_FI NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_FI NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_FI NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_FI NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_FI NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_FI NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_FI NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_FI NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_FI NULL
#define OPTION_VAL_TWB64_182_PINK109_FI NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_FI NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_FI NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_FI NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_FI NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_FI NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_FI NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_FI NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_FI NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_FI NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_FI NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_FI NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_FI NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_FI NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_FI NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_FI NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_FI NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_FI NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_FI NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_FI NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_FI NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_FI NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_FI NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_FI NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_FI NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_FI NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_FI NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_FI NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_FI NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_FI NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_FI NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_FI NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_FI NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_FI NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_FI NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_FI NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_FI NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_FI NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__FI NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_FI NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_FI NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_FI NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_FI NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_FI NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_FI NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_FI NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_FI NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_FI NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_FI NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_FI NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_FI NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_FI NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_FI NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_FI NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_FI NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_FI NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_FI NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_FI NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_FI NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_FI NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_FI NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_FI NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_FI NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_FI NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_FI NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_FI NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_FI "Värinkorjaus"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_FI NULL
#define OPTION_VAL_GBC_ONLY_FI NULL
#define OPTION_VAL_ALWAYS_FI "Aina"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_FI "Värinkorjauksen tila"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_FI NULL
#define OPTION_VAL_ACCURATE_FI "Tarkka"
#define OPTION_VAL_FAST_FI "Nopea"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_FI NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_FI NULL
#define OPTION_VAL_CENTRAL_FI NULL
#define OPTION_VAL_ABOVE_SCREEN_FI "Näytön yläpuolella"
#define OPTION_VAL_BELOW_SCREEN_FI "Näytön alapuolella"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_FI NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_FI NULL
#define GAMBATTE_MIX_FRAMES_LABEL_FI "Rajakuvien yhdistäminen"
#define GAMBATTE_MIX_FRAMES_INFO_0_FI NULL
#define OPTION_VAL_MIX_FI "Yksinkertainen"
#define OPTION_VAL_LCD_GHOSTING_FI "LCD-ghosting (Tarkka)"
#define OPTION_VAL_LCD_GHOSTING_FAST_FI "LCD-ghosting (Nopea)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_FI "Ääninäytteenottaja"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_FI NULL
#define OPTION_VAL_SINC_FI NULL
#define OPTION_VAL_CC_FI NULL
#define GAMBATTE_GB_HWMODE_LABEL_FI "Emuloitu laitteisto (Uudelleenkäynnistys vaaditaan)"
#define GAMBATTE_GB_HWMODE_INFO_0_FI NULL
#define OPTION_VAL_GB_FI NULL
#define OPTION_VAL_GBA_FI NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_FI "Käytä virallista käynnistyslataajaa (uudelleenkäynnistys vaaditaan)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_FI NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_FI "Salli vastakkaiset suunnat"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_FI NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_FI NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_FI NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_FI NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_FI NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_FI NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_FI NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_FI NULL
#define OPTION_VAL_NOT_CONNECTED_FI "Ei yhdistetty"
#define OPTION_VAL_NETWORK_SERVER_FI "Verkkopalvelin"
#define OPTION_VAL_NETWORK_CLIENT_FI "Verkkoasiakas"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_FI "Portti"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_FI NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_FI NULL

struct retro_core_option_v2_category option_cats_fi[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_FI,
      CATEGORY_GB_LINK_INFO_0_FI
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_fi[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_FI,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_FI,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_FI },
         { "GBC",      OPTION_VAL_GBC_FI },
         { "SGB",      OPTION_VAL_SGB_FI },
         { "internal", OPTION_VAL_INTERNAL_FI },
         { "custom",   OPTION_VAL_CUSTOM_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_FI,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_FI,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_FI },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_FI },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_FI },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_FI },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_FI },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_FI },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_FI },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_FI },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_FI },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_FI },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_FI },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_FI },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_FI },
         { "GBC - Red",                OPTION_VAL_GBC_RED_FI },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_FI },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_FI },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_FI },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_FI },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_FI },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_FI },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_FI },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_FI },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_FI },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_FI },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_FI },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_FI },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_FI },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_FI },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_FI },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_FI },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_FI },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_FI },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_FI },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_FI },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_FI },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_FI },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_FI },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_FI },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_FI },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_FI },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_FI },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_FI },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_FI },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_FI },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_FI },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_FI },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_FI },
         { "Special 1",                OPTION_VAL_SPECIAL_1_FI },
         { "Special 2",                OPTION_VAL_SPECIAL_2_FI },
         { "Special 3",                OPTION_VAL_SPECIAL_3_FI },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_FI },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_FI },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_FI },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_FI },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_FI,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_FI,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_FI },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_FI },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_FI },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_FI },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_FI },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_FI },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_FI },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_FI },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_FI },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_FI },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_FI },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_FI },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_FI },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_FI },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_FI },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_FI },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_FI },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_FI },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_FI },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_FI },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_FI },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_FI },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_FI },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_FI },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_FI },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_FI },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_FI },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_FI },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_FI },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_FI },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_FI },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_FI },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_FI },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_FI },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_FI },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_FI },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_FI },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_FI },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_FI },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_FI },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_FI },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_FI },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_FI },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_FI },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_FI },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_FI },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_FI },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_FI },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_FI },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_FI },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_FI },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_FI },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_FI },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_FI },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_FI },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_FI },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_FI },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_FI },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_FI },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_FI },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_FI },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_FI },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_FI },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_FI },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_FI },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_FI },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_FI },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_FI },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_FI },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_FI },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_FI },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_FI },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_FI },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_FI },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_FI },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_FI },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_FI },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_FI },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_FI },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_FI },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_FI },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_FI },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_FI },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_FI },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_FI },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_FI },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_FI },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_FI },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_FI },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_FI },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_FI },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_FI },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_FI },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_FI },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_FI },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_FI },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_FI },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_FI },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_FI },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_FI },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_FI,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_FI,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_FI },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_FI },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_FI },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_FI },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_FI },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_FI },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_FI },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_FI },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_FI },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_FI },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_FI },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_FI },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_FI },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_FI },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_FI },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_FI },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_FI },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_FI },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_FI },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_FI },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_FI },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_FI },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_FI },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_FI },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_FI },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_FI },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_FI },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_FI },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_FI },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_FI },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_FI },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_FI },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_FI },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_FI },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_FI },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_FI },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_FI },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_FI },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_FI },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_FI },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_FI },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_FI },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_FI },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_FI },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_FI },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_FI },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_FI },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_FI },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_FI },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_FI },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_FI },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_FI },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_FI },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_FI },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_FI },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_FI },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_FI },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_FI },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_FI },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_FI },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_FI },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_FI },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_FI },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_FI },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_FI },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_FI },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_FI },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_FI },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_FI },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_FI },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_FI },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_FI },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_FI },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_FI },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_FI },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_FI },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_FI },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_FI },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_FI },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_FI },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_FI },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_FI },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_FI },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_FI },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_FI },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_FI },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_FI },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_FI },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_FI },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_FI },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_FI },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_FI },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_FI },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_FI },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_FI },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_FI },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_FI },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_FI },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_FI },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_FI },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_FI,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_FI,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_FI },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_FI },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_FI },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_FI },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_FI },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_FI },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_FI },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_FI },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_FI },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_FI },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_FI },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_FI },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_FI },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_FI },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_FI },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_FI },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_FI },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__FI },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_FI },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_FI },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_FI },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_FI },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_FI },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_FI },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_FI },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_FI },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_FI },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_FI },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_FI },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_FI },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_FI },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_FI },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_FI },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_FI },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_FI },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_FI },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_FI },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_FI },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_FI },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_FI },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_FI },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_FI },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_FI },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_FI },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_FI },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_FI,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_FI,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_FI },
         { "always",   OPTION_VAL_ALWAYS_FI },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_FI,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_FI,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_FI },
         { "fast",     OPTION_VAL_FAST_FI },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_FI,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_FI,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_FI },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_FI },
         { "below screen", OPTION_VAL_BELOW_SCREEN_FI },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_FI,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_FI,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_FI,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_FI,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_FI },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_FI },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_FI },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_FI,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_FI,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_FI },
         { "cc",   OPTION_VAL_CC_FI },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_FI,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_FI,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_FI },
         { "GB",   OPTION_VAL_GB_FI },
         { "GBC",  OPTION_VAL_GBC_FI },
         { "GBA",  OPTION_VAL_GBA_FI },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_FI,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_FI,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_FI,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_FI,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_FI,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_FI,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_FI,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_FI,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_FI,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_FI,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_FI,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_MODE_INFO_0_FI,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_FI },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_FI },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_FI },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_FI,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_FI,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_FI,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_fi = {
   option_cats_fi,
   option_defs_fi
};

/* RETRO_LANGUAGE_FR */

#define CATEGORY_GB_LINK_LABEL_FR "Câble link"
#define CATEGORY_GB_LINK_INFO_0_FR "Changer les réglages du câble link en réseau (multijoueur)."
#define GAMBATTE_GB_COLORIZATION_LABEL_FR "Colorisation GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_FR "Active la colorisation des jeux Game Boy. 'Auto' sélectionne la 'meilleure' palette (la plus colorée/appropriée). 'GBC' sélectionne la palette Game Boy Color spécifique au jeu si elle est définie, sinon 'GBC - Vert foncé'. 'SGB' sélectionne la palette Super Game Boy spécifique au jeu si elle est définie, sinon 'SGB - 1A'. 'Interne' utilise l'option du cœur 'Palette interne'. 'Personnalisée' charge la palette créée par l'utilisateur à partir du dossier système."
#define OPTION_VAL_AUTO_FR NULL
#define OPTION_VAL_GBC_FR NULL
#define OPTION_VAL_SGB_FR NULL
#define OPTION_VAL_INTERNAL_FR "Interne"
#define OPTION_VAL_CUSTOM_FR "Personnalisé"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_FR "Palette interne"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_FR "Sélectionne la palette utilisée pour coloriser les jeux Game Boy lorsque 'Colorisation GB' est réglée sur 'Interne', ou lorsque 'Colorisation GB' est réglée sur 'Auto' et que le jeu n'a pas de palette SGB/GBC prédéfinie. Les palettes 'GB' imitent l'affichage du matériel original de la Game Boy. Les palettes 'GBC' sont identiques aux présélections intégrées à la Game Boy Color. Les palettes 'SGB' sont identiques aux présélections intégrées au Super Game Boy."
#define OPTION_VAL_GB_DMG_FR NULL
#define OPTION_VAL_GB_POCKET_FR NULL
#define OPTION_VAL_GB_LIGHT_FR NULL
#define OPTION_VAL_GBC_BLUE_FR "GBC - Bleue"
#define OPTION_VAL_GBC_BROWN_FR "GBC - Marron"
#define OPTION_VAL_GBC_DARK_BLUE_FR "GBC - Bleu foncé"
#define OPTION_VAL_GBC_DARK_BROWN_FR "GBC - Marron foncé"
#define OPTION_VAL_GBC_DARK_GREEN_FR "GBC - Vert foncé"
#define OPTION_VAL_GBC_GRAYSCALE_FR "GBC - Niveaux de gris"
#define OPTION_VAL_GBC_GREEN_FR "GBC - Verte"
#define OPTION_VAL_GBC_INVERTED_FR "GBC - Inversée"
#define OPTION_VAL_GBC_ORANGE_FR NULL
#define OPTION_VAL_GBC_PASTEL_MIX_FR "GBC - Mix pastel"
#define OPTION_VAL_GBC_RED_FR "GBC - Rouge"
#define OPTION_VAL_GBC_YELLOW_FR "GBC - Jaune"
#define OPTION_VAL_SGB_1A_FR NULL
#define OPTION_VAL_SGB_1B_FR NULL
#define OPTION_VAL_SGB_1C_FR NULL
#define OPTION_VAL_SGB_1D_FR NULL
#define OPTION_VAL_SGB_1E_FR NULL
#define OPTION_VAL_SGB_1F_FR NULL
#define OPTION_VAL_SGB_1G_FR NULL
#define OPTION_VAL_SGB_1H_FR NULL
#define OPTION_VAL_SGB_2A_FR NULL
#define OPTION_VAL_SGB_2B_FR NULL
#define OPTION_VAL_SGB_2C_FR NULL
#define OPTION_VAL_SGB_2D_FR NULL
#define OPTION_VAL_SGB_2E_FR NULL
#define OPTION_VAL_SGB_2F_FR NULL
#define OPTION_VAL_SGB_2G_FR NULL
#define OPTION_VAL_SGB_2H_FR NULL
#define OPTION_VAL_SGB_3A_FR NULL
#define OPTION_VAL_SGB_3B_FR NULL
#define OPTION_VAL_SGB_3C_FR NULL
#define OPTION_VAL_SGB_3D_FR NULL
#define OPTION_VAL_SGB_3E_FR NULL
#define OPTION_VAL_SGB_3F_FR NULL
#define OPTION_VAL_SGB_3G_FR NULL
#define OPTION_VAL_SGB_3H_FR NULL
#define OPTION_VAL_SGB_4A_FR NULL
#define OPTION_VAL_SGB_4B_FR NULL
#define OPTION_VAL_SGB_4C_FR NULL
#define OPTION_VAL_SGB_4D_FR NULL
#define OPTION_VAL_SGB_4E_FR NULL
#define OPTION_VAL_SGB_4F_FR NULL
#define OPTION_VAL_SGB_4G_FR NULL
#define OPTION_VAL_SGB_4H_FR NULL
#define OPTION_VAL_SPECIAL_1_FR "Spéciale 1"
#define OPTION_VAL_SPECIAL_2_FR "Spéciale 2"
#define OPTION_VAL_SPECIAL_3_FR "Spéciale 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_FR "Spéciale 4 (Héritée de la TI-83)"
#define OPTION_VAL_TWB64_PACK_1_FR NULL
#define OPTION_VAL_TWB64_PACK_2_FR NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_FR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_FR "> TWB64 - Palette du pack 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_FR "Sélectionne la palette de colorisation interne lorsque 'Palette interne' est définie sur 'TWB64 - Pack 1'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_FR "TWB64 001 - Bleu Aqours"
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_FR "TWB64 002 - Version Anime Expo"
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_FR "TWB64 003 - Jaune Bob l'éponge"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_FR "TWB64 004 - Rose Patrick Étoile"
#define OPTION_VAL_TWB64_005_NEON_RED_FR "TWB64 005 - Rouge néon"
#define OPTION_VAL_TWB64_006_NEON_BLUE_FR "TWB64 006 - Bleu néon"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_FR "TWB64 007 - Jaune néon"
#define OPTION_VAL_TWB64_008_NEON_GREEN_FR "TWB64 008 - Vert néon"
#define OPTION_VAL_TWB64_009_NEON_PINK_FR "TWB64 009 - Rose néon"
#define OPTION_VAL_TWB64_010_MARIO_RED_FR "TWB64 010 - Rouge Mario"
#define OPTION_VAL_TWB64_011_NICK_ORANGE_FR "TWB64 011 - Orange Nick"
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_FR "TWB64 012 - Version Virtual Boy"
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_FR "TWB64 013 - Doré Wild"
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_FR "TWB64 014 - Jaune constructeur"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_FR "TWB64 015 - Bleuet classique"
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_FR "TWB64 016 - Version 765 Production"
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_FR "TWB64 017 - Ivoire Superball"
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_FR "TWB64 018 - Orange Crunchyroll"
#define OPTION_VAL_TWB64_019_MUSE_PINK_FR "TWB64 019 - Rose Muse"
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_FR "TWB64 020 - Jaune Nijigasaki"
#define OPTION_VAL_TWB64_021_GAMATE_VER_FR "TWB64 021 - Version Gamate"
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_FR "TWB64 022 - Version niveaux de vert"
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_FR "TWB64 023 - Or Odyssey"
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_FR "TWB64 024 - Dieu Super Saiyan"
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_FR "TWB64 025 - Bleu Super Saiyan"
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_FR "TWB64 026 - Rose Bizarre"
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_FR "TWB64 027 - Version Nintendo Switch Lite"
#define OPTION_VAL_TWB64_028_GAME_COM_VER_FR "TWB64 028 - Version Game.com"
#define OPTION_VAL_TWB64_029_SANRIO_PINK_FR "TWB64 029 - Rose Sanrio"
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_FR "TWB64 030 - Version BANDAI NAMCO"
#define OPTION_VAL_TWB64_031_COSMO_GREEN_FR "TWB64 031 - Vert Cosmo"
#define OPTION_VAL_TWB64_032_WANDA_PINK_FR "TWB64 032 - Rose Wanda"
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_FR "TWB64 033 - Version Link's Awakening DX"
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_FR "TWB64 034 - Bois des Voyages"
#define OPTION_VAL_TWB64_035_POKEMON_VER_FR "TWB64 035 - Version Pokémon"
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_FR "TWB64 036 - Orange Game Grump"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_FR "TWB64 037 - Version Scooby-Doo Mystères"
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_FR "TWB64 038 - Version Pokémon mini"
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_FR "TWB64 039 - Version Supervision"
#define OPTION_VAL_TWB64_040_DMG_VER_FR "TWB64 040 - Version DMG"
#define OPTION_VAL_TWB64_041_POCKET_VER_FR "TWB64 041 - Version Pocket"
#define OPTION_VAL_TWB64_042_LIGHT_VER_FR "TWB64 042 - Version Light"
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_FR "TWB64 043 - Bleu Miraitowa"
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_FR "TWB64 044 - Rose Someity"
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_FR "TWB64 045 - Jaune Pikachu"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_FR "TWB64 046 - Marron Évoli"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_FR "TWB64 047 - Version Microvision"
#define OPTION_VAL_TWB64_048_TI_83_VER_FR "TWB64 048 - Version TI-83"
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_FR "TWB64 049 - Cerise Aegis"
#define OPTION_VAL_TWB64_050_LABO_FAWN_FR "TWB64 050 - Faon Labo"
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_FR "TWB64 051 - OR MILLION LIVE !"
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_FR "TWB64 052 - Version Tokyo Midtown"
#define OPTION_VAL_TWB64_053_VMU_VER_FR "TWB64 053 - Version VMU"
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_FR "TWB64 054 - Version Game Master"
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_FR "TWB64 055 - Vert Android"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_FR "TWB64 056 - Azur Ticketmaster"
#define OPTION_VAL_TWB64_057_GOOGLE_RED_FR "TWB64 057 - Rouge Google"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_FR "TWB64 058 - Bleu Google"
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_FR "TWB64 059 - Jaune Google"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_FR "TWB64 060 - Vert Google"
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_FR "TWB64 061 - Version WonderSwan"
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_FR "TWB64 062 - Version Neo Geo Pocket"
#define OPTION_VAL_TWB64_063_DEW_GREEN_FR "TWB64 063 - Vert Dew"
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_FR "TWB64 064 - Rouge Coca-Cola"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_FR "TWB64 065 - Version GameKing"
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_FR "TWB64 066 - Version Do The Dew"
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_FR "TWB64 067 - Version Digivice"
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_FR "TWB64 068 - Version Bikini Bottom"
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_FR "TWB64 069 - Rose Belle"
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_FR "TWB64 070 - Bleu Bulle"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_FR "TWB64 071 - Vert Rebelle"
#define OPTION_VAL_TWB64_072_NASCAR_VER_FR "TWB64 072 - Version NASCAR"
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_FR "TWB64 073 - Citron-citron vert"
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_FR "TWB64 074 - Version Mega Man V"
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_FR "TWB64 075 - Version Tamagotchi"
#define OPTION_VAL_TWB64_076_PHANTOM_RED_FR "TWB64 076 - Rouge Fantômes"
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_FR "TWB64 077 - Version Halloween"
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_FR "TWB64 078 - Version Noël"
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_FR "TWB64 079 - Rose Cardcaptor"
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_FR "TWB64 080 - Or Pretty Guardian"
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_FR "TWB64 081 - Version camouflage"
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_FR "TWB64 082 - Super Saiyan légendaire"
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_FR "TWB64 083 - Rosé Super Saiyan"
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_FR NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_FR "TWB64 085 - Ultra Instinct maîtrisé"
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_FR "TWB64 086 - Rouge Saint Snow"
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_FR "TWB64 087 - Banane jaune"
#define OPTION_VAL_TWB64_088_GREEN_BANANA_FR "TWB64 088 - Banane verte"
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_FR NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_FR "TWB64 090 - Super Saiyan Blue Évolué"
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_FR "TWB64 091 - Version Pocket Tales"
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_FR "TWB64 092 - Jaune Investigation"
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_FR "TWB64 093 - Bleu S.E.E.S."
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_FR "TWB64 094 - Cyan Game Awards"
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_FR "TWB64 095 - Orange Hokage"
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_FR "TWB64 096 - Rouge Chapeau de paille"
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_FR "TWB64 097 - Cyan Sword Art"
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_FR "TWB64 098 - Émeraude Deku Alpha"
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_FR "TWB64 099 - Version Blue Stripes"
#define OPTION_VAL_TWB64_100_STONE_ORANGE_FR "TWB64 100 - Orange Stone"
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_FR "> TWB64 - Palette du pack 2"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_FR "Sélectionne la palette de colorisation interne lorsque 'Palette interne' est définie sur 'TWB64 - Pack 2'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_FR "TWB64 101 - Rose 765PRO"
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_FR "TWB64 102 - Bleu CINDERELLA"
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_FR "TWB64 103 - Jaune MILLION !"
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_FR "TWB64 104 - Vert SideM"
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_FR "TWB64 105 - Bleu ciel SHINY"
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_FR "TWB64 106 - Version Angry Volcano"
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_FR "TWB64 107 - Rose Yo-kai"
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_FR "TWB64 108 - Vert Yo-kai"
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_FR "TWB64 109 - Bleu Yo-kai"
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_FR "TWB64 110 - Violet Yo-kai"
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_FR "TWB64 111 - Iro aquatique"
#define OPTION_VAL_TWB64_112_TEA_MIDORI_FR "TWB64 112 - Thé midori"
#define OPTION_VAL_TWB64_113_SAKURA_PINK_FR "TWB64 113 - Rose sakura"
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_FR NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_FR NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_FR "TWB64 116 - Kiiro doré"
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_FR "TWB64 117 - Shiro argenté"
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_FR "TWB64 118 - Orange fruité"
#define OPTION_VAL_TWB64_119_AKB48_PINK_FR "TWB64 119 - Rose AKB48"
#define OPTION_VAL_TWB64_120_MIKU_BLUE_FR "TWB64 120 - Bleu Miku"
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_FR "TWB64 121 - Rouge Fairy Tail"
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_FR "TWB64 122 - Marron Survey Corps"
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_FR "TWB64 123 - Vert insulaire"
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_FR "TWB64 124 - Vert Mania Plus"
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_FR "TWB64 125 - Vert Tortues Ninja"
#define OPTION_VAL_TWB64_126_SLIME_BLUE_FR "TWB64 126 - Bleu slime"
#define OPTION_VAL_TWB64_127_LIME_MIDORI_FR "TWB64 127 - Citron vert Midori"
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_FR "TWB64 128 - Aoi fantomatique"
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_FR "TWB64 129 - Bogeda rétro"
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_FR "TWB64 130 - Bleu royal"
#define OPTION_VAL_TWB64_131_NEON_PURPLE_FR "TWB64 131 - Violet néon"
#define OPTION_VAL_TWB64_132_NEON_ORANGE_FR "TWB64 132 - Orange néon"
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_FR "TWB64 133 - Vision Moonlight"
#define OPTION_VAL_TWB64_134_TOKYO_RED_FR "TWB64 134 - Rouge Tokyo"
#define OPTION_VAL_TWB64_135_PARIS_GOLD_FR "TWB64 135 - Or Paris"
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_FR "TWB64 136 - Bleu Beijing"
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_FR "TWB64 137 - Jaune Pac-Man"
#define OPTION_VAL_TWB64_138_IRISH_GREEN_FR "TWB64 138 - Vert irlandais"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_FR "TWB64 139 - Orange Kakarot"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_FR "TWB64 140 - Orange Dragon Ball"
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_FR "TWB64 141 - Or de Noël"
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_FR "TWB64 142 - Bleu Pepsi"
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_FR "TWB64 143 - Vert Bub"
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_FR "TWB64 144 - Bleu Bob"
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_FR "TWB64 145 - Tempête Baja Blast"
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_FR "TWB64 146 - Or olympique"
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_FR "TWB64 147 - Orange valeur"
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_FR "TWB64 148 - Violet Liella !"
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_FR "TWB64 149 - Argent olympique"
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_FR "TWB64 150 - Bronze olympique"
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_FR "TWB64 151 - Bleu ciel ANA"
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_FR "TWB64 152 - Orange Nijigasaki"
#define OPTION_VAL_TWB64_153_HOLOBLUE_FR "TWB64 153 - HoloBleu"
#define OPTION_VAL_TWB64_154_WRESTLING_RED_FR "TWB64 154 - Rouge catch"
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_FR "TWB64 155 - Vert œuf de Yoshi"
#define OPTION_VAL_TWB64_156_POKEDEX_RED_FR "TWB64 156 - Rouge Pokédex"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_FR "TWB64 157 - Rêve bleu Disney"
#define OPTION_VAL_TWB64_158_XBOX_GREEN_FR "TWB64 158 - Vert Xbox"
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_FR "TWB64 159 - Mega Bleu Sonic"
#define OPTION_VAL_TWB64_160_G4_ORANGE_FR "TWB64 160 - Orange G4"
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_FR "TWB64 161 - Vert Scarlett"
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_FR "TWB64 162 - Bleu Glitchy"
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_FR "TWB64 163 - LCD classique"
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_FR "TWB64 164 - Version Console virtuelle 3DS"
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_FR "TWB64 165 - Version PocketStation"
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_FR "TWB64 166 - Game and Or"
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_FR "TWB64 167 - Schtroumpfement bleu"
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_FR "TWB64 168 - Vert ogre marécageux"
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_FR "TWB64 169 - Vert épinards de marin"
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_FR "TWB64 170 - Vert Shenron"
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_FR "TWB64 171 - Sang Berserk"
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_FR "TWB64 172 - Rose Fun Pak"
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_FR "TWB64 173 - Version Gamebuino Classic"
#define OPTION_VAL_TWB64_174_BARBIE_PINK_FR "TWB64 174 - Rose Barbie"
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_FR "TWB64 175 - Vert Star Command"
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_FR "TWB64 176 - Version Nokia 3310"
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_FR "TWB64 177 - Vert trèfle"
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_FR "TWB64 178 - Orange Crash"
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_FR "TWB64 179 - Jaune disquette Famicom"
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_FR "TWB64 180 - Rouge Team Rocket"
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_FR "TWB64 181 - Jaune minuteur SEIKO"
#define OPTION_VAL_TWB64_182_PINK109_FR NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_FR "TWB64 183 - Bleu Doraemon"
#define OPTION_VAL_TWB64_184_FURY_BLUE_FR "TWB64 184 - Bleu Fury"
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_FR "TWB64 185 - Orange Rockstar"
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_FR "TWB64 186 - Vert Puyo Puyo"
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_FR "TWB64 187 - Rose Susan G."
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_FR "TWB64 188 - Rouge Pizza Hut"
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_FR "TWB64 189 - Vert plumbob"
#define OPTION_VAL_TWB64_190_GRAND_IVORY_FR "TWB64 190 - Grand Ivoire"
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_FR "TWB64 191 - Or du démon"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_FR "TWB64 192 - Bleu Tokyo SEGA"
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_FR "TWB64 193 - Bleu Champion"
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_FR "TWB64 194 - Marron baril DK"
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_FR "TWB64 195 - Vert Evangelion"
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_FR "TWB64 196 - Violet équestre"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_FR "TWB64 197 - Rouge Autobot"
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_FR "TWB64 198 - Vert océan Niconico"
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_FR "TWB64 199 - Cuivre Duracell"
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_FR "TWB64 200 - BLEU NUAGEUX TOKYO SKYTREE"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_FR "> PixelShift - Palette Pack 1"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_FR "Sélectionne la palette de colorisation interne lorsque 'Palette interne' est définie sur 'PixelShift - Pack 1'."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_FR "PixelShift 01 - Vert arctique"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_FR NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_FR "PixelShift 03 - Émulateur BGB 0.3"
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_FR NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_FR "PixelShift 05 - Barre de chocolat"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_FR "PixelShift 06 - CMJN"
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_FR "PixelShift 07 - Barbe à papa"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_FR "PixelShift 08 - Verts faciles"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_FR NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_FR NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_FR NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_FR "PixelShift 12 - Game Boy Pocket alt."
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_FR NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_FR NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_FR "PixelShift 15 - GB rétro-éclairage bleu"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_FR "PixelShift 16 - GB rétro-éclairage décoloré"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_FR "PixelShift 17 - GB rétro-éclairage orange"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__FR "PixelShift 18 - GB rétro-éclairage blanc "
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_FR "PixelShift 19 - GB rétro-éclairage jaune foncé"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_FR "PixelShift 20 - GB de contrebande"
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_FR NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_FR "PixelShift 22 - Kiosque GB"
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_FR "PixelShift 23 - Kiosque GB 2"
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_FR "PixelShift 24 - Nouvelle GB"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_FR "PixelShift 25 - GB détruite"
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_FR "PixelShift 26 - Vielle GB"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_FR NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_FR "PixelShift 28 - GB rétroéclairage jaune délavé"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_FR "PixelShift 29 - Fantôme"
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_FR "PixelShift 30 - Brille dans le noir"
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_FR "PixelShift 31 - Lingot d'or"
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_FR "PixelShift 32 - Pamplemousse"
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_FR "PixelShift 33 - Mélange vert gris"
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_FR NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_FR NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_FR "PixelShift 36 - Journal"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_FR NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_FR NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_FR NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_FR "PixelShift 40 - Coup de soleil"
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_FR NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_FR NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_FR NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_FR NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_FR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_FR "Correction colorimétrique"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_FR "Ajuste les couleurs de sortie pour correspondre à l'affichage du matériel réel de la Game Boy Color. 'GBC uniquement' garantit que la correction n'est appliquée que lorsque vous jouez à des jeux Game Boy Color, ou lorsque vous utilisez une palette de Game Boy Color pour coloriser un jeu Game Boy. 'Toujours' applique la correction colorimétrique sur tous les contenus, et produira des résultats inattendus/sous-optimaux lors de l'utilisation des palettes de couleurs internes 'GB' ou 'SGB'."
#define OPTION_VAL_GBC_ONLY_FR "GBC uniquement"
#define OPTION_VAL_ALWAYS_FR "Toujours"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_FR "Mode de correction colorimétrique"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_FR "Spécifie la méthode utilisée lors de la correction colorimétrique. 'Précis' produit une sortie presque indifférenciable d'un vrai panneau LCD de Game Boy Color. 'Rapide' ne fait qu'obscurcir les couleurs et réduit la saturation, et peut être utilisé sur du matériel bas de gamme si la méthode 'Précis' est trop lente."
#define OPTION_VAL_ACCURATE_FR "Précis"
#define OPTION_VAL_FAST_FR "Rapide"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_FR "Correction colorimétrique - Position de l'éclairage avant"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_FR "Simule la réponse physique du panneau LCD de la Game Boy Color lorsqu'il est illuminé sous différents angles. 'Centrale' représente la reproduction standard des couleurs. 'Au-dessus de l'écran' augmente la luminosité. 'En dessous de l'écran' réduit la luminosité. Ce paramètre s'applique uniquement lorsque le 'Mode de correction colorimétrique' est réglé sur 'Précis'."
#define OPTION_VAL_CENTRAL_FR "Centrale"
#define OPTION_VAL_ABOVE_SCREEN_FR "Au-dessus de l'écran"
#define OPTION_VAL_BELOW_SCREEN_FR "En dessous de l'écran"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_FR "Niveau du filtre d'assombrissement (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_FR "Active la réduction de l'éclairage basée sur la luminosité. Peut être utilisé pour éviter l'éblouissement/fatigue des yeux lorsque vous jouez à des jeux avec des fonds blancs, qui sont destinés à être affichés sur une Game Boy Color non-rétroéclairée et peuvent donc apparaître inconfortablement lumineux lorsqu'ils sont vus sur un écran rétro-éclairé moderne."
#define GAMBATTE_MIX_FRAMES_LABEL_FR "Mélange d'inter-trames"
#define GAMBATTE_MIX_FRAMES_INFO_0_FR "Simule les effets de rémanence LCD, 'Simple' effectue un mélange à 50/50 des images actuelles et précédentes. 'Rémanence LCD' imite le temps de réponse naturel du LCD en combinant plusieurs images mises en mémoire tampon. Un mélange 'Simple' est nécessaire lorsque vous jouez à des jeux qui dépendent de la rémanence LCD pour des effets de transparence (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_FR NULL
#define OPTION_VAL_LCD_GHOSTING_FR "Rémanence LCD (réaliste)"
#define OPTION_VAL_LCD_GHOSTING_FAST_FR "Rémanence LCD (rapide)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_FR "Ré-échantillonneur audio "
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_FR "Spécifie quel algorithme utiliser lors du rééchantillonnage du son généré (le débit audio de la Game Boy est limité uniquement par la vitesse d'écriture du processeur, de telle sorte que les fréquences 'natives' sont impraticables sur les appareils sonores modernes et doivent être sous-échantillonnées). 'Sinc' produit la plus haute qualité. 'Cosinus' améliore les performances sur du matériel de bas de gamme."
#define OPTION_VAL_SINC_FR NULL
#define OPTION_VAL_CC_FR "Cosinus"
#define GAMBATTE_GB_HWMODE_LABEL_FR "Matériel émulé (Redémarrage requis)"
#define GAMBATTE_GB_HWMODE_INFO_0_FR "Spécifie quel type de matériel émuler. 'Auto' est recommandé. Sélectionner 'GBA' déverrouille des fonctionnalités supplémentaires dans certains jeux Game Boy Color 'améliorés pour la GBA' (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_FR NULL
#define OPTION_VAL_GBA_FR NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_FR "Utiliser le bootloader officiel (Redémarrage requis)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_FR "Active la prise en charge des bootloaders officiels de la Game Boy et Game Boy Color, avec les animations du logo de démarrage correspondantes."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_FR "Autoriser les directions opposées"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_FR "L'activation de cette option permettra d'appuyer/d'alterner rapidement/de maintenir les directions gauche et droite (ou haut et bas) en même temps. Cela peut causer des bugs liés au mouvement."
#define GAMBATTE_TURBO_PERIOD_LABEL_FR "Délai d'activation du bouton en mode turbo"
#define GAMBATTE_TURBO_PERIOD_INFO_0_FR "Spécifier l'intervalle de répétition (en images) lorsque vous maintenez enfoncé les boutons Turbo A/B."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_FR "Intensité de la vibration manette"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_FR "Active les effets de retour haptique pour les jeux pris en charge (Pokémon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_FR "Afficher les paramètres du câble link"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_FR "Activer la configuration des options du câble link en réseau (multijoueur). REMARQUE : Le menu rapide peut avoir besoin d'être réouvert pour que ce paramètre prenne effet."
#define GAMBATTE_GB_LINK_MODE_LABEL_FR "Mode du câble link"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_FR "Mode liaison"
#define GAMBATTE_GB_LINK_MODE_INFO_0_FR "Lors de l'activation de la fonctionnalité du câble link en réseau, spécifier si l'instance actuelle doit s'exécuter en tant que serveur ou client."
#define OPTION_VAL_NOT_CONNECTED_FR "Non connecté"
#define OPTION_VAL_NETWORK_SERVER_FR "Serveur réseau"
#define OPTION_VAL_NETWORK_CLIENT_FR "Client réseau"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_FR "Port de liaison réseau"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_FR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_FR "Spécifier le port utilisé pour la communication réseau du câble link."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_FR "Adresse du serveur de liaison réseau partie 01 : x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_FR "Adresse du serveur partie 01 : x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_FR "1er chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_FR "1er chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_FR "Adresse du serveur de liaison réseau partie 02 : _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_FR "Adresse du serveur partie 02 : _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_FR "2ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_FR "2ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_FR "Adresse du serveur de liaison réseau partie 03 : __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_FR "Adresse du serveur partie 03 : __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_FR "3ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_FR "3ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_FR "Adresse du serveur de liaison réseau partie 04 : ___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_FR "Adresse du serveur partie 04 : ___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_FR "4ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_FR "4ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_FR "Adresse du serveur de liaison réseau partie 05 : ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_FR "Adresse du serveur partie 05 : ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_FR "5ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_FR "5ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_FR "Adresse du serveur de liaison réseau partie 06 : ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_FR "Adresse du serveur partie 06 : ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_FR "6ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_FR "6ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_FR "Adresse du serveur de liaison réseau partie 07 : ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_FR "Adresse du serveur partie 07 : ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_FR "7ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_FR "7ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_FR "Adresse du serveur du lien réseau partie 08 : ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_FR "Adresse du serveur partie 08 : ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_FR "8ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_FR "8ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_FR "Adresse du serveur de liaison réseau partie 09 : ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_FR "Adresse du serveur partie 09 : ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_FR "9ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_FR "9ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_FR "Adresse du serveur du lien réseau partie 10 : ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_FR "Adresse du serveur partie 10 : ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_FR "10ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_FR "10ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_FR "Adresse du serveur de liaison réseau partie 11 : ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_FR "Adresse du serveur partie 11 : ___.___.___._._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_FR "11ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_FR "11ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_FR "Adresse du serveur de liaison réseau partie 12 : ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_FR "Adresse du serveur partie 12 : ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_FR "12ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode du câble link' est réglé sur 'Client réseau'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_FR "12ème chiffre de l'adresse IP du serveur réseau du câble link distant. Utilisé uniquement lorsque le 'Mode liaison' est réglé sur 'Client réseau'."

struct retro_core_option_v2_category option_cats_fr[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_FR,
      CATEGORY_GB_LINK_INFO_0_FR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_fr[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_FR,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_FR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_FR },
         { "GBC",      OPTION_VAL_GBC_FR },
         { "SGB",      OPTION_VAL_SGB_FR },
         { "internal", OPTION_VAL_INTERNAL_FR },
         { "custom",   OPTION_VAL_CUSTOM_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_FR,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_FR,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_FR },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_FR },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_FR },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_FR },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_FR },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_FR },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_FR },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_FR },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_FR },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_FR },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_FR },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_FR },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_FR },
         { "GBC - Red",                OPTION_VAL_GBC_RED_FR },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_FR },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_FR },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_FR },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_FR },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_FR },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_FR },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_FR },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_FR },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_FR },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_FR },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_FR },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_FR },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_FR },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_FR },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_FR },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_FR },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_FR },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_FR },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_FR },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_FR },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_FR },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_FR },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_FR },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_FR },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_FR },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_FR },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_FR },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_FR },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_FR },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_FR },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_FR },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_FR },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_FR },
         { "Special 1",                OPTION_VAL_SPECIAL_1_FR },
         { "Special 2",                OPTION_VAL_SPECIAL_2_FR },
         { "Special 3",                OPTION_VAL_SPECIAL_3_FR },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_FR },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_FR },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_FR },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_FR },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_FR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_FR,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_FR },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_FR },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_FR },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_FR },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_FR },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_FR },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_FR },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_FR },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_FR },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_FR },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_FR },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_FR },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_FR },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_FR },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_FR },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_FR },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_FR },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_FR },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_FR },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_FR },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_FR },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_FR },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_FR },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_FR },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_FR },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_FR },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_FR },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_FR },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_FR },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_FR },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_FR },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_FR },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_FR },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_FR },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_FR },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_FR },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_FR },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_FR },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_FR },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_FR },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_FR },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_FR },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_FR },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_FR },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_FR },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_FR },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_FR },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_FR },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_FR },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_FR },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_FR },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_FR },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_FR },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_FR },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_FR },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_FR },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_FR },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_FR },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_FR },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_FR },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_FR },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_FR },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_FR },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_FR },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_FR },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_FR },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_FR },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_FR },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_FR },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_FR },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_FR },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_FR },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_FR },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_FR },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_FR },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_FR },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_FR },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_FR },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_FR },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_FR },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_FR },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_FR },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_FR },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_FR },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_FR },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_FR },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_FR },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_FR },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_FR },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_FR },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_FR },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_FR },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_FR },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_FR },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_FR },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_FR },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_FR },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_FR },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_FR },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_FR },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_FR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_FR,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_FR },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_FR },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_FR },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_FR },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_FR },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_FR },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_FR },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_FR },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_FR },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_FR },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_FR },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_FR },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_FR },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_FR },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_FR },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_FR },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_FR },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_FR },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_FR },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_FR },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_FR },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_FR },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_FR },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_FR },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_FR },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_FR },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_FR },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_FR },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_FR },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_FR },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_FR },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_FR },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_FR },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_FR },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_FR },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_FR },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_FR },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_FR },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_FR },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_FR },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_FR },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_FR },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_FR },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_FR },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_FR },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_FR },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_FR },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_FR },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_FR },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_FR },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_FR },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_FR },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_FR },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_FR },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_FR },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_FR },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_FR },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_FR },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_FR },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_FR },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_FR },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_FR },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_FR },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_FR },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_FR },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_FR },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_FR },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_FR },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_FR },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_FR },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_FR },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_FR },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_FR },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_FR },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_FR },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_FR },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_FR },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_FR },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_FR },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_FR },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_FR },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_FR },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_FR },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_FR },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_FR },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_FR },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_FR },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_FR },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_FR },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_FR },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_FR },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_FR },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_FR },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_FR },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_FR },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_FR },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_FR },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_FR },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_FR },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_FR },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_FR,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_FR,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_FR },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_FR },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_FR },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_FR },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_FR },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_FR },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_FR },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_FR },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_FR },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_FR },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_FR },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_FR },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_FR },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_FR },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_FR },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_FR },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_FR },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__FR },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_FR },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_FR },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_FR },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_FR },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_FR },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_FR },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_FR },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_FR },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_FR },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_FR },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_FR },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_FR },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_FR },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_FR },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_FR },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_FR },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_FR },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_FR },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_FR },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_FR },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_FR },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_FR },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_FR },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_FR },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_FR },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_FR },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_FR },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_FR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_FR,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_FR },
         { "always",   OPTION_VAL_ALWAYS_FR },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_FR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_FR,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_FR },
         { "fast",     OPTION_VAL_FAST_FR },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_FR,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_FR,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_FR },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_FR },
         { "below screen", OPTION_VAL_BELOW_SCREEN_FR },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_FR,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_FR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_FR,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_FR,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_FR },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_FR },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_FR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_FR,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_FR,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_FR },
         { "cc",   OPTION_VAL_CC_FR },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_FR,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_FR,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_FR },
         { "GB",   OPTION_VAL_GB_FR },
         { "GBC",  OPTION_VAL_GBC_FR },
         { "GBA",  OPTION_VAL_GBA_FR },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_FR,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_FR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_FR,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_FR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_FR,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_FR,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_FR,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_FR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_FR,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_FR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_FR,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_MODE_INFO_0_FR,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_FR },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_FR },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_FR },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_FR,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_FR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_FR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_fr = {
   option_cats_fr,
   option_defs_fr
};

/* RETRO_LANGUAGE_GL */

#define CATEGORY_GB_LINK_LABEL_GL NULL
#define CATEGORY_GB_LINK_INFO_0_GL "(Multixogador) Cambiar a configuración do Game Link."
#define GAMBATTE_GB_COLORIZATION_LABEL_GL NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_GL NULL
#define OPTION_VAL_AUTO_GL NULL
#define OPTION_VAL_GBC_GL NULL
#define OPTION_VAL_SGB_GL NULL
#define OPTION_VAL_INTERNAL_GL NULL
#define OPTION_VAL_CUSTOM_GL NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_GL NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_GL NULL
#define OPTION_VAL_GB_DMG_GL NULL
#define OPTION_VAL_GB_POCKET_GL NULL
#define OPTION_VAL_GB_LIGHT_GL NULL
#define OPTION_VAL_GBC_BLUE_GL NULL
#define OPTION_VAL_GBC_BROWN_GL NULL
#define OPTION_VAL_GBC_DARK_BLUE_GL NULL
#define OPTION_VAL_GBC_DARK_BROWN_GL NULL
#define OPTION_VAL_GBC_DARK_GREEN_GL NULL
#define OPTION_VAL_GBC_GRAYSCALE_GL NULL
#define OPTION_VAL_GBC_GREEN_GL NULL
#define OPTION_VAL_GBC_INVERTED_GL NULL
#define OPTION_VAL_GBC_ORANGE_GL NULL
#define OPTION_VAL_GBC_PASTEL_MIX_GL NULL
#define OPTION_VAL_GBC_RED_GL NULL
#define OPTION_VAL_GBC_YELLOW_GL NULL
#define OPTION_VAL_SGB_1A_GL NULL
#define OPTION_VAL_SGB_1B_GL NULL
#define OPTION_VAL_SGB_1C_GL NULL
#define OPTION_VAL_SGB_1D_GL NULL
#define OPTION_VAL_SGB_1E_GL NULL
#define OPTION_VAL_SGB_1F_GL NULL
#define OPTION_VAL_SGB_1G_GL NULL
#define OPTION_VAL_SGB_1H_GL NULL
#define OPTION_VAL_SGB_2A_GL NULL
#define OPTION_VAL_SGB_2B_GL NULL
#define OPTION_VAL_SGB_2C_GL NULL
#define OPTION_VAL_SGB_2D_GL NULL
#define OPTION_VAL_SGB_2E_GL NULL
#define OPTION_VAL_SGB_2F_GL NULL
#define OPTION_VAL_SGB_2G_GL NULL
#define OPTION_VAL_SGB_2H_GL NULL
#define OPTION_VAL_SGB_3A_GL NULL
#define OPTION_VAL_SGB_3B_GL NULL
#define OPTION_VAL_SGB_3C_GL NULL
#define OPTION_VAL_SGB_3D_GL NULL
#define OPTION_VAL_SGB_3E_GL NULL
#define OPTION_VAL_SGB_3F_GL NULL
#define OPTION_VAL_SGB_3G_GL NULL
#define OPTION_VAL_SGB_3H_GL NULL
#define OPTION_VAL_SGB_4A_GL NULL
#define OPTION_VAL_SGB_4B_GL NULL
#define OPTION_VAL_SGB_4C_GL NULL
#define OPTION_VAL_SGB_4D_GL NULL
#define OPTION_VAL_SGB_4E_GL NULL
#define OPTION_VAL_SGB_4F_GL NULL
#define OPTION_VAL_SGB_4G_GL NULL
#define OPTION_VAL_SGB_4H_GL NULL
#define OPTION_VAL_SPECIAL_1_GL NULL
#define OPTION_VAL_SPECIAL_2_GL NULL
#define OPTION_VAL_SPECIAL_3_GL NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_GL NULL
#define OPTION_VAL_TWB64_PACK_1_GL NULL
#define OPTION_VAL_TWB64_PACK_2_GL NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_GL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_GL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_GL NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_GL NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_GL NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_GL NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_GL NULL
#define OPTION_VAL_TWB64_005_NEON_RED_GL NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_GL NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_GL NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_GL NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_GL NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_GL NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_GL NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_GL NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_GL NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_GL NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_GL NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_GL NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_GL NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_GL NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_GL NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_GL NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_GL NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_GL NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_GL NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_GL NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_GL NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_GL NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_GL NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_GL NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_GL NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_GL NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_GL NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_GL NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_GL NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_GL NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_GL NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_GL NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_GL NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_GL NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_GL NULL
#define OPTION_VAL_TWB64_040_DMG_VER_GL NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_GL NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_GL NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_GL NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_GL NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_GL NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_GL NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_GL NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_GL NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_GL NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_GL NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_GL NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_GL NULL
#define OPTION_VAL_TWB64_053_VMU_VER_GL NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_GL NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_GL NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_GL NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_GL NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_GL NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_GL NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_GL NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_GL NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_GL NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_GL NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_GL NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_GL NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_GL NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_GL NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_GL NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_GL NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_GL NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_GL NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_GL NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_GL NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_GL NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_GL NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_GL NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_GL NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_GL NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_GL NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_GL NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_GL NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_GL NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_GL NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_GL NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_GL NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_GL NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_GL NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_GL NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_GL NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_GL NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_GL NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_GL NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_GL NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_GL NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_GL NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_GL NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_GL NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_GL NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_GL NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_GL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_GL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_GL NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_GL NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_GL NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_GL NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_GL NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_GL NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_GL NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_GL NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_GL NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_GL NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_GL NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_GL NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_GL NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_GL NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_GL NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_GL NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_GL NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_GL NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_GL NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_GL NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_GL NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_GL NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_GL NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_GL NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_GL NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_GL NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_GL NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_GL NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_GL NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_GL NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_GL NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_GL NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_GL NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_GL NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_GL NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_GL NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_GL NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_GL NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_GL NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_GL NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_GL NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_GL NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_GL NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_GL NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_GL NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_GL NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_GL NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_GL NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_GL NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_GL NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_GL NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_GL NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_GL NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_GL NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_GL NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_GL NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_GL NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_GL NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_GL NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_GL NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_GL NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_GL NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_GL NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_GL NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_GL NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_GL NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_GL NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_GL NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_GL NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_GL NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_GL NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_GL NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_GL NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_GL NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_GL NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_GL NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_GL NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_GL NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_GL NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_GL NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_GL NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_GL NULL
#define OPTION_VAL_TWB64_182_PINK109_GL NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_GL NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_GL NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_GL NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_GL NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_GL NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_GL NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_GL NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_GL NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_GL NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_GL NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_GL NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_GL NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_GL NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_GL NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_GL NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_GL NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_GL NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_GL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_GL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_GL NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_GL NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_GL NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_GL NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_GL NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_GL NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_GL NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_GL NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_GL NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_GL NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_GL NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_GL NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_GL NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_GL NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_GL NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_GL NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_GL NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_GL NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__GL NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_GL NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_GL NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_GL NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_GL NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_GL NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_GL NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_GL NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_GL NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_GL NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_GL NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_GL NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_GL NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_GL NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_GL NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_GL NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_GL NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_GL NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_GL NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_GL NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_GL NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_GL NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_GL NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_GL NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_GL NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_GL NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_GL NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_GL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_GL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_GL NULL
#define OPTION_VAL_GBC_ONLY_GL NULL
#define OPTION_VAL_ALWAYS_GL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_GL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_GL NULL
#define OPTION_VAL_ACCURATE_GL NULL
#define OPTION_VAL_FAST_GL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_GL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_GL NULL
#define OPTION_VAL_CENTRAL_GL NULL
#define OPTION_VAL_ABOVE_SCREEN_GL NULL
#define OPTION_VAL_BELOW_SCREEN_GL NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_GL "Nivel de filtro escuro (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_GL NULL
#define GAMBATTE_MIX_FRAMES_LABEL_GL NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_GL NULL
#define OPTION_VAL_MIX_GL NULL
#define OPTION_VAL_LCD_GHOSTING_GL NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_GL NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_GL "Remostreador de audio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_GL NULL
#define OPTION_VAL_SINC_GL NULL
#define OPTION_VAL_CC_GL NULL
#define GAMBATTE_GB_HWMODE_LABEL_GL "Hardware emulado (Require reiniciar)"
#define GAMBATTE_GB_HWMODE_INFO_0_GL "Especifica qué tipo de hardware a emular. 'Auto' é o recomendado. Seleccionando 'GBA' desbloquea características extra en certos xogos de Game Boy Color 'GBA millorados' (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_GL NULL
#define OPTION_VAL_GBA_GL NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_GL "Usar o Bootloader oficial (Requírese reiniciar)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_GL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_GL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_GL "Activando esta opción permite o pulsado rápido, alternando e mantendo pulsadas, ambas direccións ao mesmo tempo, esquerda e dereita (ou arriba e abaixo). Isto pode causar fallos nos movementos."
#define GAMBATTE_TURBO_PERIOD_LABEL_GL NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_GL NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_GL NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_GL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_GL "Amosa a configuración do Game Link"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_GL "Activa a configuración das opcións do Game Link en rede (multixogador). NOTA: O menú rápido necesitaría estar activado para que esta configuración surta efecto."
#define GAMBATTE_GB_LINK_MODE_LABEL_GL "Modo Game Link"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_GL "Cando se activa a funcionalidade Game Link en rede, especifica se a instancia actual debería correr como servidor ou como cliente."
#define OPTION_VAL_NOT_CONNECTED_GL NULL
#define OPTION_VAL_NETWORK_SERVER_GL NULL
#define OPTION_VAL_NETWORK_CLIENT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_GL "Especifica o porto usado para a comunicación en rede do Game Link."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_GL "1º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_GL "1º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_GL "2º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_GL "2º dixito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_GL "3º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_GL "3º dixito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_GL "4º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_GL "4º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_GL "5º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_GL "5º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_GL "6º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_GL "6º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_GL "7º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_GL "8º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_GL "8º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_GL "8º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_GL "9º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_GL "9º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_GL "10º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_GL "10º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_GL "11º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_GL "11º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_GL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_GL "12º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo Game Link' está configurado como 'Cliente en rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_GL "12º díxito da dirección IP do Game Link remoto. Só se usa cando o 'Modo de Enlace' está configurado como 'Cliente en rede'."

struct retro_core_option_v2_category option_cats_gl[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_GL,
      CATEGORY_GB_LINK_INFO_0_GL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_gl[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_GL,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_GL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_GL },
         { "GBC",      OPTION_VAL_GBC_GL },
         { "SGB",      OPTION_VAL_SGB_GL },
         { "internal", OPTION_VAL_INTERNAL_GL },
         { "custom",   OPTION_VAL_CUSTOM_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_GL,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_GL,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_GL },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_GL },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_GL },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_GL },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_GL },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_GL },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_GL },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_GL },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_GL },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_GL },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_GL },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_GL },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_GL },
         { "GBC - Red",                OPTION_VAL_GBC_RED_GL },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_GL },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_GL },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_GL },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_GL },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_GL },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_GL },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_GL },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_GL },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_GL },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_GL },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_GL },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_GL },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_GL },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_GL },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_GL },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_GL },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_GL },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_GL },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_GL },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_GL },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_GL },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_GL },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_GL },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_GL },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_GL },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_GL },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_GL },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_GL },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_GL },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_GL },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_GL },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_GL },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_GL },
         { "Special 1",                OPTION_VAL_SPECIAL_1_GL },
         { "Special 2",                OPTION_VAL_SPECIAL_2_GL },
         { "Special 3",                OPTION_VAL_SPECIAL_3_GL },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_GL },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_GL },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_GL },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_GL },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_GL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_GL,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_GL },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_GL },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_GL },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_GL },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_GL },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_GL },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_GL },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_GL },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_GL },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_GL },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_GL },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_GL },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_GL },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_GL },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_GL },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_GL },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_GL },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_GL },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_GL },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_GL },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_GL },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_GL },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_GL },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_GL },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_GL },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_GL },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_GL },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_GL },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_GL },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_GL },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_GL },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_GL },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_GL },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_GL },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_GL },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_GL },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_GL },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_GL },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_GL },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_GL },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_GL },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_GL },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_GL },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_GL },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_GL },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_GL },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_GL },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_GL },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_GL },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_GL },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_GL },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_GL },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_GL },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_GL },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_GL },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_GL },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_GL },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_GL },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_GL },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_GL },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_GL },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_GL },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_GL },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_GL },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_GL },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_GL },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_GL },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_GL },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_GL },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_GL },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_GL },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_GL },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_GL },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_GL },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_GL },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_GL },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_GL },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_GL },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_GL },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_GL },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_GL },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_GL },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_GL },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_GL },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_GL },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_GL },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_GL },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_GL },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_GL },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_GL },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_GL },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_GL },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_GL },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_GL },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_GL },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_GL },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_GL },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_GL },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_GL },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_GL },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_GL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_GL,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_GL },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_GL },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_GL },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_GL },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_GL },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_GL },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_GL },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_GL },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_GL },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_GL },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_GL },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_GL },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_GL },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_GL },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_GL },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_GL },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_GL },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_GL },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_GL },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_GL },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_GL },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_GL },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_GL },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_GL },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_GL },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_GL },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_GL },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_GL },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_GL },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_GL },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_GL },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_GL },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_GL },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_GL },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_GL },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_GL },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_GL },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_GL },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_GL },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_GL },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_GL },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_GL },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_GL },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_GL },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_GL },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_GL },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_GL },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_GL },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_GL },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_GL },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_GL },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_GL },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_GL },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_GL },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_GL },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_GL },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_GL },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_GL },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_GL },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_GL },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_GL },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_GL },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_GL },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_GL },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_GL },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_GL },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_GL },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_GL },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_GL },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_GL },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_GL },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_GL },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_GL },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_GL },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_GL },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_GL },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_GL },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_GL },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_GL },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_GL },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_GL },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_GL },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_GL },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_GL },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_GL },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_GL },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_GL },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_GL },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_GL },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_GL },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_GL },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_GL },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_GL },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_GL },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_GL },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_GL },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_GL },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_GL },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_GL },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_GL },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_GL,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_GL,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_GL },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_GL },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_GL },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_GL },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_GL },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_GL },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_GL },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_GL },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_GL },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_GL },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_GL },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_GL },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_GL },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_GL },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_GL },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_GL },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_GL },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__GL },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_GL },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_GL },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_GL },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_GL },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_GL },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_GL },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_GL },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_GL },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_GL },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_GL },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_GL },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_GL },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_GL },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_GL },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_GL },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_GL },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_GL },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_GL },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_GL },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_GL },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_GL },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_GL },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_GL },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_GL },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_GL },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_GL },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_GL },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_GL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_GL,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_GL },
         { "always",   OPTION_VAL_ALWAYS_GL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_GL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_GL,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_GL },
         { "fast",     OPTION_VAL_FAST_GL },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_GL,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_GL,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_GL },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_GL },
         { "below screen", OPTION_VAL_BELOW_SCREEN_GL },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_GL,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_GL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_GL,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_GL,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_GL },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_GL },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_GL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_GL,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_GL,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_GL },
         { "cc",   OPTION_VAL_CC_GL },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_GL,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_GL,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_GL },
         { "GB",   OPTION_VAL_GB_GL },
         { "GBC",  OPTION_VAL_GBC_GL },
         { "GBA",  OPTION_VAL_GBA_GL },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_GL,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_GL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_GL,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_GL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_GL,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_GL,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_GL,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_GL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_GL,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_GL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_GL,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_MODE_INFO_0_GL,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_GL },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_GL },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_GL },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_GL,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_GL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_GL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_gl = {
   option_cats_gl,
   option_defs_gl
};

/* RETRO_LANGUAGE_HE */

#define CATEGORY_GB_LINK_LABEL_HE NULL
#define CATEGORY_GB_LINK_INFO_0_HE NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_HE NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_HE NULL
#define OPTION_VAL_AUTO_HE NULL
#define OPTION_VAL_GBC_HE NULL
#define OPTION_VAL_SGB_HE NULL
#define OPTION_VAL_INTERNAL_HE NULL
#define OPTION_VAL_CUSTOM_HE NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_HE NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_HE NULL
#define OPTION_VAL_GB_DMG_HE NULL
#define OPTION_VAL_GB_POCKET_HE NULL
#define OPTION_VAL_GB_LIGHT_HE NULL
#define OPTION_VAL_GBC_BLUE_HE NULL
#define OPTION_VAL_GBC_BROWN_HE NULL
#define OPTION_VAL_GBC_DARK_BLUE_HE NULL
#define OPTION_VAL_GBC_DARK_BROWN_HE NULL
#define OPTION_VAL_GBC_DARK_GREEN_HE NULL
#define OPTION_VAL_GBC_GRAYSCALE_HE NULL
#define OPTION_VAL_GBC_GREEN_HE NULL
#define OPTION_VAL_GBC_INVERTED_HE NULL
#define OPTION_VAL_GBC_ORANGE_HE NULL
#define OPTION_VAL_GBC_PASTEL_MIX_HE NULL
#define OPTION_VAL_GBC_RED_HE NULL
#define OPTION_VAL_GBC_YELLOW_HE NULL
#define OPTION_VAL_SGB_1A_HE NULL
#define OPTION_VAL_SGB_1B_HE NULL
#define OPTION_VAL_SGB_1C_HE NULL
#define OPTION_VAL_SGB_1D_HE NULL
#define OPTION_VAL_SGB_1E_HE NULL
#define OPTION_VAL_SGB_1F_HE NULL
#define OPTION_VAL_SGB_1G_HE NULL
#define OPTION_VAL_SGB_1H_HE NULL
#define OPTION_VAL_SGB_2A_HE NULL
#define OPTION_VAL_SGB_2B_HE NULL
#define OPTION_VAL_SGB_2C_HE NULL
#define OPTION_VAL_SGB_2D_HE NULL
#define OPTION_VAL_SGB_2E_HE NULL
#define OPTION_VAL_SGB_2F_HE NULL
#define OPTION_VAL_SGB_2G_HE NULL
#define OPTION_VAL_SGB_2H_HE NULL
#define OPTION_VAL_SGB_3A_HE NULL
#define OPTION_VAL_SGB_3B_HE NULL
#define OPTION_VAL_SGB_3C_HE NULL
#define OPTION_VAL_SGB_3D_HE NULL
#define OPTION_VAL_SGB_3E_HE NULL
#define OPTION_VAL_SGB_3F_HE NULL
#define OPTION_VAL_SGB_3G_HE NULL
#define OPTION_VAL_SGB_3H_HE NULL
#define OPTION_VAL_SGB_4A_HE NULL
#define OPTION_VAL_SGB_4B_HE NULL
#define OPTION_VAL_SGB_4C_HE NULL
#define OPTION_VAL_SGB_4D_HE NULL
#define OPTION_VAL_SGB_4E_HE NULL
#define OPTION_VAL_SGB_4F_HE NULL
#define OPTION_VAL_SGB_4G_HE NULL
#define OPTION_VAL_SGB_4H_HE NULL
#define OPTION_VAL_SPECIAL_1_HE NULL
#define OPTION_VAL_SPECIAL_2_HE NULL
#define OPTION_VAL_SPECIAL_3_HE NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_HE NULL
#define OPTION_VAL_TWB64_PACK_1_HE NULL
#define OPTION_VAL_TWB64_PACK_2_HE NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_HE NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_HE NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_HE NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_HE NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_HE NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_HE NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_HE NULL
#define OPTION_VAL_TWB64_005_NEON_RED_HE NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_HE NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_HE NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_HE NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_HE NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_HE NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_HE NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_HE NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_HE NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_HE NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_HE NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_HE NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_HE NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_HE NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_HE NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_HE NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_HE NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_HE NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_HE NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_HE NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_HE NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_HE NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_HE NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_HE NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_HE NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_HE NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_HE NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_HE NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_HE NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_HE NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_HE NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_HE NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_HE NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_HE NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_HE NULL
#define OPTION_VAL_TWB64_040_DMG_VER_HE NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_HE NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_HE NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_HE NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_HE NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_HE NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_HE NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_HE NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_HE NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_HE NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_HE NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_HE NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_HE NULL
#define OPTION_VAL_TWB64_053_VMU_VER_HE NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_HE NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_HE NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_HE NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_HE NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_HE NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_HE NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_HE NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_HE NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_HE NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_HE NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_HE NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_HE NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_HE NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_HE NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_HE NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_HE NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_HE NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_HE NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_HE NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_HE NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_HE NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_HE NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_HE NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_HE NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_HE NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_HE NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_HE NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_HE NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_HE NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_HE NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_HE NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_HE NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_HE NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_HE NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_HE NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_HE NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_HE NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_HE NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_HE NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_HE NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_HE NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_HE NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_HE NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_HE NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_HE NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_HE NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_HE NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_HE NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_HE NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_HE NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_HE NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_HE NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_HE NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_HE NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_HE NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_HE NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_HE NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_HE NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_HE NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_HE NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_HE NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_HE NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_HE NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_HE NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_HE NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_HE NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_HE NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_HE NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_HE NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_HE NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_HE NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_HE NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_HE NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_HE NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_HE NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_HE NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_HE NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_HE NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_HE NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_HE NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_HE NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_HE NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_HE NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_HE NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_HE NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_HE NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_HE NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_HE NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_HE NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_HE NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_HE NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_HE NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_HE NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_HE NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_HE NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_HE NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_HE NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_HE NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_HE NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_HE NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_HE NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_HE NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_HE NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_HE NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_HE NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_HE NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_HE NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_HE NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_HE NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_HE NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_HE NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_HE NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_HE NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_HE NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_HE NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_HE NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_HE NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_HE NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_HE NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_HE NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_HE NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_HE NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_HE NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_HE NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_HE NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_HE NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_HE NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_HE NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_HE NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_HE NULL
#define OPTION_VAL_TWB64_182_PINK109_HE NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_HE NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_HE NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_HE NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_HE NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_HE NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_HE NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_HE NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_HE NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_HE NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_HE NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_HE NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_HE NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_HE NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_HE NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_HE NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_HE NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_HE NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_HE NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_HE NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_HE NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_HE NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_HE NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_HE NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_HE NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_HE NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_HE NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_HE NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_HE NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_HE NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_HE NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_HE NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_HE NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_HE NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_HE NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_HE NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_HE NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_HE NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__HE NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_HE NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_HE NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_HE NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_HE NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_HE NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_HE NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_HE NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_HE NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_HE NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_HE NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_HE NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_HE NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_HE NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_HE NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_HE NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_HE NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_HE NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_HE NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_HE NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_HE NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_HE NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_HE NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_HE NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_HE NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_HE NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_HE NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_HE NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_HE NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_HE NULL
#define OPTION_VAL_GBC_ONLY_HE NULL
#define OPTION_VAL_ALWAYS_HE NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_HE NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_HE NULL
#define OPTION_VAL_ACCURATE_HE NULL
#define OPTION_VAL_FAST_HE NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_HE NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_HE NULL
#define OPTION_VAL_CENTRAL_HE NULL
#define OPTION_VAL_ABOVE_SCREEN_HE NULL
#define OPTION_VAL_BELOW_SCREEN_HE NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_HE NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_HE NULL
#define GAMBATTE_MIX_FRAMES_LABEL_HE NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_HE NULL
#define OPTION_VAL_MIX_HE NULL
#define OPTION_VAL_LCD_GHOSTING_HE NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_HE NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_HE NULL
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_HE NULL
#define OPTION_VAL_SINC_HE NULL
#define OPTION_VAL_CC_HE NULL
#define GAMBATTE_GB_HWMODE_LABEL_HE NULL
#define GAMBATTE_GB_HWMODE_INFO_0_HE NULL
#define OPTION_VAL_GB_HE NULL
#define OPTION_VAL_GBA_HE NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_HE NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_HE NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_HE NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_HE NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_HE NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_HE NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_HE NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_HE NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_HE NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_HE NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_HE NULL
#define OPTION_VAL_NOT_CONNECTED_HE NULL
#define OPTION_VAL_NETWORK_SERVER_HE NULL
#define OPTION_VAL_NETWORK_CLIENT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_HE NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_HE NULL

struct retro_core_option_v2_category option_cats_he[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_HE,
      CATEGORY_GB_LINK_INFO_0_HE
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_he[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_HE,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_HE,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_HE },
         { "GBC",      OPTION_VAL_GBC_HE },
         { "SGB",      OPTION_VAL_SGB_HE },
         { "internal", OPTION_VAL_INTERNAL_HE },
         { "custom",   OPTION_VAL_CUSTOM_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_HE,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_HE,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_HE },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_HE },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_HE },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_HE },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_HE },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_HE },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_HE },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_HE },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_HE },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_HE },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_HE },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_HE },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_HE },
         { "GBC - Red",                OPTION_VAL_GBC_RED_HE },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_HE },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_HE },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_HE },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_HE },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_HE },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_HE },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_HE },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_HE },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_HE },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_HE },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_HE },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_HE },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_HE },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_HE },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_HE },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_HE },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_HE },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_HE },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_HE },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_HE },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_HE },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_HE },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_HE },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_HE },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_HE },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_HE },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_HE },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_HE },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_HE },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_HE },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_HE },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_HE },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_HE },
         { "Special 1",                OPTION_VAL_SPECIAL_1_HE },
         { "Special 2",                OPTION_VAL_SPECIAL_2_HE },
         { "Special 3",                OPTION_VAL_SPECIAL_3_HE },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_HE },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_HE },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_HE },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_HE },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_HE,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_HE,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_HE },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_HE },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_HE },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_HE },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_HE },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_HE },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_HE },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_HE },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_HE },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_HE },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_HE },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_HE },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_HE },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_HE },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_HE },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_HE },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_HE },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_HE },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_HE },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_HE },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_HE },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_HE },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_HE },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_HE },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_HE },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_HE },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_HE },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_HE },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_HE },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_HE },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_HE },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_HE },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_HE },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_HE },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_HE },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_HE },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_HE },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_HE },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_HE },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_HE },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_HE },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_HE },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_HE },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_HE },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_HE },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_HE },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_HE },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_HE },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_HE },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_HE },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_HE },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_HE },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_HE },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_HE },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_HE },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_HE },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_HE },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_HE },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_HE },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_HE },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_HE },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_HE },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_HE },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_HE },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_HE },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_HE },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_HE },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_HE },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_HE },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_HE },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_HE },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_HE },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_HE },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_HE },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_HE },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_HE },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_HE },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_HE },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_HE },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_HE },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_HE },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_HE },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_HE },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_HE },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_HE },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_HE },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_HE },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_HE },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_HE },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_HE },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_HE },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_HE },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_HE },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_HE },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_HE },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_HE },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_HE },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_HE },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_HE },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_HE },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_HE,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_HE,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_HE },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_HE },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_HE },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_HE },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_HE },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_HE },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_HE },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_HE },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_HE },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_HE },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_HE },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_HE },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_HE },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_HE },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_HE },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_HE },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_HE },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_HE },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_HE },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_HE },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_HE },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_HE },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_HE },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_HE },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_HE },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_HE },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_HE },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_HE },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_HE },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_HE },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_HE },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_HE },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_HE },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_HE },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_HE },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_HE },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_HE },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_HE },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_HE },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_HE },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_HE },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_HE },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_HE },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_HE },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_HE },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_HE },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_HE },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_HE },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_HE },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_HE },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_HE },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_HE },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_HE },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_HE },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_HE },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_HE },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_HE },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_HE },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_HE },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_HE },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_HE },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_HE },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_HE },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_HE },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_HE },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_HE },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_HE },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_HE },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_HE },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_HE },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_HE },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_HE },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_HE },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_HE },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_HE },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_HE },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_HE },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_HE },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_HE },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_HE },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_HE },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_HE },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_HE },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_HE },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_HE },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_HE },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_HE },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_HE },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_HE },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_HE },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_HE },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_HE },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_HE },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_HE },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_HE },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_HE },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_HE },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_HE },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_HE },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_HE },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_HE,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_HE,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_HE },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_HE },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_HE },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_HE },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_HE },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_HE },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_HE },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_HE },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_HE },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_HE },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_HE },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_HE },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_HE },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_HE },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_HE },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_HE },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_HE },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__HE },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_HE },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_HE },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_HE },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_HE },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_HE },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_HE },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_HE },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_HE },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_HE },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_HE },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_HE },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_HE },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_HE },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_HE },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_HE },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_HE },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_HE },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_HE },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_HE },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_HE },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_HE },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_HE },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_HE },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_HE },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_HE },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_HE },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_HE },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_HE,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_HE,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_HE },
         { "always",   OPTION_VAL_ALWAYS_HE },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_HE,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_HE,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_HE },
         { "fast",     OPTION_VAL_FAST_HE },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_HE,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_HE,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_HE },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_HE },
         { "below screen", OPTION_VAL_BELOW_SCREEN_HE },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_HE,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_HE,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_HE,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_HE,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_HE },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_HE },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_HE },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_HE,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_HE,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_HE },
         { "cc",   OPTION_VAL_CC_HE },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_HE,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_HE,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_HE },
         { "GB",   OPTION_VAL_GB_HE },
         { "GBC",  OPTION_VAL_GBC_HE },
         { "GBA",  OPTION_VAL_GBA_HE },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_HE,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_HE,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_HE,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_HE,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_HE,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_HE,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_HE,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_HE,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_HE,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_HE,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_HE,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_MODE_INFO_0_HE,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_HE },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_HE },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_HE },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_HE,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_HE,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_HE,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_he = {
   option_cats_he,
   option_defs_he
};

/* RETRO_LANGUAGE_HR */

#define CATEGORY_GB_LINK_LABEL_HR NULL
#define CATEGORY_GB_LINK_INFO_0_HR NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_HR NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_HR NULL
#define OPTION_VAL_AUTO_HR NULL
#define OPTION_VAL_GBC_HR NULL
#define OPTION_VAL_SGB_HR NULL
#define OPTION_VAL_INTERNAL_HR NULL
#define OPTION_VAL_CUSTOM_HR NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_HR NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_HR NULL
#define OPTION_VAL_GB_DMG_HR NULL
#define OPTION_VAL_GB_POCKET_HR NULL
#define OPTION_VAL_GB_LIGHT_HR NULL
#define OPTION_VAL_GBC_BLUE_HR NULL
#define OPTION_VAL_GBC_BROWN_HR NULL
#define OPTION_VAL_GBC_DARK_BLUE_HR NULL
#define OPTION_VAL_GBC_DARK_BROWN_HR NULL
#define OPTION_VAL_GBC_DARK_GREEN_HR NULL
#define OPTION_VAL_GBC_GRAYSCALE_HR NULL
#define OPTION_VAL_GBC_GREEN_HR NULL
#define OPTION_VAL_GBC_INVERTED_HR NULL
#define OPTION_VAL_GBC_ORANGE_HR NULL
#define OPTION_VAL_GBC_PASTEL_MIX_HR NULL
#define OPTION_VAL_GBC_RED_HR NULL
#define OPTION_VAL_GBC_YELLOW_HR NULL
#define OPTION_VAL_SGB_1A_HR NULL
#define OPTION_VAL_SGB_1B_HR NULL
#define OPTION_VAL_SGB_1C_HR NULL
#define OPTION_VAL_SGB_1D_HR NULL
#define OPTION_VAL_SGB_1E_HR NULL
#define OPTION_VAL_SGB_1F_HR NULL
#define OPTION_VAL_SGB_1G_HR NULL
#define OPTION_VAL_SGB_1H_HR NULL
#define OPTION_VAL_SGB_2A_HR NULL
#define OPTION_VAL_SGB_2B_HR NULL
#define OPTION_VAL_SGB_2C_HR NULL
#define OPTION_VAL_SGB_2D_HR NULL
#define OPTION_VAL_SGB_2E_HR NULL
#define OPTION_VAL_SGB_2F_HR NULL
#define OPTION_VAL_SGB_2G_HR NULL
#define OPTION_VAL_SGB_2H_HR NULL
#define OPTION_VAL_SGB_3A_HR NULL
#define OPTION_VAL_SGB_3B_HR NULL
#define OPTION_VAL_SGB_3C_HR NULL
#define OPTION_VAL_SGB_3D_HR NULL
#define OPTION_VAL_SGB_3E_HR NULL
#define OPTION_VAL_SGB_3F_HR NULL
#define OPTION_VAL_SGB_3G_HR NULL
#define OPTION_VAL_SGB_3H_HR NULL
#define OPTION_VAL_SGB_4A_HR NULL
#define OPTION_VAL_SGB_4B_HR NULL
#define OPTION_VAL_SGB_4C_HR NULL
#define OPTION_VAL_SGB_4D_HR NULL
#define OPTION_VAL_SGB_4E_HR NULL
#define OPTION_VAL_SGB_4F_HR NULL
#define OPTION_VAL_SGB_4G_HR NULL
#define OPTION_VAL_SGB_4H_HR NULL
#define OPTION_VAL_SPECIAL_1_HR NULL
#define OPTION_VAL_SPECIAL_2_HR NULL
#define OPTION_VAL_SPECIAL_3_HR NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_HR NULL
#define OPTION_VAL_TWB64_PACK_1_HR NULL
#define OPTION_VAL_TWB64_PACK_2_HR NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_HR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_HR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_HR NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_HR NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_HR NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_HR NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_HR NULL
#define OPTION_VAL_TWB64_005_NEON_RED_HR NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_HR NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_HR NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_HR NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_HR NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_HR NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_HR NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_HR NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_HR NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_HR NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_HR NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_HR NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_HR NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_HR NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_HR NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_HR NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_HR NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_HR NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_HR NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_HR NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_HR NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_HR NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_HR NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_HR NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_HR NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_HR NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_HR NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_HR NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_HR NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_HR NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_HR NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_HR NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_HR NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_HR NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_HR NULL
#define OPTION_VAL_TWB64_040_DMG_VER_HR NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_HR NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_HR NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_HR NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_HR NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_HR NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_HR NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_HR NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_HR NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_HR NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_HR NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_HR NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_HR NULL
#define OPTION_VAL_TWB64_053_VMU_VER_HR NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_HR NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_HR NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_HR NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_HR NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_HR NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_HR NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_HR NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_HR NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_HR NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_HR NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_HR NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_HR NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_HR NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_HR NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_HR NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_HR NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_HR NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_HR NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_HR NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_HR NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_HR NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_HR NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_HR NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_HR NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_HR NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_HR NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_HR NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_HR NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_HR NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_HR NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_HR NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_HR NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_HR NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_HR NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_HR NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_HR NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_HR NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_HR NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_HR NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_HR NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_HR NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_HR NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_HR NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_HR NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_HR NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_HR NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_HR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_HR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_HR NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_HR NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_HR NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_HR NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_HR NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_HR NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_HR NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_HR NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_HR NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_HR NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_HR NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_HR NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_HR NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_HR NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_HR NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_HR NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_HR NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_HR NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_HR NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_HR NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_HR NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_HR NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_HR NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_HR NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_HR NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_HR NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_HR NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_HR NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_HR NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_HR NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_HR NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_HR NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_HR NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_HR NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_HR NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_HR NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_HR NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_HR NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_HR NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_HR NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_HR NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_HR NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_HR NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_HR NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_HR NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_HR NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_HR NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_HR NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_HR NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_HR NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_HR NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_HR NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_HR NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_HR NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_HR NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_HR NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_HR NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_HR NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_HR NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_HR NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_HR NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_HR NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_HR NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_HR NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_HR NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_HR NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_HR NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_HR NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_HR NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_HR NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_HR NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_HR NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_HR NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_HR NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_HR NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_HR NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_HR NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_HR NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_HR NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_HR NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_HR NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_HR NULL
#define OPTION_VAL_TWB64_182_PINK109_HR NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_HR NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_HR NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_HR NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_HR NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_HR NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_HR NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_HR NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_HR NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_HR NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_HR NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_HR NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_HR NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_HR NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_HR NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_HR NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_HR NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_HR NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_HR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_HR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_HR NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_HR NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_HR NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_HR NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_HR NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_HR NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_HR NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_HR NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_HR NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_HR NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_HR NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_HR NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_HR NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_HR NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_HR NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_HR NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_HR NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_HR NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__HR NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_HR NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_HR NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_HR NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_HR NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_HR NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_HR NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_HR NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_HR NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_HR NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_HR NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_HR NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_HR NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_HR NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_HR NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_HR NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_HR NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_HR NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_HR NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_HR NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_HR NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_HR NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_HR NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_HR NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_HR NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_HR NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_HR NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_HR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_HR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_HR NULL
#define OPTION_VAL_GBC_ONLY_HR NULL
#define OPTION_VAL_ALWAYS_HR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_HR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_HR NULL
#define OPTION_VAL_ACCURATE_HR NULL
#define OPTION_VAL_FAST_HR NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_HR NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_HR NULL
#define OPTION_VAL_CENTRAL_HR NULL
#define OPTION_VAL_ABOVE_SCREEN_HR NULL
#define OPTION_VAL_BELOW_SCREEN_HR NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_HR NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_HR NULL
#define GAMBATTE_MIX_FRAMES_LABEL_HR NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_HR NULL
#define OPTION_VAL_MIX_HR NULL
#define OPTION_VAL_LCD_GHOSTING_HR NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_HR NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_HR NULL
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_HR NULL
#define OPTION_VAL_SINC_HR NULL
#define OPTION_VAL_CC_HR NULL
#define GAMBATTE_GB_HWMODE_LABEL_HR NULL
#define GAMBATTE_GB_HWMODE_INFO_0_HR NULL
#define OPTION_VAL_GB_HR NULL
#define OPTION_VAL_GBA_HR NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_HR NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_HR NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_HR NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_HR NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_HR NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_HR NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_HR NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_HR NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_HR NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_HR NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_HR NULL
#define OPTION_VAL_NOT_CONNECTED_HR NULL
#define OPTION_VAL_NETWORK_SERVER_HR NULL
#define OPTION_VAL_NETWORK_CLIENT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_HR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_HR NULL

struct retro_core_option_v2_category option_cats_hr[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_HR,
      CATEGORY_GB_LINK_INFO_0_HR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_hr[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_HR,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_HR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_HR },
         { "GBC",      OPTION_VAL_GBC_HR },
         { "SGB",      OPTION_VAL_SGB_HR },
         { "internal", OPTION_VAL_INTERNAL_HR },
         { "custom",   OPTION_VAL_CUSTOM_HR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_HR,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_HR,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_HR },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_HR },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_HR },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_HR },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_HR },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_HR },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_HR },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_HR },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_HR },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_HR },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_HR },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_HR },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_HR },
         { "GBC - Red",                OPTION_VAL_GBC_RED_HR },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_HR },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_HR },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_HR },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_HR },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_HR },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_HR },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_HR },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_HR },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_HR },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_HR },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_HR },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_HR },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_HR },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_HR },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_HR },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_HR },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_HR },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_HR },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_HR },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_HR },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_HR },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_HR },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_HR },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_HR },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_HR },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_HR },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_HR },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_HR },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_HR },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_HR },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_HR },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_HR },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_HR },
         { "Special 1",                OPTION_VAL_SPECIAL_1_HR },
         { "Special 2",                OPTION_VAL_SPECIAL_2_HR },
         { "Special 3",                OPTION_VAL_SPECIAL_3_HR },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_HR },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_HR },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_HR },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_HR },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_HR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_HR,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_HR },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_HR },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_HR },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_HR },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_HR },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_HR },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_HR },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_HR },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_HR },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_HR },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_HR },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_HR },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_HR },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_HR },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_HR },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_HR },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_HR },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_HR },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_HR },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_HR },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_HR },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_HR },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_HR },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_HR },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_HR },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_HR },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_HR },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_HR },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_HR },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_HR },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_HR },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_HR },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_HR },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_HR },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_HR },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_HR },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_HR },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_HR },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_HR },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_HR },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_HR },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_HR },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_HR },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_HR },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_HR },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_HR },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_HR },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_HR },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_HR },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_HR },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_HR },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_HR },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_HR },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_HR },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_HR },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_HR },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_HR },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_HR },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_HR },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_HR },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_HR },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_HR },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_HR },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_HR },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_HR },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_HR },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_HR },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_HR },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_HR },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_HR },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_HR },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_HR },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_HR },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_HR },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_HR },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_HR },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_HR },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_HR },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_HR },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_HR },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_HR },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_HR },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_HR },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_HR },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_HR },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_HR },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_HR },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_HR },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_HR },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_HR },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_HR },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_HR },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_HR },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_HR },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_HR },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_HR },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_HR },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_HR },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_HR },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_HR },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_HR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_HR,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_HR },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_HR },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_HR },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_HR },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_HR },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_HR },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_HR },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_HR },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_HR },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_HR },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_HR },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_HR },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_HR },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_HR },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_HR },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_HR },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_HR },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_HR },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_HR },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_HR },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_HR },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_HR },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_HR },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_HR },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_HR },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_HR },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_HR },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_HR },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_HR },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_HR },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_HR },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_HR },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_HR },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_HR },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_HR },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_HR },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_HR },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_HR },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_HR },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_HR },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_HR },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_HR },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_HR },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_HR },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_HR },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_HR },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_HR },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_HR },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_HR },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_HR },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_HR },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_HR },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_HR },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_HR },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_HR },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_HR },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_HR },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_HR },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_HR },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_HR },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_HR },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_HR },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_HR },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_HR },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_HR },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_HR },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_HR },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_HR },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_HR },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_HR },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_HR },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_HR },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_HR },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_HR },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_HR },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_HR },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_HR },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_HR },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_HR },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_HR },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_HR },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_HR },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_HR },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_HR },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_HR },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_HR },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_HR },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_HR },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_HR },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_HR },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_HR },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_HR },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_HR },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_HR },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_HR },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_HR },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_HR },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_HR },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_HR },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_HR },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_HR,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_HR,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_HR },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_HR },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_HR },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_HR },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_HR },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_HR },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_HR },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_HR },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_HR },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_HR },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_HR },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_HR },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_HR },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_HR },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_HR },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_HR },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_HR },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__HR },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_HR },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_HR },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_HR },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_HR },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_HR },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_HR },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_HR },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_HR },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_HR },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_HR },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_HR },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_HR },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_HR },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_HR },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_HR },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_HR },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_HR },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_HR },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_HR },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_HR },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_HR },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_HR },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_HR },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_HR },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_HR },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_HR },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_HR },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_HR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_HR,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_HR },
         { "always",   OPTION_VAL_ALWAYS_HR },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_HR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_HR,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_HR },
         { "fast",     OPTION_VAL_FAST_HR },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_HR,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_HR,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_HR },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_HR },
         { "below screen", OPTION_VAL_BELOW_SCREEN_HR },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_HR,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_HR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_HR,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_HR,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_HR },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_HR },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_HR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_HR,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_HR,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_HR },
         { "cc",   OPTION_VAL_CC_HR },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_HR,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_HR,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_HR },
         { "GB",   OPTION_VAL_GB_HR },
         { "GBC",  OPTION_VAL_GBC_HR },
         { "GBA",  OPTION_VAL_GBA_HR },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_HR,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_HR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_HR,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_HR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_HR,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_HR,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_HR,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_HR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_HR,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_HR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_HR,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_MODE_INFO_0_HR,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_HR },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_HR },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_HR },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_HR,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_HR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_HR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_hr = {
   option_cats_hr,
   option_defs_hr
};

/* RETRO_LANGUAGE_HU */

#define CATEGORY_GB_LINK_LABEL_HU NULL
#define CATEGORY_GB_LINK_INFO_0_HU "A Game Link (multiplayer) hálózati beállításai."
#define GAMBATTE_GB_COLORIZATION_LABEL_HU "GB színezés"
#define GAMBATTE_GB_COLORIZATION_INFO_0_HU "A Game Boy játékok színezése. Automatikus: a \"legjobb\" (legszínesebb/legmegfelelőbb) plaetta. GBC: játékspecifikus Game Boy Color paletta ha van, egyébként GBC-sötétzöld. SGB: játékspecifikus Super Game Boy paletta ha van, egyébként SGB-1A. Belső: a Belső paletta mag beállítás használata. Egyedi: felhasználó által kreált paletta a rendszerkönyvtárból."
#define OPTION_VAL_AUTO_HU "Automatikus"
#define OPTION_VAL_GBC_HU NULL
#define OPTION_VAL_SGB_HU NULL
#define OPTION_VAL_INTERNAL_HU "Belső"
#define OPTION_VAL_CUSTOM_HU "Egyedi"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_HU "Belső paletta"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_HU "A Game Boy játékok színezéséhez használt paletta, amikor a GB színezés Belső értékre van állítva, vagy automatikusra, de a játéknak nincs előre definiált SBC/GBC palettája. A \"GB\" paletták az eredeti Game Boy hardvert utánozzák. A \"GBC\" paletták megegyeznek a Game Boy Color beépített preset-jeivel. Az \"SGB\" paletták megegyeznek a Super Game Boy beépített preset-jeivel."
#define OPTION_VAL_GB_DMG_HU NULL
#define OPTION_VAL_GB_POCKET_HU NULL
#define OPTION_VAL_GB_LIGHT_HU NULL
#define OPTION_VAL_GBC_BLUE_HU "GBC - kék"
#define OPTION_VAL_GBC_BROWN_HU "GBC - barna"
#define OPTION_VAL_GBC_DARK_BLUE_HU "GBC - sötétkék"
#define OPTION_VAL_GBC_DARK_BROWN_HU "GBC - sötétbarna"
#define OPTION_VAL_GBC_DARK_GREEN_HU "GBC - sötétzöld"
#define OPTION_VAL_GBC_GRAYSCALE_HU "GBC - szürkeárnyalatos"
#define OPTION_VAL_GBC_GREEN_HU "GBC - zöld"
#define OPTION_VAL_GBC_INVERTED_HU "GBC - inverz"
#define OPTION_VAL_GBC_ORANGE_HU "GBC - narancs"
#define OPTION_VAL_GBC_PASTEL_MIX_HU "GBC - kevert pasztell"
#define OPTION_VAL_GBC_RED_HU "GBC - piros"
#define OPTION_VAL_GBC_YELLOW_HU "GBC - sárga"
#define OPTION_VAL_SGB_1A_HU NULL
#define OPTION_VAL_SGB_1B_HU NULL
#define OPTION_VAL_SGB_1C_HU NULL
#define OPTION_VAL_SGB_1D_HU NULL
#define OPTION_VAL_SGB_1E_HU NULL
#define OPTION_VAL_SGB_1F_HU NULL
#define OPTION_VAL_SGB_1G_HU NULL
#define OPTION_VAL_SGB_1H_HU NULL
#define OPTION_VAL_SGB_2A_HU NULL
#define OPTION_VAL_SGB_2B_HU NULL
#define OPTION_VAL_SGB_2C_HU NULL
#define OPTION_VAL_SGB_2D_HU NULL
#define OPTION_VAL_SGB_2E_HU NULL
#define OPTION_VAL_SGB_2F_HU NULL
#define OPTION_VAL_SGB_2G_HU NULL
#define OPTION_VAL_SGB_2H_HU NULL
#define OPTION_VAL_SGB_3A_HU NULL
#define OPTION_VAL_SGB_3B_HU NULL
#define OPTION_VAL_SGB_3C_HU NULL
#define OPTION_VAL_SGB_3D_HU NULL
#define OPTION_VAL_SGB_3E_HU NULL
#define OPTION_VAL_SGB_3F_HU NULL
#define OPTION_VAL_SGB_3G_HU NULL
#define OPTION_VAL_SGB_3H_HU NULL
#define OPTION_VAL_SGB_4A_HU NULL
#define OPTION_VAL_SGB_4B_HU NULL
#define OPTION_VAL_SGB_4C_HU NULL
#define OPTION_VAL_SGB_4D_HU NULL
#define OPTION_VAL_SGB_4E_HU NULL
#define OPTION_VAL_SGB_4F_HU NULL
#define OPTION_VAL_SGB_4G_HU NULL
#define OPTION_VAL_SGB_4H_HU NULL
#define OPTION_VAL_SPECIAL_1_HU NULL
#define OPTION_VAL_SPECIAL_2_HU NULL
#define OPTION_VAL_SPECIAL_3_HU NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_HU "Special 4 (TI-83)"
#define OPTION_VAL_TWB64_PACK_1_HU NULL
#define OPTION_VAL_TWB64_PACK_2_HU NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_HU NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_HU "> TWB64 - Pack 1 paletta"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_HU "A belső színezés palettája, amikor a belső paletta értéke \"TWB64 - Pack 1\"."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_HU NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_HU NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_HU NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_HU NULL
#define OPTION_VAL_TWB64_005_NEON_RED_HU NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_HU NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_HU NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_HU NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_HU NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_HU NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_HU NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_HU NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_HU NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_HU NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_HU NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_HU NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_HU NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_HU NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_HU NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_HU NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_HU NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_HU NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_HU NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_HU NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_HU NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_HU NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_HU NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_HU NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_HU NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_HU NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_HU NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_HU NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_HU NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_HU NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_HU NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_HU NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_HU NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_HU NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_HU NULL
#define OPTION_VAL_TWB64_040_DMG_VER_HU NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_HU NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_HU NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_HU NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_HU NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_HU NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_HU NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_HU NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_HU NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_HU NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_HU NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_HU NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_HU NULL
#define OPTION_VAL_TWB64_053_VMU_VER_HU NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_HU NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_HU NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_HU NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_HU NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_HU NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_HU NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_HU NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_HU NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_HU NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_HU NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_HU NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_HU NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_HU NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_HU NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_HU NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_HU NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_HU NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_HU NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_HU NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_HU NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_HU NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_HU NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_HU NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_HU NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_HU NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_HU NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_HU NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_HU NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_HU NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_HU NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_HU NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_HU NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_HU NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_HU NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_HU NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_HU NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_HU NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_HU NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_HU NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_HU NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_HU NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_HU NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_HU NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_HU NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_HU NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_HU NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_HU NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_HU "> TWB64 - Pack 2 paletta"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_HU "A belső színezés palettája, amikor a belső paletta értéke \"TWB64 - Pack 2\"."
#define OPTION_VAL_TWB64_101_765PRO_PINK_HU NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_HU NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_HU NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_HU NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_HU NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_HU NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_HU NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_HU NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_HU NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_HU NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_HU NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_HU NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_HU NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_HU NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_HU NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_HU NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_HU NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_HU NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_HU NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_HU NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_HU NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_HU NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_HU NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_HU NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_HU NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_HU NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_HU NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_HU NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_HU NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_HU NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_HU NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_HU NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_HU NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_HU NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_HU NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_HU NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_HU NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_HU NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_HU NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_HU NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_HU NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_HU NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_HU NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_HU NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_HU NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_HU NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_HU NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_HU NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_HU NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_HU NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_HU NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_HU NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_HU NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_HU NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_HU NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_HU NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_HU NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_HU NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_HU NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_HU NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_HU NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_HU NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_HU NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_HU NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_HU NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_HU NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_HU NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_HU NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_HU NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_HU NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_HU NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_HU NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_HU NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_HU NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_HU NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_HU NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_HU NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_HU NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_HU NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_HU NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_HU NULL
#define OPTION_VAL_TWB64_182_PINK109_HU NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_HU NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_HU NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_HU NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_HU NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_HU NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_HU NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_HU NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_HU NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_HU NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_HU NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_HU NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_HU NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_HU NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_HU NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_HU NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_HU NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_HU NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_HU NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_HU "> PixelShift - Pack 1 paletta"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_HU "A belső színezés palettája, amikor a belső paletta értéke \"PixelShift - Pack 1\"."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_HU NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_HU NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_HU NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_HU NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_HU NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_HU NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_HU NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_HU NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_HU NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_HU NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_HU NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_HU NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_HU NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_HU NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_HU NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_HU NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_HU NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__HU NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_HU NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_HU NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_HU NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_HU NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_HU NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_HU NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_HU NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_HU NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_HU NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_HU NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_HU NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_HU NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_HU NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_HU NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_HU NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_HU NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_HU NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_HU NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_HU NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_HU NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_HU NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_HU NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_HU NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_HU NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_HU NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_HU NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_HU NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_HU "Színkorrekció"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_HU "A kimenő színek áthangolása a valódi Game Boy Color hardver kijelzőjének megfelelően. Csak GBC állásban a korrekció csak Game Boy Color játékokra, vagy Game Boy Color palettával színezett Game Boy játékokra lesz érvényes. Mindig állásban a színkorrekció minden tartalomra érvényes, és váratlan/szuboptimális eredményeket hozhat GB vagy SGB belső színpaletták használatánál."
#define OPTION_VAL_GBC_ONLY_HU "Csak GBC"
#define OPTION_VAL_ALWAYS_HU "Mindig"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_HU "Színkorrekció módja"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_HU "A színkorrekcióhoz használt eljárás. A Pontos beállítás kimenete majdnem megkülönböztethetetlen egy valódi Game Boy Color LCD kijelzőtől. Gyors módban csak a színeket sötétíti és a telítettséget veszi vissza, alsó kategóriás hardveren használható, ha a Pontos módszer túl lassú."
#define OPTION_VAL_ACCURATE_HU "Pontos"
#define OPTION_VAL_FAST_HU "Gyors"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_HU "Színkorrekció - megvilágítás helyzete"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_HU "A Game Boy Color LCD panel fizikai válaszát szimulálja különféle szögű megvilágítások esetén. A \"Középen\" lehetőség a szokásos színvisszaadás. A \"Képernyő felett\" lehetőséggel nó a fényesség, a \"Képernyő alatt\" lehetőséggel csökken. Csak akkor van hatása, ha a színkorrekció módja \"Pontos\"."
#define OPTION_VAL_CENTRAL_HU "Középen"
#define OPTION_VAL_ABOVE_SCREEN_HU "Képernyő fölött"
#define OPTION_VAL_BELOW_SCREEN_HU "Képernyő alatt"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_HU "Sötét szűrő szintje (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_HU "A fényerő alapú fényességcsökkentés engedélyezése. A káprázást / szemerőltetést lehet vele elkerülni olyan fehér hátterű játékok játszásánál, amelyeket háttérmegvilágítás nélküli Game Boy Color-ra terveztek, és a modern háttérvilágítású kijelzőkön kényelmetlenül világosak lehetnek."
#define GAMBATTE_MIX_FRAMES_LABEL_HU "Képkockák vegyítése"
#define GAMBATTE_MIX_FRAMES_INFO_0_HU "Az LCD szellemkép szimulálása. \"Egyszerű\" állapotban a jelenlegi és az előző képkockát 50:50 arányban keveri. \"LCD szellemkép\" állásban az LCD természetes válaszidejét utánozza több képkocka kombinálásával. Az \"Egyszerű\" beállítás szükséges azokhoz a játékokhoz, amelyek az LCD szellemképet használják átlátszósági effektekhez (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_HU "Egyszerű"
#define OPTION_VAL_LCD_GHOSTING_HU "LCD szellemkép (pontos)"
#define OPTION_VAL_LCD_GHOSTING_FAST_HU "LCD szellemkép (gyors)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_HU "Hang-újramintavételező"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_HU "A generált hang újramintavételezésének algoritmusa. (A Game Boy hang frissítési frekvenciáját csak a CPU-jának írási sebessége korlátozza, ezek az eredeti frekvenciák nem praktikusak modern hangeszközökön és le kell konvertálni azt.) A \"Sinc\" beállítás a legjobb minőségű, a \"Koszinuszos\" javítja a teljesítményt alacsony kategóriás hardveren."
#define OPTION_VAL_SINC_HU NULL
#define OPTION_VAL_CC_HU "Koszinuszos"
#define GAMBATTE_GB_HWMODE_LABEL_HU "Emulált hardver (újraindítás szükséges)"
#define GAMBATTE_GB_HWMODE_INFO_0_HU "Az emulált hardver típusa. Ajánlott az automatikus beállítás. A \"GBA\" mód extra funkciókat old fel bizonyos \"GBA Enhanced\" Game Boy Color játékokban (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_HU NULL
#define OPTION_VAL_GBA_HU NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_HU "Hivatalos betöltő (újraindítás szükséges)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_HU "A Game Boy és Game Boy Color hivatalos betöltő támogatása, a megfelelő indító logo animációkkal."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_HU "Ellentétes irányok engedélyezése"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_HU "A jobb és bal (vagy fel és le) irányok egyidejű/gyorsan váltakozó lenyomásának vagy nyomva tartásának engedélyezése. Hibákat okozhat a mozgatásban."
#define GAMBATTE_TURBO_PERIOD_LABEL_HU "Turbo gomb periódusa"
#define GAMBATTE_TURBO_PERIOD_INFO_0_HU "Az ismétlési periódus (képkockában) a Turbo A/B gombok lenyomva tartásakor."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_HU "Kontroller rezgés erőssége"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_HU "A tapintható visszajelzés engedélyezése a támogatott játékokban (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_HU "Game Link beállítások"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_HU "A hálózatos Game Link (többjátékosos) beállításai. Figyelem: a változtatás életbelépéséhez újra be kell lépni a gyorsmenübe."
#define GAMBATTE_GB_LINK_MODE_LABEL_HU "Game Link módja"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_HU "A kapcsolat módja"
#define GAMBATTE_GB_LINK_MODE_INFO_0_HU "Hálózatos Game Link funkció engedélyezésekor ez a példány szerverként vagy kliensként fusson."
#define OPTION_VAL_NOT_CONNECTED_HU "Nincs kapcsolat"
#define OPTION_VAL_NETWORK_SERVER_HU "Hálózati szerver"
#define OPTION_VAL_NETWORK_CLIENT_HU "Hálózati kliens"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_HU "Hálózati kapcsolat portja"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_HU "Csatlakozó"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_HU "A Game Link hálózati kommunikációjához használt port."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_HU "Hálózati kapcsolat szerverének címe, 01. rész: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_HU "Szerver címe, 01. rész: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 1. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 1. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_HU "Hálózati kapcsolat szerverének címe, 02. rész: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_HU "Szerver címe, 02. rész: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 2. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 2. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_HU "Hálózati kapcsolat szerverének címe, 03. rész: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_HU "Szerver címe, 03. rész: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 3. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 3. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_HU "Hálózati kapcsolat szerverének címe, 04. rész: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_HU "Szerver címe, 04. rész: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 4. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 4. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_HU "Hálózati kapcsolat szerverének címe, 05. rész: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_HU "Szerver címe, 05. rész: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 5. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 5. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_HU "Hálózati kapcsolat szerverének címe, 06. rész: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_HU "Szerver címe, 06. rész: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 6. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 6. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_HU "Hálózati kapcsolat szerverének címe, 07. rész: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_HU "Szerver címe, 07. rész: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 7. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 7. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_HU "Hálózati kapcsolat szerverének címe, 08. rész: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_HU "Szerver címe, 08. rész: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 8. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 8. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_HU "Hálózati kapcsolat szerverének címe, 09. rész: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_HU "Szerver címe, 09. rész: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 9. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 9. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_HU "Hálózati kapcsolat szerverének címe, 10. rész: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_HU "Szerver címe, 10. rész: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 10. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 10. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_HU "Hálózati kapcsolat szerverének címe, 11. rész: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_HU "Szerver címe, 11. rész: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 11. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 11. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_HU "Hálózati kapcsolat szerverének címe, 12. rész: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_HU "Szerver címe, 12. rész: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_HU "A távoli Game Link hálózati szerver IP címének 12. számjegye. Csak akkor használatos, ha a Game Link módja Hálózati kliens."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_HU "A távoli Game Link hálózati szerver IP címének 12. számjegye. Csak akkor használatos, ha a kapcsolat módja Hálózati kliens."

struct retro_core_option_v2_category option_cats_hu[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_HU,
      CATEGORY_GB_LINK_INFO_0_HU
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_hu[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_HU,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_HU,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_HU },
         { "GBC",      OPTION_VAL_GBC_HU },
         { "SGB",      OPTION_VAL_SGB_HU },
         { "internal", OPTION_VAL_INTERNAL_HU },
         { "custom",   OPTION_VAL_CUSTOM_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_HU,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_HU,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_HU },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_HU },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_HU },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_HU },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_HU },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_HU },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_HU },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_HU },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_HU },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_HU },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_HU },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_HU },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_HU },
         { "GBC - Red",                OPTION_VAL_GBC_RED_HU },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_HU },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_HU },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_HU },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_HU },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_HU },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_HU },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_HU },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_HU },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_HU },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_HU },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_HU },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_HU },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_HU },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_HU },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_HU },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_HU },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_HU },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_HU },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_HU },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_HU },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_HU },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_HU },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_HU },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_HU },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_HU },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_HU },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_HU },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_HU },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_HU },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_HU },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_HU },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_HU },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_HU },
         { "Special 1",                OPTION_VAL_SPECIAL_1_HU },
         { "Special 2",                OPTION_VAL_SPECIAL_2_HU },
         { "Special 3",                OPTION_VAL_SPECIAL_3_HU },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_HU },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_HU },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_HU },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_HU },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_HU,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_HU,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_HU },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_HU },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_HU },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_HU },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_HU },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_HU },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_HU },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_HU },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_HU },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_HU },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_HU },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_HU },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_HU },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_HU },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_HU },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_HU },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_HU },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_HU },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_HU },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_HU },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_HU },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_HU },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_HU },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_HU },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_HU },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_HU },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_HU },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_HU },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_HU },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_HU },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_HU },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_HU },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_HU },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_HU },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_HU },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_HU },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_HU },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_HU },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_HU },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_HU },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_HU },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_HU },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_HU },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_HU },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_HU },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_HU },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_HU },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_HU },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_HU },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_HU },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_HU },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_HU },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_HU },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_HU },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_HU },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_HU },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_HU },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_HU },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_HU },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_HU },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_HU },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_HU },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_HU },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_HU },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_HU },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_HU },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_HU },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_HU },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_HU },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_HU },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_HU },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_HU },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_HU },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_HU },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_HU },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_HU },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_HU },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_HU },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_HU },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_HU },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_HU },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_HU },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_HU },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_HU },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_HU },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_HU },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_HU },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_HU },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_HU },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_HU },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_HU },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_HU },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_HU },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_HU },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_HU },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_HU },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_HU },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_HU },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_HU },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_HU },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_HU,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_HU,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_HU },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_HU },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_HU },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_HU },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_HU },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_HU },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_HU },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_HU },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_HU },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_HU },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_HU },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_HU },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_HU },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_HU },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_HU },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_HU },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_HU },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_HU },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_HU },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_HU },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_HU },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_HU },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_HU },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_HU },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_HU },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_HU },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_HU },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_HU },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_HU },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_HU },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_HU },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_HU },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_HU },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_HU },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_HU },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_HU },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_HU },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_HU },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_HU },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_HU },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_HU },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_HU },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_HU },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_HU },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_HU },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_HU },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_HU },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_HU },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_HU },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_HU },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_HU },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_HU },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_HU },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_HU },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_HU },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_HU },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_HU },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_HU },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_HU },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_HU },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_HU },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_HU },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_HU },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_HU },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_HU },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_HU },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_HU },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_HU },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_HU },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_HU },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_HU },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_HU },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_HU },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_HU },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_HU },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_HU },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_HU },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_HU },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_HU },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_HU },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_HU },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_HU },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_HU },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_HU },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_HU },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_HU },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_HU },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_HU },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_HU },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_HU },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_HU },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_HU },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_HU },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_HU },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_HU },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_HU },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_HU },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_HU },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_HU },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_HU },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_HU,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_HU,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_HU },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_HU },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_HU },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_HU },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_HU },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_HU },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_HU },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_HU },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_HU },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_HU },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_HU },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_HU },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_HU },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_HU },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_HU },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_HU },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_HU },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__HU },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_HU },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_HU },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_HU },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_HU },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_HU },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_HU },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_HU },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_HU },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_HU },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_HU },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_HU },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_HU },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_HU },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_HU },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_HU },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_HU },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_HU },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_HU },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_HU },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_HU },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_HU },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_HU },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_HU },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_HU },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_HU },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_HU },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_HU },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_HU,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_HU,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_HU },
         { "always",   OPTION_VAL_ALWAYS_HU },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_HU,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_HU,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_HU },
         { "fast",     OPTION_VAL_FAST_HU },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_HU,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_HU,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_HU },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_HU },
         { "below screen", OPTION_VAL_BELOW_SCREEN_HU },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_HU,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_HU,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_HU,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_HU,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_HU },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_HU },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_HU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_HU,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_HU,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_HU },
         { "cc",   OPTION_VAL_CC_HU },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_HU,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_HU,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_HU },
         { "GB",   OPTION_VAL_GB_HU },
         { "GBC",  OPTION_VAL_GBC_HU },
         { "GBA",  OPTION_VAL_GBA_HU },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_HU,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_HU,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_HU,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_HU,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_HU,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_HU,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_HU,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_HU,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_HU,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_HU,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_HU,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_MODE_INFO_0_HU,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_HU },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_HU },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_HU },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_HU,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_HU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_HU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_hu = {
   option_cats_hu,
   option_defs_hu
};

/* RETRO_LANGUAGE_ID */

#define CATEGORY_GB_LINK_LABEL_ID NULL
#define CATEGORY_GB_LINK_INFO_0_ID NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_ID NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_ID NULL
#define OPTION_VAL_AUTO_ID "Otomatis"
#define OPTION_VAL_GBC_ID NULL
#define OPTION_VAL_SGB_ID NULL
#define OPTION_VAL_INTERNAL_ID NULL
#define OPTION_VAL_CUSTOM_ID NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_ID NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_ID NULL
#define OPTION_VAL_GB_DMG_ID NULL
#define OPTION_VAL_GB_POCKET_ID NULL
#define OPTION_VAL_GB_LIGHT_ID NULL
#define OPTION_VAL_GBC_BLUE_ID NULL
#define OPTION_VAL_GBC_BROWN_ID NULL
#define OPTION_VAL_GBC_DARK_BLUE_ID NULL
#define OPTION_VAL_GBC_DARK_BROWN_ID NULL
#define OPTION_VAL_GBC_DARK_GREEN_ID NULL
#define OPTION_VAL_GBC_GRAYSCALE_ID NULL
#define OPTION_VAL_GBC_GREEN_ID NULL
#define OPTION_VAL_GBC_INVERTED_ID NULL
#define OPTION_VAL_GBC_ORANGE_ID NULL
#define OPTION_VAL_GBC_PASTEL_MIX_ID NULL
#define OPTION_VAL_GBC_RED_ID NULL
#define OPTION_VAL_GBC_YELLOW_ID NULL
#define OPTION_VAL_SGB_1A_ID NULL
#define OPTION_VAL_SGB_1B_ID NULL
#define OPTION_VAL_SGB_1C_ID NULL
#define OPTION_VAL_SGB_1D_ID NULL
#define OPTION_VAL_SGB_1E_ID NULL
#define OPTION_VAL_SGB_1F_ID NULL
#define OPTION_VAL_SGB_1G_ID NULL
#define OPTION_VAL_SGB_1H_ID NULL
#define OPTION_VAL_SGB_2A_ID NULL
#define OPTION_VAL_SGB_2B_ID NULL
#define OPTION_VAL_SGB_2C_ID NULL
#define OPTION_VAL_SGB_2D_ID NULL
#define OPTION_VAL_SGB_2E_ID NULL
#define OPTION_VAL_SGB_2F_ID NULL
#define OPTION_VAL_SGB_2G_ID NULL
#define OPTION_VAL_SGB_2H_ID NULL
#define OPTION_VAL_SGB_3A_ID NULL
#define OPTION_VAL_SGB_3B_ID NULL
#define OPTION_VAL_SGB_3C_ID NULL
#define OPTION_VAL_SGB_3D_ID NULL
#define OPTION_VAL_SGB_3E_ID NULL
#define OPTION_VAL_SGB_3F_ID NULL
#define OPTION_VAL_SGB_3G_ID NULL
#define OPTION_VAL_SGB_3H_ID NULL
#define OPTION_VAL_SGB_4A_ID NULL
#define OPTION_VAL_SGB_4B_ID NULL
#define OPTION_VAL_SGB_4C_ID NULL
#define OPTION_VAL_SGB_4D_ID NULL
#define OPTION_VAL_SGB_4E_ID NULL
#define OPTION_VAL_SGB_4F_ID NULL
#define OPTION_VAL_SGB_4G_ID NULL
#define OPTION_VAL_SGB_4H_ID NULL
#define OPTION_VAL_SPECIAL_1_ID NULL
#define OPTION_VAL_SPECIAL_2_ID NULL
#define OPTION_VAL_SPECIAL_3_ID NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_ID NULL
#define OPTION_VAL_TWB64_PACK_1_ID NULL
#define OPTION_VAL_TWB64_PACK_2_ID NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_ID NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_ID NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_ID NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_ID NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_ID NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_ID NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_ID NULL
#define OPTION_VAL_TWB64_005_NEON_RED_ID NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_ID NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_ID NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_ID NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_ID NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_ID NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_ID NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_ID NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_ID NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_ID NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_ID NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_ID NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_ID NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_ID NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_ID NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_ID NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_ID NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_ID NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_ID NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_ID NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_ID NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_ID NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_ID NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_ID NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_ID NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_ID NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_ID NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_ID NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_ID NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_ID NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_ID NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_ID NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_ID NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_ID NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_ID NULL
#define OPTION_VAL_TWB64_040_DMG_VER_ID NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_ID NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_ID NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_ID NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_ID NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_ID NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_ID NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_ID NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_ID NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_ID NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_ID NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_ID NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_ID NULL
#define OPTION_VAL_TWB64_053_VMU_VER_ID NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_ID NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_ID NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_ID NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_ID NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_ID NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_ID NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_ID NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_ID NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_ID NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_ID NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_ID NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_ID NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_ID NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_ID NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_ID NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_ID NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_ID NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_ID NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_ID NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_ID NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_ID NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_ID NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_ID NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_ID NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_ID NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_ID NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_ID NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_ID NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_ID NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_ID NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_ID NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_ID NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_ID NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_ID NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_ID NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_ID NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_ID NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_ID NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_ID NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_ID NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_ID NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_ID NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_ID NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_ID NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_ID NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_ID NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_ID NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_ID NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_ID NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_ID NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_ID NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_ID NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_ID NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_ID NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_ID NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_ID NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_ID NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_ID NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_ID NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_ID NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_ID NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_ID NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_ID NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_ID NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_ID NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_ID NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_ID NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_ID NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_ID NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_ID NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_ID NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_ID NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_ID NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_ID NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_ID NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_ID NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_ID NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_ID NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_ID NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_ID NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_ID NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_ID NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_ID NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_ID NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_ID NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_ID NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_ID NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_ID NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_ID NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_ID NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_ID NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_ID NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_ID NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_ID NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_ID NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_ID NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_ID NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_ID NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_ID NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_ID NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_ID NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_ID NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_ID NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_ID NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_ID NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_ID NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_ID NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_ID NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_ID NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_ID NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_ID NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_ID NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_ID NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_ID NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_ID NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_ID NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_ID NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_ID NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_ID NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_ID NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_ID NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_ID NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_ID NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_ID NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_ID NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_ID NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_ID NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_ID NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_ID NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_ID NULL
#define OPTION_VAL_TWB64_182_PINK109_ID NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_ID NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_ID NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_ID NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_ID NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_ID NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_ID NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_ID NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_ID NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_ID NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_ID NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_ID NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_ID NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_ID NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_ID NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_ID NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_ID NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_ID NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_ID NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_ID NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_ID NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_ID NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_ID NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_ID NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_ID NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_ID NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_ID NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_ID NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_ID NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_ID NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_ID NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_ID NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_ID NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_ID NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_ID NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_ID NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_ID NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_ID NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__ID NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_ID NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_ID NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_ID NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_ID NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_ID NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_ID NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_ID NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_ID NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_ID NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_ID NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_ID NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_ID NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_ID NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_ID NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_ID NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_ID NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_ID NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_ID NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_ID NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_ID NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_ID NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_ID NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_ID NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_ID NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_ID NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_ID NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_ID NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_ID NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_ID NULL
#define OPTION_VAL_GBC_ONLY_ID NULL
#define OPTION_VAL_ALWAYS_ID NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_ID NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_ID NULL
#define OPTION_VAL_ACCURATE_ID NULL
#define OPTION_VAL_FAST_ID NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_ID NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_ID NULL
#define OPTION_VAL_CENTRAL_ID NULL
#define OPTION_VAL_ABOVE_SCREEN_ID NULL
#define OPTION_VAL_BELOW_SCREEN_ID NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_ID NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_ID NULL
#define GAMBATTE_MIX_FRAMES_LABEL_ID NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_ID NULL
#define OPTION_VAL_MIX_ID NULL
#define OPTION_VAL_LCD_GHOSTING_ID NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_ID NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_ID NULL
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_ID NULL
#define OPTION_VAL_SINC_ID NULL
#define OPTION_VAL_CC_ID NULL
#define GAMBATTE_GB_HWMODE_LABEL_ID NULL
#define GAMBATTE_GB_HWMODE_INFO_0_ID NULL
#define OPTION_VAL_GB_ID NULL
#define OPTION_VAL_GBA_ID NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_ID NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_ID NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_ID NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_ID NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_ID "Lamanya Tombol Bertubi"
#define GAMBATTE_TURBO_PERIOD_INFO_0_ID NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_ID "Kekuatan Getar Stik Kendali"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_ID NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_ID NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_ID NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_ID NULL
#define OPTION_VAL_NOT_CONNECTED_ID NULL
#define OPTION_VAL_NETWORK_SERVER_ID NULL
#define OPTION_VAL_NETWORK_CLIENT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_ID "Porta Taut Jejaring"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_ID NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_ID NULL

struct retro_core_option_v2_category option_cats_id[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_ID,
      CATEGORY_GB_LINK_INFO_0_ID
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_id[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_ID,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_ID,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_ID },
         { "GBC",      OPTION_VAL_GBC_ID },
         { "SGB",      OPTION_VAL_SGB_ID },
         { "internal", OPTION_VAL_INTERNAL_ID },
         { "custom",   OPTION_VAL_CUSTOM_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_ID,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_ID,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_ID },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_ID },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_ID },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_ID },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_ID },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_ID },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_ID },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_ID },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_ID },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_ID },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_ID },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_ID },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_ID },
         { "GBC - Red",                OPTION_VAL_GBC_RED_ID },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_ID },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_ID },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_ID },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_ID },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_ID },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_ID },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_ID },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_ID },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_ID },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_ID },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_ID },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_ID },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_ID },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_ID },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_ID },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_ID },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_ID },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_ID },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_ID },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_ID },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_ID },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_ID },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_ID },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_ID },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_ID },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_ID },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_ID },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_ID },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_ID },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_ID },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_ID },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_ID },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_ID },
         { "Special 1",                OPTION_VAL_SPECIAL_1_ID },
         { "Special 2",                OPTION_VAL_SPECIAL_2_ID },
         { "Special 3",                OPTION_VAL_SPECIAL_3_ID },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_ID },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_ID },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_ID },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_ID },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_ID,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_ID,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_ID },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_ID },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_ID },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_ID },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_ID },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_ID },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_ID },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_ID },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_ID },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_ID },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_ID },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_ID },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_ID },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_ID },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_ID },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_ID },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_ID },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_ID },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_ID },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_ID },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_ID },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_ID },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_ID },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_ID },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_ID },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_ID },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_ID },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_ID },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_ID },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_ID },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_ID },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_ID },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_ID },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_ID },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_ID },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_ID },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_ID },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_ID },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_ID },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_ID },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_ID },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_ID },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_ID },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_ID },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_ID },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_ID },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_ID },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_ID },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_ID },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_ID },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_ID },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_ID },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_ID },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_ID },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_ID },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_ID },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_ID },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_ID },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_ID },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_ID },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_ID },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_ID },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_ID },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_ID },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_ID },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_ID },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_ID },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_ID },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_ID },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_ID },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_ID },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_ID },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_ID },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_ID },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_ID },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_ID },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_ID },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_ID },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_ID },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_ID },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_ID },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_ID },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_ID },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_ID },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_ID },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_ID },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_ID },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_ID },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_ID },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_ID },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_ID },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_ID },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_ID },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_ID },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_ID },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_ID },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_ID },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_ID },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_ID },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_ID },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_ID,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_ID,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_ID },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_ID },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_ID },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_ID },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_ID },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_ID },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_ID },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_ID },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_ID },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_ID },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_ID },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_ID },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_ID },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_ID },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_ID },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_ID },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_ID },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_ID },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_ID },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_ID },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_ID },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_ID },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_ID },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_ID },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_ID },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_ID },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_ID },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_ID },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_ID },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_ID },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_ID },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_ID },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_ID },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_ID },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_ID },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_ID },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_ID },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_ID },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_ID },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_ID },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_ID },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_ID },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_ID },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_ID },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_ID },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_ID },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_ID },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_ID },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_ID },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_ID },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_ID },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_ID },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_ID },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_ID },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_ID },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_ID },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_ID },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_ID },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_ID },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_ID },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_ID },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_ID },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_ID },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_ID },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_ID },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_ID },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_ID },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_ID },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_ID },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_ID },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_ID },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_ID },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_ID },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_ID },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_ID },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_ID },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_ID },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_ID },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_ID },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_ID },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_ID },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_ID },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_ID },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_ID },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_ID },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_ID },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_ID },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_ID },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_ID },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_ID },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_ID },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_ID },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_ID },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_ID },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_ID },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_ID },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_ID },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_ID },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_ID },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_ID },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_ID,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_ID,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_ID },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_ID },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_ID },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_ID },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_ID },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_ID },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_ID },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_ID },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_ID },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_ID },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_ID },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_ID },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_ID },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_ID },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_ID },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_ID },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_ID },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__ID },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_ID },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_ID },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_ID },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_ID },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_ID },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_ID },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_ID },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_ID },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_ID },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_ID },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_ID },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_ID },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_ID },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_ID },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_ID },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_ID },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_ID },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_ID },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_ID },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_ID },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_ID },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_ID },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_ID },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_ID },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_ID },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_ID },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_ID },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_ID,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_ID,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_ID },
         { "always",   OPTION_VAL_ALWAYS_ID },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_ID,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_ID,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_ID },
         { "fast",     OPTION_VAL_FAST_ID },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_ID,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_ID,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_ID },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_ID },
         { "below screen", OPTION_VAL_BELOW_SCREEN_ID },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_ID,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_ID,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_ID,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_ID,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_ID },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_ID },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_ID },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_ID,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_ID,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_ID },
         { "cc",   OPTION_VAL_CC_ID },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_ID,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_ID,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_ID },
         { "GB",   OPTION_VAL_GB_ID },
         { "GBC",  OPTION_VAL_GBC_ID },
         { "GBA",  OPTION_VAL_GBA_ID },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_ID,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_ID,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_ID,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_ID,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_ID,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_ID,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_ID,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_ID,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_ID,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_ID,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_ID,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_MODE_INFO_0_ID,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_ID },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_ID },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_ID },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_ID,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_ID,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_ID,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_id = {
   option_cats_id,
   option_defs_id
};

/* RETRO_LANGUAGE_IT */

#define CATEGORY_GB_LINK_LABEL_IT NULL
#define CATEGORY_GB_LINK_INFO_0_IT "Cambia le impostazioni di Game Link (multiplayer) in rete."
#define GAMBATTE_GB_COLORIZATION_LABEL_IT "Colorazione GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_IT "Abilita la colorazione dei giochi di Game Boy. 'Auto' seleziona la tavolozza 'migliore' (più colorata/appropriata). 'GBC' seleziona la tavolozza Game-specific Game Boy Color se definita, altrimenti 'GBC - Dark Green'. 'SGB' seleziona la tavolozza Super Game Boy specifica il gioco se definita, altrimenti 'SGB - 1A'. 'Internal' utilizza l'opzione core 'Tavolozza interna'. 'Personalizza' carica la tavolozza creata dall'utente dalla directory di sistema."
#define OPTION_VAL_AUTO_IT NULL
#define OPTION_VAL_GBC_IT NULL
#define OPTION_VAL_SGB_IT NULL
#define OPTION_VAL_INTERNAL_IT "Interno"
#define OPTION_VAL_CUSTOM_IT "Personalizzato"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_IT "Tavolozza Interna"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_IT "Seleziona la tavolozza usata per colorare i giochi di Game Boy quando 'Colorazione GGB' è impostata su 'Internal', o quando la colorazione 'GB ' è impostata su 'Auto' e il gioco non ha una tavolozza SGB/GBC predefinita. Le tavolozze 'GB' imitano la visualizzazione dell'hardware originale Game Boy. Le tavolozze 'GBC' sono identiche alle preimpostazioni integrate del Game Boy Color. Le tavolozze 'SGB' sono identiche alle preimpostazioni integrate del Super Game Boy."
#define OPTION_VAL_GB_DMG_IT NULL
#define OPTION_VAL_GB_POCKET_IT NULL
#define OPTION_VAL_GB_LIGHT_IT "GB - Chiaro"
#define OPTION_VAL_GBC_BLUE_IT "GBC - Blu"
#define OPTION_VAL_GBC_BROWN_IT "GBC - Marrone"
#define OPTION_VAL_GBC_DARK_BLUE_IT "GBC - Blu Scuro"
#define OPTION_VAL_GBC_DARK_BROWN_IT "GBC - Marrone Scuro"
#define OPTION_VAL_GBC_DARK_GREEN_IT "GBC - Verde Scuro"
#define OPTION_VAL_GBC_GRAYSCALE_IT NULL
#define OPTION_VAL_GBC_GREEN_IT "GBC - Verde"
#define OPTION_VAL_GBC_INVERTED_IT "GBC - Invertito"
#define OPTION_VAL_GBC_ORANGE_IT "GBC - Arancione"
#define OPTION_VAL_GBC_PASTEL_MIX_IT NULL
#define OPTION_VAL_GBC_RED_IT "GBC - Rosso"
#define OPTION_VAL_GBC_YELLOW_IT "GBC - Giallo"
#define OPTION_VAL_SGB_1A_IT NULL
#define OPTION_VAL_SGB_1B_IT NULL
#define OPTION_VAL_SGB_1C_IT NULL
#define OPTION_VAL_SGB_1D_IT NULL
#define OPTION_VAL_SGB_1E_IT NULL
#define OPTION_VAL_SGB_1F_IT NULL
#define OPTION_VAL_SGB_1G_IT NULL
#define OPTION_VAL_SGB_1H_IT NULL
#define OPTION_VAL_SGB_2A_IT NULL
#define OPTION_VAL_SGB_2B_IT NULL
#define OPTION_VAL_SGB_2C_IT NULL
#define OPTION_VAL_SGB_2D_IT NULL
#define OPTION_VAL_SGB_2E_IT NULL
#define OPTION_VAL_SGB_2F_IT NULL
#define OPTION_VAL_SGB_2G_IT NULL
#define OPTION_VAL_SGB_2H_IT NULL
#define OPTION_VAL_SGB_3A_IT NULL
#define OPTION_VAL_SGB_3B_IT NULL
#define OPTION_VAL_SGB_3C_IT NULL
#define OPTION_VAL_SGB_3D_IT NULL
#define OPTION_VAL_SGB_3E_IT NULL
#define OPTION_VAL_SGB_3F_IT NULL
#define OPTION_VAL_SGB_3G_IT NULL
#define OPTION_VAL_SGB_3H_IT NULL
#define OPTION_VAL_SGB_4A_IT NULL
#define OPTION_VAL_SGB_4B_IT NULL
#define OPTION_VAL_SGB_4C_IT NULL
#define OPTION_VAL_SGB_4D_IT NULL
#define OPTION_VAL_SGB_4E_IT NULL
#define OPTION_VAL_SGB_4F_IT NULL
#define OPTION_VAL_SGB_4G_IT NULL
#define OPTION_VAL_SGB_4H_IT NULL
#define OPTION_VAL_SPECIAL_1_IT "Speciale 1"
#define OPTION_VAL_SPECIAL_2_IT "Speciale 2"
#define OPTION_VAL_SPECIAL_3_IT "Speciale 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_IT "Speciale 4 (TI-83 Legacy)"
#define OPTION_VAL_TWB64_PACK_1_IT "TWB64 - Pacco 1"
#define OPTION_VAL_TWB64_PACK_2_IT "TWB64 - Pacco 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_IT "PixelShift - Pacchetto 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_IT "> TWB64 - Pacco 1 Palette"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_IT "Seleziona la tavolozza di colorazione interna quando 'Tavolozza interna' è impostata su 'TWB64 - Pacco 1'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_IT NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_IT NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_IT "TWB64 003 - SpongeBob Giallo"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_IT NULL
#define OPTION_VAL_TWB64_005_NEON_RED_IT NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_IT NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_IT "TWB64 007 - Giallo Neon"
#define OPTION_VAL_TWB64_008_NEON_GREEN_IT NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_IT NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_IT NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_IT NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_IT NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_IT NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_IT "TWB64 014 - Giallo Del Costruttore"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_IT "TWB64 015 - Sfocatura Classica"
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_IT "TWB64 016 - 765 Produzione Ver."
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_IT NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_IT NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_IT NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_IT NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_IT NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_IT NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_IT NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_IT "TWB64 024 - Dio Super Saiyan"
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_IT NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_IT NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_IT NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_IT NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_IT NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_IT NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_IT NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_IT NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_IT NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_IT "TWB64 034 - Legno Da Viaggio"
#define OPTION_VAL_TWB64_035_POKEMON_VER_IT NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_IT "TWB64 036 - Gioco Grump Orange"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_IT NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_IT NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_IT NULL
#define OPTION_VAL_TWB64_040_DMG_VER_IT NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_IT NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_IT NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_IT NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_IT NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_IT NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_IT NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_IT NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_IT NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_IT NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_IT NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_IT NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_IT NULL
#define OPTION_VAL_TWB64_053_VMU_VER_IT NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_IT NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_IT NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_IT NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_IT NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_IT NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_IT NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_IT NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_IT NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_IT NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_IT NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_IT "TWB64 064 - Rosso Coca-Cola"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_IT NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_IT NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_IT NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_IT NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_IT NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_IT "TWB64 070 - Blu Bolle"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_IT "TWB64 071 - Verde Ranuncolo"
#define OPTION_VAL_TWB64_072_NASCAR_VER_IT NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_IT "TWB64 073 - Verde Limone-Limetta"
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_IT NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_IT NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_IT "TWB64 076 - Rosso Fantasma"
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_IT NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_IT NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_IT NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_IT NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_IT NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_IT "TWB64 082 - Super Saiyan Leggendario"
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_IT NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_IT NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_IT "TWB64 085 - Ultra Instinto Perfezionato"
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_IT NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_IT "TWB64 087 - Banana Gialla"
#define OPTION_VAL_TWB64_088_GREEN_BANANA_IT "TWB64 088 - Banana Verde"
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_IT NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_IT NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_IT NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_IT "TWB64 092 - Giallo D'Inchiesta"
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_IT NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_IT NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_IT NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_IT "TWB64 096 - Cappello Di Paglia Rosso"
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_IT "TWB64 097 - Sword Art Ciano"
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_IT NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_IT NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_IT NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_IT NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_IT "Seleziona la tavolozza di colorazione interna quando 'Tavolozza interna' è impostata su 'TWB64 - Pack 2'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_IT NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_IT NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_IT NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_IT NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_IT NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_IT NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_IT NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_IT NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_IT NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_IT NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_IT "TWB64 111 - Iro Acquatico"
#define OPTION_VAL_TWB64_112_TEA_MIDORI_IT NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_IT NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_IT NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_IT NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_IT NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_IT NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_IT "TWB64 118 - Arancia Fruttata"
#define OPTION_VAL_TWB64_119_AKB48_PINK_IT NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_IT NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_IT NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_IT NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_IT NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_IT NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_IT NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_IT NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_IT NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_IT NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_IT NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_IT NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_IT NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_IT NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_IT NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_IT NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_IT NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_IT NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_IT "TWB64 137 - Pac-Man Giallo"
#define OPTION_VAL_TWB64_138_IRISH_GREEN_IT NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_IT "TWB64 139 - Arancio Di Kakarot"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_IT "TWB64 140 - Dragon Ball Arancione"
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_IT "TWB64 141 - Oro Di Natale"
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_IT "TWB64 142 - Pepsi-Cola Blu"
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_IT "TWB64 143 - Verde Bubblun"
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_IT "TWB64 144 - Blu Bobblun"
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_IT NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_IT "TWB64 146 - Oro Olimpico"
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_IT NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_IT NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_IT "TWB64 149 - Argento Olimpico"
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_IT "TWB64 150 - Bronzo Olimpico"
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_IT NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_IT NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_IT NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_IT "TWB64 154 - Rosso Wrestling"
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_IT NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_IT "TWB64 156 - Rosso Pokedex"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_IT NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_IT NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_IT NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_IT NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_IT NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_IT NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_IT NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_IT NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_IT NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_IT "TWB64 166 - Game and Oro"
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_IT NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_IT NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_IT "TWB64 169 - Sailor Spinach Verde"
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_IT "TWB64 170 - Verde Shenron"
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_IT "TWB64 171 - Sangue Di Berserk"
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_IT NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_IT NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_IT NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_IT NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_IT NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_IT "TWB64 177 - Verde Trifoglio"
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_IT "TWB64 178 - Arancione Crash"
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_IT NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_IT "TWB64 180 - Team Rocket Rosso"
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_IT "TWB64 181 - SEIKO Timer Giallo"
#define OPTION_VAL_TWB64_182_PINK109_IT NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_IT NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_IT NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_IT NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_IT NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_IT NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_IT NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_IT NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_IT NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_IT "TWB64 191 - Oro Del Demone"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_IT NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_IT NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_IT NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_IT NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_IT NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_IT NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_IT NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_IT NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_IT NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_IT "> PixelShift - Pacchetto 1 Tavolozza"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_IT "Seleziona la tavolozza di colorazione interna quando 'Tavolozza interna' è impostata su 'PixelShift - Pachetto 1'."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_IT "PixelShift 01 - Verde Artico"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_IT NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_IT "PixelShift 03 - Emulatore BGB 0.3"
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_IT NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_IT "PixelShift 05 - Barra di Cioccolato"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_IT NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_IT "PixelShift 07 - Zucchero Filato"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_IT "PixelShift 08 - Verdi Facili"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_IT NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_IT NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_IT NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_IT NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_IT NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_IT NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_IT "PixelShift 15 - GB Retroilluminazione Blu"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_IT "PixelShift 16 - GB Retroilluminazione Sbiadita"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_IT "PixelShift 17 - GB Retroilluminazione Arancione"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__IT "PixelShift 18 - GB Retroilluminazione Bianca "
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_IT "PixelShift 19 - GB Retroilluminazione Giallo Scuro"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_IT NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_IT "PixelShift 21 - GB Cacciatore"
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_IT "PixelShift 22 - Chiosco GB"
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_IT "PixelShift 23 - Chiosco Gb 2"
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_IT "PixelShift 24 - Nuovo GB"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_IT "PixelShift 25 - GB Esploso"
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_IT "PixelShift 26 - GB Vecchio"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_IT NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_IT "PixelShift 28 - GB Giallo Lavato Retroilluminato"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_IT "PixelShift 29 - Fantasma"
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_IT "PixelShift 30 - Illumina al buio"
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_IT "PixelShift 31 - Lingotto D'Oro"
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_IT "PixelShift 32 - Pompelmo"
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_IT "PixelShift 33 - Miscela Verde Grigio"
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_IT NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_IT NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_IT "PixelShift 36 - Giornale"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_IT NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_IT NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_IT NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_IT "PixelShift 40 - Sprazzo di Sole"
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_IT NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_IT NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_IT NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_IT NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_IT "PixelShift 45 - Desiderio"
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_IT "Correzione Colore"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_IT "Regola i colori di uscita per abbinare la visualizzazione dell'hardware reale Game Boy Color. 'GBC Only' assicura che la correzione venga applicata solo quando si gioca ai giochi di Game Boy Color, o quando si utilizza una tavolozza di colori Game Boy per colorare un gioco Game Boy. 'Sempre' applica la correzione del colore a tutti i contenuti, e produrrà risultati inattesi/subottimali quando si usano le tavolozze di colori interne 'GB' o 'SGB'."
#define OPTION_VAL_GBC_ONLY_IT "Solo GBC"
#define OPTION_VAL_ALWAYS_IT "Sempre"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_IT "Modalità Correzione Colore"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_IT "Specifica il metodo utilizzato per eseguire la correzione del colore. 'Accurate' produce output quasi indistinguibile da un vero e proprio pannello LCD Game Boy Color. 'Fast' scurisce semplicemente i colori e riduce la saturazione, e può essere utilizzato su hardware di fascia bassa se il metodo 'Accurato' è troppo lento."
#define OPTION_VAL_ACCURATE_IT "Preciso"
#define OPTION_VAL_FAST_IT "Veloce"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_IT "Correzione Colore - Posizione Frontlight"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_IT "Simula la risposta fisica del pannello LCD Game Boy Color quando illuminato da diverse angolazioni. 'Centrale' rappresenta la riproduzione standard del colore. 'Sopra lo schermo' aumenta la luminosità. 'Sotto lo schermo' riduce la luminosità. Questa impostazione si applica solo quando la 'Modalità Correzione del colore' è impostata su 'Accurata'."
#define OPTION_VAL_CENTRAL_IT "Centrale"
#define OPTION_VAL_ABOVE_SCREEN_IT "Sopra Lo Schermo"
#define OPTION_VAL_BELOW_SCREEN_IT "Sotto Lo Schermo"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_IT "Livello Filtro Scuro (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_IT "Abilita la riduzione della luminosità basata sulla luminosità. Può essere usato per evitare abbagliamento/tensione oculare quando si gioca con sfondi bianchi, che sono destinati per visualizzazione su un non retroilluminato Game Boy Color e quindi possono apparire scomodi luminosi quando visto su uno schermo retroilluminato moderno."
#define GAMBATTE_MIX_FRAMES_LABEL_IT "Combinazione Interframe"
#define GAMBATTE_MIX_FRAMES_INFO_0_IT "Simula gli effetti fantasma LCD. 'Semplice' esegue un mix di 50:50 dei fotogrammi attuali e precedenti. 'LCD Ghosting' imita i tempi naturali di risposta LCD combinando più frame tamponati. 'Semplice' miscelazione è necessaria quando si gioca a giochi che si basano su fantasma LCD per gli effetti di trasparenza (Wave Race, Ballistico, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_IT "Semplice"
#define OPTION_VAL_LCD_GHOSTING_IT "Ghosting LCD (preciso)"
#define OPTION_VAL_LCD_GHOSTING_FAST_IT "Ghosting LCD (veloce)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_IT "Driver per il Riamplificatore Audio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_IT "Specifica quale algoritmo usare quando si ricampiona l'audio generato (la velocità di Game Boy è limitata solo dalla velocità di scrittura della CPU, in modo che le frequenze 'native' non siano pratiche sui moderni dispositivi sonori e debbano essere sottoposte a campionamento). 'Sinc' produce la massima qualità. 'Cosine' migliora le prestazioni su hardware di fascia bassa."
#define OPTION_VAL_SINC_IT NULL
#define OPTION_VAL_CC_IT NULL
#define GAMBATTE_GB_HWMODE_LABEL_IT "Hardware Emulato (Riavvio Richiesto)"
#define GAMBATTE_GB_HWMODE_INFO_0_IT "Specificare il tipo di hardware da emulare. Si raccomanda 'Auto'. Selezionando 'GBA' sblocca le funzioni extra in alcuni giochi 'GBA Enhanced' Game Boy Color (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_IT NULL
#define OPTION_VAL_GBA_IT NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_IT "Usa Bootloader Ufficiale (Riavvio Richiesto)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_IT "Abilita il supporto per bootloaders ufficiali di Game Boy e Game Boy Color con le relative animazioni del logo di avvio."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_IT "Permetti Direzioni Opposte"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_IT "Abilitando questa opzione sarà possibile pressare/alterare/tenere premute contemporaneamente sia le direzioni sinistra che destra (o su e giù). Ciò potrebbe causare problemi basati sui movimenti."
#define GAMBATTE_TURBO_PERIOD_LABEL_IT "Periodo Pulsante Turbo"
#define GAMBATTE_TURBO_PERIOD_INFO_0_IT "Specificare l'intervallo di ripetizione (in fotogrammi) tenendo premuto i pulsanti Turbo A/B."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_IT "Forza di vibrazione del controller"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_IT "Abilita effetti di feedback tattili per i giochi supportati (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_IT "Mostra Impostazioni del Game Link"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_IT "Abilita la configurazione delle opzioni di collegamento di gioco in rete (multiplayer). NOTA: potrebbe essere necessario attivare il menu rapido affinché questa impostazione abbia effetto."
#define GAMBATTE_GB_LINK_MODE_LABEL_IT "Modalità Game Link"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_IT "Modalità Collegamento"
#define GAMBATTE_GB_LINK_MODE_INFO_0_IT "Quando si attiva la funzionalità di Game Link in rete, specificare se l'istanza corrente debba essere eseguita come server o client."
#define OPTION_VAL_NOT_CONNECTED_IT "Non Connesso"
#define OPTION_VAL_NETWORK_SERVER_IT "Server Di Rete"
#define OPTION_VAL_NETWORK_CLIENT_IT "Client Di Rete"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_IT "Porta Collegamento Di Rete"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_IT "Porta"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_IT "Specifica la porta utilizzata per la comunicazione di rete Game Link."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_IT "Indirizzo Server Link Di Rete Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_IT "Indirizzo server Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_IT "1a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_IT "1a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_IT "Indirizzo Server Link Di Rete Pt. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_IT "Indirizzo Server Pt. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_IT "2a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_IT "2a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_IT "Indirizzo Server Link Di Rete Pt. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_IT "Indirizzo Del Server Pt. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_IT "3a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_IT "3a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_IT "Indirizzo Server Link Di Rete Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_IT "Indirizzo Server Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_IT "4a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Network Client'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_IT "4a cifra di indirizzo IP del server di rete di Game Link. Usato solo quando 'Modalità collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_IT "Indirizzo Server Link Di Rete Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_IT "Indirizzo Del Server Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_IT "5a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Network Client'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_IT "5a cifra di indirizzo IP del server di rete di Game Link. Usato solo quando 'Modalità collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_IT "Indirizzo Server Link Di Rete Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_IT "Indirizzo Del Server Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_IT "6a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_IT "6a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_IT "Indirizzo Server Link Di Rete Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_IT "Indirizzo Server Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_IT "7a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Network Client'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_IT "7a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_IT "Indirizzo Server Link Di Rete 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_IT "Indirizzo Del Server 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_IT "8a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_IT "8a cifra di indirizzo IP del server di rete di Game Link. Usato solo quando 'Modalità collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_IT "Indirizzo Del Server Collegamento Di Rete N. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_IT "Indirizzo Del Server 09: ___.___.___x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_IT "9a cifra dell'indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_IT "9a cifra dell'indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_IT "Indirizzo Server Link Di Rete Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_IT "Indirizzo Del Server Pt. 10: ___.___.___._x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_IT "10a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_IT "10a cifra di indirizzo IP del server di rete di Game Link. Usato solo quando 'Modalità collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_IT "Indirizzo Del Server Collegamento Di Rete Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_IT "Indirizzo Del Server Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_IT "11a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_IT "11a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Collegamento' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_IT "Indirizzo Del Server Collegamento Di Rete Pt. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_IT "Indirizzo Del Server Pt. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_IT "12a cifra di indirizzo IP del server di rete di Game Link remoto. Usato solo quando 'Modalità Game Link' è impostato su 'Client di rete'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_IT "12a cifra di indirizzo IP del server di rete di Game Link. Usato solo quando 'Modalità collegamento' è impostato su 'Client di rete'."

struct retro_core_option_v2_category option_cats_it[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_IT,
      CATEGORY_GB_LINK_INFO_0_IT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_it[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_IT,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_IT,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_IT },
         { "GBC",      OPTION_VAL_GBC_IT },
         { "SGB",      OPTION_VAL_SGB_IT },
         { "internal", OPTION_VAL_INTERNAL_IT },
         { "custom",   OPTION_VAL_CUSTOM_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_IT,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_IT,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_IT },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_IT },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_IT },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_IT },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_IT },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_IT },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_IT },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_IT },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_IT },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_IT },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_IT },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_IT },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_IT },
         { "GBC - Red",                OPTION_VAL_GBC_RED_IT },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_IT },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_IT },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_IT },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_IT },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_IT },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_IT },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_IT },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_IT },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_IT },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_IT },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_IT },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_IT },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_IT },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_IT },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_IT },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_IT },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_IT },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_IT },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_IT },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_IT },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_IT },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_IT },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_IT },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_IT },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_IT },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_IT },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_IT },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_IT },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_IT },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_IT },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_IT },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_IT },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_IT },
         { "Special 1",                OPTION_VAL_SPECIAL_1_IT },
         { "Special 2",                OPTION_VAL_SPECIAL_2_IT },
         { "Special 3",                OPTION_VAL_SPECIAL_3_IT },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_IT },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_IT },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_IT },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_IT },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_IT,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_IT,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_IT },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_IT },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_IT },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_IT },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_IT },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_IT },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_IT },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_IT },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_IT },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_IT },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_IT },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_IT },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_IT },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_IT },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_IT },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_IT },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_IT },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_IT },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_IT },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_IT },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_IT },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_IT },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_IT },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_IT },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_IT },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_IT },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_IT },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_IT },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_IT },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_IT },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_IT },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_IT },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_IT },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_IT },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_IT },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_IT },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_IT },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_IT },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_IT },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_IT },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_IT },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_IT },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_IT },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_IT },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_IT },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_IT },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_IT },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_IT },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_IT },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_IT },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_IT },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_IT },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_IT },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_IT },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_IT },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_IT },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_IT },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_IT },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_IT },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_IT },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_IT },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_IT },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_IT },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_IT },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_IT },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_IT },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_IT },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_IT },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_IT },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_IT },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_IT },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_IT },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_IT },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_IT },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_IT },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_IT },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_IT },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_IT },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_IT },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_IT },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_IT },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_IT },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_IT },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_IT },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_IT },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_IT },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_IT },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_IT },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_IT },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_IT },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_IT },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_IT },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_IT },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_IT },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_IT },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_IT },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_IT },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_IT },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_IT },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_IT },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_IT,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_IT,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_IT },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_IT },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_IT },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_IT },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_IT },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_IT },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_IT },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_IT },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_IT },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_IT },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_IT },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_IT },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_IT },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_IT },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_IT },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_IT },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_IT },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_IT },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_IT },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_IT },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_IT },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_IT },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_IT },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_IT },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_IT },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_IT },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_IT },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_IT },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_IT },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_IT },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_IT },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_IT },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_IT },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_IT },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_IT },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_IT },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_IT },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_IT },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_IT },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_IT },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_IT },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_IT },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_IT },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_IT },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_IT },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_IT },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_IT },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_IT },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_IT },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_IT },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_IT },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_IT },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_IT },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_IT },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_IT },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_IT },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_IT },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_IT },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_IT },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_IT },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_IT },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_IT },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_IT },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_IT },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_IT },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_IT },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_IT },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_IT },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_IT },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_IT },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_IT },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_IT },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_IT },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_IT },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_IT },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_IT },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_IT },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_IT },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_IT },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_IT },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_IT },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_IT },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_IT },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_IT },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_IT },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_IT },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_IT },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_IT },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_IT },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_IT },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_IT },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_IT },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_IT },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_IT },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_IT },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_IT },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_IT },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_IT },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_IT },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_IT },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_IT,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_IT,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_IT },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_IT },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_IT },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_IT },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_IT },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_IT },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_IT },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_IT },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_IT },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_IT },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_IT },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_IT },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_IT },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_IT },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_IT },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_IT },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_IT },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__IT },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_IT },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_IT },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_IT },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_IT },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_IT },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_IT },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_IT },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_IT },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_IT },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_IT },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_IT },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_IT },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_IT },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_IT },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_IT },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_IT },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_IT },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_IT },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_IT },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_IT },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_IT },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_IT },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_IT },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_IT },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_IT },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_IT },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_IT },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_IT,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_IT,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_IT },
         { "always",   OPTION_VAL_ALWAYS_IT },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_IT,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_IT,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_IT },
         { "fast",     OPTION_VAL_FAST_IT },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_IT,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_IT,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_IT },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_IT },
         { "below screen", OPTION_VAL_BELOW_SCREEN_IT },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_IT,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_IT,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_IT,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_IT,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_IT },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_IT },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_IT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_IT,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_IT,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_IT },
         { "cc",   OPTION_VAL_CC_IT },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_IT,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_IT,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_IT },
         { "GB",   OPTION_VAL_GB_IT },
         { "GBC",  OPTION_VAL_GBC_IT },
         { "GBA",  OPTION_VAL_GBA_IT },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_IT,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_IT,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_IT,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_IT,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_IT,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_IT,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_IT,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_IT,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_IT,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_IT,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_IT,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_MODE_INFO_0_IT,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_IT },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_IT },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_IT },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_IT,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_IT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_IT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_it = {
   option_cats_it,
   option_defs_it
};

/* RETRO_LANGUAGE_JA */

#define CATEGORY_GB_LINK_LABEL_JA NULL
#define CATEGORY_GB_LINK_INFO_0_JA NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_JA NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_JA NULL
#define OPTION_VAL_AUTO_JA "自動"
#define OPTION_VAL_GBC_JA NULL
#define OPTION_VAL_SGB_JA NULL
#define OPTION_VAL_INTERNAL_JA NULL
#define OPTION_VAL_CUSTOM_JA "カスタム"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_JA NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_JA NULL
#define OPTION_VAL_GB_DMG_JA NULL
#define OPTION_VAL_GB_POCKET_JA NULL
#define OPTION_VAL_GB_LIGHT_JA NULL
#define OPTION_VAL_GBC_BLUE_JA NULL
#define OPTION_VAL_GBC_BROWN_JA NULL
#define OPTION_VAL_GBC_DARK_BLUE_JA NULL
#define OPTION_VAL_GBC_DARK_BROWN_JA NULL
#define OPTION_VAL_GBC_DARK_GREEN_JA NULL
#define OPTION_VAL_GBC_GRAYSCALE_JA NULL
#define OPTION_VAL_GBC_GREEN_JA NULL
#define OPTION_VAL_GBC_INVERTED_JA NULL
#define OPTION_VAL_GBC_ORANGE_JA NULL
#define OPTION_VAL_GBC_PASTEL_MIX_JA NULL
#define OPTION_VAL_GBC_RED_JA NULL
#define OPTION_VAL_GBC_YELLOW_JA NULL
#define OPTION_VAL_SGB_1A_JA NULL
#define OPTION_VAL_SGB_1B_JA NULL
#define OPTION_VAL_SGB_1C_JA NULL
#define OPTION_VAL_SGB_1D_JA NULL
#define OPTION_VAL_SGB_1E_JA NULL
#define OPTION_VAL_SGB_1F_JA NULL
#define OPTION_VAL_SGB_1G_JA NULL
#define OPTION_VAL_SGB_1H_JA NULL
#define OPTION_VAL_SGB_2A_JA NULL
#define OPTION_VAL_SGB_2B_JA NULL
#define OPTION_VAL_SGB_2C_JA NULL
#define OPTION_VAL_SGB_2D_JA NULL
#define OPTION_VAL_SGB_2E_JA NULL
#define OPTION_VAL_SGB_2F_JA NULL
#define OPTION_VAL_SGB_2G_JA NULL
#define OPTION_VAL_SGB_2H_JA NULL
#define OPTION_VAL_SGB_3A_JA NULL
#define OPTION_VAL_SGB_3B_JA NULL
#define OPTION_VAL_SGB_3C_JA NULL
#define OPTION_VAL_SGB_3D_JA NULL
#define OPTION_VAL_SGB_3E_JA NULL
#define OPTION_VAL_SGB_3F_JA NULL
#define OPTION_VAL_SGB_3G_JA NULL
#define OPTION_VAL_SGB_3H_JA NULL
#define OPTION_VAL_SGB_4A_JA NULL
#define OPTION_VAL_SGB_4B_JA NULL
#define OPTION_VAL_SGB_4C_JA NULL
#define OPTION_VAL_SGB_4D_JA NULL
#define OPTION_VAL_SGB_4E_JA NULL
#define OPTION_VAL_SGB_4F_JA NULL
#define OPTION_VAL_SGB_4G_JA NULL
#define OPTION_VAL_SGB_4H_JA NULL
#define OPTION_VAL_SPECIAL_1_JA NULL
#define OPTION_VAL_SPECIAL_2_JA NULL
#define OPTION_VAL_SPECIAL_3_JA NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_JA NULL
#define OPTION_VAL_TWB64_PACK_1_JA NULL
#define OPTION_VAL_TWB64_PACK_2_JA NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_JA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_JA NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_JA NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_JA NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_JA NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_JA NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_JA NULL
#define OPTION_VAL_TWB64_005_NEON_RED_JA NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_JA NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_JA NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_JA NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_JA NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_JA NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_JA NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_JA NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_JA NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_JA NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_JA NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_JA NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_JA NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_JA NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_JA NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_JA NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_JA NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_JA NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_JA NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_JA NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_JA NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_JA NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_JA NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_JA NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_JA NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_JA NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_JA NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_JA NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_JA NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_JA NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_JA NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_JA NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_JA NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_JA NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_JA NULL
#define OPTION_VAL_TWB64_040_DMG_VER_JA NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_JA NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_JA NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_JA NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_JA NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_JA NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_JA NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_JA NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_JA NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_JA NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_JA NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_JA NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_JA NULL
#define OPTION_VAL_TWB64_053_VMU_VER_JA NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_JA NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_JA NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_JA NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_JA NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_JA NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_JA NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_JA NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_JA NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_JA NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_JA NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_JA NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_JA NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_JA NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_JA NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_JA NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_JA NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_JA NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_JA NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_JA NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_JA NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_JA NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_JA NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_JA NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_JA NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_JA NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_JA NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_JA NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_JA NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_JA NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_JA NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_JA NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_JA NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_JA NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_JA NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_JA NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_JA NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_JA NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_JA NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_JA NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_JA NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_JA NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_JA NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_JA NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_JA NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_JA NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_JA NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_JA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_JA NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_JA NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_JA NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_JA NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_JA NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_JA NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_JA NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_JA NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_JA NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_JA NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_JA NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_JA NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_JA NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_JA NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_JA NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_JA NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_JA NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_JA NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_JA NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_JA NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_JA NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_JA NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_JA NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_JA NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_JA NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_JA NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_JA NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_JA NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_JA NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_JA NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_JA NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_JA NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_JA NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_JA NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_JA NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_JA NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_JA NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_JA NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_JA NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_JA NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_JA NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_JA NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_JA NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_JA NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_JA NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_JA NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_JA NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_JA NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_JA NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_JA NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_JA NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_JA NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_JA NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_JA NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_JA NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_JA NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_JA NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_JA NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_JA NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_JA NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_JA NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_JA NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_JA NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_JA NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_JA NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_JA NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_JA NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_JA NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_JA NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_JA NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_JA NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_JA NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_JA NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_JA NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_JA NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_JA NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_JA NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_JA NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_JA NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_JA NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_JA NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_JA NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_JA NULL
#define OPTION_VAL_TWB64_182_PINK109_JA NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_JA NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_JA NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_JA NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_JA NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_JA NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_JA NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_JA NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_JA NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_JA NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_JA NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_JA NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_JA NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_JA NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_JA NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_JA NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_JA NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_JA NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_JA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_JA NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_JA NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_JA NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_JA NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_JA NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_JA NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_JA NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_JA NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_JA NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_JA NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_JA NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_JA NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_JA NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_JA NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_JA NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_JA NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_JA NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_JA NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_JA NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__JA NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_JA NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_JA NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_JA NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_JA NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_JA NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_JA NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_JA NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_JA NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_JA NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_JA NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_JA NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_JA NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_JA NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_JA NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_JA NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_JA NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_JA NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_JA NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_JA NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_JA NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_JA NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_JA NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_JA NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_JA NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_JA NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_JA NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_JA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_JA "カラーコレクション"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_JA NULL
#define OPTION_VAL_GBC_ONLY_JA NULL
#define OPTION_VAL_ALWAYS_JA "常に表示する"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_JA NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_JA NULL
#define OPTION_VAL_ACCURATE_JA NULL
#define OPTION_VAL_FAST_JA "高速"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_JA NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_JA NULL
#define OPTION_VAL_CENTRAL_JA NULL
#define OPTION_VAL_ABOVE_SCREEN_JA NULL
#define OPTION_VAL_BELOW_SCREEN_JA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_JA NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_JA NULL
#define GAMBATTE_MIX_FRAMES_LABEL_JA NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_JA NULL
#define OPTION_VAL_MIX_JA "シンプル"
#define OPTION_VAL_LCD_GHOSTING_JA "液晶残像 (精密)"
#define OPTION_VAL_LCD_GHOSTING_FAST_JA "液晶残像 (高速)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_JA "オーディオリサンプラーのドライバ"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_JA NULL
#define OPTION_VAL_SINC_JA NULL
#define OPTION_VAL_CC_JA NULL
#define GAMBATTE_GB_HWMODE_LABEL_JA NULL
#define GAMBATTE_GB_HWMODE_INFO_0_JA NULL
#define OPTION_VAL_GB_JA NULL
#define OPTION_VAL_GBA_JA NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_JA NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_JA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_JA NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_JA NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_JA NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_JA NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_JA NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_JA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_JA NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_JA NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_JA NULL
#define OPTION_VAL_NOT_CONNECTED_JA NULL
#define OPTION_VAL_NETWORK_SERVER_JA NULL
#define OPTION_VAL_NETWORK_CLIENT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_JA "ポート"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_JA NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_JA NULL

struct retro_core_option_v2_category option_cats_ja[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_JA,
      CATEGORY_GB_LINK_INFO_0_JA
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ja[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_JA,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_JA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_JA },
         { "GBC",      OPTION_VAL_GBC_JA },
         { "SGB",      OPTION_VAL_SGB_JA },
         { "internal", OPTION_VAL_INTERNAL_JA },
         { "custom",   OPTION_VAL_CUSTOM_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_JA,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_JA,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_JA },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_JA },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_JA },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_JA },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_JA },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_JA },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_JA },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_JA },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_JA },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_JA },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_JA },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_JA },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_JA },
         { "GBC - Red",                OPTION_VAL_GBC_RED_JA },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_JA },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_JA },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_JA },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_JA },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_JA },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_JA },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_JA },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_JA },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_JA },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_JA },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_JA },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_JA },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_JA },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_JA },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_JA },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_JA },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_JA },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_JA },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_JA },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_JA },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_JA },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_JA },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_JA },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_JA },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_JA },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_JA },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_JA },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_JA },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_JA },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_JA },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_JA },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_JA },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_JA },
         { "Special 1",                OPTION_VAL_SPECIAL_1_JA },
         { "Special 2",                OPTION_VAL_SPECIAL_2_JA },
         { "Special 3",                OPTION_VAL_SPECIAL_3_JA },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_JA },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_JA },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_JA },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_JA },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_JA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_JA,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_JA },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_JA },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_JA },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_JA },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_JA },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_JA },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_JA },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_JA },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_JA },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_JA },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_JA },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_JA },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_JA },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_JA },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_JA },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_JA },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_JA },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_JA },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_JA },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_JA },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_JA },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_JA },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_JA },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_JA },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_JA },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_JA },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_JA },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_JA },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_JA },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_JA },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_JA },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_JA },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_JA },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_JA },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_JA },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_JA },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_JA },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_JA },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_JA },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_JA },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_JA },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_JA },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_JA },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_JA },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_JA },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_JA },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_JA },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_JA },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_JA },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_JA },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_JA },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_JA },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_JA },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_JA },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_JA },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_JA },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_JA },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_JA },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_JA },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_JA },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_JA },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_JA },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_JA },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_JA },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_JA },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_JA },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_JA },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_JA },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_JA },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_JA },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_JA },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_JA },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_JA },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_JA },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_JA },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_JA },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_JA },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_JA },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_JA },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_JA },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_JA },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_JA },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_JA },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_JA },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_JA },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_JA },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_JA },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_JA },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_JA },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_JA },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_JA },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_JA },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_JA },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_JA },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_JA },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_JA },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_JA },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_JA },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_JA },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_JA },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_JA,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_JA,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_JA },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_JA },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_JA },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_JA },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_JA },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_JA },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_JA },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_JA },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_JA },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_JA },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_JA },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_JA },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_JA },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_JA },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_JA },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_JA },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_JA },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_JA },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_JA },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_JA },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_JA },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_JA },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_JA },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_JA },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_JA },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_JA },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_JA },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_JA },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_JA },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_JA },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_JA },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_JA },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_JA },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_JA },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_JA },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_JA },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_JA },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_JA },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_JA },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_JA },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_JA },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_JA },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_JA },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_JA },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_JA },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_JA },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_JA },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_JA },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_JA },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_JA },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_JA },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_JA },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_JA },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_JA },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_JA },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_JA },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_JA },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_JA },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_JA },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_JA },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_JA },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_JA },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_JA },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_JA },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_JA },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_JA },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_JA },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_JA },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_JA },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_JA },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_JA },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_JA },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_JA },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_JA },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_JA },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_JA },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_JA },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_JA },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_JA },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_JA },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_JA },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_JA },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_JA },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_JA },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_JA },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_JA },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_JA },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_JA },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_JA },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_JA },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_JA },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_JA },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_JA },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_JA },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_JA },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_JA },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_JA },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_JA },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_JA },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_JA },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_JA,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_JA,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_JA },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_JA },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_JA },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_JA },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_JA },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_JA },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_JA },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_JA },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_JA },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_JA },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_JA },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_JA },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_JA },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_JA },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_JA },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_JA },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_JA },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__JA },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_JA },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_JA },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_JA },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_JA },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_JA },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_JA },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_JA },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_JA },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_JA },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_JA },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_JA },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_JA },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_JA },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_JA },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_JA },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_JA },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_JA },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_JA },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_JA },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_JA },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_JA },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_JA },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_JA },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_JA },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_JA },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_JA },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_JA },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_JA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_JA,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_JA },
         { "always",   OPTION_VAL_ALWAYS_JA },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_JA,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_JA,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_JA },
         { "fast",     OPTION_VAL_FAST_JA },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_JA,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_JA,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_JA },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_JA },
         { "below screen", OPTION_VAL_BELOW_SCREEN_JA },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_JA,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_JA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_JA,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_JA,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_JA },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_JA },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_JA },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_JA,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_JA,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_JA },
         { "cc",   OPTION_VAL_CC_JA },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_JA,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_JA,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_JA },
         { "GB",   OPTION_VAL_GB_JA },
         { "GBC",  OPTION_VAL_GBC_JA },
         { "GBA",  OPTION_VAL_GBA_JA },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_JA,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_JA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_JA,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_JA,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_JA,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_JA,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_JA,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_JA,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_JA,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_JA,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_JA,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_MODE_INFO_0_JA,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_JA },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_JA },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_JA },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_JA,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_JA,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_JA,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ja = {
   option_cats_ja,
   option_defs_ja
};

/* RETRO_LANGUAGE_KO */

#define CATEGORY_GB_LINK_LABEL_KO "게임 통신"
#define CATEGORY_GB_LINK_INFO_0_KO "온라인 '게임 통신' (멀티플레이어) 옵션을 설정합니다."
#define GAMBATTE_GB_COLORIZATION_LABEL_KO "GB 색상화"
#define GAMBATTE_GB_COLORIZATION_INFO_0_KO "Game Boy 게임을 색상화합니다. '자동'은 최선의(가장 색이 도드라지고 적절한) 팔레트를 선택합니다. 'GBC'는 Game Boy Color에 정의된 팔레트가 있을 경우 해당 팔레트를, 없을 경우 'GBC - 어두운 초록'을 사용합니다. 'SGB'는 Super Game Boy에 정의된 팔레트가 있을 경우 해당 팔레트를, 없을 경우 'SGB - 1A'를 사용합니다. '내장'은 '내장 팔레트' 코어 옵션을 사용합니다. '사용자 정의'는 시스템 디렉토리에서 사용자 정의 팔레트를 불러옵니다."
#define OPTION_VAL_AUTO_KO "자동"
#define OPTION_VAL_GBC_KO NULL
#define OPTION_VAL_SGB_KO NULL
#define OPTION_VAL_INTERNAL_KO "내장"
#define OPTION_VAL_CUSTOM_KO "사용자"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_KO "내장 팔레트"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_KO "'GB 색상화' 옵션이 '내장'으로 설정되었거나 '자동'에서 미리 정의된 SGB/GBC 팔레트를 찾을 수 없을 경우 사용할 Game Boy 게임 색상화 팔레트를 선택합니다. 'GB'는 원본 Game Boy 하드웨어를 흉내냅니다. 'GBC'는 Game Boy Color에 내장된 프리셋 팔레트와 동일합니다. 'SGB'는 Super Game Boy에 내장된 프리셋 팔레트와 동일합니다."
#define OPTION_VAL_GB_DMG_KO NULL
#define OPTION_VAL_GB_POCKET_KO NULL
#define OPTION_VAL_GB_LIGHT_KO NULL
#define OPTION_VAL_GBC_BLUE_KO "GBC - 파랑"
#define OPTION_VAL_GBC_BROWN_KO "GBC - 갈색"
#define OPTION_VAL_GBC_DARK_BLUE_KO "GBC - 어두운 파랑"
#define OPTION_VAL_GBC_DARK_BROWN_KO "GBC - 어두운 갈색"
#define OPTION_VAL_GBC_DARK_GREEN_KO "GBC - 어두운 초록"
#define OPTION_VAL_GBC_GRAYSCALE_KO "GBC - 흑백"
#define OPTION_VAL_GBC_GREEN_KO "GBC - 초록"
#define OPTION_VAL_GBC_INVERTED_KO "GBC - 반전"
#define OPTION_VAL_GBC_ORANGE_KO "GBC - 오렌지"
#define OPTION_VAL_GBC_PASTEL_MIX_KO "GBC - 파스텔"
#define OPTION_VAL_GBC_RED_KO "GBC - 빨강"
#define OPTION_VAL_GBC_YELLOW_KO "GBC - 노랑"
#define OPTION_VAL_SGB_1A_KO NULL
#define OPTION_VAL_SGB_1B_KO NULL
#define OPTION_VAL_SGB_1C_KO NULL
#define OPTION_VAL_SGB_1D_KO NULL
#define OPTION_VAL_SGB_1E_KO NULL
#define OPTION_VAL_SGB_1F_KO NULL
#define OPTION_VAL_SGB_1G_KO NULL
#define OPTION_VAL_SGB_1H_KO NULL
#define OPTION_VAL_SGB_2A_KO NULL
#define OPTION_VAL_SGB_2B_KO NULL
#define OPTION_VAL_SGB_2C_KO NULL
#define OPTION_VAL_SGB_2D_KO NULL
#define OPTION_VAL_SGB_2E_KO NULL
#define OPTION_VAL_SGB_2F_KO NULL
#define OPTION_VAL_SGB_2G_KO NULL
#define OPTION_VAL_SGB_2H_KO NULL
#define OPTION_VAL_SGB_3A_KO NULL
#define OPTION_VAL_SGB_3B_KO NULL
#define OPTION_VAL_SGB_3C_KO NULL
#define OPTION_VAL_SGB_3D_KO NULL
#define OPTION_VAL_SGB_3E_KO NULL
#define OPTION_VAL_SGB_3F_KO NULL
#define OPTION_VAL_SGB_3G_KO NULL
#define OPTION_VAL_SGB_3H_KO NULL
#define OPTION_VAL_SGB_4A_KO NULL
#define OPTION_VAL_SGB_4B_KO NULL
#define OPTION_VAL_SGB_4C_KO NULL
#define OPTION_VAL_SGB_4D_KO NULL
#define OPTION_VAL_SGB_4E_KO NULL
#define OPTION_VAL_SGB_4F_KO NULL
#define OPTION_VAL_SGB_4G_KO NULL
#define OPTION_VAL_SGB_4H_KO NULL
#define OPTION_VAL_SPECIAL_1_KO "특별 1"
#define OPTION_VAL_SPECIAL_2_KO "특별 2"
#define OPTION_VAL_SPECIAL_3_KO "특별 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_KO "특별 4 (TI-83 레거시)"
#define OPTION_VAL_TWB64_PACK_1_KO "TWB64 - 팩 1"
#define OPTION_VAL_TWB64_PACK_2_KO "TWB64 - 팩 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_KO "PixelShift - 팩 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_KO "> TWB64 - 팩 1 팔레트"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_KO "'내장 팔레트'가 'TWB64 - 팩 1'일 때 사용할 내장 색상화 팔레트를 선택합니다."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_KO NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_KO NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_KO NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_KO NULL
#define OPTION_VAL_TWB64_005_NEON_RED_KO NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_KO NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_KO NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_KO NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_KO NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_KO NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_KO NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_KO NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_KO NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_KO NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_KO NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_KO NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_KO NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_KO NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_KO NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_KO NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_KO NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_KO NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_KO NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_KO NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_KO NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_KO NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_KO NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_KO NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_KO NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_KO NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_KO NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_KO NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_KO NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_KO NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_KO NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_KO NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_KO NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_KO NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_KO NULL
#define OPTION_VAL_TWB64_040_DMG_VER_KO NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_KO NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_KO NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_KO NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_KO NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_KO NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_KO NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_KO NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_KO NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_KO NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_KO NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_KO NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_KO NULL
#define OPTION_VAL_TWB64_053_VMU_VER_KO NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_KO NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_KO NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_KO NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_KO NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_KO NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_KO NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_KO NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_KO NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_KO NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_KO NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_KO NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_KO NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_KO NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_KO NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_KO NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_KO NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_KO NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_KO NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_KO NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_KO NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_KO NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_KO NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_KO NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_KO NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_KO NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_KO NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_KO NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_KO NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_KO NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_KO NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_KO NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_KO NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_KO NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_KO NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_KO NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_KO NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_KO NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_KO NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_KO NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_KO NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_KO NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_KO NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_KO NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_KO NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_KO NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_KO NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_KO NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_KO "> TWB64 - 팩 2 팔레트"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_KO "'내장 팔레트'가 'TWB64 - 팩 2'일 때 사용할 내장 색상화 팔레트를 선택합니다."
#define OPTION_VAL_TWB64_101_765PRO_PINK_KO NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_KO NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_KO NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_KO NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_KO NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_KO NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_KO NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_KO NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_KO NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_KO NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_KO NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_KO NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_KO NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_KO NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_KO NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_KO NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_KO NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_KO NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_KO NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_KO NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_KO NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_KO NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_KO NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_KO NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_KO NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_KO NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_KO NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_KO NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_KO NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_KO NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_KO NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_KO NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_KO NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_KO NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_KO NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_KO NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_KO NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_KO NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_KO NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_KO NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_KO NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_KO NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_KO NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_KO NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_KO NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_KO NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_KO NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_KO NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_KO NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_KO NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_KO NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_KO NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_KO NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_KO NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_KO NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_KO NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_KO NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_KO NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_KO NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_KO NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_KO NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_KO NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_KO NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_KO NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_KO NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_KO NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_KO NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_KO NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_KO NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_KO NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_KO NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_KO NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_KO NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_KO NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_KO NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_KO NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_KO NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_KO NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_KO NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_KO NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_KO NULL
#define OPTION_VAL_TWB64_182_PINK109_KO NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_KO NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_KO NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_KO NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_KO NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_KO NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_KO NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_KO NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_KO NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_KO NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_KO NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_KO NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_KO NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_KO NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_KO NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_KO NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_KO NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_KO NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_KO NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_KO "> PixelShift - 팩 1 팔레트"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_KO "'내장 팔레트'가 'PixelShift - 팩 1'일 때 사용할 내장 색상화 팔레트를 선택합니다."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_KO NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_KO NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_KO NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_KO NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_KO NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_KO NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_KO NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_KO NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_KO NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_KO NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_KO NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_KO NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_KO NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_KO NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_KO NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_KO NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_KO NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__KO NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_KO NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_KO NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_KO NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_KO NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_KO NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_KO NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_KO NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_KO NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_KO NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_KO NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_KO NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_KO NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_KO NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_KO NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_KO NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_KO NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_KO NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_KO NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_KO NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_KO NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_KO NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_KO NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_KO NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_KO NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_KO NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_KO NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_KO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_KO "색상 보정"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_KO "출력 색상을 원본 Game Boy Color 하드웨어와 비슷하게 조정합니다. 'GBC만'은 색상 보정을 Game Boy Color 게임 또는 Game Boy 게임에 Game Boy Color 팔레트를 사용하는 경우에만 적용합니다. '항상'은 모든 콘텐츠에 항상 색상 보정을 적용하며, 'GB' 또는 'SGB' 내장 팔레트를 사용할 경우 예기치 않은 부정확한 색상이 표시될 수 있습니다."
#define OPTION_VAL_GBC_ONLY_KO "GBC만"
#define OPTION_VAL_ALWAYS_KO "항상"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_KO "색상 보정 모드"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_KO "색상 보정을 적용할 방식을 선택합니다. '정확하게'는 실제 Game Boy Color의 LCD 패널과 거의 동일한 색상을 출력합니다. '빠르게'는 단순히 색을 어둡게 하고 채도를 낮게 변경하며, '정확하게'가 너무 느린 저사양 환경에서 사용될 수 있습니다."
#define OPTION_VAL_ACCURATE_KO "정확하게"
#define OPTION_VAL_FAST_KO "빠르게"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_KO "색상 보정 - 프론트라이트 위치"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_KO "Game Boy Color LCD 패널에 빛을 비추는 방향에 따른 물리적 반응을 흉내냅니다. '중앙'은 일반적인 색 표현을 나타냅니다. '화면 위'는 밝기를 향상시킵니다. '화면 아래'는 밝기를 감소시킵니다. 이 설정은 '색상 보정 모드'가 '정확히'일 때만 적용됩니다."
#define OPTION_VAL_CENTRAL_KO "중앙"
#define OPTION_VAL_ABOVE_SCREEN_KO "화면 위"
#define OPTION_VAL_BELOW_SCREEN_KO "화면 아래"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_KO "검정 필터 수준 (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_KO "휘도 기반 밝기 감쇄를 사용합니다. 백라이트가 없는 Game Boy Color를 염두에 두고 개발된 게임이 흰색 배경을 사용할 경우 현대적인 백라이트 화면에서는 불편할 정도로 밝게 표시될 수 있습니다. 이로 인한 빛 반사 및 눈 피로를 이 옵션으로 최소화할 수 있습니다."
#define GAMBATTE_MIX_FRAMES_LABEL_KO "프레임 간 혼합"
#define GAMBATTE_MIX_FRAMES_INFO_0_KO "LCD 고스팅 효과를 흉내냅니다. '단순'은 현재 프레임과 이전 프레임을 50:50 비율로 혼합합니다. 'LCD 고스팅' 옵션은 LCD 반응 시간에 따라 여러 프레임을 혼합합니다. LCD 고스팅을 이용해 투명 효과를 구현하는 게임(Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS 등)을 플레이하려면 '단순' 혼합을 사용해야 합니다."
#define OPTION_VAL_MIX_KO "단순"
#define OPTION_VAL_LCD_GHOSTING_KO "LCD 고스팅 (정확하게)"
#define OPTION_VAL_LCD_GHOSTING_FAST_KO "LCD 고스팅 (빠르게)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_KO "오디오 리샘플러 드라이버"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_KO "생성된 오디오를 리샘플링할 때 사용할 알고리즘을 지정합니다. (Game Boy의 오디오 샘플 레이트는 전적으로 CPU의 쓰기 속도에 따라 정해지기 때문에, 이들의 '네이티브' 주파수는 현대의 사운드 장치와 맞지 않아 다운샘플링을 거쳐야 합니다) '싱크'는 가장 고품질의 오디오를 만들어냅니다. '코사인'은 저사양 환경에서 성능을 개선합니다."
#define OPTION_VAL_SINC_KO "싱크"
#define OPTION_VAL_CC_KO "코사인"
#define GAMBATTE_GB_HWMODE_LABEL_KO "에뮬레이트할 하드웨어 (재시작 필요)"
#define GAMBATTE_GB_HWMODE_INFO_0_KO "어떤 종류의 하드웨어를 에뮬레이트할지 선택합니다. '자동'이 권장됩니다. 'GBA'를 선택하면 일부 'GBA 개선'을 지원하는 Game Boy Color 게임(Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages 등)에서 추가 기능을 해금할 수 있습니다."
#define OPTION_VAL_GB_KO NULL
#define OPTION_VAL_GBA_KO NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_KO "공식 부트로더 사용 (재시작 필요)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_KO "공식 Game Boy 및 Game Boy Color 부트로더 지원을 활성화합니다. 시작 로고 애니메이션이 재생됩니다."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_KO "반대 방향 동시 입력 허용"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_KO "이 옵션을 활성화하면 왼쪽과 오른쪽 (또는 위쪽과 아래쪽) 방향 입력을 동시에 누르거나 빠르게 번갈아 누르는 것을 허용합니다. 이는 움직임 관련 버그를 일으킬 수 있습니다."
#define GAMBATTE_TURBO_PERIOD_LABEL_KO "터보 버튼 간격"
#define GAMBATTE_TURBO_PERIOD_INFO_0_KO "터보 A/B 버튼을 꾹 누를 때 사용될 입력 간격(프레임)을 지정합니다."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_KO "컨트롤러 진동 강도"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_KO "지원되는 게임(Pokemon Pinball, Perfect Dark 등)에서 햅틱 피드백 효과를 활성화합니다."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_KO "게임 통신 설정 표시"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_KO "'게임 통신' (멀티플레이어) 설정을 활성화합니다. 주의: 이 설정은 빠른 메뉴를 껐다 켜야 반영됩니다."
#define GAMBATTE_GB_LINK_MODE_LABEL_KO "게임 통신 모드"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_KO "통신 모드"
#define GAMBATTE_GB_LINK_MODE_INFO_0_KO "'게임 통신' 기능을 사용할 때, 현재 인스턴스가 서버로 구동될 것인지 클라이언트로 구동될 것인지 지정합니다."
#define OPTION_VAL_NOT_CONNECTED_KO "연결되지 않음"
#define OPTION_VAL_NETWORK_SERVER_KO "네트워크 서버"
#define OPTION_VAL_NETWORK_CLIENT_KO "네트워크 클라이언트"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_KO "네트워크 통신 포트"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_KO "포트"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_KO "'게임 통신' 기능이 사용할 포트를 지정합니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_KO "네트워크 통신 서버 주소 파트 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_KO "서버 주소 파트 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 1번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 1번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_KO "네트워크 통신 서버 주소 파트 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_KO "서버 주소 파트 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 2번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 2번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_KO "네트워크 통신 서버 주소 파트 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_KO "서버 주소 파트 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 3번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 3번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_KO "네트워크 통신 서버 주소 파트 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_KO "서버 주소 파트 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 4번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 4번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_KO "네트워크 통신 서버 주소 파트 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_KO "서버 주소 파트 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 5번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 5번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_KO "네트워크 통신 서버 주소 파트 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_KO "서버 주소 파트 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 6번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 6번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_KO "네트워크 통신 서버 주소 파트 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_KO "서버 주소 파트 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 7번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 7번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_KO "네트워크 통신 서버 주소 파트 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_KO "서버 주소 파트 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 8번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 8번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_KO "네트워크 통신 서버 주소 파트 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_KO "서버 주소 파트 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 9번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 9번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_KO "네트워크 통신 서버 주소 파트 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_KO "서버 주소 파트 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 10번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 10번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_KO "네트워크 통신 서버 주소 파트 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_KO "서버 주소 파트 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 11번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 11번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_KO "네트워크 통신 서버 주소 파트 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_KO "서버 주소 파트 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_KO "'게임 통신'의 원격 서버 IP 주소의 12번째 자리입니다. '게임 통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_KO "'게임 통신'의 원격 서버 IP 주소의 12번째 자리입니다. '통신 모드'가 '네트워크 클라이언트'로 설정되었을 때만 사용됩니다."

struct retro_core_option_v2_category option_cats_ko[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_KO,
      CATEGORY_GB_LINK_INFO_0_KO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ko[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_KO,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_KO,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_KO },
         { "GBC",      OPTION_VAL_GBC_KO },
         { "SGB",      OPTION_VAL_SGB_KO },
         { "internal", OPTION_VAL_INTERNAL_KO },
         { "custom",   OPTION_VAL_CUSTOM_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_KO,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_KO,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_KO },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_KO },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_KO },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_KO },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_KO },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_KO },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_KO },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_KO },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_KO },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_KO },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_KO },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_KO },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_KO },
         { "GBC - Red",                OPTION_VAL_GBC_RED_KO },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_KO },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_KO },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_KO },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_KO },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_KO },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_KO },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_KO },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_KO },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_KO },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_KO },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_KO },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_KO },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_KO },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_KO },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_KO },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_KO },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_KO },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_KO },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_KO },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_KO },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_KO },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_KO },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_KO },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_KO },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_KO },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_KO },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_KO },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_KO },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_KO },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_KO },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_KO },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_KO },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_KO },
         { "Special 1",                OPTION_VAL_SPECIAL_1_KO },
         { "Special 2",                OPTION_VAL_SPECIAL_2_KO },
         { "Special 3",                OPTION_VAL_SPECIAL_3_KO },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_KO },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_KO },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_KO },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_KO },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_KO,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_KO,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_KO },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_KO },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_KO },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_KO },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_KO },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_KO },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_KO },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_KO },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_KO },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_KO },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_KO },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_KO },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_KO },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_KO },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_KO },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_KO },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_KO },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_KO },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_KO },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_KO },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_KO },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_KO },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_KO },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_KO },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_KO },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_KO },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_KO },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_KO },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_KO },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_KO },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_KO },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_KO },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_KO },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_KO },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_KO },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_KO },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_KO },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_KO },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_KO },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_KO },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_KO },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_KO },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_KO },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_KO },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_KO },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_KO },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_KO },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_KO },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_KO },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_KO },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_KO },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_KO },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_KO },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_KO },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_KO },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_KO },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_KO },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_KO },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_KO },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_KO },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_KO },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_KO },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_KO },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_KO },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_KO },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_KO },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_KO },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_KO },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_KO },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_KO },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_KO },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_KO },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_KO },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_KO },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_KO },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_KO },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_KO },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_KO },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_KO },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_KO },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_KO },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_KO },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_KO },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_KO },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_KO },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_KO },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_KO },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_KO },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_KO },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_KO },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_KO },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_KO },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_KO },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_KO },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_KO },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_KO },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_KO },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_KO },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_KO },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_KO },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_KO,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_KO,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_KO },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_KO },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_KO },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_KO },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_KO },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_KO },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_KO },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_KO },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_KO },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_KO },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_KO },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_KO },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_KO },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_KO },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_KO },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_KO },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_KO },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_KO },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_KO },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_KO },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_KO },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_KO },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_KO },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_KO },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_KO },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_KO },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_KO },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_KO },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_KO },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_KO },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_KO },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_KO },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_KO },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_KO },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_KO },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_KO },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_KO },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_KO },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_KO },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_KO },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_KO },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_KO },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_KO },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_KO },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_KO },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_KO },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_KO },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_KO },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_KO },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_KO },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_KO },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_KO },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_KO },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_KO },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_KO },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_KO },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_KO },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_KO },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_KO },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_KO },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_KO },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_KO },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_KO },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_KO },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_KO },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_KO },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_KO },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_KO },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_KO },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_KO },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_KO },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_KO },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_KO },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_KO },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_KO },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_KO },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_KO },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_KO },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_KO },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_KO },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_KO },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_KO },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_KO },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_KO },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_KO },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_KO },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_KO },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_KO },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_KO },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_KO },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_KO },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_KO },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_KO },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_KO },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_KO },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_KO },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_KO },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_KO },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_KO },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_KO },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_KO,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_KO,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_KO },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_KO },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_KO },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_KO },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_KO },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_KO },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_KO },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_KO },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_KO },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_KO },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_KO },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_KO },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_KO },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_KO },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_KO },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_KO },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_KO },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__KO },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_KO },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_KO },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_KO },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_KO },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_KO },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_KO },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_KO },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_KO },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_KO },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_KO },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_KO },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_KO },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_KO },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_KO },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_KO },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_KO },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_KO },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_KO },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_KO },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_KO },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_KO },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_KO },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_KO },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_KO },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_KO },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_KO },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_KO },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_KO,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_KO,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_KO },
         { "always",   OPTION_VAL_ALWAYS_KO },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_KO,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_KO,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_KO },
         { "fast",     OPTION_VAL_FAST_KO },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_KO,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_KO,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_KO },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_KO },
         { "below screen", OPTION_VAL_BELOW_SCREEN_KO },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_KO,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_KO,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_KO,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_KO,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_KO },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_KO },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_KO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_KO,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_KO,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_KO },
         { "cc",   OPTION_VAL_CC_KO },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_KO,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_KO,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_KO },
         { "GB",   OPTION_VAL_GB_KO },
         { "GBC",  OPTION_VAL_GBC_KO },
         { "GBA",  OPTION_VAL_GBA_KO },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_KO,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_KO,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_KO,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_KO,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_KO,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_KO,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_KO,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_KO,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_KO,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_KO,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_KO,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_MODE_INFO_0_KO,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_KO },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_KO },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_KO },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_KO,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_KO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_KO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ko = {
   option_cats_ko,
   option_defs_ko
};

/* RETRO_LANGUAGE_NL */

#define CATEGORY_GB_LINK_LABEL_NL NULL
#define CATEGORY_GB_LINK_INFO_0_NL NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_NL NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_NL NULL
#define OPTION_VAL_AUTO_NL "Automatisch"
#define OPTION_VAL_GBC_NL NULL
#define OPTION_VAL_SGB_NL NULL
#define OPTION_VAL_INTERNAL_NL NULL
#define OPTION_VAL_CUSTOM_NL "Aangepast"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_NL NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_NL NULL
#define OPTION_VAL_GB_DMG_NL NULL
#define OPTION_VAL_GB_POCKET_NL NULL
#define OPTION_VAL_GB_LIGHT_NL NULL
#define OPTION_VAL_GBC_BLUE_NL NULL
#define OPTION_VAL_GBC_BROWN_NL NULL
#define OPTION_VAL_GBC_DARK_BLUE_NL NULL
#define OPTION_VAL_GBC_DARK_BROWN_NL NULL
#define OPTION_VAL_GBC_DARK_GREEN_NL NULL
#define OPTION_VAL_GBC_GRAYSCALE_NL NULL
#define OPTION_VAL_GBC_GREEN_NL NULL
#define OPTION_VAL_GBC_INVERTED_NL NULL
#define OPTION_VAL_GBC_ORANGE_NL NULL
#define OPTION_VAL_GBC_PASTEL_MIX_NL NULL
#define OPTION_VAL_GBC_RED_NL NULL
#define OPTION_VAL_GBC_YELLOW_NL NULL
#define OPTION_VAL_SGB_1A_NL NULL
#define OPTION_VAL_SGB_1B_NL NULL
#define OPTION_VAL_SGB_1C_NL NULL
#define OPTION_VAL_SGB_1D_NL NULL
#define OPTION_VAL_SGB_1E_NL NULL
#define OPTION_VAL_SGB_1F_NL NULL
#define OPTION_VAL_SGB_1G_NL NULL
#define OPTION_VAL_SGB_1H_NL NULL
#define OPTION_VAL_SGB_2A_NL NULL
#define OPTION_VAL_SGB_2B_NL NULL
#define OPTION_VAL_SGB_2C_NL NULL
#define OPTION_VAL_SGB_2D_NL NULL
#define OPTION_VAL_SGB_2E_NL NULL
#define OPTION_VAL_SGB_2F_NL NULL
#define OPTION_VAL_SGB_2G_NL NULL
#define OPTION_VAL_SGB_2H_NL NULL
#define OPTION_VAL_SGB_3A_NL NULL
#define OPTION_VAL_SGB_3B_NL NULL
#define OPTION_VAL_SGB_3C_NL NULL
#define OPTION_VAL_SGB_3D_NL NULL
#define OPTION_VAL_SGB_3E_NL NULL
#define OPTION_VAL_SGB_3F_NL NULL
#define OPTION_VAL_SGB_3G_NL NULL
#define OPTION_VAL_SGB_3H_NL NULL
#define OPTION_VAL_SGB_4A_NL NULL
#define OPTION_VAL_SGB_4B_NL NULL
#define OPTION_VAL_SGB_4C_NL NULL
#define OPTION_VAL_SGB_4D_NL NULL
#define OPTION_VAL_SGB_4E_NL NULL
#define OPTION_VAL_SGB_4F_NL NULL
#define OPTION_VAL_SGB_4G_NL NULL
#define OPTION_VAL_SGB_4H_NL NULL
#define OPTION_VAL_SPECIAL_1_NL NULL
#define OPTION_VAL_SPECIAL_2_NL NULL
#define OPTION_VAL_SPECIAL_3_NL NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_NL NULL
#define OPTION_VAL_TWB64_PACK_1_NL NULL
#define OPTION_VAL_TWB64_PACK_2_NL NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_NL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_NL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_NL NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_NL NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_NL NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_NL NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_NL NULL
#define OPTION_VAL_TWB64_005_NEON_RED_NL NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_NL NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_NL NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_NL NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_NL NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_NL NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_NL NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_NL NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_NL NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_NL NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_NL NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_NL NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_NL NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_NL NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_NL NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_NL NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_NL NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_NL NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_NL NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_NL NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_NL NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_NL NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_NL NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_NL NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_NL NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_NL NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_NL NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_NL NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_NL NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_NL NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_NL NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_NL NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_NL NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_NL NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_NL NULL
#define OPTION_VAL_TWB64_040_DMG_VER_NL NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_NL NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_NL NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_NL NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_NL NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_NL NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_NL NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_NL NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_NL NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_NL NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_NL NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_NL NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_NL NULL
#define OPTION_VAL_TWB64_053_VMU_VER_NL NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_NL NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_NL NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_NL NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_NL NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_NL NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_NL NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_NL NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_NL NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_NL NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_NL NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_NL NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_NL NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_NL NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_NL NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_NL NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_NL NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_NL NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_NL NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_NL NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_NL NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_NL NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_NL NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_NL NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_NL NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_NL NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_NL NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_NL NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_NL NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_NL NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_NL NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_NL NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_NL NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_NL NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_NL NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_NL NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_NL NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_NL NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_NL NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_NL NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_NL NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_NL NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_NL NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_NL NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_NL NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_NL NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_NL NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_NL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_NL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_NL NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_NL NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_NL NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_NL NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_NL NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_NL NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_NL NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_NL NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_NL NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_NL NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_NL NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_NL NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_NL NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_NL NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_NL NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_NL NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_NL NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_NL NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_NL NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_NL NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_NL NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_NL NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_NL NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_NL NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_NL NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_NL NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_NL NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_NL NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_NL NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_NL NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_NL NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_NL NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_NL NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_NL NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_NL NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_NL NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_NL NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_NL NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_NL NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_NL NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_NL NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_NL NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_NL NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_NL NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_NL NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_NL NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_NL NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_NL NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_NL NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_NL NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_NL NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_NL NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_NL NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_NL NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_NL NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_NL NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_NL NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_NL NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_NL NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_NL NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_NL NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_NL NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_NL NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_NL NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_NL NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_NL NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_NL NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_NL NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_NL NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_NL NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_NL NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_NL NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_NL NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_NL NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_NL NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_NL NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_NL NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_NL NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_NL NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_NL NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_NL NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_NL NULL
#define OPTION_VAL_TWB64_182_PINK109_NL NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_NL NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_NL NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_NL NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_NL NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_NL NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_NL NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_NL NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_NL NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_NL NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_NL NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_NL NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_NL NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_NL NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_NL NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_NL NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_NL NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_NL NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_NL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_NL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_NL NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_NL NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_NL NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_NL NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_NL NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_NL NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_NL NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_NL NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_NL NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_NL NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_NL NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_NL NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_NL NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_NL NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_NL NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_NL NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_NL NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_NL NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__NL NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_NL NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_NL NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_NL NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_NL NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_NL NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_NL NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_NL NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_NL NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_NL NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_NL NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_NL NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_NL NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_NL NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_NL NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_NL NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_NL NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_NL NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_NL NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_NL NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_NL NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_NL NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_NL NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_NL NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_NL NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_NL NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_NL NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_NL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_NL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_NL NULL
#define OPTION_VAL_GBC_ONLY_NL NULL
#define OPTION_VAL_ALWAYS_NL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_NL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_NL NULL
#define OPTION_VAL_ACCURATE_NL NULL
#define OPTION_VAL_FAST_NL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_NL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_NL NULL
#define OPTION_VAL_CENTRAL_NL NULL
#define OPTION_VAL_ABOVE_SCREEN_NL NULL
#define OPTION_VAL_BELOW_SCREEN_NL NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_NL NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_NL NULL
#define GAMBATTE_MIX_FRAMES_LABEL_NL NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_NL NULL
#define OPTION_VAL_MIX_NL NULL
#define OPTION_VAL_LCD_GHOSTING_NL NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_NL NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_NL NULL
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_NL NULL
#define OPTION_VAL_SINC_NL NULL
#define OPTION_VAL_CC_NL NULL
#define GAMBATTE_GB_HWMODE_LABEL_NL NULL
#define GAMBATTE_GB_HWMODE_INFO_0_NL NULL
#define OPTION_VAL_GB_NL NULL
#define OPTION_VAL_GBA_NL NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_NL NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_NL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_NL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_NL NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_NL NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_NL NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_NL NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_NL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_NL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_NL NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_NL NULL
#define OPTION_VAL_NOT_CONNECTED_NL NULL
#define OPTION_VAL_NETWORK_SERVER_NL NULL
#define OPTION_VAL_NETWORK_CLIENT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_NL "Poort"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_NL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_NL NULL

struct retro_core_option_v2_category option_cats_nl[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_NL,
      CATEGORY_GB_LINK_INFO_0_NL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_nl[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_NL,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_NL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_NL },
         { "GBC",      OPTION_VAL_GBC_NL },
         { "SGB",      OPTION_VAL_SGB_NL },
         { "internal", OPTION_VAL_INTERNAL_NL },
         { "custom",   OPTION_VAL_CUSTOM_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_NL,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_NL,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_NL },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_NL },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_NL },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_NL },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_NL },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_NL },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_NL },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_NL },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_NL },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_NL },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_NL },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_NL },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_NL },
         { "GBC - Red",                OPTION_VAL_GBC_RED_NL },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_NL },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_NL },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_NL },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_NL },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_NL },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_NL },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_NL },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_NL },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_NL },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_NL },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_NL },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_NL },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_NL },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_NL },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_NL },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_NL },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_NL },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_NL },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_NL },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_NL },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_NL },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_NL },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_NL },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_NL },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_NL },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_NL },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_NL },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_NL },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_NL },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_NL },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_NL },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_NL },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_NL },
         { "Special 1",                OPTION_VAL_SPECIAL_1_NL },
         { "Special 2",                OPTION_VAL_SPECIAL_2_NL },
         { "Special 3",                OPTION_VAL_SPECIAL_3_NL },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_NL },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_NL },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_NL },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_NL },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_NL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_NL,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_NL },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_NL },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_NL },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_NL },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_NL },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_NL },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_NL },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_NL },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_NL },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_NL },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_NL },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_NL },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_NL },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_NL },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_NL },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_NL },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_NL },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_NL },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_NL },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_NL },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_NL },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_NL },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_NL },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_NL },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_NL },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_NL },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_NL },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_NL },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_NL },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_NL },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_NL },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_NL },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_NL },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_NL },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_NL },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_NL },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_NL },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_NL },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_NL },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_NL },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_NL },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_NL },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_NL },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_NL },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_NL },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_NL },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_NL },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_NL },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_NL },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_NL },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_NL },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_NL },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_NL },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_NL },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_NL },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_NL },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_NL },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_NL },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_NL },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_NL },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_NL },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_NL },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_NL },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_NL },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_NL },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_NL },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_NL },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_NL },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_NL },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_NL },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_NL },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_NL },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_NL },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_NL },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_NL },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_NL },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_NL },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_NL },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_NL },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_NL },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_NL },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_NL },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_NL },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_NL },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_NL },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_NL },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_NL },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_NL },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_NL },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_NL },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_NL },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_NL },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_NL },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_NL },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_NL },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_NL },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_NL },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_NL },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_NL },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_NL },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_NL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_NL,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_NL },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_NL },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_NL },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_NL },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_NL },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_NL },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_NL },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_NL },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_NL },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_NL },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_NL },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_NL },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_NL },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_NL },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_NL },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_NL },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_NL },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_NL },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_NL },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_NL },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_NL },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_NL },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_NL },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_NL },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_NL },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_NL },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_NL },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_NL },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_NL },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_NL },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_NL },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_NL },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_NL },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_NL },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_NL },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_NL },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_NL },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_NL },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_NL },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_NL },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_NL },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_NL },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_NL },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_NL },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_NL },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_NL },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_NL },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_NL },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_NL },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_NL },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_NL },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_NL },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_NL },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_NL },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_NL },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_NL },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_NL },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_NL },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_NL },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_NL },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_NL },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_NL },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_NL },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_NL },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_NL },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_NL },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_NL },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_NL },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_NL },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_NL },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_NL },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_NL },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_NL },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_NL },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_NL },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_NL },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_NL },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_NL },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_NL },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_NL },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_NL },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_NL },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_NL },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_NL },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_NL },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_NL },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_NL },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_NL },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_NL },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_NL },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_NL },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_NL },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_NL },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_NL },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_NL },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_NL },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_NL },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_NL },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_NL },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_NL },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_NL,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_NL,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_NL },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_NL },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_NL },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_NL },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_NL },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_NL },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_NL },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_NL },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_NL },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_NL },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_NL },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_NL },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_NL },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_NL },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_NL },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_NL },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_NL },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__NL },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_NL },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_NL },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_NL },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_NL },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_NL },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_NL },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_NL },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_NL },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_NL },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_NL },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_NL },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_NL },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_NL },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_NL },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_NL },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_NL },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_NL },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_NL },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_NL },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_NL },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_NL },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_NL },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_NL },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_NL },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_NL },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_NL },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_NL },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_NL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_NL,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_NL },
         { "always",   OPTION_VAL_ALWAYS_NL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_NL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_NL,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_NL },
         { "fast",     OPTION_VAL_FAST_NL },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_NL,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_NL,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_NL },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_NL },
         { "below screen", OPTION_VAL_BELOW_SCREEN_NL },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_NL,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_NL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_NL,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_NL,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_NL },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_NL },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_NL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_NL,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_NL,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_NL },
         { "cc",   OPTION_VAL_CC_NL },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_NL,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_NL,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_NL },
         { "GB",   OPTION_VAL_GB_NL },
         { "GBC",  OPTION_VAL_GBC_NL },
         { "GBA",  OPTION_VAL_GBA_NL },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_NL,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_NL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_NL,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_NL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_NL,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_NL,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_NL,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_NL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_NL,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_NL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_NL,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_MODE_INFO_0_NL,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_NL },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_NL },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_NL },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_NL,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_NL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_NL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_nl = {
   option_cats_nl,
   option_defs_nl
};

/* RETRO_LANGUAGE_NO */

#define CATEGORY_GB_LINK_LABEL_NO NULL
#define CATEGORY_GB_LINK_INFO_0_NO NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_NO NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_NO NULL
#define OPTION_VAL_AUTO_NO NULL
#define OPTION_VAL_GBC_NO NULL
#define OPTION_VAL_SGB_NO NULL
#define OPTION_VAL_INTERNAL_NO NULL
#define OPTION_VAL_CUSTOM_NO NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_NO NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_NO NULL
#define OPTION_VAL_GB_DMG_NO NULL
#define OPTION_VAL_GB_POCKET_NO NULL
#define OPTION_VAL_GB_LIGHT_NO NULL
#define OPTION_VAL_GBC_BLUE_NO NULL
#define OPTION_VAL_GBC_BROWN_NO NULL
#define OPTION_VAL_GBC_DARK_BLUE_NO NULL
#define OPTION_VAL_GBC_DARK_BROWN_NO NULL
#define OPTION_VAL_GBC_DARK_GREEN_NO NULL
#define OPTION_VAL_GBC_GRAYSCALE_NO NULL
#define OPTION_VAL_GBC_GREEN_NO NULL
#define OPTION_VAL_GBC_INVERTED_NO NULL
#define OPTION_VAL_GBC_ORANGE_NO NULL
#define OPTION_VAL_GBC_PASTEL_MIX_NO NULL
#define OPTION_VAL_GBC_RED_NO NULL
#define OPTION_VAL_GBC_YELLOW_NO NULL
#define OPTION_VAL_SGB_1A_NO NULL
#define OPTION_VAL_SGB_1B_NO NULL
#define OPTION_VAL_SGB_1C_NO NULL
#define OPTION_VAL_SGB_1D_NO NULL
#define OPTION_VAL_SGB_1E_NO NULL
#define OPTION_VAL_SGB_1F_NO NULL
#define OPTION_VAL_SGB_1G_NO NULL
#define OPTION_VAL_SGB_1H_NO NULL
#define OPTION_VAL_SGB_2A_NO NULL
#define OPTION_VAL_SGB_2B_NO NULL
#define OPTION_VAL_SGB_2C_NO NULL
#define OPTION_VAL_SGB_2D_NO NULL
#define OPTION_VAL_SGB_2E_NO NULL
#define OPTION_VAL_SGB_2F_NO NULL
#define OPTION_VAL_SGB_2G_NO NULL
#define OPTION_VAL_SGB_2H_NO NULL
#define OPTION_VAL_SGB_3A_NO NULL
#define OPTION_VAL_SGB_3B_NO NULL
#define OPTION_VAL_SGB_3C_NO NULL
#define OPTION_VAL_SGB_3D_NO NULL
#define OPTION_VAL_SGB_3E_NO NULL
#define OPTION_VAL_SGB_3F_NO NULL
#define OPTION_VAL_SGB_3G_NO NULL
#define OPTION_VAL_SGB_3H_NO NULL
#define OPTION_VAL_SGB_4A_NO NULL
#define OPTION_VAL_SGB_4B_NO NULL
#define OPTION_VAL_SGB_4C_NO NULL
#define OPTION_VAL_SGB_4D_NO NULL
#define OPTION_VAL_SGB_4E_NO NULL
#define OPTION_VAL_SGB_4F_NO NULL
#define OPTION_VAL_SGB_4G_NO NULL
#define OPTION_VAL_SGB_4H_NO NULL
#define OPTION_VAL_SPECIAL_1_NO NULL
#define OPTION_VAL_SPECIAL_2_NO NULL
#define OPTION_VAL_SPECIAL_3_NO NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_NO NULL
#define OPTION_VAL_TWB64_PACK_1_NO NULL
#define OPTION_VAL_TWB64_PACK_2_NO NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_NO NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_NO NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_NO NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_NO NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_NO NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_NO NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_NO NULL
#define OPTION_VAL_TWB64_005_NEON_RED_NO NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_NO NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_NO NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_NO NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_NO NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_NO NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_NO NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_NO NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_NO NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_NO NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_NO NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_NO NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_NO NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_NO NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_NO NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_NO NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_NO NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_NO NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_NO NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_NO NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_NO NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_NO NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_NO NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_NO NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_NO NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_NO NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_NO NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_NO NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_NO NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_NO NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_NO NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_NO NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_NO NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_NO NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_NO NULL
#define OPTION_VAL_TWB64_040_DMG_VER_NO NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_NO NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_NO NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_NO NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_NO NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_NO NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_NO NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_NO NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_NO NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_NO NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_NO NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_NO NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_NO NULL
#define OPTION_VAL_TWB64_053_VMU_VER_NO NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_NO NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_NO NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_NO NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_NO NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_NO NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_NO NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_NO NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_NO NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_NO NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_NO NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_NO NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_NO NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_NO NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_NO NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_NO NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_NO NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_NO NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_NO NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_NO NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_NO NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_NO NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_NO NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_NO NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_NO NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_NO NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_NO NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_NO NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_NO NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_NO NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_NO NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_NO NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_NO NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_NO NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_NO NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_NO NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_NO NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_NO NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_NO NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_NO NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_NO NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_NO NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_NO NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_NO NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_NO NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_NO NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_NO NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_NO NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_NO NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_NO NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_NO NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_NO NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_NO NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_NO NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_NO NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_NO NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_NO NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_NO NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_NO NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_NO NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_NO NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_NO NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_NO NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_NO NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_NO NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_NO NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_NO NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_NO NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_NO NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_NO NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_NO NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_NO NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_NO NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_NO NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_NO NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_NO NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_NO NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_NO NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_NO NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_NO NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_NO NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_NO NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_NO NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_NO NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_NO NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_NO NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_NO NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_NO NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_NO NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_NO NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_NO NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_NO NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_NO NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_NO NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_NO NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_NO NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_NO NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_NO NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_NO NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_NO NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_NO NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_NO NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_NO NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_NO NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_NO NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_NO NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_NO NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_NO NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_NO NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_NO NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_NO NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_NO NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_NO NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_NO NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_NO NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_NO NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_NO NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_NO NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_NO NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_NO NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_NO NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_NO NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_NO NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_NO NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_NO NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_NO NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_NO NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_NO NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_NO NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_NO NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_NO NULL
#define OPTION_VAL_TWB64_182_PINK109_NO NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_NO NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_NO NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_NO NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_NO NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_NO NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_NO NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_NO NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_NO NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_NO NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_NO NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_NO NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_NO NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_NO NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_NO NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_NO NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_NO NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_NO NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_NO NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_NO NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_NO NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_NO NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_NO NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_NO NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_NO NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_NO NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_NO NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_NO NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_NO NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_NO NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_NO NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_NO NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_NO NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_NO NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_NO NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_NO NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_NO NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_NO NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__NO NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_NO NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_NO NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_NO NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_NO NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_NO NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_NO NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_NO NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_NO NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_NO NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_NO NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_NO NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_NO NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_NO NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_NO NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_NO NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_NO NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_NO NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_NO NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_NO NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_NO NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_NO NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_NO NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_NO NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_NO NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_NO NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_NO NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_NO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_NO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_NO NULL
#define OPTION_VAL_GBC_ONLY_NO NULL
#define OPTION_VAL_ALWAYS_NO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_NO NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_NO NULL
#define OPTION_VAL_ACCURATE_NO NULL
#define OPTION_VAL_FAST_NO NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_NO NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_NO NULL
#define OPTION_VAL_CENTRAL_NO NULL
#define OPTION_VAL_ABOVE_SCREEN_NO NULL
#define OPTION_VAL_BELOW_SCREEN_NO NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_NO NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_NO NULL
#define GAMBATTE_MIX_FRAMES_LABEL_NO NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_NO NULL
#define OPTION_VAL_MIX_NO NULL
#define OPTION_VAL_LCD_GHOSTING_NO NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_NO NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_NO "Lyd samplingsfrekvens-konverterer"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_NO NULL
#define OPTION_VAL_SINC_NO NULL
#define OPTION_VAL_CC_NO NULL
#define GAMBATTE_GB_HWMODE_LABEL_NO NULL
#define GAMBATTE_GB_HWMODE_INFO_0_NO NULL
#define OPTION_VAL_GB_NO NULL
#define OPTION_VAL_GBA_NO NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_NO NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_NO NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_NO NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_NO NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_NO NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_NO NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_NO NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_NO NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_NO NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_NO NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_NO NULL
#define OPTION_VAL_NOT_CONNECTED_NO NULL
#define OPTION_VAL_NETWORK_SERVER_NO NULL
#define OPTION_VAL_NETWORK_CLIENT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_NO NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_NO NULL

struct retro_core_option_v2_category option_cats_no[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_NO,
      CATEGORY_GB_LINK_INFO_0_NO
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_no[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_NO,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_NO,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_NO },
         { "GBC",      OPTION_VAL_GBC_NO },
         { "SGB",      OPTION_VAL_SGB_NO },
         { "internal", OPTION_VAL_INTERNAL_NO },
         { "custom",   OPTION_VAL_CUSTOM_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_NO,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_NO,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_NO },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_NO },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_NO },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_NO },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_NO },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_NO },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_NO },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_NO },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_NO },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_NO },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_NO },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_NO },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_NO },
         { "GBC - Red",                OPTION_VAL_GBC_RED_NO },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_NO },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_NO },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_NO },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_NO },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_NO },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_NO },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_NO },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_NO },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_NO },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_NO },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_NO },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_NO },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_NO },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_NO },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_NO },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_NO },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_NO },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_NO },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_NO },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_NO },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_NO },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_NO },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_NO },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_NO },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_NO },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_NO },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_NO },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_NO },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_NO },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_NO },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_NO },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_NO },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_NO },
         { "Special 1",                OPTION_VAL_SPECIAL_1_NO },
         { "Special 2",                OPTION_VAL_SPECIAL_2_NO },
         { "Special 3",                OPTION_VAL_SPECIAL_3_NO },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_NO },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_NO },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_NO },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_NO },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_NO,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_NO,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_NO },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_NO },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_NO },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_NO },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_NO },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_NO },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_NO },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_NO },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_NO },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_NO },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_NO },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_NO },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_NO },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_NO },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_NO },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_NO },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_NO },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_NO },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_NO },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_NO },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_NO },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_NO },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_NO },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_NO },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_NO },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_NO },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_NO },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_NO },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_NO },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_NO },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_NO },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_NO },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_NO },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_NO },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_NO },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_NO },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_NO },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_NO },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_NO },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_NO },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_NO },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_NO },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_NO },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_NO },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_NO },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_NO },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_NO },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_NO },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_NO },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_NO },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_NO },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_NO },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_NO },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_NO },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_NO },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_NO },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_NO },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_NO },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_NO },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_NO },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_NO },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_NO },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_NO },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_NO },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_NO },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_NO },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_NO },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_NO },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_NO },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_NO },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_NO },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_NO },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_NO },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_NO },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_NO },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_NO },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_NO },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_NO },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_NO },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_NO },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_NO },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_NO },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_NO },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_NO },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_NO },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_NO },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_NO },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_NO },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_NO },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_NO },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_NO },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_NO },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_NO },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_NO },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_NO },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_NO },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_NO },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_NO },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_NO },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_NO },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_NO,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_NO,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_NO },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_NO },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_NO },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_NO },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_NO },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_NO },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_NO },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_NO },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_NO },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_NO },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_NO },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_NO },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_NO },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_NO },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_NO },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_NO },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_NO },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_NO },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_NO },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_NO },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_NO },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_NO },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_NO },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_NO },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_NO },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_NO },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_NO },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_NO },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_NO },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_NO },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_NO },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_NO },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_NO },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_NO },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_NO },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_NO },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_NO },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_NO },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_NO },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_NO },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_NO },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_NO },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_NO },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_NO },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_NO },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_NO },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_NO },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_NO },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_NO },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_NO },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_NO },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_NO },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_NO },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_NO },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_NO },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_NO },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_NO },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_NO },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_NO },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_NO },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_NO },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_NO },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_NO },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_NO },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_NO },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_NO },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_NO },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_NO },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_NO },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_NO },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_NO },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_NO },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_NO },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_NO },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_NO },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_NO },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_NO },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_NO },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_NO },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_NO },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_NO },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_NO },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_NO },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_NO },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_NO },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_NO },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_NO },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_NO },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_NO },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_NO },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_NO },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_NO },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_NO },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_NO },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_NO },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_NO },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_NO },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_NO },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_NO },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_NO },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_NO,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_NO,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_NO },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_NO },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_NO },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_NO },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_NO },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_NO },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_NO },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_NO },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_NO },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_NO },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_NO },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_NO },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_NO },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_NO },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_NO },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_NO },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_NO },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__NO },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_NO },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_NO },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_NO },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_NO },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_NO },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_NO },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_NO },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_NO },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_NO },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_NO },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_NO },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_NO },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_NO },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_NO },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_NO },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_NO },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_NO },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_NO },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_NO },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_NO },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_NO },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_NO },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_NO },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_NO },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_NO },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_NO },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_NO },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_NO,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_NO,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_NO },
         { "always",   OPTION_VAL_ALWAYS_NO },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_NO,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_NO,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_NO },
         { "fast",     OPTION_VAL_FAST_NO },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_NO,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_NO,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_NO },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_NO },
         { "below screen", OPTION_VAL_BELOW_SCREEN_NO },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_NO,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_NO,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_NO,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_NO,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_NO },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_NO },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_NO },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_NO,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_NO,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_NO },
         { "cc",   OPTION_VAL_CC_NO },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_NO,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_NO,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_NO },
         { "GB",   OPTION_VAL_GB_NO },
         { "GBC",  OPTION_VAL_GBC_NO },
         { "GBA",  OPTION_VAL_GBA_NO },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_NO,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_NO,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_NO,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_NO,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_NO,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_NO,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_NO,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_NO,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_NO,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_NO,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_NO,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_MODE_INFO_0_NO,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_NO },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_NO },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_NO },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_NO,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_NO,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_NO,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_no = {
   option_cats_no,
   option_defs_no
};

/* RETRO_LANGUAGE_PL */

#define CATEGORY_GB_LINK_LABEL_PL "Link do gry"
#define CATEGORY_GB_LINK_INFO_0_PL NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_PL "Koloryzacja GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_PL NULL
#define OPTION_VAL_AUTO_PL "Automatyczny"
#define OPTION_VAL_GBC_PL NULL
#define OPTION_VAL_SGB_PL NULL
#define OPTION_VAL_INTERNAL_PL "Wewnętrzna"
#define OPTION_VAL_CUSTOM_PL "Niestandardowy"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_PL "Paleta wewnętrzna"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_PL NULL
#define OPTION_VAL_GB_DMG_PL NULL
#define OPTION_VAL_GB_POCKET_PL NULL
#define OPTION_VAL_GB_LIGHT_PL "GB - Lekki"
#define OPTION_VAL_GBC_BLUE_PL "GBC - Niebieski"
#define OPTION_VAL_GBC_BROWN_PL "GBC - Brązowy"
#define OPTION_VAL_GBC_DARK_BLUE_PL "GBC - Ciemnoniebieski"
#define OPTION_VAL_GBC_DARK_BROWN_PL "GBC - Ciemno brązowy"
#define OPTION_VAL_GBC_DARK_GREEN_PL "GBC - Ciemno zielony"
#define OPTION_VAL_GBC_GRAYSCALE_PL "GBC - Skala szarości"
#define OPTION_VAL_GBC_GREEN_PL "GBC - Zielony"
#define OPTION_VAL_GBC_INVERTED_PL "GBC - Odwrócone"
#define OPTION_VAL_GBC_ORANGE_PL "GBC - Pomarańczowy"
#define OPTION_VAL_GBC_PASTEL_MIX_PL NULL
#define OPTION_VAL_GBC_RED_PL "GBC - Czerwony"
#define OPTION_VAL_GBC_YELLOW_PL "GBC - Żółty"
#define OPTION_VAL_SGB_1A_PL NULL
#define OPTION_VAL_SGB_1B_PL NULL
#define OPTION_VAL_SGB_1C_PL NULL
#define OPTION_VAL_SGB_1D_PL NULL
#define OPTION_VAL_SGB_1E_PL NULL
#define OPTION_VAL_SGB_1F_PL NULL
#define OPTION_VAL_SGB_1G_PL NULL
#define OPTION_VAL_SGB_1H_PL NULL
#define OPTION_VAL_SGB_2A_PL NULL
#define OPTION_VAL_SGB_2B_PL NULL
#define OPTION_VAL_SGB_2C_PL NULL
#define OPTION_VAL_SGB_2D_PL NULL
#define OPTION_VAL_SGB_2E_PL NULL
#define OPTION_VAL_SGB_2F_PL NULL
#define OPTION_VAL_SGB_2G_PL NULL
#define OPTION_VAL_SGB_2H_PL NULL
#define OPTION_VAL_SGB_3A_PL NULL
#define OPTION_VAL_SGB_3B_PL NULL
#define OPTION_VAL_SGB_3C_PL NULL
#define OPTION_VAL_SGB_3D_PL NULL
#define OPTION_VAL_SGB_3E_PL NULL
#define OPTION_VAL_SGB_3F_PL NULL
#define OPTION_VAL_SGB_3G_PL NULL
#define OPTION_VAL_SGB_3H_PL NULL
#define OPTION_VAL_SGB_4A_PL NULL
#define OPTION_VAL_SGB_4B_PL NULL
#define OPTION_VAL_SGB_4C_PL NULL
#define OPTION_VAL_SGB_4D_PL NULL
#define OPTION_VAL_SGB_4E_PL NULL
#define OPTION_VAL_SGB_4F_PL NULL
#define OPTION_VAL_SGB_4G_PL NULL
#define OPTION_VAL_SGB_4H_PL NULL
#define OPTION_VAL_SPECIAL_1_PL "Specjalny 1"
#define OPTION_VAL_SPECIAL_2_PL "Specjalny 2"
#define OPTION_VAL_SPECIAL_3_PL "Specjalny 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_PL "Specjalny 4 (TI-83 Legacy)"
#define OPTION_VAL_TWB64_PACK_1_PL NULL
#define OPTION_VAL_TWB64_PACK_2_PL NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_PL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_PL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_PL "Wybiera wewnętrzną paletę kolorów, gdy 'Wewnętrzna paleta' jest ustawiona na 'TWB64 - Pack 1'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_PL NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_PL NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_PL "TWB64 003 - Żółty SpongeBob"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_PL NULL
#define OPTION_VAL_TWB64_005_NEON_RED_PL NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_PL NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_PL NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_PL NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_PL NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_PL NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_PL NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_PL NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_PL NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_PL NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_PL NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_PL NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_PL NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_PL NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_PL NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_PL NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_PL NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_PL NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_PL NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_PL NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_PL NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_PL NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_PL NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_PL NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_PL NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_PL NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_PL NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_PL NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_PL NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_PL NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_PL NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_PL NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_PL NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_PL NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_PL NULL
#define OPTION_VAL_TWB64_040_DMG_VER_PL NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_PL NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_PL NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_PL NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_PL NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_PL NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_PL NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_PL NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_PL NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_PL NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_PL NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_PL NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_PL NULL
#define OPTION_VAL_TWB64_053_VMU_VER_PL NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_PL NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_PL NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_PL NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_PL NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_PL NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_PL NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_PL NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_PL NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_PL NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_PL NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_PL NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_PL NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_PL NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_PL NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_PL NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_PL NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_PL NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_PL NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_PL NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_PL NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_PL NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_PL NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_PL NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_PL NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_PL NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_PL NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_PL NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_PL NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_PL NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_PL NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_PL NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_PL NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_PL NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_PL NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_PL NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_PL NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_PL NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_PL NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_PL NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_PL NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_PL NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_PL NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_PL NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_PL NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_PL NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_PL NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_PL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_PL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_PL "Wybiera wewnętrzną paletę kolorów, gdy 'Wewnętrzna paleta' jest ustawiona na 'TWB64 - Pack 2'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_PL NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_PL NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_PL NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_PL NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_PL NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_PL NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_PL NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_PL NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_PL NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_PL NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_PL NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_PL NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_PL NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_PL NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_PL NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_PL NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_PL NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_PL NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_PL NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_PL NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_PL NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_PL NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_PL NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_PL NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_PL NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_PL NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_PL NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_PL NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_PL NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_PL NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_PL NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_PL NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_PL "TWB64 133 – Wizja księżycowa"
#define OPTION_VAL_TWB64_134_TOKYO_RED_PL NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_PL "TWB64 135 – Złoto paryskie"
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_PL NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_PL NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_PL "TWB64 138 – irlandzki zielony"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_PL "TWB64 139 - Kakarot Pomarańczowy"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_PL "TWB64 140 - Smocza Piłka pomarańczowa"
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_PL NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_PL NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_PL NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_PL NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_PL NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_PL NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_PL NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_PL NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_PL NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_PL NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_PL NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_PL NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_PL NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_PL NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_PL NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_PL NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_PL NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_PL NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_PL NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_PL NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_PL NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_PL NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_PL NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_PL NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_PL NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_PL NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_PL NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_PL NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_PL NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_PL NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_PL NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_PL NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_PL NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_PL NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_PL NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_PL NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_PL NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_PL NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_PL NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_PL NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_PL NULL
#define OPTION_VAL_TWB64_182_PINK109_PL NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_PL NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_PL NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_PL "TWB64 185 - Pomarańczowy Rockstar"
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_PL NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_PL NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_PL NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_PL NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_PL NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_PL "TWB64 191 - Złoto Demona"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_PL NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_PL NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_PL NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_PL NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_PL "TWB64 196 - Fiolet jeździecki"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_PL NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_PL NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_PL NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_PL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_PL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_PL NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_PL NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_PL NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_PL NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_PL NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_PL NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_PL NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_PL NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_PL NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_PL NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_PL NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_PL NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_PL NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_PL NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_PL NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_PL NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_PL NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_PL NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__PL NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_PL NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_PL NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_PL NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_PL NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_PL NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_PL NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_PL NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_PL NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_PL NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_PL NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_PL NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_PL NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_PL NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_PL NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_PL NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_PL NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_PL NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_PL NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_PL NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_PL NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_PL NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_PL NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_PL NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_PL NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_PL NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_PL NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_PL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_PL "Korekcja kolorów"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_PL "Dostosowuje kolory wyjściowe, aby pasowały do wyświetlania prawdziwego urządzenia Game Boy Color. 'Tylko GBC' zapewnia, że korekta będzie stosowana tylko podczas grania w Game Boy Color lub podczas używania palety kolorów Game Boy Boy Color do kolorowania gry Game Boy. 'Zawsze' stosuje korektę kolorów do wszystkich treści i przyniesie niespodziewane / nieoptymalne wyniki podczas używania wewnętrznych palet kolorów 'GB' lub 'SGB'."
#define OPTION_VAL_GBC_ONLY_PL "Tylko GBC"
#define OPTION_VAL_ALWAYS_PL "Zawsze"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_PL "Tryb korekcji kolorów"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_PL "Określa metodę używaną przy korekcji kolorów. \"Dokładność\" wytwarza dane wyjściowe prawie niepodzielne z prawdziwego panelu LCD-u Game Boy Color. 'Szybko' tylko ciemni kolory i zmniejsza nasycenie i może być użyty na sprzęcie niskiej klasy jeśli metoda 'dokładności' jest zbyt wolna."
#define OPTION_VAL_ACCURATE_PL "Dokładny"
#define OPTION_VAL_FAST_PL "Szybko"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_PL "Korekcja kolorów - Pozycja światła głównego"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_PL "Symuluje reakcję fizyczną panelu LCD koloru Game Boy Color LCD podświetlonego pod różnymi kątami. „Centralny” reprezentuje standardową reprodukcję kolorów. 'Powyżej ekranu' zwiększa jasność. 'Poniżej ekranu' zmniejsza jasność. To ustawienie ma zastosowanie tylko wtedy, gdy 'Tryb korekcji kolorów' jest ustawiony na 'dokładny'."
#define OPTION_VAL_CENTRAL_PL "Centralny"
#define OPTION_VAL_ABOVE_SCREEN_PL "Powyżej ekranu"
#define OPTION_VAL_BELOW_SCREEN_PL "Poniżej ekranu"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_PL "Poziom ciemnego filtra (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_PL "Włącz zmniejszenie jasności oparte na luminancji. Może być stosowany w celu uniknięcia kontaktu z oczami podczas grania w gry z białymi tłami, które są przeznaczone do wyświetlania na niepodświetlonym kolorze Chłopiec z gry, i w związku z tym mogą wydawać się niewygodnie jasne, gdy są oglądane na nowoczesnym ekranie z tyłu."
#define GAMBATTE_MIX_FRAMES_LABEL_PL "Łączenie międzyramowe"
#define GAMBATTE_MIX_FRAMES_INFO_0_PL "Symuluje efekty duchowe LCD. 'Proste' wykonuje mieszankę 50:50 bieżących i poprzednich ramek. \"LCD Ghosting\" naśladuje naturalne czasy reakcji LCD przez połączenie wielu zbuforowanych ram. \"Proste\" mieszanie jest wymagane podczas grania w gry, które polegają na duchach LCD dla efektów przezroczystości (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_PL "Prosty"
#define OPTION_VAL_LCD_GHOSTING_PL "Ghosting LCD (dokładny)"
#define OPTION_VAL_LCD_GHOSTING_FAST_PL "LCD Ghosting (szybki)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_PL "Resampler dźwięku"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_PL NULL
#define OPTION_VAL_SINC_PL NULL
#define OPTION_VAL_CC_PL NULL
#define GAMBATTE_GB_HWMODE_LABEL_PL "Emulacja sprzętowa (wymagany restart)"
#define GAMBATTE_GB_HWMODE_INFO_0_PL NULL
#define OPTION_VAL_GB_PL NULL
#define OPTION_VAL_GBA_PL NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_PL NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_PL "Włącz wsparcie dla oficjalnych bootloaderów Game Boy i Game Boy Color, z odpowiednimi animacjami logo startu."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_PL "Zezwalaj na przeciwne kierunki"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_PL NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_PL "Okres przycisków Turbo"
#define GAMBATTE_TURBO_PERIOD_INFO_0_PL NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_PL NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_PL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_PL "Pokaż ustawienia linku do gry"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_PL "Włącz konfigurację sieciowego łącza do gry (wieloosobowej). UWAGA: Szybkie menu może wymagać przełączania, aby to ustawienie zaczęło obowiązywać."
#define GAMBATTE_GB_LINK_MODE_LABEL_PL "Tryb łącza do gry"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_PL "Tryb linku"
#define GAMBATTE_GB_LINK_MODE_INFO_0_PL NULL
#define OPTION_VAL_NOT_CONNECTED_PL "Nie połączono"
#define OPTION_VAL_NETWORK_SERVER_PL "Serwer sieciowy"
#define OPTION_VAL_NETWORK_CLIENT_PL "Klient sieci"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_PL "Port łącza sieciowego"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_PL "Adres serwera łącza sieciowego, Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_PL "Adres serwera 01: x__.___.___.___ _"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_PL "Adres serwera łącza sieciowego, Pt. 02: _x_.___.___.___ _"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_PL "Adres serwera 02: _x_.___.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_PL "Adres serwera łącza sieciowego, Pt. 03: __x.___.___.___ _"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_PL "Adres serwera 03: __x.___.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_PL "Adres serwera łącza sieciowego, Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_PL "Adres serwera łącza sieciowego, Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_PL "Adres serwera łącza sieciowego, Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_PL "Adres serwera 05: ___._x_.___.___ _"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_PL "Adres serwera łącza sieciowego, Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_PL "Adres serwera 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_PL "Adres serwera łącza sieciowego, Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_PL "Adres serwera 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_PL "Adres serwera łącza sieciowego, Pt. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_PL "Adres serwera 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_PL "Adres serwera łącza sieciowego, Pt. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_PL "Adres serwera 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_PL "Adres serwera łącza sieciowego, Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_PL "Adres serwera Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_PL "Adres serwera łącza sieciowego, Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_PL "Adres serwera Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_PL "Adres serwera łącza sieciowego, Pt. 12: ___.___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_PL "Adres serwera Pt. 12: ___.___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_PL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_PL NULL

struct retro_core_option_v2_category option_cats_pl[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_PL,
      CATEGORY_GB_LINK_INFO_0_PL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_pl[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_PL,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_PL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_PL },
         { "GBC",      OPTION_VAL_GBC_PL },
         { "SGB",      OPTION_VAL_SGB_PL },
         { "internal", OPTION_VAL_INTERNAL_PL },
         { "custom",   OPTION_VAL_CUSTOM_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_PL,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_PL,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_PL },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_PL },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_PL },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_PL },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_PL },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_PL },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_PL },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_PL },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_PL },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_PL },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_PL },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_PL },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_PL },
         { "GBC - Red",                OPTION_VAL_GBC_RED_PL },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_PL },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_PL },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_PL },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_PL },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_PL },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_PL },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_PL },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_PL },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_PL },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_PL },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_PL },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_PL },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_PL },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_PL },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_PL },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_PL },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_PL },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_PL },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_PL },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_PL },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_PL },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_PL },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_PL },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_PL },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_PL },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_PL },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_PL },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_PL },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_PL },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_PL },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_PL },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_PL },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_PL },
         { "Special 1",                OPTION_VAL_SPECIAL_1_PL },
         { "Special 2",                OPTION_VAL_SPECIAL_2_PL },
         { "Special 3",                OPTION_VAL_SPECIAL_3_PL },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_PL },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_PL },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_PL },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_PL },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_PL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_PL,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_PL },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_PL },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_PL },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_PL },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_PL },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_PL },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_PL },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_PL },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_PL },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_PL },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_PL },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_PL },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_PL },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_PL },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_PL },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_PL },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_PL },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_PL },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_PL },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_PL },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_PL },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_PL },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_PL },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_PL },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_PL },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_PL },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_PL },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_PL },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_PL },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_PL },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_PL },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_PL },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_PL },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_PL },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_PL },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_PL },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_PL },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_PL },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_PL },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_PL },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_PL },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_PL },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_PL },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_PL },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_PL },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_PL },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_PL },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_PL },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_PL },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_PL },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_PL },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_PL },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_PL },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_PL },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_PL },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_PL },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_PL },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_PL },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_PL },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_PL },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_PL },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_PL },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_PL },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_PL },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_PL },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_PL },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_PL },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_PL },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_PL },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_PL },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_PL },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_PL },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_PL },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_PL },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_PL },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_PL },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_PL },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_PL },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_PL },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_PL },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_PL },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_PL },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_PL },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_PL },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_PL },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_PL },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_PL },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_PL },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_PL },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_PL },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_PL },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_PL },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_PL },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_PL },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_PL },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_PL },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_PL },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_PL },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_PL },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_PL },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_PL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_PL,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_PL },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_PL },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_PL },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_PL },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_PL },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_PL },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_PL },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_PL },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_PL },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_PL },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_PL },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_PL },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_PL },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_PL },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_PL },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_PL },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_PL },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_PL },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_PL },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_PL },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_PL },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_PL },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_PL },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_PL },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_PL },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_PL },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_PL },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_PL },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_PL },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_PL },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_PL },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_PL },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_PL },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_PL },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_PL },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_PL },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_PL },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_PL },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_PL },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_PL },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_PL },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_PL },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_PL },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_PL },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_PL },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_PL },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_PL },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_PL },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_PL },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_PL },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_PL },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_PL },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_PL },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_PL },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_PL },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_PL },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_PL },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_PL },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_PL },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_PL },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_PL },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_PL },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_PL },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_PL },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_PL },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_PL },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_PL },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_PL },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_PL },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_PL },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_PL },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_PL },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_PL },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_PL },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_PL },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_PL },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_PL },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_PL },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_PL },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_PL },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_PL },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_PL },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_PL },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_PL },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_PL },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_PL },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_PL },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_PL },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_PL },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_PL },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_PL },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_PL },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_PL },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_PL },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_PL },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_PL },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_PL },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_PL },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_PL },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_PL },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_PL,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_PL,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_PL },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_PL },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_PL },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_PL },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_PL },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_PL },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_PL },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_PL },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_PL },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_PL },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_PL },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_PL },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_PL },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_PL },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_PL },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_PL },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_PL },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__PL },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_PL },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_PL },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_PL },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_PL },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_PL },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_PL },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_PL },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_PL },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_PL },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_PL },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_PL },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_PL },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_PL },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_PL },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_PL },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_PL },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_PL },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_PL },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_PL },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_PL },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_PL },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_PL },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_PL },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_PL },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_PL },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_PL },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_PL },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_PL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_PL,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_PL },
         { "always",   OPTION_VAL_ALWAYS_PL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_PL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_PL,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_PL },
         { "fast",     OPTION_VAL_FAST_PL },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_PL,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_PL,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_PL },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_PL },
         { "below screen", OPTION_VAL_BELOW_SCREEN_PL },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_PL,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_PL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_PL,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_PL,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_PL },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_PL },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_PL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_PL,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_PL,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_PL },
         { "cc",   OPTION_VAL_CC_PL },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_PL,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_PL,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_PL },
         { "GB",   OPTION_VAL_GB_PL },
         { "GBC",  OPTION_VAL_GBC_PL },
         { "GBA",  OPTION_VAL_GBA_PL },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_PL,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_PL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_PL,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_PL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_PL,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_PL,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_PL,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_PL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_PL,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_PL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_PL,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_MODE_INFO_0_PL,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_PL },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_PL },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_PL },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_PL,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_PL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_PL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_pl = {
   option_cats_pl,
   option_defs_pl
};

/* RETRO_LANGUAGE_PT_BR */

#define CATEGORY_GB_LINK_LABEL_PT_BR NULL
#define CATEGORY_GB_LINK_INFO_0_PT_BR "Altera as configurações da conexão (multijogador) mediante o cabo 'Game Link'."
#define GAMBATTE_GB_COLORIZATION_LABEL_PT_BR "Colorização do GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_PT_BR "Habilita a coloração de jogos de Game Boy. \"Automática\" seleciona a paleta mais colorida ou adequada. \"GBC\" seleciona a paleta especifica de Game Boy Color se existir, caso contrário, \"GBC - Verde Escuro\". \"SGB\" seleciona a paleta especifica de Super Game Boy se existir, caso contrário, \"SGB - 1A\". \"Interna\" usa a opção de núcleo \"Paleta interna\". \"Personalizada\" carrega a paleta personalizada do seu diretório."
#define OPTION_VAL_AUTO_PT_BR "Automático"
#define OPTION_VAL_GBC_PT_BR NULL
#define OPTION_VAL_SGB_PT_BR NULL
#define OPTION_VAL_INTERNAL_PT_BR "Interna"
#define OPTION_VAL_CUSTOM_PT_BR "Personalizado"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_PT_BR "Paleta interna"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_PT_BR "Seleciona a paleta usada para colorização de jogos quando 'Colorização do GB' estiver definida como 'Interna', ou quando 'Colorização do GB' estiver definida como 'Automática' e o jogo não possui uma paleta SGB/GBC predefinida. As paletas 'GB' imitam a exibição do hardware original do Game Boy. As paletas 'GBC' são idênticas às predefinições internas do Game Boy Color. As paletas 'SGB' são idênticas às predefinições internas do Super Game Boy."
#define OPTION_VAL_GB_DMG_PT_BR NULL
#define OPTION_VAL_GB_POCKET_PT_BR NULL
#define OPTION_VAL_GB_LIGHT_PT_BR "GB - Claro"
#define OPTION_VAL_GBC_BLUE_PT_BR "GBC - Azul"
#define OPTION_VAL_GBC_BROWN_PT_BR "GBC - Marrom"
#define OPTION_VAL_GBC_DARK_BLUE_PT_BR "GBC - Azul Escuro"
#define OPTION_VAL_GBC_DARK_BROWN_PT_BR "GBC - Marrom Escuro"
#define OPTION_VAL_GBC_DARK_GREEN_PT_BR "GBC - Verde Escuro"
#define OPTION_VAL_GBC_GRAYSCALE_PT_BR "GBC - Tons de Cinza"
#define OPTION_VAL_GBC_GREEN_PT_BR "GBC - Verde"
#define OPTION_VAL_GBC_INVERTED_PT_BR "GBC - Invertido"
#define OPTION_VAL_GBC_ORANGE_PT_BR "GBC - Laranja"
#define OPTION_VAL_GBC_PASTEL_MIX_PT_BR "GBC - Pastel"
#define OPTION_VAL_GBC_RED_PT_BR "GBC - Vermelho"
#define OPTION_VAL_GBC_YELLOW_PT_BR "GBC - Amarelo"
#define OPTION_VAL_SGB_1A_PT_BR NULL
#define OPTION_VAL_SGB_1B_PT_BR NULL
#define OPTION_VAL_SGB_1C_PT_BR NULL
#define OPTION_VAL_SGB_1D_PT_BR NULL
#define OPTION_VAL_SGB_1E_PT_BR NULL
#define OPTION_VAL_SGB_1F_PT_BR NULL
#define OPTION_VAL_SGB_1G_PT_BR NULL
#define OPTION_VAL_SGB_1H_PT_BR NULL
#define OPTION_VAL_SGB_2A_PT_BR NULL
#define OPTION_VAL_SGB_2B_PT_BR NULL
#define OPTION_VAL_SGB_2C_PT_BR NULL
#define OPTION_VAL_SGB_2D_PT_BR NULL
#define OPTION_VAL_SGB_2E_PT_BR NULL
#define OPTION_VAL_SGB_2F_PT_BR NULL
#define OPTION_VAL_SGB_2G_PT_BR NULL
#define OPTION_VAL_SGB_2H_PT_BR NULL
#define OPTION_VAL_SGB_3A_PT_BR NULL
#define OPTION_VAL_SGB_3B_PT_BR NULL
#define OPTION_VAL_SGB_3C_PT_BR NULL
#define OPTION_VAL_SGB_3D_PT_BR NULL
#define OPTION_VAL_SGB_3E_PT_BR NULL
#define OPTION_VAL_SGB_3F_PT_BR NULL
#define OPTION_VAL_SGB_3G_PT_BR NULL
#define OPTION_VAL_SGB_3H_PT_BR NULL
#define OPTION_VAL_SGB_4A_PT_BR NULL
#define OPTION_VAL_SGB_4B_PT_BR NULL
#define OPTION_VAL_SGB_4C_PT_BR NULL
#define OPTION_VAL_SGB_4D_PT_BR NULL
#define OPTION_VAL_SGB_4E_PT_BR NULL
#define OPTION_VAL_SGB_4F_PT_BR NULL
#define OPTION_VAL_SGB_4G_PT_BR NULL
#define OPTION_VAL_SGB_4H_PT_BR NULL
#define OPTION_VAL_SPECIAL_1_PT_BR "Especial 1"
#define OPTION_VAL_SPECIAL_2_PT_BR "Especial 2"
#define OPTION_VAL_SPECIAL_3_PT_BR "Especial 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_PT_BR "Especial 4 (Legado TI-83)"
#define OPTION_VAL_TWB64_PACK_1_PT_BR "TWB64 - Pacote 1"
#define OPTION_VAL_TWB64_PACK_2_PT_BR "TWB64 - Pacote 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_PT_BR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_PT_BR "> TWB64 - Pacote de Paleta 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_PT_BR "Seleciona a paleta de colorização interna a ser utilizada quando o 'TWB64 - Pacote 1' tiver sido selecionado como 'Paleta interna'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_PT_BR "TWB64 001 - Azul Aqours"
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_PT_BR "TWB64 002 - Versão Anime Expo"
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_PT_BR "TWB64 003 - Amarelo Bob Esponja"
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_PT_BR "TWB64 004 - Rosa Patrick Estrela"
#define OPTION_VAL_TWB64_005_NEON_RED_PT_BR "TWB64 005 - Vermelho Neon"
#define OPTION_VAL_TWB64_006_NEON_BLUE_PT_BR "TWB64 006 - Azul Neon"
#define OPTION_VAL_TWB64_007_NEON_YELLOW_PT_BR "TWB64 007 - Amarelo Neon"
#define OPTION_VAL_TWB64_008_NEON_GREEN_PT_BR "TWB64 008 - Verde Neon"
#define OPTION_VAL_TWB64_009_NEON_PINK_PT_BR "TWB64 009 - Rosa Neon"
#define OPTION_VAL_TWB64_010_MARIO_RED_PT_BR "TWB64 010 - Vermelho Mario"
#define OPTION_VAL_TWB64_011_NICK_ORANGE_PT_BR "TWB64 011 - Laranja Nick"
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_PT_BR "TWB64 012 - Versão Virtual Boy"
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_PT_BR NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_PT_BR "TWB64 014 - Amarelo Construção"
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_PT_BR "TWB64 015 - Azul Púrpura Clássico"
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_PT_BR "TWB64 016 - Ver. 765 Production"
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_PT_BR "TWB64 017 - Marfim Superball"
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_PT_BR "TWB64 018 - Laranja Crunchyroll"
#define OPTION_VAL_TWB64_019_MUSE_PINK_PT_BR "TWB64 019 - Rosa Muse"
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_PT_BR "TWB64 020 - Amarelo Nijigasaki"
#define OPTION_VAL_TWB64_021_GAMATE_VER_PT_BR "TWB64 021 - Versão Gamate"
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_PT_BR "TWB64 022 - Versão Verdejante"
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_PT_BR "TWB64 023 - Dourado Odyssey"
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_PT_BR "TWB64 024 - Deus Super Saiyan"
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_PT_BR "TWB64 025 - Super Saiyan Azul"
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_PT_BR "TWB64 026 - Rosa Bizarre"
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_PT_BR "TWB64 027 - Ver. Nintendo Switch Lite"
#define OPTION_VAL_TWB64_028_GAME_COM_VER_PT_BR "TWB64 028 - Ver. GameKing"
#define OPTION_VAL_TWB64_029_SANRIO_PINK_PT_BR "TWB64 029 - Rosa Sanrio"
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_PT_BR "TWB64 030 - Ver. BANDAI NAMCO"
#define OPTION_VAL_TWB64_031_COSMO_GREEN_PT_BR "TWB64 031 - Verde Cosmo"
#define OPTION_VAL_TWB64_032_WANDA_PINK_PT_BR "TWB64 032 - Rosa Wanda"
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_PT_BR "TWB64 033 - Ver. Link's Awakening DX"
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_PT_BR "TWB64 034 - Madeira de Viagem"
#define OPTION_VAL_TWB64_035_POKEMON_VER_PT_BR "TWB64 035 - Versão Pokemon"
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_PT_BR "TWB64 036 - Laranja Game Grump"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_PT_BR "TWB64 037 - Ver. Scooby-Doo Mistério"
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_PT_BR "TWB64 038 - Ver. Pokemon mini."
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_PT_BR "TWB64 039 - Versão Supervision."
#define OPTION_VAL_TWB64_040_DMG_VER_PT_BR "TWB64 040 - Versão DMG"
#define OPTION_VAL_TWB64_041_POCKET_VER_PT_BR "TWB64 041 - Versão Pocket"
#define OPTION_VAL_TWB64_042_LIGHT_VER_PT_BR "TWB64 042 - Versão Light"
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_PT_BR "TWB64 043 - Azul Miraitowa"
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_PT_BR "TWB64 044 - Rosa Someity"
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_PT_BR "TWB64 045 - Amarelo Pikachu"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_PT_BR "TWB64 046 - Marrom Eevee"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_PT_BR "TWB64 047 - Versão Microvision"
#define OPTION_VAL_TWB64_048_TI_83_VER_PT_BR "TWB64 048 - Versão TI-83"
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_PT_BR "TWB64 049 - Vermelho Aegis"
#define OPTION_VAL_TWB64_050_LABO_FAWN_PT_BR "TWB64 050 - Beje Labo"
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_PT_BR "TWB64 051 - OURO MILLION LIVE!"
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_PT_BR "TWB64 052 - Ver. Tokyo Midtown"
#define OPTION_VAL_TWB64_053_VMU_VER_PT_BR "TWB64 053 - Versão VMU"
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_PT_BR "TWB64 054 - Ver. Game Master"
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_PT_BR "TWB64 055 - Verde Android"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_PT_BR "TWB64 056 - Azul Ticketmaster"
#define OPTION_VAL_TWB64_057_GOOGLE_RED_PT_BR "TWB64 057 - Vermelho Google"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_PT_BR "TWB64 058 - Azul Google"
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_PT_BR "TWB64 059 - Amarelo Google"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_PT_BR "TWB64 060 - Verde Google"
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_PT_BR "TWB64 061 - Ver. WonderSwan"
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_PT_BR "TWB64 062 - Ver. Neo Geo Pocket"
#define OPTION_VAL_TWB64_063_DEW_GREEN_PT_BR "TWB64 063 - Verde Dew"
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_PT_BR "TWB64 064 - Vermelho Coca-Cola"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_PT_BR "TWB64 065 - Versão GameKing"
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_PT_BR "TWB64 066 - VErsão Do The Dew"
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_PT_BR "TWB64 067 - Versão Digivice"
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_PT_BR "TWB64 068 - Versão Fenda do Bikini"
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_PT_BR "TWB64 069 - Rosa Florido"
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_PT_BR "TWB64 070 - Azul Bolhas"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_PT_BR "TWB64 071 - Verde Cactus"
#define OPTION_VAL_TWB64_072_NASCAR_VER_PT_BR "TWB64 072 - Versão NASCAR"
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_PT_BR "TWB64 073 - Verde Limão-limão"
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_PT_BR "TWB64 074 - Versão Mega Man V"
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_PT_BR "TWB64 075 - Versão Tamagotchi"
#define OPTION_VAL_TWB64_076_PHANTOM_RED_PT_BR "TWB64 076 - Vermelho Fantasma"
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_PT_BR "TWB64 077 - Ver. Dias das Bruxas"
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_PT_BR "TWB64 078 - Versão Natal"
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_PT_BR "TWB64 079 - Rosa Card Captors"
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_PT_BR "TWB64 080 - Dourado Pretty Guardian"
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_PT_BR "TWB64 081 - Versão Camuflagem."
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_PT_BR "TWB64 082 - Super Saiyan Lendário"
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_PT_BR "TWB64 083 - Super Saiyan Rosa"
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_PT_BR NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_PT_BR NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_PT_BR "TWB64 086 - Vermelho Saint Snow"
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_PT_BR "TWB64 087 - Amarelo Banana"
#define OPTION_VAL_TWB64_088_GREEN_BANANA_PT_BR "TWB64 088 - Verde Banana"
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_PT_BR NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_PT_BR "TWB64 090 - Super Saiyan Azul Evoluído"
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_PT_BR "TWB64 091 - Ver. Pocket Tales"
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_PT_BR "TWB64 092 - Amarelo Investigação"
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_PT_BR "TWB64 093 - Azul S.E.E.S."
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_PT_BR "TWB64 094 - Ciano Game Awards"
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_PT_BR "TWB64 095 - Laranja Hokage"
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_PT_BR "TWB64 096 - Vermelho chapéu de palha "
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_PT_BR "TWB64 097 - Ciano Sword Art"
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_PT_BR "TWB64 098 - Esmeralda Deku Alpha"
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_PT_BR "TWB64 099 - Versão Listras Azuis"
#define OPTION_VAL_TWB64_100_STONE_ORANGE_PT_BR "TWB64 100 - Laranja Stone"
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_PT_BR "> TWB64 - Pacote de Paleta 2"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_PT_BR "Seleciona a paleta de colorização interna a ser utilizada quando 'TWB64 - Pacote 2' tiver sido selecionado como 'Paleta interna'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_PT_BR "TWB64 101 - Rosa 765PRO"
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_PT_BR "TWB64 102 - Azul CINDERELLA"
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_PT_BR "TWB64 103 - Amarelo MILLION!"
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_PT_BR "TWB64 104 - Verde SideM"
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_PT_BR "TWB64 105 - Azul Céu SHINY"
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_PT_BR "TWB64 106 - Versão Angry Volcano"
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_PT_BR "TWB64 107 - Rosa Yo-kai"
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_PT_BR "TWB64 108 - Verde Yo-kai"
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_PT_BR "TWB64 109 - Azul Yo-kai"
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_PT_BR "TWB64 110 - Roxo Yo-kai"
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_PT_BR "TWB64 111 - Iro Água"
#define OPTION_VAL_TWB64_112_TEA_MIDORI_PT_BR "TWB64 112 - Chá Midori"
#define OPTION_VAL_TWB64_113_SAKURA_PINK_PT_BR "TWB64 113 - Rosa Sakura"
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_PT_BR NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_PT_BR NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_PT_BR "TWB64 116 - Dourado Kiiro"
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_PT_BR "TWB64 117 - Prata Shiro"
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_PT_BR "TWB64 118 - Laranja Frutal"
#define OPTION_VAL_TWB64_119_AKB48_PINK_PT_BR "TWB64 119 - Rosa AKB48"
#define OPTION_VAL_TWB64_120_MIKU_BLUE_PT_BR "TWB64 120 - Azul Miku"
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_PT_BR "TWB64 121 - Vermelho Fairy Tail"
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_PT_BR "TWB64 122 - Marrom Corpo de Exploração"
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_PT_BR "TWB64 123 - Verde Ilha"
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_PT_BR "TWB64 124 - Verde Sonic Mania Plus"
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_PT_BR "TWB64 125 - Verde Tartaruga Ninja"
#define OPTION_VAL_TWB64_126_SLIME_BLUE_PT_BR "TWB64 126 - Azul Slime"
#define OPTION_VAL_TWB64_127_LIME_MIDORI_PT_BR "TWB64 127 - Verde Lima Midori"
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_PT_BR "TWB64 128 - Espectral Aoi"
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_PT_BR NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_PT_BR "TWB64 130 - Azul Real"
#define OPTION_VAL_TWB64_131_NEON_PURPLE_PT_BR "TWB64 131 - Roxo Neon"
#define OPTION_VAL_TWB64_132_NEON_ORANGE_PT_BR "TWB64 132 - Laranja Neon"
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_PT_BR NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_PT_BR "TWB64 134 - Vermelho Tóquio"
#define OPTION_VAL_TWB64_135_PARIS_GOLD_PT_BR "TWB64 135 - Dourado Paris"
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_PT_BR "TWB64 136 - Azul Pequim"
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_PT_BR "TWB64 137 - Amarelo Pac-Man"
#define OPTION_VAL_TWB64_138_IRISH_GREEN_PT_BR "TWB64 138 - Verde Irlandês"
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_PT_BR "TWB64 139 - Laranja Kakaroto"
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_PT_BR "TWB64 140 - Laranja Dragon Ball"
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_PT_BR "TWB64 141 - Dourado Natal"
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_PT_BR NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_PT_BR "TWB64 143 - Verde Bub"
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_PT_BR "TWB64 144 - Azul Bob"
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_PT_BR "TWB64 145 - Tempestade Baja Blast"
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_PT_BR "TWB64 146 - Ouro Olímpico"
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_PT_BR "TWB64 147 - Laranja Valor"
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_PT_BR "TWB64 148 - Roxo Liella!"
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_PT_BR "TWB64 149 - Prata Olímpica"
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_PT_BR "TWB64 150 - Bronze Olímpico"
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_PT_BR "TWB64 151 - Azul Céu ANA"
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_PT_BR "TWB64 152 - Laranja Nijigasaki"
#define OPTION_VAL_TWB64_153_HOLOBLUE_PT_BR "TWB64 153 - HoloAzul"
#define OPTION_VAL_TWB64_154_WRESTLING_RED_PT_BR "TWB64 154 - Vermelho Luta Livre"
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_PT_BR "TWB64 155 - Verde Ovo de Yoshi"
#define OPTION_VAL_TWB64_156_POKEDEX_RED_PT_BR "TWB64 156 - Vermelho Pokedex"
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_PT_BR "TWB64 157 - Azul Sonho da Disney"
#define OPTION_VAL_TWB64_158_XBOX_GREEN_PT_BR "TWB64 158 - Verde Xbox"
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_PT_BR "TWB64 159 - Azul Sonic Mega"
#define OPTION_VAL_TWB64_160_G4_ORANGE_PT_BR "TWB64 160 - Laranja G4"
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_PT_BR "TWB64 161 - Verde Scarlett"
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_PT_BR "TWB64 162 - Azul Glitchy"
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_PT_BR "TWB64 163 - LCD Clássico"
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_PT_BR "TWB64 164 - Ver. 3DS Virtual Console"
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_PT_BR "TWB64 165 - Ver. PocketStation"
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_PT_BR "TWB64 166 - Game and Watch"
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_PT_BR "TWB64 167 - Azul Smurfy"
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_PT_BR "TWB64 168 - Verde Shrek"
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_PT_BR "TWB64 169 - Verde Espinafre de Marinheiro"
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_PT_BR "TWB64 170 - Verde Shenron"
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_PT_BR "TWB64 171 - Vermelho Sangue Berserk"
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_PT_BR "TWB64 172 - Rosa Super Star"
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_PT_BR "TWB64 173 - Ver. Gamebuino Classic"
#define OPTION_VAL_TWB64_174_BARBIE_PINK_PT_BR "TWB64 174 - Rosa Barbie"
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_PT_BR "TWB64 175 - Verde Comando Estelar"
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_PT_BR "TWB64 176 - Versão Nokia 3310"
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_PT_BR "TWB64 177 - Verde Trevo"
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_PT_BR "TWB64 178 - Laranja Crash Bandicoot"
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_PT_BR "TWB64 179 - Amarelo Famicom Disk"
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_PT_BR "TWB64 180 - Vermelho Equipe Rocket"
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_PT_BR "TWB64 181 - Amarelo Cronômetro SEIKO"
#define OPTION_VAL_TWB64_182_PINK109_PT_BR NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_PT_BR "TWB64 183 - Azul Doraemon"
#define OPTION_VAL_TWB64_184_FURY_BLUE_PT_BR "TWB64 184 - Azul Fury"
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_PT_BR "TWB64 185 - Laranja Rockstar"
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_PT_BR "TWB64 186 - Verde Puyo Puyo"
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_PT_BR "TWB64 187 - Rosa Susan G."
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_PT_BR "TWB64 188 - Vermelho Pizza Hut"
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_PT_BR "TWB64 189 - Verde Plumbob"
#define OPTION_VAL_TWB64_190_GRAND_IVORY_PT_BR "TWB64 190 - Marfim Grand"
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_PT_BR "TWB64 191 - Dourado Demônio"
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_PT_BR "TWB64 192 - Azul SEGA Tóquio"
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_PT_BR "TWB64 193 - Azul Campeão"
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_PT_BR "TWB64 194 - Marrom Barril do DK"
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_PT_BR "TWB64 195 - Verde Evangelion"
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_PT_BR "TWB64 196 - Roxo Equestrian"
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_PT_BR "TWB64 197 - Vermelho Autobot"
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_PT_BR "TWB64 198 - Verde Mar Niconico"
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_PT_BR "TWB64 199 - Cobre Duracell"
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_PT_BR "TWB64 200 - AZUL TOKYO SKYTREE"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_PT_BR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_PT_BR NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_PT_BR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_PT_BR "Correção de cor"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_PT_BR "Ajusta as cores da saída de vídeo para se assemelharem às do hardware real de um Game Boy Color. 'Apenas GBC' faz com que a correção seja aplicada somente ao executar jogos Game Boy Color ou ao usar uma paleta de Game Boy Color para colorir um jogo Game Boy. 'Sempre' aplicará correção de cor a todo o conteúdo, produzindo resultados inesperados ou ruins ao utilizar as paletas internas do 'GB' ou 'SGB'."
#define OPTION_VAL_GBC_ONLY_PT_BR "Apenas GBC"
#define OPTION_VAL_ALWAYS_PT_BR "Sempre"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_PT_BR "Modo de correção de cor"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_PT_BR "Especifica o método a ser usado para a correção de cor. 'Precisa' produzirá uma imagem que é quase indistinguível da tela LCD de um Game Boy Color real. 'Rápida' irá apenas escurecer as cores e reduzir a saturação. A opção 'Rápido' pode ser usada em hardware de baixo custo se a opção 'Preciso' for muito lenta."
#define OPTION_VAL_ACCURATE_PT_BR "Precisa"
#define OPTION_VAL_FAST_PT_BR "Rápida"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_PT_BR "Correção de cor - Posição de luz frontal"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_PT_BR "Simula a resposta física de um painel LCD do Game Boy Color quando iluminado a partir de ângulos diferentes. 'Centrada' representa a reprodução de cores padrão. 'Acima da tela' aumenta seu brilho e 'Abaixo da tela' diminui seu brilho. Este ajuste será aplicado somente quando o modo de correção de cor for ajustado para 'Preciso'."
#define OPTION_VAL_CENTRAL_PT_BR "Centrada"
#define OPTION_VAL_ABOVE_SCREEN_PT_BR "Acima da tela"
#define OPTION_VAL_BELOW_SCREEN_PT_BR "Abaixo da tela"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_PT_BR "Nível do filtro escuro (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_PT_BR "Permite que o brilho seja reduzido baseado em luminosidade. Pode ser usado para evitar reflexos ou cansaço dos olhos ao jogar jogos com fundos brancos que se destinam a um Game Boy Color não retroiluminado e que podem ser exibidos com muito brilho em uma tela moderna retroiluminada."
#define GAMBATTE_MIX_FRAMES_LABEL_PT_BR "Fusão entre quadros"
#define GAMBATTE_MIX_FRAMES_INFO_0_PT_BR "Simula o efeito fantasma da tela LCD. 'Simples' executa uma mistura a metade dos quadros atuais e anteriores. 'Efeito fantasma' imita os tempos de resposta naturais de uma tela LCD combinando vários quadros armazenados no buffer. A mistura 'Simples' é necessária em jogos que dependem do efeito fantasma da tela LCD para efeitos de transparência (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_PT_BR "Simples"
#define OPTION_VAL_LCD_GHOSTING_PT_BR "Efeito fantasma do LCD (detalhado)"
#define OPTION_VAL_LCD_GHOSTING_FAST_PT_BR "Efeito fantasma do LCD (rápido)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_PT_BR "Reamostragem de áudio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_PT_BR NULL
#define OPTION_VAL_SINC_PT_BR NULL
#define OPTION_VAL_CC_PT_BR NULL
#define GAMBATTE_GB_HWMODE_LABEL_PT_BR "Hardware emulado (requer reinício)"
#define GAMBATTE_GB_HWMODE_INFO_0_PT_BR "Especifique o tipo de hardware que deve ser emulado. Recomenda-se o 'Automático'. A opção 'GBA' desbloqueia recursos extras em certos para Game Boy Color com o modo 'GBA Enhanced' (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_PT_BR NULL
#define OPTION_VAL_GBA_PT_BR NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_PT_BR "Usar carregador de inicialização oficial (requer reinício)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_PT_BR "Permite o suporte os carregadores de inicialização oficiais do Game Boy e Game Boy Color com suas animações de inicialização correspondentes."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_PT_BR "Permite direções contrárias"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_PT_BR "Esta opção permitirá pressionar, alternar ou segurar rapidamente as direções esquerda e direita (ou cima e baixo) ao mesmo tempo. Pode causar falhas de movimento."
#define GAMBATTE_TURBO_PERIOD_LABEL_PT_BR "Duração do botão 'Turbo'"
#define GAMBATTE_TURBO_PERIOD_INFO_0_PT_BR "Especifica o intervalo (em quadros) que se repetirá o pressionamento dos botões A ou B ao manter pressionados seus equivalentes com turbo."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_PT_BR "Força da vibração do controle"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_PT_BR "Ativa os efeitos de resposta háptica/vibração para os jogos compatíveis (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_PT_BR "Mostrar configurações do cabo Game Link"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_PT_BR "Ativa as configurações da conexão (multijogador) em rede por cabo Game Link. NOTA: É necessário sair e entrar novamente no 'Menu rápido' para que a mudança tenha efeito."
#define GAMBATTE_GB_LINK_MODE_LABEL_PT_BR "Modo cabo Game Link"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_PT_BR "Modo de conexão"
#define GAMBATTE_GB_LINK_MODE_INFO_0_PT_BR "Quando a função de rede do cabo Game Link é ativada, esta opção especifica qual instância deve atuar como servidor ou cliente."
#define OPTION_VAL_NOT_CONNECTED_PT_BR "Não conectado"
#define OPTION_VAL_NETWORK_SERVER_PT_BR "Servidores da rede"
#define OPTION_VAL_NETWORK_CLIENT_PT_BR "Cliente de rede"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_PT_BR "Porta de conexão de rede"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_PT_BR "Porta"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_PT_BR "Defina a porta que será usada para a comunicação de rede do cabo Game Link."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_PT_BR "Valor 01 do endereço do servidor de rede: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_PT_BR "Valor 01 do endereço do servidor: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_PT_BR "1º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_PT_BR "1º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_PT_BR "Valor 02 do endereço do servidor de rede: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_PT_BR "Valor 02 do endereço do servidor: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_PT_BR "2º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_PT_BR "2º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_PT_BR "Valor 03 do endereço do servidor de rede: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_PT_BR "Valor 03 do endereço do servidor: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_PT_BR "3º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_PT_BR "3º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_PT_BR "Valor 04 do endereço do servidor de rede: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_PT_BR "Valor 04 do endereço do servidor: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_PT_BR "4º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_PT_BR "4º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_PT_BR "Valor 05 do endereço do servidor de rede: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_PT_BR "Valor 05 do endereço do servidor: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_PT_BR "5º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_PT_BR "5º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_PT_BR "Valor 06 do endereço do servidor de rede: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_PT_BR "Valor 06 do endereço do servidor: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_PT_BR "6º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_PT_BR "6º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_PT_BR "Valor 07 do endereço do servidor de rede: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_PT_BR "Valor 07 do endereço do servidor: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_PT_BR "7º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_PT_BR "7º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_PT_BR "Valor 08 do endereço do servidor de rede: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_PT_BR "Valor 08 do endereço do servidor: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_PT_BR "8º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_PT_BR "8º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_PT_BR "Valor 09 do endereço do servidor de rede: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_PT_BR "Valor 09 do endereço do servidor: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_PT_BR "9º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_PT_BR "9º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_PT_BR "Valor 10 do endereço do servidor de rede: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_PT_BR "Valor 10 do endereço do servidor: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_PT_BR "10º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_PT_BR "10º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_PT_BR "Valor 11 do endereço do servidor de rede: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_PT_BR "Valor 11 do endereço do servidor: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_PT_BR "11º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_PT_BR "11º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_PT_BR "Valor 12 do endereço do servidor de rede: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_PT_BR "Valor 12 do endereço do servidor: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_PT_BR "12º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo cabo Game Link' estiver definido como 'Cliente de rede'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_PT_BR "12º dígito do endereço IP do servidor de rede do cabo Game link. Só é usado quando o 'Modo de conexão' estiver definido como 'Cliente de rede'."

struct retro_core_option_v2_category option_cats_pt_br[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_PT_BR,
      CATEGORY_GB_LINK_INFO_0_PT_BR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_pt_br[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_PT_BR },
         { "GBC",      OPTION_VAL_GBC_PT_BR },
         { "SGB",      OPTION_VAL_SGB_PT_BR },
         { "internal", OPTION_VAL_INTERNAL_PT_BR },
         { "custom",   OPTION_VAL_CUSTOM_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_PT_BR },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_PT_BR },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_PT_BR },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_PT_BR },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_PT_BR },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_PT_BR },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_PT_BR },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_PT_BR },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_PT_BR },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_PT_BR },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_PT_BR },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_PT_BR },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_PT_BR },
         { "GBC - Red",                OPTION_VAL_GBC_RED_PT_BR },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_PT_BR },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_PT_BR },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_PT_BR },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_PT_BR },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_PT_BR },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_PT_BR },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_PT_BR },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_PT_BR },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_PT_BR },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_PT_BR },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_PT_BR },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_PT_BR },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_PT_BR },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_PT_BR },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_PT_BR },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_PT_BR },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_PT_BR },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_PT_BR },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_PT_BR },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_PT_BR },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_PT_BR },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_PT_BR },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_PT_BR },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_PT_BR },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_PT_BR },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_PT_BR },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_PT_BR },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_PT_BR },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_PT_BR },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_PT_BR },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_PT_BR },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_PT_BR },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_PT_BR },
         { "Special 1",                OPTION_VAL_SPECIAL_1_PT_BR },
         { "Special 2",                OPTION_VAL_SPECIAL_2_PT_BR },
         { "Special 3",                OPTION_VAL_SPECIAL_3_PT_BR },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_PT_BR },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_PT_BR },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_PT_BR },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_PT_BR },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_PT_BR },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_PT_BR },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_PT_BR },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_PT_BR },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_PT_BR },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_PT_BR },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_PT_BR },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_PT_BR },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_PT_BR },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_PT_BR },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_PT_BR },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_PT_BR },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_PT_BR },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_PT_BR },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_PT_BR },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_PT_BR },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_PT_BR },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_PT_BR },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_PT_BR },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_PT_BR },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_PT_BR },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_PT_BR },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_PT_BR },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_PT_BR },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_PT_BR },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_PT_BR },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_PT_BR },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_PT_BR },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_PT_BR },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_PT_BR },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_PT_BR },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_PT_BR },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_PT_BR },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_PT_BR },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_PT_BR },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_PT_BR },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_PT_BR },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_PT_BR },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_PT_BR },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_PT_BR },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_PT_BR },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_PT_BR },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_PT_BR },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_PT_BR },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_PT_BR },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_PT_BR },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_PT_BR },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_PT_BR },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_PT_BR },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_PT_BR },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_PT_BR },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_PT_BR },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_PT_BR },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_PT_BR },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_PT_BR },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_PT_BR },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_PT_BR },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_PT_BR },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_PT_BR },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_PT_BR },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_PT_BR },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_PT_BR },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_PT_BR },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_PT_BR },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_PT_BR },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_PT_BR },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_PT_BR },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_PT_BR },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_PT_BR },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_PT_BR },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_PT_BR },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_PT_BR },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_PT_BR },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_PT_BR },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_PT_BR },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_PT_BR },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_PT_BR },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_PT_BR },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_PT_BR },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_PT_BR },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_PT_BR },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_PT_BR },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_PT_BR },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_PT_BR },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_PT_BR },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_PT_BR },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_PT_BR },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_PT_BR },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_PT_BR },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_PT_BR },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_PT_BR },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_PT_BR },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_PT_BR },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_PT_BR },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_PT_BR },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_PT_BR },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_PT_BR },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_PT_BR },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_PT_BR },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_PT_BR },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_PT_BR },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_PT_BR },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_PT_BR },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_PT_BR },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_PT_BR },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_PT_BR },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_PT_BR },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_PT_BR },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_PT_BR },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_PT_BR },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_PT_BR },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_PT_BR },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_PT_BR },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_PT_BR },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_PT_BR },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_PT_BR },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_PT_BR },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_PT_BR },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_PT_BR },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_PT_BR },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_PT_BR },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_PT_BR },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_PT_BR },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_PT_BR },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_PT_BR },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_PT_BR },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_PT_BR },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_PT_BR },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_PT_BR },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_PT_BR },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_PT_BR },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_PT_BR },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_PT_BR },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_PT_BR },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_PT_BR },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_PT_BR },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_PT_BR },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_PT_BR },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_PT_BR },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_PT_BR },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_PT_BR },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_PT_BR },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_PT_BR },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_PT_BR },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_PT_BR },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_PT_BR },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_PT_BR },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_PT_BR },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_PT_BR },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_PT_BR },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_PT_BR },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_PT_BR },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_PT_BR },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_PT_BR },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_PT_BR },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_PT_BR },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_PT_BR },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_PT_BR },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_PT_BR },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_PT_BR },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_PT_BR },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_PT_BR },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_PT_BR },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_PT_BR },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_PT_BR },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_PT_BR },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_PT_BR },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_PT_BR },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_PT_BR },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_PT_BR },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_PT_BR },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_PT_BR },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_PT_BR },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_PT_BR },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_PT_BR },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_PT_BR },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_PT_BR },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_PT_BR },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_PT_BR },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_PT_BR },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_PT_BR },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_PT_BR },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_PT_BR },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_PT_BR },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_PT_BR },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_PT_BR },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_PT_BR },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_PT_BR },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_PT_BR },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_PT_BR },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_PT_BR },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_PT_BR },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_PT_BR },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_PT_BR },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_PT_BR },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_PT_BR },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_PT_BR },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_PT_BR },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_PT_BR },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_PT_BR },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_PT_BR },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_PT_BR },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_PT_BR },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_PT_BR },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_PT_BR },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_PT_BR },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_PT_BR },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_PT_BR },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_PT_BR },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_PT_BR },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_PT_BR },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_PT_BR },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_PT_BR },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_PT_BR },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_PT_BR },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_PT_BR },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_PT_BR },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__PT_BR },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_PT_BR },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_PT_BR },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_PT_BR },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_PT_BR },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_PT_BR },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_PT_BR },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_PT_BR },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_PT_BR },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_PT_BR },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_PT_BR },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_PT_BR },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_PT_BR },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_PT_BR },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_PT_BR },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_PT_BR },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_PT_BR },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_PT_BR },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_PT_BR },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_PT_BR },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_PT_BR },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_PT_BR },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_PT_BR },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_PT_BR },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_PT_BR },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_PT_BR },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_PT_BR },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_PT_BR },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_PT_BR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_PT_BR },
         { "always",   OPTION_VAL_ALWAYS_PT_BR },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_PT_BR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_PT_BR },
         { "fast",     OPTION_VAL_FAST_PT_BR },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_PT_BR,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_PT_BR },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_PT_BR },
         { "below screen", OPTION_VAL_BELOW_SCREEN_PT_BR },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_PT_BR,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_PT_BR,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_PT_BR },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_PT_BR },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_PT_BR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_PT_BR,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_PT_BR },
         { "cc",   OPTION_VAL_CC_PT_BR },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_PT_BR },
         { "GB",   OPTION_VAL_GB_PT_BR },
         { "GBC",  OPTION_VAL_GBC_PT_BR },
         { "GBA",  OPTION_VAL_GBA_PT_BR },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_PT_BR,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_PT_BR,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_PT_BR,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_PT_BR,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_PT_BR,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_PT_BR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_PT_BR,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_MODE_INFO_0_PT_BR,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_PT_BR },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_PT_BR },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_PT_BR },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_PT_BR,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_PT_BR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_PT_BR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_pt_br = {
   option_cats_pt_br,
   option_defs_pt_br
};

/* RETRO_LANGUAGE_PT_PT */

#define CATEGORY_GB_LINK_LABEL_PT_PT NULL
#define CATEGORY_GB_LINK_INFO_0_PT_PT NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_PT_PT NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_PT_PT NULL
#define OPTION_VAL_AUTO_PT_PT "Automático"
#define OPTION_VAL_GBC_PT_PT NULL
#define OPTION_VAL_SGB_PT_PT NULL
#define OPTION_VAL_INTERNAL_PT_PT NULL
#define OPTION_VAL_CUSTOM_PT_PT "Personalizar"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_PT_PT NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_PT_PT NULL
#define OPTION_VAL_GB_DMG_PT_PT NULL
#define OPTION_VAL_GB_POCKET_PT_PT NULL
#define OPTION_VAL_GB_LIGHT_PT_PT NULL
#define OPTION_VAL_GBC_BLUE_PT_PT NULL
#define OPTION_VAL_GBC_BROWN_PT_PT NULL
#define OPTION_VAL_GBC_DARK_BLUE_PT_PT NULL
#define OPTION_VAL_GBC_DARK_BROWN_PT_PT NULL
#define OPTION_VAL_GBC_DARK_GREEN_PT_PT NULL
#define OPTION_VAL_GBC_GRAYSCALE_PT_PT NULL
#define OPTION_VAL_GBC_GREEN_PT_PT NULL
#define OPTION_VAL_GBC_INVERTED_PT_PT NULL
#define OPTION_VAL_GBC_ORANGE_PT_PT NULL
#define OPTION_VAL_GBC_PASTEL_MIX_PT_PT NULL
#define OPTION_VAL_GBC_RED_PT_PT NULL
#define OPTION_VAL_GBC_YELLOW_PT_PT NULL
#define OPTION_VAL_SGB_1A_PT_PT NULL
#define OPTION_VAL_SGB_1B_PT_PT NULL
#define OPTION_VAL_SGB_1C_PT_PT NULL
#define OPTION_VAL_SGB_1D_PT_PT NULL
#define OPTION_VAL_SGB_1E_PT_PT NULL
#define OPTION_VAL_SGB_1F_PT_PT NULL
#define OPTION_VAL_SGB_1G_PT_PT NULL
#define OPTION_VAL_SGB_1H_PT_PT NULL
#define OPTION_VAL_SGB_2A_PT_PT NULL
#define OPTION_VAL_SGB_2B_PT_PT NULL
#define OPTION_VAL_SGB_2C_PT_PT NULL
#define OPTION_VAL_SGB_2D_PT_PT NULL
#define OPTION_VAL_SGB_2E_PT_PT NULL
#define OPTION_VAL_SGB_2F_PT_PT NULL
#define OPTION_VAL_SGB_2G_PT_PT NULL
#define OPTION_VAL_SGB_2H_PT_PT NULL
#define OPTION_VAL_SGB_3A_PT_PT NULL
#define OPTION_VAL_SGB_3B_PT_PT NULL
#define OPTION_VAL_SGB_3C_PT_PT NULL
#define OPTION_VAL_SGB_3D_PT_PT NULL
#define OPTION_VAL_SGB_3E_PT_PT NULL
#define OPTION_VAL_SGB_3F_PT_PT NULL
#define OPTION_VAL_SGB_3G_PT_PT NULL
#define OPTION_VAL_SGB_3H_PT_PT NULL
#define OPTION_VAL_SGB_4A_PT_PT NULL
#define OPTION_VAL_SGB_4B_PT_PT NULL
#define OPTION_VAL_SGB_4C_PT_PT NULL
#define OPTION_VAL_SGB_4D_PT_PT NULL
#define OPTION_VAL_SGB_4E_PT_PT NULL
#define OPTION_VAL_SGB_4F_PT_PT NULL
#define OPTION_VAL_SGB_4G_PT_PT NULL
#define OPTION_VAL_SGB_4H_PT_PT NULL
#define OPTION_VAL_SPECIAL_1_PT_PT NULL
#define OPTION_VAL_SPECIAL_2_PT_PT NULL
#define OPTION_VAL_SPECIAL_3_PT_PT NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_PT_PT NULL
#define OPTION_VAL_TWB64_PACK_1_PT_PT NULL
#define OPTION_VAL_TWB64_PACK_2_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_PT_PT NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_PT_PT NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_PT_PT NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_PT_PT NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_005_NEON_RED_PT_PT NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_PT_PT NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_PT_PT NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_PT_PT NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_PT_PT NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_PT_PT NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_PT_PT NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_PT_PT NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_PT_PT NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_PT_PT NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_PT_PT NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_PT_PT NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_PT_PT NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_PT_PT NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_PT_PT NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_PT_PT NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_PT_PT NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_PT_PT NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_PT_PT NULL
#define OPTION_VAL_TWB64_040_DMG_VER_PT_PT NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_PT_PT NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_PT_PT NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_PT_PT NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_PT_PT NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_PT_PT NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_PT_PT NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_PT_PT NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_PT_PT NULL
#define OPTION_VAL_TWB64_053_VMU_VER_PT_PT NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_PT_PT NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_PT_PT NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_PT_PT NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_PT_PT NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_PT_PT NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_PT_PT NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_PT_PT NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_PT_PT NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_PT_PT NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_PT_PT NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_PT_PT NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_PT_PT NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_PT_PT NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_PT_PT NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_PT_PT NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_PT_PT NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_PT_PT NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_PT_PT NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_PT_PT NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_PT_PT NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_PT_PT NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_PT_PT NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_PT_PT NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_PT_PT NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_PT_PT NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_PT_PT NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_PT_PT NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_PT_PT NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_PT_PT NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_PT_PT NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_PT_PT NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_PT_PT NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_PT_PT NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_PT_PT NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_PT_PT NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_PT_PT NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_PT_PT NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_PT_PT NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_PT_PT NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_PT_PT NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_PT_PT NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_PT_PT NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_PT_PT NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_PT_PT NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_PT_PT NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_PT_PT NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_PT_PT NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_PT_PT NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_PT_PT NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_PT_PT NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_PT_PT NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_PT_PT NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_PT_PT NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_PT_PT NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_PT_PT NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_PT_PT NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_PT_PT NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_PT_PT NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_PT_PT NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_PT_PT NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_PT_PT NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_PT_PT NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_PT_PT NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_PT_PT NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_PT_PT NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_PT_PT NULL
#define OPTION_VAL_TWB64_182_PINK109_PT_PT NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_PT_PT NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_PT_PT NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_PT_PT NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_PT_PT NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_PT_PT NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_PT_PT NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_PT_PT NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_PT_PT NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_PT_PT NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_PT_PT NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_PT_PT NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_PT_PT NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_PT_PT NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_PT_PT NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_PT_PT NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_PT_PT NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_PT_PT NULL
#define OPTION_VAL_GBC_ONLY_PT_PT NULL
#define OPTION_VAL_ALWAYS_PT_PT NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_PT_PT NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_PT_PT NULL
#define OPTION_VAL_ACCURATE_PT_PT NULL
#define OPTION_VAL_FAST_PT_PT NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_PT_PT NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_PT_PT NULL
#define OPTION_VAL_CENTRAL_PT_PT NULL
#define OPTION_VAL_ABOVE_SCREEN_PT_PT NULL
#define OPTION_VAL_BELOW_SCREEN_PT_PT NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_PT_PT NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_PT_PT NULL
#define GAMBATTE_MIX_FRAMES_LABEL_PT_PT NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_PT_PT NULL
#define OPTION_VAL_MIX_PT_PT NULL
#define OPTION_VAL_LCD_GHOSTING_PT_PT NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_PT_PT NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_PT_PT "Reamostragem de áudio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_PT_PT NULL
#define OPTION_VAL_SINC_PT_PT NULL
#define OPTION_VAL_CC_PT_PT NULL
#define GAMBATTE_GB_HWMODE_LABEL_PT_PT NULL
#define GAMBATTE_GB_HWMODE_INFO_0_PT_PT NULL
#define OPTION_VAL_GB_PT_PT NULL
#define OPTION_VAL_GBA_PT_PT NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_PT_PT NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_PT_PT NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_PT_PT NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_PT_PT NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_PT_PT NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_PT_PT NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_PT_PT NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_PT_PT NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_PT_PT NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_PT_PT NULL
#define OPTION_VAL_NOT_CONNECTED_PT_PT NULL
#define OPTION_VAL_NETWORK_SERVER_PT_PT NULL
#define OPTION_VAL_NETWORK_CLIENT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_PT_PT "Porta"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_PT_PT NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_PT_PT NULL

struct retro_core_option_v2_category option_cats_pt_pt[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_PT_PT,
      CATEGORY_GB_LINK_INFO_0_PT_PT
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_pt_pt[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_PT_PT },
         { "GBC",      OPTION_VAL_GBC_PT_PT },
         { "SGB",      OPTION_VAL_SGB_PT_PT },
         { "internal", OPTION_VAL_INTERNAL_PT_PT },
         { "custom",   OPTION_VAL_CUSTOM_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_PT_PT },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_PT_PT },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_PT_PT },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_PT_PT },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_PT_PT },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_PT_PT },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_PT_PT },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_PT_PT },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_PT_PT },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_PT_PT },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_PT_PT },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_PT_PT },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_PT_PT },
         { "GBC - Red",                OPTION_VAL_GBC_RED_PT_PT },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_PT_PT },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_PT_PT },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_PT_PT },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_PT_PT },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_PT_PT },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_PT_PT },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_PT_PT },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_PT_PT },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_PT_PT },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_PT_PT },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_PT_PT },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_PT_PT },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_PT_PT },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_PT_PT },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_PT_PT },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_PT_PT },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_PT_PT },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_PT_PT },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_PT_PT },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_PT_PT },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_PT_PT },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_PT_PT },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_PT_PT },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_PT_PT },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_PT_PT },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_PT_PT },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_PT_PT },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_PT_PT },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_PT_PT },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_PT_PT },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_PT_PT },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_PT_PT },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_PT_PT },
         { "Special 1",                OPTION_VAL_SPECIAL_1_PT_PT },
         { "Special 2",                OPTION_VAL_SPECIAL_2_PT_PT },
         { "Special 3",                OPTION_VAL_SPECIAL_3_PT_PT },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_PT_PT },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_PT_PT },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_PT_PT },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_PT_PT },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_PT_PT },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_PT_PT },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_PT_PT },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_PT_PT },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_PT_PT },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_PT_PT },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_PT_PT },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_PT_PT },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_PT_PT },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_PT_PT },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_PT_PT },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_PT_PT },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_PT_PT },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_PT_PT },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_PT_PT },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_PT_PT },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_PT_PT },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_PT_PT },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_PT_PT },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_PT_PT },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_PT_PT },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_PT_PT },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_PT_PT },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_PT_PT },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_PT_PT },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_PT_PT },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_PT_PT },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_PT_PT },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_PT_PT },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_PT_PT },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_PT_PT },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_PT_PT },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_PT_PT },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_PT_PT },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_PT_PT },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_PT_PT },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_PT_PT },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_PT_PT },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_PT_PT },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_PT_PT },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_PT_PT },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_PT_PT },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_PT_PT },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_PT_PT },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_PT_PT },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_PT_PT },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_PT_PT },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_PT_PT },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_PT_PT },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_PT_PT },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_PT_PT },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_PT_PT },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_PT_PT },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_PT_PT },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_PT_PT },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_PT_PT },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_PT_PT },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_PT_PT },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_PT_PT },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_PT_PT },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_PT_PT },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_PT_PT },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_PT_PT },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_PT_PT },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_PT_PT },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_PT_PT },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_PT_PT },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_PT_PT },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_PT_PT },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_PT_PT },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_PT_PT },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_PT_PT },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_PT_PT },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_PT_PT },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_PT_PT },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_PT_PT },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_PT_PT },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_PT_PT },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_PT_PT },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_PT_PT },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_PT_PT },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_PT_PT },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_PT_PT },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_PT_PT },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_PT_PT },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_PT_PT },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_PT_PT },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_PT_PT },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_PT_PT },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_PT_PT },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_PT_PT },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_PT_PT },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_PT_PT },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_PT_PT },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_PT_PT },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_PT_PT },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_PT_PT },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_PT_PT },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_PT_PT },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_PT_PT },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_PT_PT },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_PT_PT },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_PT_PT },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_PT_PT },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_PT_PT },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_PT_PT },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_PT_PT },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_PT_PT },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_PT_PT },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_PT_PT },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_PT_PT },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_PT_PT },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_PT_PT },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_PT_PT },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_PT_PT },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_PT_PT },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_PT_PT },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_PT_PT },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_PT_PT },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_PT_PT },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_PT_PT },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_PT_PT },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_PT_PT },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_PT_PT },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_PT_PT },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_PT_PT },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_PT_PT },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_PT_PT },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_PT_PT },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_PT_PT },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_PT_PT },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_PT_PT },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_PT_PT },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_PT_PT },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_PT_PT },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_PT_PT },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_PT_PT },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_PT_PT },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_PT_PT },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_PT_PT },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_PT_PT },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_PT_PT },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_PT_PT },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_PT_PT },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_PT_PT },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_PT_PT },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_PT_PT },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_PT_PT },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_PT_PT },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_PT_PT },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_PT_PT },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_PT_PT },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_PT_PT },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_PT_PT },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_PT_PT },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_PT_PT },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_PT_PT },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_PT_PT },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_PT_PT },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_PT_PT },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_PT_PT },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_PT_PT },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_PT_PT },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_PT_PT },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_PT_PT },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_PT_PT },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_PT_PT },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_PT_PT },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_PT_PT },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_PT_PT },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_PT_PT },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_PT_PT },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_PT_PT },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_PT_PT },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_PT_PT },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_PT_PT },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_PT_PT },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_PT_PT },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_PT_PT },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_PT_PT },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_PT_PT },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_PT_PT },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_PT_PT },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_PT_PT },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_PT_PT },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_PT_PT },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_PT_PT },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_PT_PT },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_PT_PT },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_PT_PT },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_PT_PT },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_PT_PT },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_PT_PT },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_PT_PT },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_PT_PT },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_PT_PT },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_PT_PT },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_PT_PT },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_PT_PT },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_PT_PT },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_PT_PT },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_PT_PT },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_PT_PT },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_PT_PT },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_PT_PT },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_PT_PT },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_PT_PT },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_PT_PT },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_PT_PT },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_PT_PT },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_PT_PT },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_PT_PT },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_PT_PT },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_PT_PT },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_PT_PT },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_PT_PT },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_PT_PT },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__PT_PT },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_PT_PT },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_PT_PT },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_PT_PT },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_PT_PT },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_PT_PT },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_PT_PT },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_PT_PT },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_PT_PT },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_PT_PT },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_PT_PT },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_PT_PT },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_PT_PT },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_PT_PT },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_PT_PT },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_PT_PT },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_PT_PT },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_PT_PT },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_PT_PT },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_PT_PT },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_PT_PT },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_PT_PT },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_PT_PT },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_PT_PT },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_PT_PT },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_PT_PT },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_PT_PT },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_PT_PT },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_PT_PT,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_PT_PT },
         { "always",   OPTION_VAL_ALWAYS_PT_PT },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_PT_PT,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_PT_PT },
         { "fast",     OPTION_VAL_FAST_PT_PT },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_PT_PT,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_PT_PT },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_PT_PT },
         { "below screen", OPTION_VAL_BELOW_SCREEN_PT_PT },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_PT_PT,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_PT_PT,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_PT_PT },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_PT_PT },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_PT_PT },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_PT_PT,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_PT_PT },
         { "cc",   OPTION_VAL_CC_PT_PT },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_PT_PT },
         { "GB",   OPTION_VAL_GB_PT_PT },
         { "GBC",  OPTION_VAL_GBC_PT_PT },
         { "GBA",  OPTION_VAL_GBA_PT_PT },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_PT_PT,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_PT_PT,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_PT_PT,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_PT_PT,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_PT_PT,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_PT_PT,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_PT_PT,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_MODE_INFO_0_PT_PT,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_PT_PT },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_PT_PT },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_PT_PT },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_PT_PT,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_PT_PT,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_PT_PT,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_pt_pt = {
   option_cats_pt_pt,
   option_defs_pt_pt
};

/* RETRO_LANGUAGE_RU */

#define CATEGORY_GB_LINK_LABEL_RU NULL
#define CATEGORY_GB_LINK_INFO_0_RU "Изменить сетевые настройки Game Link (мультиплеер)."
#define GAMBATTE_GB_COLORIZATION_LABEL_RU "Колоризация GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_RU "Включает колоризацию игр Game Boy. 'Авто' выбирает 'наилучшую' (наиболее подходящую/красочную) палитру. 'GBC' использует для игры предустановленную палитру Game Boy Color или, при её отсутствии, 'GBC - Dark Green'. 'SGB' использует для игры предустановленную палитру Super Game Boy или, при её отсутствии, 'SGB - 1A'. 'Встроенная' использует опцию 'Встроенная палитра'. 'Кастомная' загружает пользовательскую палитру из системного каталога."
#define OPTION_VAL_AUTO_RU "Авто"
#define OPTION_VAL_GBC_RU NULL
#define OPTION_VAL_SGB_RU NULL
#define OPTION_VAL_INTERNAL_RU "Встроенная"
#define OPTION_VAL_CUSTOM_RU "Пользовательская"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_RU "Встроенная палитра"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_RU "Палитра, используемая для раскрашивания игр Game Boy при установке опции 'Колоризация GB' в режим 'Встроенная' или когда установлен режим 'Авто' и для игры нет предустановленной палитры SGB/GBC. Палитры 'GB' имитируют оригинальное изображение консоли. Палитры 'GBC' идентичны встроенным пресетам Game Boy Color. Палитры 'SGB' соответствуют встроенным пресетам Super Game Boy."
#define OPTION_VAL_GB_DMG_RU NULL
#define OPTION_VAL_GB_POCKET_RU NULL
#define OPTION_VAL_GB_LIGHT_RU "GB - Светлая"
#define OPTION_VAL_GBC_BLUE_RU "GBC - Голубая"
#define OPTION_VAL_GBC_BROWN_RU "GBC - Коричневая"
#define OPTION_VAL_GBC_DARK_BLUE_RU "GBC - Тёмно-синяя"
#define OPTION_VAL_GBC_DARK_BROWN_RU "GBC - Тёмно-коричневая"
#define OPTION_VAL_GBC_DARK_GREEN_RU "GBC - Тёмно-зелёная"
#define OPTION_VAL_GBC_GRAYSCALE_RU "GBC - Оттенки серого"
#define OPTION_VAL_GBC_GREEN_RU "GBC - Зелёная"
#define OPTION_VAL_GBC_INVERTED_RU "GBC - Инверсия"
#define OPTION_VAL_GBC_ORANGE_RU "GBC - Оранжевая"
#define OPTION_VAL_GBC_PASTEL_MIX_RU "GBC - Пастельный микс"
#define OPTION_VAL_GBC_RED_RU "GBC - Красная"
#define OPTION_VAL_GBC_YELLOW_RU "GBC - Жёлтая"
#define OPTION_VAL_SGB_1A_RU NULL
#define OPTION_VAL_SGB_1B_RU NULL
#define OPTION_VAL_SGB_1C_RU NULL
#define OPTION_VAL_SGB_1D_RU NULL
#define OPTION_VAL_SGB_1E_RU NULL
#define OPTION_VAL_SGB_1F_RU NULL
#define OPTION_VAL_SGB_1G_RU NULL
#define OPTION_VAL_SGB_1H_RU NULL
#define OPTION_VAL_SGB_2A_RU NULL
#define OPTION_VAL_SGB_2B_RU NULL
#define OPTION_VAL_SGB_2C_RU NULL
#define OPTION_VAL_SGB_2D_RU NULL
#define OPTION_VAL_SGB_2E_RU NULL
#define OPTION_VAL_SGB_2F_RU NULL
#define OPTION_VAL_SGB_2G_RU NULL
#define OPTION_VAL_SGB_2H_RU NULL
#define OPTION_VAL_SGB_3A_RU NULL
#define OPTION_VAL_SGB_3B_RU NULL
#define OPTION_VAL_SGB_3C_RU NULL
#define OPTION_VAL_SGB_3D_RU NULL
#define OPTION_VAL_SGB_3E_RU NULL
#define OPTION_VAL_SGB_3F_RU NULL
#define OPTION_VAL_SGB_3G_RU NULL
#define OPTION_VAL_SGB_3H_RU NULL
#define OPTION_VAL_SGB_4A_RU NULL
#define OPTION_VAL_SGB_4B_RU NULL
#define OPTION_VAL_SGB_4C_RU NULL
#define OPTION_VAL_SGB_4D_RU NULL
#define OPTION_VAL_SGB_4E_RU NULL
#define OPTION_VAL_SGB_4F_RU NULL
#define OPTION_VAL_SGB_4G_RU NULL
#define OPTION_VAL_SGB_4H_RU NULL
#define OPTION_VAL_SPECIAL_1_RU "Особая 1"
#define OPTION_VAL_SPECIAL_2_RU "Особая 2"
#define OPTION_VAL_SPECIAL_3_RU "Особая 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_RU NULL
#define OPTION_VAL_TWB64_PACK_1_RU "TWB64 - Пакет 1"
#define OPTION_VAL_TWB64_PACK_2_RU "TWB64 - Пакет 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_RU NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_RU "> Палитра TWB64 - Пакет 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_RU "Выбор встроенной палитры колоризации при установке параметра 'Встроенная палитра' на 'TWB64 - Пакет 1'."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_RU NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_RU NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_RU NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_RU NULL
#define OPTION_VAL_TWB64_005_NEON_RED_RU NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_RU NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_RU NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_RU NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_RU NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_RU NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_RU NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_RU NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_RU NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_RU NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_RU NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_RU NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_RU NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_RU NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_RU NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_RU NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_RU NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_RU NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_RU NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_RU NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_RU NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_RU NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_RU NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_RU NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_RU NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_RU NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_RU NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_RU NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_RU NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_RU NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_RU NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_RU NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_RU NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_RU NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_RU NULL
#define OPTION_VAL_TWB64_040_DMG_VER_RU NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_RU NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_RU NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_RU NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_RU NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_RU NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_RU NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_RU NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_RU NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_RU NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_RU NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_RU NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_RU NULL
#define OPTION_VAL_TWB64_053_VMU_VER_RU NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_RU NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_RU NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_RU NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_RU NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_RU NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_RU NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_RU NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_RU NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_RU NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_RU NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_RU NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_RU NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_RU NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_RU NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_RU NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_RU NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_RU NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_RU NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_RU NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_RU NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_RU NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_RU NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_RU NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_RU NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_RU NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_RU NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_RU NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_RU NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_RU NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_RU NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_RU NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_RU NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_RU NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_RU NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_RU NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_RU NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_RU NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_RU NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_RU NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_RU NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_RU NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_RU NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_RU NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_RU NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_RU NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_RU NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_RU NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_RU "> Палитра TWB64 - Пакет 2"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_RU "Выбор встроенной палитры колоризации при установке параметра 'Встроенная палитра' на 'TWB64 - Пакет 2'."
#define OPTION_VAL_TWB64_101_765PRO_PINK_RU NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_RU NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_RU NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_RU NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_RU NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_RU NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_RU NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_RU NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_RU NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_RU NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_RU NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_RU NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_RU NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_RU NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_RU NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_RU NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_RU NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_RU NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_RU NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_RU NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_RU NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_RU NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_RU NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_RU NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_RU NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_RU NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_RU NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_RU NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_RU NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_RU NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_RU NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_RU NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_RU NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_RU NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_RU NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_RU NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_RU NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_RU NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_RU NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_RU NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_RU NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_RU NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_RU NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_RU NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_RU NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_RU NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_RU NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_RU NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_RU NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_RU NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_RU NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_RU NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_RU NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_RU NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_RU NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_RU NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_RU NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_RU NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_RU NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_RU NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_RU NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_RU NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_RU NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_RU NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_RU NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_RU NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_RU NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_RU NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_RU NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_RU NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_RU NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_RU NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_RU NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_RU NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_RU NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_RU NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_RU NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_RU NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_RU NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_RU NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_RU NULL
#define OPTION_VAL_TWB64_182_PINK109_RU NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_RU NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_RU NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_RU NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_RU NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_RU NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_RU NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_RU NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_RU NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_RU NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_RU NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_RU NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_RU NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_RU NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_RU NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_RU NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_RU NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_RU NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_RU NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_RU NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_RU NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_RU NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_RU NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_RU NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_RU NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_RU NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_RU NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_RU NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_RU NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_RU NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_RU NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_RU NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_RU NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_RU NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_RU NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_RU NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_RU NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_RU NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__RU NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_RU NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_RU NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_RU NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_RU NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_RU NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_RU NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_RU NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_RU NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_RU NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_RU NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_RU NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_RU NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_RU NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_RU NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_RU NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_RU NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_RU NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_RU NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_RU NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_RU NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_RU NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_RU NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_RU NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_RU NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_RU NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_RU NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_RU NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_RU "Коррекция цвета"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_RU "Подстройка цветности для соответствия изображению на дисплее реального Game Boy Color. 'Только GBC' применяет коррекцию при запуске игр Game Boy Color или когда для колоризации игры Game Boy используется палитра Game Boy Color. 'Всегда' применяет цветокоррекцию ко всему контенту и приводит к нежелательным результатам при использовании встроенных палитр 'GB' или 'SGB'."
#define OPTION_VAL_GBC_ONLY_RU "Только GBC"
#define OPTION_VAL_ALWAYS_RU "Всегда"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_RU "Режим цветокоррекции"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_RU "Выбор режима, используемого для цветокоррекции. 'Точный' воспроизводит цвета практически неотличимо от реальной ЖК-панели Game Boy Color. 'Быстрый' только затемняет цвета и уменьшает насыщенность и подходит для слабых устройств в том случае, когда 'Точный' режим работает слишком медленно."
#define OPTION_VAL_ACCURATE_RU "Точный"
#define OPTION_VAL_FAST_RU "Быстро"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_RU "Цветокоррекция - источник света"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_RU "Имитирует физический отклик ЖК-панели Game Boy Color при освещении с разных углов. 'По центру' соответствует стандартной цветопередаче. 'Над экраном' увеличивает яркость. 'Под экраном' уменьшает яркость. Данная настройка применяется только в том случае, если 'Режим цветокоррекции' имеет значение 'Точный'."
#define OPTION_VAL_CENTRAL_RU "По центру"
#define OPTION_VAL_ABOVE_SCREEN_RU "Над экраном"
#define OPTION_VAL_BELOW_SCREEN_RU "Под экраном"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_RU "Уровень фильтра затемнения (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_RU "Включает уменьшение яркости в зависимости от освещённости. Может использоваться для избежания перенапряжения глаз в играх с белым задним фоном, предназначенным для Game Boy Color без подсветки и способным вызвать дискомфорт из-за избыточной яркости на современных экранах с подсветкой."
#define GAMBATTE_MIX_FRAMES_LABEL_RU "Межкадровое смешение"
#define GAMBATTE_MIX_FRAMES_INFO_0_RU "Имитация эффекта двоения LCD. 'Простое' смешивает текущие кадры с предыдущими в пропорции 50:50. 'Двоение LCD' имитирует естественное время отклика LCD объединением нескольких буферированных кадров. 'Простое' смешение требуется для игр, использующих LCD-гостинг для эффектов прозрачности (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...)."
#define OPTION_VAL_MIX_RU "Простое"
#define OPTION_VAL_LCD_GHOSTING_RU "Двоение ЖК (точно)"
#define OPTION_VAL_LCD_GHOSTING_FAST_RU "Двоение ЖК (быстро)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_RU "Аудиоресемплер"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_RU NULL
#define OPTION_VAL_SINC_RU NULL
#define OPTION_VAL_CC_RU NULL
#define GAMBATTE_GB_HWMODE_LABEL_RU "Модель консоли (требуется перезапуск)"
#define GAMBATTE_GB_HWMODE_INFO_0_RU "Выбор системы для эмуляции. Рекомендуется установить 'Авто'. Выбор 'GBA' открывает новые возможности в некоторых играх Game Boy Color с улучшениями для GBA (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...)."
#define OPTION_VAL_GB_RU NULL
#define OPTION_VAL_GBA_RU NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_RU "Исп. официальный загрузчик (требуется перезапуск)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_RU "Включает поддержку официальных загрузчиков Game Boy и Game Boy Color с соответствующей анимацией запуска."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_RU "Разрешить противоположные направления"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_RU "Позволяет нажимать/быстро менять/зажимать одновременно направления влево и вправо (или вверх и вниз). Может вызывать глитчи, связанные с перемещением."
#define GAMBATTE_TURBO_PERIOD_LABEL_RU "Период турбо-кнопки"
#define GAMBATTE_TURBO_PERIOD_INFO_0_RU "Устанавливает интервал повтора (в кадрах) при удерживании турбо-кнопок A/B."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_RU "Сила отдачи контроллера"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_RU "Включает эффекты тактильной отдачи для игр с поддержкой (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_RU "Показывать настройки Game Link"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_RU "Включить настройку сетевых параметров Game Link (мультиплеера). Для применения изменений требуется переключить быстрое меню."
#define GAMBATTE_GB_LINK_MODE_LABEL_RU "Режим Game Link"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_RU "Режим связи"
#define GAMBATTE_GB_LINK_MODE_INFO_0_RU "Выбор режима сервера или клиента для текущей копии ядра при включении функции Game Link."
#define OPTION_VAL_NOT_CONNECTED_RU "Не подключено"
#define OPTION_VAL_NETWORK_SERVER_RU "Сетевой сервер"
#define OPTION_VAL_NETWORK_CLIENT_RU "Сетевой клиент"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_RU "Сетевой порт связи"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_RU "Порт"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_RU "Устанавливает порт, используемый для связи с Game Link."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_RU "Адрес сетевого сервера связи ч. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_RU "Адрес сервера ч. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_RU "1-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_RU "1-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_RU "Адрес сетевого сервера связи ч. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_RU "Адрес сервера ч. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_RU "2-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_RU "2-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_RU "Адрес сетевого сервера связи ч. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_RU "Адрес сервера ч. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_RU "3-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_RU "3-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_RU "Адрес сетевого сервера связи ч. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_RU "Адрес сервера ч. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_RU "4-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_RU "4-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_RU "Адрес сетевого сервера связи ч. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_RU "Адрес сервера ч. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_RU "5-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_RU "5-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_RU "Адрес сетевого сервера связи ч. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_RU "Адрес сервера ч. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_RU "6-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_RU "6-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_RU "Адрес сетевого сервера связи ч. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_RU "Адрес сервера ч. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_RU "7-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_RU "7-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_RU "Адрес сетевого сервера связи ч. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_RU "Адрес сервера ч. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_RU "8-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_RU "8-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_RU "Адрес сетевого сервера связи ч. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_RU "Адрес сервера ч. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_RU "9-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_RU "9-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_RU "Адрес сетевого сервера связи ч. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_RU "Адрес сервера ч. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_RU "10-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_RU "10-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_RU "Адрес сетевого сервера связи ч. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_RU "Адрес сервера ч. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_RU "11-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_RU "11-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_RU "Адрес сетевого сервера связи ч. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_RU "Адрес сервера ч. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_RU "12-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим Game Link' установлен в 'Сетевой клиент'."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_RU "12-я цифра IP-адреса удалённого сервера Game Link. Используется только когда 'Режим связи' установлен в 'Сетевой клиент'."

struct retro_core_option_v2_category option_cats_ru[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_RU,
      CATEGORY_GB_LINK_INFO_0_RU
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_ru[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_RU,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_RU,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_RU },
         { "GBC",      OPTION_VAL_GBC_RU },
         { "SGB",      OPTION_VAL_SGB_RU },
         { "internal", OPTION_VAL_INTERNAL_RU },
         { "custom",   OPTION_VAL_CUSTOM_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_RU,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_RU,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_RU },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_RU },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_RU },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_RU },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_RU },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_RU },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_RU },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_RU },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_RU },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_RU },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_RU },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_RU },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_RU },
         { "GBC - Red",                OPTION_VAL_GBC_RED_RU },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_RU },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_RU },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_RU },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_RU },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_RU },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_RU },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_RU },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_RU },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_RU },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_RU },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_RU },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_RU },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_RU },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_RU },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_RU },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_RU },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_RU },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_RU },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_RU },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_RU },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_RU },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_RU },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_RU },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_RU },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_RU },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_RU },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_RU },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_RU },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_RU },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_RU },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_RU },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_RU },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_RU },
         { "Special 1",                OPTION_VAL_SPECIAL_1_RU },
         { "Special 2",                OPTION_VAL_SPECIAL_2_RU },
         { "Special 3",                OPTION_VAL_SPECIAL_3_RU },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_RU },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_RU },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_RU },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_RU },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_RU,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_RU,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_RU },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_RU },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_RU },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_RU },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_RU },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_RU },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_RU },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_RU },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_RU },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_RU },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_RU },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_RU },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_RU },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_RU },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_RU },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_RU },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_RU },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_RU },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_RU },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_RU },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_RU },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_RU },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_RU },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_RU },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_RU },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_RU },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_RU },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_RU },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_RU },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_RU },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_RU },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_RU },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_RU },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_RU },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_RU },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_RU },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_RU },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_RU },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_RU },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_RU },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_RU },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_RU },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_RU },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_RU },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_RU },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_RU },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_RU },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_RU },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_RU },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_RU },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_RU },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_RU },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_RU },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_RU },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_RU },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_RU },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_RU },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_RU },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_RU },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_RU },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_RU },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_RU },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_RU },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_RU },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_RU },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_RU },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_RU },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_RU },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_RU },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_RU },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_RU },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_RU },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_RU },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_RU },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_RU },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_RU },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_RU },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_RU },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_RU },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_RU },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_RU },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_RU },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_RU },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_RU },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_RU },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_RU },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_RU },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_RU },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_RU },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_RU },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_RU },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_RU },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_RU },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_RU },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_RU },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_RU },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_RU },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_RU },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_RU },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_RU },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_RU,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_RU,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_RU },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_RU },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_RU },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_RU },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_RU },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_RU },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_RU },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_RU },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_RU },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_RU },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_RU },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_RU },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_RU },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_RU },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_RU },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_RU },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_RU },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_RU },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_RU },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_RU },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_RU },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_RU },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_RU },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_RU },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_RU },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_RU },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_RU },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_RU },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_RU },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_RU },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_RU },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_RU },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_RU },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_RU },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_RU },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_RU },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_RU },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_RU },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_RU },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_RU },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_RU },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_RU },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_RU },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_RU },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_RU },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_RU },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_RU },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_RU },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_RU },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_RU },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_RU },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_RU },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_RU },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_RU },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_RU },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_RU },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_RU },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_RU },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_RU },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_RU },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_RU },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_RU },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_RU },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_RU },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_RU },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_RU },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_RU },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_RU },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_RU },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_RU },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_RU },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_RU },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_RU },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_RU },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_RU },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_RU },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_RU },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_RU },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_RU },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_RU },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_RU },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_RU },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_RU },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_RU },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_RU },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_RU },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_RU },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_RU },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_RU },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_RU },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_RU },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_RU },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_RU },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_RU },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_RU },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_RU },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_RU },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_RU },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_RU },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_RU },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_RU,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_RU,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_RU },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_RU },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_RU },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_RU },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_RU },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_RU },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_RU },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_RU },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_RU },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_RU },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_RU },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_RU },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_RU },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_RU },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_RU },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_RU },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_RU },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__RU },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_RU },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_RU },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_RU },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_RU },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_RU },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_RU },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_RU },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_RU },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_RU },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_RU },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_RU },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_RU },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_RU },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_RU },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_RU },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_RU },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_RU },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_RU },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_RU },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_RU },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_RU },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_RU },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_RU },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_RU },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_RU },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_RU },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_RU },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_RU,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_RU,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_RU },
         { "always",   OPTION_VAL_ALWAYS_RU },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_RU,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_RU,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_RU },
         { "fast",     OPTION_VAL_FAST_RU },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_RU,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_RU,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_RU },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_RU },
         { "below screen", OPTION_VAL_BELOW_SCREEN_RU },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_RU,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_RU,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_RU,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_RU,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_RU },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_RU },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_RU },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_RU,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_RU,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_RU },
         { "cc",   OPTION_VAL_CC_RU },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_RU,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_RU,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_RU },
         { "GB",   OPTION_VAL_GB_RU },
         { "GBC",  OPTION_VAL_GBC_RU },
         { "GBA",  OPTION_VAL_GBA_RU },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_RU,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_RU,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_RU,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_RU,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_RU,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_RU,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_RU,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_RU,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_RU,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_RU,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_RU,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_MODE_INFO_0_RU,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_RU },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_RU },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_RU },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_RU,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_RU,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_RU,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_ru = {
   option_cats_ru,
   option_defs_ru
};

/* RETRO_LANGUAGE_SK */

#define CATEGORY_GB_LINK_LABEL_SK NULL
#define CATEGORY_GB_LINK_INFO_0_SK NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_SK NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_SK NULL
#define OPTION_VAL_AUTO_SK NULL
#define OPTION_VAL_GBC_SK NULL
#define OPTION_VAL_SGB_SK NULL
#define OPTION_VAL_INTERNAL_SK "Interné"
#define OPTION_VAL_CUSTOM_SK "Vlastné"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_SK "Vnútorná paleta"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_SK NULL
#define OPTION_VAL_GB_DMG_SK NULL
#define OPTION_VAL_GB_POCKET_SK NULL
#define OPTION_VAL_GB_LIGHT_SK NULL
#define OPTION_VAL_GBC_BLUE_SK "GBC - modrá"
#define OPTION_VAL_GBC_BROWN_SK "GBC - hnedá"
#define OPTION_VAL_GBC_DARK_BLUE_SK "GBC - tmavomodrá"
#define OPTION_VAL_GBC_DARK_BROWN_SK "GBC - tmavohnedá"
#define OPTION_VAL_GBC_DARK_GREEN_SK "GBC - tmavozelená"
#define OPTION_VAL_GBC_GRAYSCALE_SK "GBC - šedá"
#define OPTION_VAL_GBC_GREEN_SK "GBC - zelená"
#define OPTION_VAL_GBC_INVERTED_SK "GBC - inverzná"
#define OPTION_VAL_GBC_ORANGE_SK "GBC - oranžová"
#define OPTION_VAL_GBC_PASTEL_MIX_SK "GBC - pastelový mix"
#define OPTION_VAL_GBC_RED_SK "GBC - červená"
#define OPTION_VAL_GBC_YELLOW_SK "GBC - žltá"
#define OPTION_VAL_SGB_1A_SK NULL
#define OPTION_VAL_SGB_1B_SK NULL
#define OPTION_VAL_SGB_1C_SK NULL
#define OPTION_VAL_SGB_1D_SK NULL
#define OPTION_VAL_SGB_1E_SK NULL
#define OPTION_VAL_SGB_1F_SK NULL
#define OPTION_VAL_SGB_1G_SK NULL
#define OPTION_VAL_SGB_1H_SK NULL
#define OPTION_VAL_SGB_2A_SK NULL
#define OPTION_VAL_SGB_2B_SK NULL
#define OPTION_VAL_SGB_2C_SK NULL
#define OPTION_VAL_SGB_2D_SK NULL
#define OPTION_VAL_SGB_2E_SK NULL
#define OPTION_VAL_SGB_2F_SK NULL
#define OPTION_VAL_SGB_2G_SK NULL
#define OPTION_VAL_SGB_2H_SK NULL
#define OPTION_VAL_SGB_3A_SK NULL
#define OPTION_VAL_SGB_3B_SK NULL
#define OPTION_VAL_SGB_3C_SK NULL
#define OPTION_VAL_SGB_3D_SK NULL
#define OPTION_VAL_SGB_3E_SK NULL
#define OPTION_VAL_SGB_3F_SK NULL
#define OPTION_VAL_SGB_3G_SK NULL
#define OPTION_VAL_SGB_3H_SK NULL
#define OPTION_VAL_SGB_4A_SK NULL
#define OPTION_VAL_SGB_4B_SK NULL
#define OPTION_VAL_SGB_4C_SK NULL
#define OPTION_VAL_SGB_4D_SK NULL
#define OPTION_VAL_SGB_4E_SK NULL
#define OPTION_VAL_SGB_4F_SK NULL
#define OPTION_VAL_SGB_4G_SK NULL
#define OPTION_VAL_SGB_4H_SK NULL
#define OPTION_VAL_SPECIAL_1_SK "Špeciálne 1"
#define OPTION_VAL_SPECIAL_2_SK "Špeciálne 2"
#define OPTION_VAL_SPECIAL_3_SK "Špeciálne 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_SK "Špeciálne 4 (TI-83 Legacy)"
#define OPTION_VAL_TWB64_PACK_1_SK NULL
#define OPTION_VAL_TWB64_PACK_2_SK NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_SK NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_SK NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_SK NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_SK NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_SK NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_SK NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_SK NULL
#define OPTION_VAL_TWB64_005_NEON_RED_SK NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_SK NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_SK NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_SK NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_SK NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_SK NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_SK NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_SK NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_SK NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_SK NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_SK NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_SK NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_SK NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_SK NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_SK NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_SK NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_SK NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_SK NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_SK NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_SK NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_SK NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_SK NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_SK NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_SK NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_SK NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_SK NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_SK NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_SK NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_SK NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_SK NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_SK NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_SK NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_SK NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_SK NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_SK NULL
#define OPTION_VAL_TWB64_040_DMG_VER_SK NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_SK NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_SK NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_SK NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_SK NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_SK NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_SK NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_SK NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_SK NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_SK NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_SK NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_SK NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_SK NULL
#define OPTION_VAL_TWB64_053_VMU_VER_SK NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_SK NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_SK NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_SK NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_SK NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_SK NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_SK NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_SK NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_SK NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_SK NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_SK NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_SK NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_SK NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_SK NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_SK NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_SK NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_SK NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_SK NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_SK NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_SK NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_SK NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_SK NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_SK NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_SK NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_SK NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_SK NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_SK NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_SK NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_SK NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_SK NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_SK NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_SK NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_SK NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_SK NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_SK NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_SK NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_SK NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_SK NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_SK NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_SK NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_SK NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_SK NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_SK NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_SK NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_SK NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_SK NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_SK NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_SK NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_SK NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_SK NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_SK NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_SK NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_SK NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_SK NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_SK NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_SK NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_SK NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_SK NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_SK NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_SK NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_SK NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_SK NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_SK NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_SK NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_SK NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_SK NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_SK NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_SK NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_SK NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_SK NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_SK NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_SK NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_SK NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_SK NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_SK NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_SK NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_SK NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_SK NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_SK NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_SK NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_SK NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_SK NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_SK NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_SK NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_SK NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_SK NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_SK NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_SK NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_SK NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_SK NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_SK NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_SK NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_SK NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_SK NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_SK NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_SK NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_SK NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_SK NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_SK NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_SK NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_SK NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_SK NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_SK NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_SK NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_SK NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_SK NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_SK NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_SK NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_SK NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_SK NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_SK NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_SK NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_SK NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_SK NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_SK NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_SK NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_SK NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_SK NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_SK NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_SK NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_SK NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_SK NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_SK NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_SK NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_SK NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_SK NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_SK NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_SK NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_SK NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_SK NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_SK NULL
#define OPTION_VAL_TWB64_182_PINK109_SK NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_SK NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_SK NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_SK NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_SK NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_SK NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_SK NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_SK NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_SK NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_SK NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_SK NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_SK NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_SK NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_SK NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_SK NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_SK NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_SK NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_SK NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_SK NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_SK NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_SK NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_SK NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_SK NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_SK NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_SK NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_SK NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_SK NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_SK NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_SK NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_SK NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_SK NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_SK NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_SK NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_SK NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_SK NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_SK NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_SK NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_SK NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__SK NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_SK NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_SK NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_SK NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_SK NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_SK NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_SK NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_SK NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_SK NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_SK NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_SK NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_SK NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_SK NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_SK NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_SK NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_SK NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_SK NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_SK NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_SK NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_SK NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_SK NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_SK NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_SK NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_SK NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_SK NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_SK NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_SK NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_SK NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_SK "Korekcia farieb"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_SK NULL
#define OPTION_VAL_GBC_ONLY_SK "Iba GBC"
#define OPTION_VAL_ALWAYS_SK "Vždy"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_SK NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_SK NULL
#define OPTION_VAL_ACCURATE_SK "Presné"
#define OPTION_VAL_FAST_SK "Rýchlo"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_SK NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_SK NULL
#define OPTION_VAL_CENTRAL_SK "Centrálny"
#define OPTION_VAL_ABOVE_SCREEN_SK NULL
#define OPTION_VAL_BELOW_SCREEN_SK NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_SK NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_SK NULL
#define GAMBATTE_MIX_FRAMES_LABEL_SK NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_SK NULL
#define OPTION_VAL_MIX_SK "Jednoduché"
#define OPTION_VAL_LCD_GHOSTING_SK NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_SK NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_SK "Vzorkovač zvuku"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_SK NULL
#define OPTION_VAL_SINC_SK NULL
#define OPTION_VAL_CC_SK "Kosínus"
#define GAMBATTE_GB_HWMODE_LABEL_SK NULL
#define GAMBATTE_GB_HWMODE_INFO_0_SK NULL
#define OPTION_VAL_GB_SK NULL
#define OPTION_VAL_GBA_SK NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_SK NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_SK NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_SK NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_SK NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_SK NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_SK NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_SK NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_SK NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_SK NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_SK NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_SK NULL
#define OPTION_VAL_NOT_CONNECTED_SK "Nepripojené"
#define OPTION_VAL_NETWORK_SERVER_SK "Sieťový server"
#define OPTION_VAL_NETWORK_CLIENT_SK "Sieťový klient"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_SK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_SK NULL

struct retro_core_option_v2_category option_cats_sk[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_SK,
      CATEGORY_GB_LINK_INFO_0_SK
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_sk[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_SK,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_SK,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_SK },
         { "GBC",      OPTION_VAL_GBC_SK },
         { "SGB",      OPTION_VAL_SGB_SK },
         { "internal", OPTION_VAL_INTERNAL_SK },
         { "custom",   OPTION_VAL_CUSTOM_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_SK,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_SK,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_SK },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_SK },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_SK },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_SK },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_SK },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_SK },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_SK },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_SK },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_SK },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_SK },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_SK },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_SK },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_SK },
         { "GBC - Red",                OPTION_VAL_GBC_RED_SK },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_SK },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_SK },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_SK },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_SK },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_SK },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_SK },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_SK },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_SK },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_SK },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_SK },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_SK },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_SK },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_SK },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_SK },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_SK },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_SK },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_SK },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_SK },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_SK },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_SK },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_SK },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_SK },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_SK },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_SK },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_SK },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_SK },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_SK },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_SK },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_SK },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_SK },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_SK },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_SK },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_SK },
         { "Special 1",                OPTION_VAL_SPECIAL_1_SK },
         { "Special 2",                OPTION_VAL_SPECIAL_2_SK },
         { "Special 3",                OPTION_VAL_SPECIAL_3_SK },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_SK },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_SK },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_SK },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_SK },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_SK,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_SK,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_SK },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_SK },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_SK },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_SK },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_SK },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_SK },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_SK },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_SK },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_SK },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_SK },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_SK },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_SK },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_SK },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_SK },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_SK },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_SK },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_SK },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_SK },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_SK },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_SK },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_SK },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_SK },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_SK },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_SK },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_SK },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_SK },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_SK },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_SK },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_SK },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_SK },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_SK },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_SK },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_SK },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_SK },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_SK },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_SK },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_SK },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_SK },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_SK },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_SK },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_SK },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_SK },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_SK },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_SK },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_SK },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_SK },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_SK },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_SK },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_SK },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_SK },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_SK },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_SK },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_SK },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_SK },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_SK },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_SK },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_SK },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_SK },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_SK },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_SK },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_SK },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_SK },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_SK },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_SK },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_SK },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_SK },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_SK },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_SK },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_SK },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_SK },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_SK },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_SK },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_SK },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_SK },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_SK },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_SK },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_SK },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_SK },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_SK },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_SK },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_SK },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_SK },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_SK },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_SK },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_SK },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_SK },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_SK },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_SK },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_SK },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_SK },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_SK },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_SK },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_SK },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_SK },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_SK },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_SK },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_SK },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_SK },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_SK },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_SK },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_SK,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_SK,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_SK },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_SK },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_SK },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_SK },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_SK },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_SK },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_SK },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_SK },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_SK },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_SK },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_SK },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_SK },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_SK },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_SK },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_SK },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_SK },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_SK },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_SK },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_SK },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_SK },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_SK },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_SK },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_SK },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_SK },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_SK },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_SK },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_SK },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_SK },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_SK },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_SK },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_SK },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_SK },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_SK },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_SK },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_SK },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_SK },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_SK },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_SK },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_SK },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_SK },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_SK },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_SK },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_SK },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_SK },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_SK },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_SK },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_SK },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_SK },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_SK },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_SK },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_SK },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_SK },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_SK },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_SK },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_SK },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_SK },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_SK },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_SK },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_SK },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_SK },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_SK },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_SK },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_SK },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_SK },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_SK },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_SK },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_SK },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_SK },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_SK },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_SK },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_SK },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_SK },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_SK },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_SK },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_SK },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_SK },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_SK },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_SK },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_SK },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_SK },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_SK },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_SK },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_SK },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_SK },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_SK },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_SK },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_SK },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_SK },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_SK },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_SK },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_SK },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_SK },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_SK },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_SK },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_SK },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_SK },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_SK },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_SK },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_SK },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_SK },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_SK,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_SK,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_SK },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_SK },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_SK },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_SK },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_SK },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_SK },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_SK },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_SK },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_SK },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_SK },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_SK },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_SK },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_SK },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_SK },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_SK },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_SK },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_SK },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__SK },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_SK },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_SK },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_SK },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_SK },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_SK },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_SK },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_SK },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_SK },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_SK },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_SK },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_SK },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_SK },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_SK },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_SK },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_SK },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_SK },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_SK },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_SK },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_SK },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_SK },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_SK },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_SK },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_SK },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_SK },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_SK },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_SK },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_SK },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_SK,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_SK,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_SK },
         { "always",   OPTION_VAL_ALWAYS_SK },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_SK,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_SK,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_SK },
         { "fast",     OPTION_VAL_FAST_SK },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_SK,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_SK,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_SK },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_SK },
         { "below screen", OPTION_VAL_BELOW_SCREEN_SK },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_SK,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_SK,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_SK,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_SK,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_SK },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_SK },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_SK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_SK,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_SK,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_SK },
         { "cc",   OPTION_VAL_CC_SK },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_SK,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_SK,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_SK },
         { "GB",   OPTION_VAL_GB_SK },
         { "GBC",  OPTION_VAL_GBC_SK },
         { "GBA",  OPTION_VAL_GBA_SK },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_SK,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_SK,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_SK,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_SK,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_SK,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_SK,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_SK,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_SK,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_SK,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_SK,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_SK,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_MODE_INFO_0_SK,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_SK },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_SK },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_SK },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_SK,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_SK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_SK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_sk = {
   option_cats_sk,
   option_defs_sk
};

/* RETRO_LANGUAGE_SR */

#define CATEGORY_GB_LINK_LABEL_SR NULL
#define CATEGORY_GB_LINK_INFO_0_SR NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_SR NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_SR NULL
#define OPTION_VAL_AUTO_SR NULL
#define OPTION_VAL_GBC_SR NULL
#define OPTION_VAL_SGB_SR NULL
#define OPTION_VAL_INTERNAL_SR NULL
#define OPTION_VAL_CUSTOM_SR NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_SR NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_SR NULL
#define OPTION_VAL_GB_DMG_SR NULL
#define OPTION_VAL_GB_POCKET_SR NULL
#define OPTION_VAL_GB_LIGHT_SR NULL
#define OPTION_VAL_GBC_BLUE_SR NULL
#define OPTION_VAL_GBC_BROWN_SR NULL
#define OPTION_VAL_GBC_DARK_BLUE_SR NULL
#define OPTION_VAL_GBC_DARK_BROWN_SR NULL
#define OPTION_VAL_GBC_DARK_GREEN_SR NULL
#define OPTION_VAL_GBC_GRAYSCALE_SR NULL
#define OPTION_VAL_GBC_GREEN_SR NULL
#define OPTION_VAL_GBC_INVERTED_SR NULL
#define OPTION_VAL_GBC_ORANGE_SR NULL
#define OPTION_VAL_GBC_PASTEL_MIX_SR NULL
#define OPTION_VAL_GBC_RED_SR NULL
#define OPTION_VAL_GBC_YELLOW_SR NULL
#define OPTION_VAL_SGB_1A_SR NULL
#define OPTION_VAL_SGB_1B_SR NULL
#define OPTION_VAL_SGB_1C_SR NULL
#define OPTION_VAL_SGB_1D_SR NULL
#define OPTION_VAL_SGB_1E_SR NULL
#define OPTION_VAL_SGB_1F_SR NULL
#define OPTION_VAL_SGB_1G_SR NULL
#define OPTION_VAL_SGB_1H_SR NULL
#define OPTION_VAL_SGB_2A_SR NULL
#define OPTION_VAL_SGB_2B_SR NULL
#define OPTION_VAL_SGB_2C_SR NULL
#define OPTION_VAL_SGB_2D_SR NULL
#define OPTION_VAL_SGB_2E_SR NULL
#define OPTION_VAL_SGB_2F_SR NULL
#define OPTION_VAL_SGB_2G_SR NULL
#define OPTION_VAL_SGB_2H_SR NULL
#define OPTION_VAL_SGB_3A_SR NULL
#define OPTION_VAL_SGB_3B_SR NULL
#define OPTION_VAL_SGB_3C_SR NULL
#define OPTION_VAL_SGB_3D_SR NULL
#define OPTION_VAL_SGB_3E_SR NULL
#define OPTION_VAL_SGB_3F_SR NULL
#define OPTION_VAL_SGB_3G_SR NULL
#define OPTION_VAL_SGB_3H_SR NULL
#define OPTION_VAL_SGB_4A_SR NULL
#define OPTION_VAL_SGB_4B_SR NULL
#define OPTION_VAL_SGB_4C_SR NULL
#define OPTION_VAL_SGB_4D_SR NULL
#define OPTION_VAL_SGB_4E_SR NULL
#define OPTION_VAL_SGB_4F_SR NULL
#define OPTION_VAL_SGB_4G_SR NULL
#define OPTION_VAL_SGB_4H_SR NULL
#define OPTION_VAL_SPECIAL_1_SR NULL
#define OPTION_VAL_SPECIAL_2_SR NULL
#define OPTION_VAL_SPECIAL_3_SR NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_SR NULL
#define OPTION_VAL_TWB64_PACK_1_SR NULL
#define OPTION_VAL_TWB64_PACK_2_SR NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_SR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_SR NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_SR NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_SR NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_SR NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_SR NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_SR NULL
#define OPTION_VAL_TWB64_005_NEON_RED_SR NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_SR NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_SR NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_SR NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_SR NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_SR NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_SR NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_SR NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_SR NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_SR NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_SR NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_SR NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_SR NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_SR NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_SR NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_SR NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_SR NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_SR NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_SR NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_SR NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_SR NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_SR NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_SR NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_SR NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_SR NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_SR NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_SR NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_SR NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_SR NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_SR NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_SR NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_SR NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_SR NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_SR NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_SR NULL
#define OPTION_VAL_TWB64_040_DMG_VER_SR NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_SR NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_SR NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_SR NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_SR NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_SR NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_SR NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_SR NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_SR NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_SR NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_SR NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_SR NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_SR NULL
#define OPTION_VAL_TWB64_053_VMU_VER_SR NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_SR NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_SR NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_SR NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_SR NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_SR NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_SR NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_SR NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_SR NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_SR NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_SR NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_SR NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_SR NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_SR NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_SR NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_SR NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_SR NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_SR NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_SR NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_SR NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_SR NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_SR NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_SR NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_SR NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_SR NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_SR NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_SR NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_SR NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_SR NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_SR NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_SR NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_SR NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_SR NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_SR NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_SR NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_SR NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_SR NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_SR NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_SR NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_SR NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_SR NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_SR NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_SR NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_SR NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_SR NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_SR NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_SR NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_SR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_SR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_SR NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_SR NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_SR NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_SR NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_SR NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_SR NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_SR NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_SR NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_SR NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_SR NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_SR NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_SR NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_SR NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_SR NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_SR NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_SR NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_SR NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_SR NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_SR NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_SR NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_SR NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_SR NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_SR NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_SR NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_SR NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_SR NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_SR NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_SR NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_SR NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_SR NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_SR NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_SR NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_SR NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_SR NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_SR NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_SR NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_SR NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_SR NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_SR NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_SR NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_SR NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_SR NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_SR NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_SR NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_SR NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_SR NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_SR NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_SR NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_SR NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_SR NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_SR NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_SR NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_SR NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_SR NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_SR NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_SR NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_SR NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_SR NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_SR NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_SR NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_SR NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_SR NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_SR NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_SR NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_SR NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_SR NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_SR NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_SR NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_SR NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_SR NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_SR NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_SR NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_SR NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_SR NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_SR NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_SR NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_SR NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_SR NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_SR NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_SR NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_SR NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_SR NULL
#define OPTION_VAL_TWB64_182_PINK109_SR NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_SR NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_SR NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_SR NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_SR NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_SR NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_SR NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_SR NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_SR NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_SR NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_SR NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_SR NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_SR NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_SR NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_SR NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_SR NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_SR NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_SR NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_SR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_SR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_SR NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_SR NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_SR NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_SR NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_SR NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_SR NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_SR NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_SR NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_SR NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_SR NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_SR NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_SR NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_SR NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_SR NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_SR NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_SR NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_SR NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_SR NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__SR NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_SR NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_SR NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_SR NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_SR NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_SR NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_SR NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_SR NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_SR NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_SR NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_SR NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_SR NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_SR NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_SR NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_SR NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_SR NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_SR NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_SR NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_SR NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_SR NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_SR NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_SR NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_SR NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_SR NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_SR NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_SR NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_SR NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_SR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_SR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_SR NULL
#define OPTION_VAL_GBC_ONLY_SR NULL
#define OPTION_VAL_ALWAYS_SR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_SR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_SR NULL
#define OPTION_VAL_ACCURATE_SR NULL
#define OPTION_VAL_FAST_SR NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_SR NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_SR NULL
#define OPTION_VAL_CENTRAL_SR NULL
#define OPTION_VAL_ABOVE_SCREEN_SR NULL
#define OPTION_VAL_BELOW_SCREEN_SR NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_SR NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_SR NULL
#define GAMBATTE_MIX_FRAMES_LABEL_SR NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_SR NULL
#define OPTION_VAL_MIX_SR NULL
#define OPTION_VAL_LCD_GHOSTING_SR NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_SR NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_SR "Reuzorkovanje zvuka"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_SR NULL
#define OPTION_VAL_SINC_SR NULL
#define OPTION_VAL_CC_SR NULL
#define GAMBATTE_GB_HWMODE_LABEL_SR NULL
#define GAMBATTE_GB_HWMODE_INFO_0_SR NULL
#define OPTION_VAL_GB_SR NULL
#define OPTION_VAL_GBA_SR NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_SR NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_SR NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_SR NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_SR NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_SR NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_SR NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_SR NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_SR NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_SR NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_SR NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_SR NULL
#define OPTION_VAL_NOT_CONNECTED_SR NULL
#define OPTION_VAL_NETWORK_SERVER_SR NULL
#define OPTION_VAL_NETWORK_CLIENT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_SR NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_SR NULL

struct retro_core_option_v2_category option_cats_sr[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_SR,
      CATEGORY_GB_LINK_INFO_0_SR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_sr[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_SR,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_SR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_SR },
         { "GBC",      OPTION_VAL_GBC_SR },
         { "SGB",      OPTION_VAL_SGB_SR },
         { "internal", OPTION_VAL_INTERNAL_SR },
         { "custom",   OPTION_VAL_CUSTOM_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_SR,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_SR,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_SR },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_SR },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_SR },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_SR },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_SR },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_SR },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_SR },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_SR },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_SR },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_SR },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_SR },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_SR },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_SR },
         { "GBC - Red",                OPTION_VAL_GBC_RED_SR },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_SR },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_SR },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_SR },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_SR },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_SR },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_SR },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_SR },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_SR },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_SR },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_SR },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_SR },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_SR },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_SR },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_SR },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_SR },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_SR },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_SR },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_SR },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_SR },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_SR },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_SR },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_SR },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_SR },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_SR },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_SR },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_SR },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_SR },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_SR },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_SR },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_SR },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_SR },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_SR },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_SR },
         { "Special 1",                OPTION_VAL_SPECIAL_1_SR },
         { "Special 2",                OPTION_VAL_SPECIAL_2_SR },
         { "Special 3",                OPTION_VAL_SPECIAL_3_SR },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_SR },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_SR },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_SR },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_SR },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_SR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_SR,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_SR },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_SR },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_SR },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_SR },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_SR },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_SR },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_SR },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_SR },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_SR },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_SR },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_SR },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_SR },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_SR },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_SR },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_SR },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_SR },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_SR },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_SR },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_SR },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_SR },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_SR },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_SR },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_SR },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_SR },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_SR },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_SR },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_SR },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_SR },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_SR },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_SR },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_SR },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_SR },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_SR },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_SR },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_SR },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_SR },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_SR },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_SR },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_SR },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_SR },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_SR },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_SR },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_SR },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_SR },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_SR },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_SR },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_SR },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_SR },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_SR },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_SR },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_SR },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_SR },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_SR },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_SR },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_SR },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_SR },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_SR },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_SR },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_SR },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_SR },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_SR },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_SR },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_SR },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_SR },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_SR },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_SR },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_SR },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_SR },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_SR },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_SR },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_SR },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_SR },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_SR },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_SR },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_SR },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_SR },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_SR },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_SR },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_SR },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_SR },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_SR },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_SR },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_SR },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_SR },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_SR },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_SR },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_SR },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_SR },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_SR },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_SR },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_SR },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_SR },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_SR },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_SR },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_SR },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_SR },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_SR },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_SR },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_SR },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_SR },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_SR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_SR,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_SR },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_SR },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_SR },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_SR },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_SR },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_SR },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_SR },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_SR },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_SR },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_SR },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_SR },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_SR },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_SR },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_SR },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_SR },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_SR },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_SR },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_SR },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_SR },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_SR },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_SR },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_SR },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_SR },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_SR },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_SR },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_SR },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_SR },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_SR },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_SR },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_SR },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_SR },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_SR },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_SR },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_SR },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_SR },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_SR },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_SR },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_SR },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_SR },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_SR },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_SR },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_SR },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_SR },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_SR },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_SR },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_SR },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_SR },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_SR },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_SR },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_SR },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_SR },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_SR },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_SR },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_SR },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_SR },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_SR },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_SR },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_SR },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_SR },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_SR },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_SR },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_SR },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_SR },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_SR },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_SR },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_SR },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_SR },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_SR },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_SR },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_SR },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_SR },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_SR },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_SR },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_SR },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_SR },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_SR },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_SR },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_SR },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_SR },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_SR },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_SR },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_SR },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_SR },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_SR },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_SR },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_SR },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_SR },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_SR },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_SR },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_SR },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_SR },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_SR },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_SR },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_SR },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_SR },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_SR },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_SR },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_SR },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_SR },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_SR },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_SR,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_SR,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_SR },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_SR },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_SR },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_SR },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_SR },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_SR },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_SR },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_SR },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_SR },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_SR },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_SR },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_SR },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_SR },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_SR },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_SR },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_SR },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_SR },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__SR },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_SR },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_SR },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_SR },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_SR },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_SR },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_SR },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_SR },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_SR },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_SR },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_SR },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_SR },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_SR },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_SR },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_SR },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_SR },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_SR },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_SR },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_SR },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_SR },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_SR },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_SR },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_SR },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_SR },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_SR },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_SR },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_SR },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_SR },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_SR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_SR,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_SR },
         { "always",   OPTION_VAL_ALWAYS_SR },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_SR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_SR,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_SR },
         { "fast",     OPTION_VAL_FAST_SR },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_SR,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_SR,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_SR },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_SR },
         { "below screen", OPTION_VAL_BELOW_SCREEN_SR },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_SR,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_SR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_SR,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_SR,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_SR },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_SR },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_SR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_SR,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_SR,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_SR },
         { "cc",   OPTION_VAL_CC_SR },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_SR,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_SR,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_SR },
         { "GB",   OPTION_VAL_GB_SR },
         { "GBC",  OPTION_VAL_GBC_SR },
         { "GBA",  OPTION_VAL_GBA_SR },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_SR,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_SR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_SR,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_SR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_SR,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_SR,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_SR,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_SR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_SR,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_SR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_SR,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_MODE_INFO_0_SR,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_SR },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_SR },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_SR },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_SR,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_SR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_SR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_sr = {
   option_cats_sr,
   option_defs_sr
};

/* RETRO_LANGUAGE_SV */

#define CATEGORY_GB_LINK_LABEL_SV "Spellänk"
#define CATEGORY_GB_LINK_INFO_0_SV "Ändra inställningar för nätverksspel (flerspelarläge)."
#define GAMBATTE_GB_COLORIZATION_LABEL_SV NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_SV NULL
#define OPTION_VAL_AUTO_SV "Automatiskt"
#define OPTION_VAL_GBC_SV NULL
#define OPTION_VAL_SGB_SV NULL
#define OPTION_VAL_INTERNAL_SV "Intern"
#define OPTION_VAL_CUSTOM_SV "Anpassad"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_SV "Intern palett"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_SV NULL
#define OPTION_VAL_GB_DMG_SV NULL
#define OPTION_VAL_GB_POCKET_SV NULL
#define OPTION_VAL_GB_LIGHT_SV "GB - Ljus"
#define OPTION_VAL_GBC_BLUE_SV "GBC - Blå"
#define OPTION_VAL_GBC_BROWN_SV "GBC - Brun"
#define OPTION_VAL_GBC_DARK_BLUE_SV "GBC - Mörkblå"
#define OPTION_VAL_GBC_DARK_BROWN_SV "GBC - Mörkbrun"
#define OPTION_VAL_GBC_DARK_GREEN_SV "GBC - Mörkgrön"
#define OPTION_VAL_GBC_GRAYSCALE_SV "GBC - Gråskala"
#define OPTION_VAL_GBC_GREEN_SV "GBC - Grön"
#define OPTION_VAL_GBC_INVERTED_SV "GBC - Inverterad"
#define OPTION_VAL_GBC_ORANGE_SV NULL
#define OPTION_VAL_GBC_PASTEL_MIX_SV "GBC - Pastell mix"
#define OPTION_VAL_GBC_RED_SV "GBC - Röd"
#define OPTION_VAL_GBC_YELLOW_SV "GBC - Gul"
#define OPTION_VAL_SGB_1A_SV NULL
#define OPTION_VAL_SGB_1B_SV NULL
#define OPTION_VAL_SGB_1C_SV NULL
#define OPTION_VAL_SGB_1D_SV NULL
#define OPTION_VAL_SGB_1E_SV NULL
#define OPTION_VAL_SGB_1F_SV NULL
#define OPTION_VAL_SGB_1G_SV NULL
#define OPTION_VAL_SGB_1H_SV NULL
#define OPTION_VAL_SGB_2A_SV NULL
#define OPTION_VAL_SGB_2B_SV NULL
#define OPTION_VAL_SGB_2C_SV NULL
#define OPTION_VAL_SGB_2D_SV NULL
#define OPTION_VAL_SGB_2E_SV NULL
#define OPTION_VAL_SGB_2F_SV NULL
#define OPTION_VAL_SGB_2G_SV NULL
#define OPTION_VAL_SGB_2H_SV NULL
#define OPTION_VAL_SGB_3A_SV NULL
#define OPTION_VAL_SGB_3B_SV NULL
#define OPTION_VAL_SGB_3C_SV NULL
#define OPTION_VAL_SGB_3D_SV NULL
#define OPTION_VAL_SGB_3E_SV NULL
#define OPTION_VAL_SGB_3F_SV NULL
#define OPTION_VAL_SGB_3G_SV NULL
#define OPTION_VAL_SGB_3H_SV NULL
#define OPTION_VAL_SGB_4A_SV NULL
#define OPTION_VAL_SGB_4B_SV NULL
#define OPTION_VAL_SGB_4C_SV NULL
#define OPTION_VAL_SGB_4D_SV NULL
#define OPTION_VAL_SGB_4E_SV NULL
#define OPTION_VAL_SGB_4F_SV NULL
#define OPTION_VAL_SGB_4G_SV NULL
#define OPTION_VAL_SGB_4H_SV NULL
#define OPTION_VAL_SPECIAL_1_SV NULL
#define OPTION_VAL_SPECIAL_2_SV NULL
#define OPTION_VAL_SPECIAL_3_SV NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_SV NULL
#define OPTION_VAL_TWB64_PACK_1_SV NULL
#define OPTION_VAL_TWB64_PACK_2_SV NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_SV NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_SV NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_SV NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_SV NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_SV NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_SV NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_SV NULL
#define OPTION_VAL_TWB64_005_NEON_RED_SV NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_SV NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_SV NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_SV NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_SV NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_SV NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_SV NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_SV NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_SV NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_SV NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_SV NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_SV NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_SV NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_SV NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_SV NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_SV NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_SV NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_SV NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_SV NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_SV NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_SV NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_SV NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_SV NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_SV NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_SV NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_SV NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_SV "TWB64 031 - Kosmisk grön"
#define OPTION_VAL_TWB64_032_WANDA_PINK_SV "TWB64 032 - Wanda Rosa"
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_SV NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_SV "TWB64 034 - Reseträ"
#define OPTION_VAL_TWB64_035_POKEMON_VER_SV NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_SV "TWB64 036 - Spel Grump Orange"
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_SV "TWB64 037 - Scooby-Doo Mystisk Ver."
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_SV NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_SV NULL
#define OPTION_VAL_TWB64_040_DMG_VER_SV NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_SV NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_SV "TWB64 042 - Ljus Ver."
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_SV "TWB64 043 - Miraitowa Blå"
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_SV NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_SV "TWB64 045 - Pikachu Gul"
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_SV "TWB64 046 - Eevee brun"
#define OPTION_VAL_TWB64_047_MICROVISION_VER_SV NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_SV NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_SV "TWB64 049 - Aegis körsbär"
#define OPTION_VAL_TWB64_050_LABO_FAWN_SV NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_SV "TWB64 051 - MILLION LIVE GULD!"
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_SV NULL
#define OPTION_VAL_TWB64_053_VMU_VER_SV NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_SV NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_SV "TWB64 055 - Android Grön"
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_SV NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_SV "TWB64 057 - Google Röd"
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_SV NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_SV "TWB64 059 - Google Gul"
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_SV NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_SV NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_SV NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_SV "TWB64 063 - Dew Grön"
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_SV "TWB64 064 - Coca-Cola röd"
#define OPTION_VAL_TWB64_065_GAMEKING_VER_SV NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_SV NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_SV NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_SV NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_SV "TWB64 069 - Blossom Rosa"
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_SV "TWB64 070 - Bubbelblå"
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_SV "TWB64 071 - Buttercups-grön"
#define OPTION_VAL_TWB64_072_NASCAR_VER_SV NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_SV "TWB64 073 - Limegrön"
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_SV NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_SV NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_SV "TWB64 076 - Fantomröd"
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_SV NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_SV NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_SV "TWB64 079 - Cardcaptor - rosa"
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_SV "TWB64 080 - Pretty Guardian - Guld"
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_SV NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_SV NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_SV NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_SV NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_SV NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_SV NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_SV NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_SV NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_SV NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_SV NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_SV NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_SV NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_SV NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_SV NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_SV NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_SV NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_SV NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_SV NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_SV NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_SV NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_SV NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_SV NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_SV NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_SV NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_SV NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_SV NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_SV NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_SV NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_SV NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_SV NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_SV NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_SV NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_SV NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_SV NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_SV NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_SV NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_SV NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_SV NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_SV NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_SV NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_SV NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_SV NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_SV NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_SV NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_SV NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_SV NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_SV NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_SV NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_SV NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_SV NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_SV NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_SV NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_SV NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_SV NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_SV NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_SV NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_SV NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_SV NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_SV NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_SV NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_SV NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_SV NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_SV NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_SV NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_SV NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_SV NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_SV NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_SV NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_SV NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_SV NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_SV NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_SV NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_SV NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_SV NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_SV NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_SV NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_SV NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_SV NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_SV NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_SV NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_SV NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_SV NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_SV NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_SV NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_SV NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_SV NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_SV NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_SV NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_SV NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_SV NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_SV NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_SV NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_SV NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_SV NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_SV NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_SV NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_SV NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_SV NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_SV NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_SV NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_SV NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_SV NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_SV NULL
#define OPTION_VAL_TWB64_182_PINK109_SV NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_SV NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_SV NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_SV NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_SV NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_SV NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_SV NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_SV NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_SV NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_SV NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_SV NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_SV NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_SV NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_SV NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_SV NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_SV NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_SV NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_SV NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_SV NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_SV NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_SV NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_SV NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_SV NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_SV NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_SV NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_SV NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_SV NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_SV NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_SV NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_SV NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_SV NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_SV NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_SV NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_SV NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_SV NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_SV NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_SV NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_SV NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__SV NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_SV NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_SV NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_SV NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_SV NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_SV NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_SV NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_SV NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_SV NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_SV NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_SV NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_SV NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_SV NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_SV NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_SV NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_SV NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_SV NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_SV NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_SV NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_SV NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_SV NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_SV NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_SV NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_SV NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_SV NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_SV NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_SV NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_SV NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_SV "Färgkorrigering"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_SV NULL
#define OPTION_VAL_GBC_ONLY_SV NULL
#define OPTION_VAL_ALWAYS_SV "Alltid"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_SV NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_SV NULL
#define OPTION_VAL_ACCURATE_SV NULL
#define OPTION_VAL_FAST_SV NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_SV NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_SV NULL
#define OPTION_VAL_CENTRAL_SV NULL
#define OPTION_VAL_ABOVE_SCREEN_SV NULL
#define OPTION_VAL_BELOW_SCREEN_SV NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_SV "Mörkerfilternivå (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_SV NULL
#define GAMBATTE_MIX_FRAMES_LABEL_SV NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_SV NULL
#define OPTION_VAL_MIX_SV "Simpel"
#define OPTION_VAL_LCD_GHOSTING_SV NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_SV NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_SV "Ljud-resampler"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_SV NULL
#define OPTION_VAL_SINC_SV NULL
#define OPTION_VAL_CC_SV NULL
#define GAMBATTE_GB_HWMODE_LABEL_SV "Emulerad hårdvara (Omstart krävs)"
#define GAMBATTE_GB_HWMODE_INFO_0_SV NULL
#define OPTION_VAL_GB_SV NULL
#define OPTION_VAL_GBA_SV NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_SV NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_SV NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_SV NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_SV NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_SV NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_SV NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_SV NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_SV NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_SV NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_SV NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_SV "Länkläge"
#define GAMBATTE_GB_LINK_MODE_INFO_0_SV NULL
#define OPTION_VAL_NOT_CONNECTED_SV "Inte ansluten"
#define OPTION_VAL_NETWORK_SERVER_SV "Nätverksserver"
#define OPTION_VAL_NETWORK_CLIENT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_SV NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_SV NULL

struct retro_core_option_v2_category option_cats_sv[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_SV,
      CATEGORY_GB_LINK_INFO_0_SV
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_sv[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_SV,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_SV,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_SV },
         { "GBC",      OPTION_VAL_GBC_SV },
         { "SGB",      OPTION_VAL_SGB_SV },
         { "internal", OPTION_VAL_INTERNAL_SV },
         { "custom",   OPTION_VAL_CUSTOM_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_SV,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_SV,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_SV },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_SV },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_SV },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_SV },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_SV },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_SV },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_SV },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_SV },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_SV },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_SV },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_SV },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_SV },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_SV },
         { "GBC - Red",                OPTION_VAL_GBC_RED_SV },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_SV },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_SV },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_SV },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_SV },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_SV },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_SV },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_SV },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_SV },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_SV },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_SV },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_SV },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_SV },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_SV },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_SV },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_SV },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_SV },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_SV },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_SV },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_SV },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_SV },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_SV },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_SV },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_SV },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_SV },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_SV },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_SV },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_SV },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_SV },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_SV },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_SV },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_SV },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_SV },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_SV },
         { "Special 1",                OPTION_VAL_SPECIAL_1_SV },
         { "Special 2",                OPTION_VAL_SPECIAL_2_SV },
         { "Special 3",                OPTION_VAL_SPECIAL_3_SV },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_SV },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_SV },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_SV },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_SV },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_SV,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_SV,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_SV },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_SV },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_SV },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_SV },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_SV },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_SV },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_SV },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_SV },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_SV },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_SV },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_SV },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_SV },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_SV },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_SV },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_SV },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_SV },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_SV },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_SV },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_SV },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_SV },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_SV },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_SV },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_SV },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_SV },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_SV },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_SV },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_SV },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_SV },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_SV },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_SV },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_SV },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_SV },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_SV },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_SV },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_SV },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_SV },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_SV },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_SV },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_SV },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_SV },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_SV },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_SV },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_SV },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_SV },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_SV },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_SV },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_SV },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_SV },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_SV },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_SV },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_SV },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_SV },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_SV },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_SV },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_SV },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_SV },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_SV },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_SV },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_SV },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_SV },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_SV },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_SV },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_SV },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_SV },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_SV },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_SV },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_SV },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_SV },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_SV },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_SV },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_SV },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_SV },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_SV },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_SV },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_SV },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_SV },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_SV },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_SV },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_SV },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_SV },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_SV },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_SV },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_SV },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_SV },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_SV },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_SV },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_SV },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_SV },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_SV },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_SV },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_SV },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_SV },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_SV },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_SV },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_SV },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_SV },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_SV },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_SV },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_SV },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_SV },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_SV,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_SV,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_SV },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_SV },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_SV },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_SV },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_SV },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_SV },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_SV },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_SV },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_SV },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_SV },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_SV },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_SV },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_SV },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_SV },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_SV },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_SV },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_SV },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_SV },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_SV },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_SV },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_SV },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_SV },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_SV },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_SV },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_SV },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_SV },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_SV },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_SV },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_SV },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_SV },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_SV },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_SV },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_SV },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_SV },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_SV },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_SV },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_SV },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_SV },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_SV },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_SV },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_SV },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_SV },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_SV },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_SV },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_SV },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_SV },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_SV },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_SV },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_SV },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_SV },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_SV },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_SV },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_SV },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_SV },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_SV },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_SV },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_SV },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_SV },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_SV },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_SV },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_SV },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_SV },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_SV },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_SV },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_SV },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_SV },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_SV },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_SV },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_SV },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_SV },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_SV },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_SV },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_SV },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_SV },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_SV },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_SV },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_SV },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_SV },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_SV },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_SV },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_SV },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_SV },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_SV },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_SV },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_SV },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_SV },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_SV },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_SV },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_SV },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_SV },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_SV },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_SV },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_SV },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_SV },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_SV },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_SV },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_SV },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_SV },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_SV },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_SV },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_SV,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_SV,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_SV },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_SV },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_SV },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_SV },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_SV },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_SV },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_SV },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_SV },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_SV },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_SV },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_SV },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_SV },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_SV },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_SV },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_SV },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_SV },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_SV },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__SV },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_SV },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_SV },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_SV },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_SV },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_SV },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_SV },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_SV },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_SV },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_SV },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_SV },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_SV },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_SV },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_SV },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_SV },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_SV },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_SV },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_SV },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_SV },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_SV },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_SV },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_SV },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_SV },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_SV },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_SV },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_SV },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_SV },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_SV },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_SV,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_SV,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_SV },
         { "always",   OPTION_VAL_ALWAYS_SV },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_SV,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_SV,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_SV },
         { "fast",     OPTION_VAL_FAST_SV },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_SV,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_SV,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_SV },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_SV },
         { "below screen", OPTION_VAL_BELOW_SCREEN_SV },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_SV,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_SV,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_SV,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_SV,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_SV },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_SV },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_SV },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_SV,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_SV,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_SV },
         { "cc",   OPTION_VAL_CC_SV },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_SV,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_SV,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_SV },
         { "GB",   OPTION_VAL_GB_SV },
         { "GBC",  OPTION_VAL_GBC_SV },
         { "GBA",  OPTION_VAL_GBA_SV },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_SV,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_SV,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_SV,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_SV,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_SV,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_SV,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_SV,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_SV,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_SV,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_SV,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_SV,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_MODE_INFO_0_SV,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_SV },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_SV },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_SV },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_SV,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_SV,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_SV,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_sv = {
   option_cats_sv,
   option_defs_sv
};

/* RETRO_LANGUAGE_TR */

#define CATEGORY_GB_LINK_LABEL_TR NULL
#define CATEGORY_GB_LINK_INFO_0_TR "Ağa bağlı Game Link (çok oyunculu) ayarlarını değiştirin."
#define GAMBATTE_GB_COLORIZATION_LABEL_TR "GB Renklendirme"
#define GAMBATTE_GB_COLORIZATION_INFO_0_TR "Game Boy oyunlarının renklendirme sağlar. 'Otomatik', 'en iyi' (en renkli/uygun) paleti seçer. 'GBC', tanımlanmışsa oyuna özel Game Boy Renk paletini seçer, tanımlanmamışsa 'GBC - Koyu Yeşil' seçer. 'SGB', tanımlanmışsa oyuna özel Super Game Boy paletini seçer, yoksa 'SGB - 1A', 'Dahili', 'Dahili Palet' çekirdek seçeneğini kullanır. 'Özel', sistem dizininden kullanıcı tarafından oluşturulan paleti yükler."
#define OPTION_VAL_AUTO_TR "Otomatik"
#define OPTION_VAL_GBC_TR NULL
#define OPTION_VAL_SGB_TR NULL
#define OPTION_VAL_INTERNAL_TR "Dahili"
#define OPTION_VAL_CUSTOM_TR "Özel"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_TR "Dahili Palet"
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_TR "'GB Renklendirme' 'Dahili' olarak ayarlandığında veya 'GB Renklendirme' 'Otomatik' olarak ayarlandığında ve oyunun önceden tanımlanmış bir SGB/GBC paleti olmadığında Game Boy oyunlarını renklendirmek için kullanılan paleti seçer. 'GB' paletleri, orijinal Game Boy donanımının görüntüsünü taklit eder. 'GBC' paletleri, Game Boy Color yerleşik ön ayarlarıyla aynıdır. 'SGB' paletleri, Super Game Boy yerleşik ön ayarlarıyla aynıdır."
#define OPTION_VAL_GB_DMG_TR NULL
#define OPTION_VAL_GB_POCKET_TR NULL
#define OPTION_VAL_GB_LIGHT_TR "GB - Açık"
#define OPTION_VAL_GBC_BLUE_TR "GBC - Mavi"
#define OPTION_VAL_GBC_BROWN_TR "GBC - Kahve"
#define OPTION_VAL_GBC_DARK_BLUE_TR "GBC - Koyu Mavi"
#define OPTION_VAL_GBC_DARK_BROWN_TR "GBC - Koyu Kahve"
#define OPTION_VAL_GBC_DARK_GREEN_TR "GBC - Koyu Gri"
#define OPTION_VAL_GBC_GRAYSCALE_TR "GBC - Gri"
#define OPTION_VAL_GBC_GREEN_TR "GBC - Yeşil"
#define OPTION_VAL_GBC_INVERTED_TR "GBC - Ters"
#define OPTION_VAL_GBC_ORANGE_TR "GBC - Turuncu"
#define OPTION_VAL_GBC_PASTEL_MIX_TR "GBC - Pastel"
#define OPTION_VAL_GBC_RED_TR "GBC - Kırmızı"
#define OPTION_VAL_GBC_YELLOW_TR "GBC - Sarı"
#define OPTION_VAL_SGB_1A_TR NULL
#define OPTION_VAL_SGB_1B_TR NULL
#define OPTION_VAL_SGB_1C_TR NULL
#define OPTION_VAL_SGB_1D_TR NULL
#define OPTION_VAL_SGB_1E_TR NULL
#define OPTION_VAL_SGB_1F_TR NULL
#define OPTION_VAL_SGB_1G_TR NULL
#define OPTION_VAL_SGB_1H_TR NULL
#define OPTION_VAL_SGB_2A_TR NULL
#define OPTION_VAL_SGB_2B_TR NULL
#define OPTION_VAL_SGB_2C_TR NULL
#define OPTION_VAL_SGB_2D_TR NULL
#define OPTION_VAL_SGB_2E_TR NULL
#define OPTION_VAL_SGB_2F_TR NULL
#define OPTION_VAL_SGB_2G_TR NULL
#define OPTION_VAL_SGB_2H_TR NULL
#define OPTION_VAL_SGB_3A_TR NULL
#define OPTION_VAL_SGB_3B_TR NULL
#define OPTION_VAL_SGB_3C_TR NULL
#define OPTION_VAL_SGB_3D_TR NULL
#define OPTION_VAL_SGB_3E_TR NULL
#define OPTION_VAL_SGB_3F_TR NULL
#define OPTION_VAL_SGB_3G_TR NULL
#define OPTION_VAL_SGB_3H_TR NULL
#define OPTION_VAL_SGB_4A_TR NULL
#define OPTION_VAL_SGB_4B_TR NULL
#define OPTION_VAL_SGB_4C_TR NULL
#define OPTION_VAL_SGB_4D_TR NULL
#define OPTION_VAL_SGB_4E_TR NULL
#define OPTION_VAL_SGB_4F_TR NULL
#define OPTION_VAL_SGB_4G_TR NULL
#define OPTION_VAL_SGB_4H_TR NULL
#define OPTION_VAL_SPECIAL_1_TR "Özel 1"
#define OPTION_VAL_SPECIAL_2_TR "Özel 2"
#define OPTION_VAL_SPECIAL_3_TR "Özel 3"
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_TR "Özel 4 (Eski TI-83)"
#define OPTION_VAL_TWB64_PACK_1_TR "TWB64 - Paket 1"
#define OPTION_VAL_TWB64_PACK_2_TR "TWB64 - Paket 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_TR "PixelShift - Paket 1"
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_TR "> TWB64 - Paket 1 Paletleri"
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_TR "'Dahili Palet', 'TWB64 - Paket 1' olarak ayarlandığında dahili renklendirme paletini seçer."
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_TR NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_TR NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_TR NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_TR NULL
#define OPTION_VAL_TWB64_005_NEON_RED_TR NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_TR NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_TR NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_TR NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_TR NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_TR NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_TR NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_TR NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_TR NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_TR NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_TR NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_TR NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_TR NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_TR NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_TR NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_TR NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_TR NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_TR NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_TR NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_TR NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_TR NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_TR NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_TR NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_TR NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_TR NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_TR NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_TR NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_TR NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_TR NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_TR NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_TR NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_TR NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_TR NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_TR NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_TR NULL
#define OPTION_VAL_TWB64_040_DMG_VER_TR NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_TR NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_TR NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_TR NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_TR NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_TR NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_TR NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_TR NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_TR NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_TR NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_TR NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_TR NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_TR NULL
#define OPTION_VAL_TWB64_053_VMU_VER_TR NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_TR NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_TR NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_TR NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_TR NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_TR NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_TR NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_TR NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_TR NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_TR NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_TR NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_TR NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_TR NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_TR NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_TR NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_TR NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_TR NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_TR NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_TR NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_TR NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_TR NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_TR NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_TR NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_TR NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_TR NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_TR NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_TR NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_TR NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_TR NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_TR NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_TR NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_TR NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_TR "TWB64 085 - Kusursuz Ultra İçgüdü"
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_TR NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_TR NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_TR NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_TR NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_TR NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_TR NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_TR NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_TR NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_TR NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_TR NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_TR NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_TR NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_TR NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_TR NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_TR NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_TR "> TWB64 - Paket 2 Paletleri"
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_TR "'Dahili Palet', 'TWB64 - Paket 2' olarak ayarlandığında dahili renklendirme paletini seçer."
#define OPTION_VAL_TWB64_101_765PRO_PINK_TR NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_TR NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_TR NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_TR NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_TR NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_TR NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_TR NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_TR NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_TR NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_TR NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_TR NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_TR NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_TR NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_TR NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_TR NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_TR NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_TR NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_TR NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_TR NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_TR NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_TR NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_TR NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_TR NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_TR NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_TR NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_TR NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_TR NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_TR NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_TR NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_TR NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_TR NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_TR NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_TR NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_TR NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_TR NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_TR NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_TR NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_TR NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_TR NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_TR NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_TR NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_TR "TWB64 142 - Pepsi-Cola Mavisi"
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_TR NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_TR NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_TR NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_TR NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_TR NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_TR NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_TR NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_TR NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_TR NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_TR NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_TR NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_TR NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_TR NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_TR NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_TR NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_TR NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_TR NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_TR NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_TR NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_TR NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_TR NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_TR NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_TR NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_TR NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_TR NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_TR NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_TR NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_TR NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_TR NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_TR NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_TR NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_TR NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_TR NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_TR NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_TR NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_TR NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_TR NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_TR NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_TR NULL
#define OPTION_VAL_TWB64_182_PINK109_TR NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_TR NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_TR NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_TR NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_TR NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_TR NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_TR NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_TR NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_TR NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_TR NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_TR NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_TR NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_TR NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_TR NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_TR NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_TR NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_TR NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_TR NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_TR NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_TR "> PixelShift - Paket 1 Paleti"
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_TR "'Dahili Palet', 'PixelShift - Paket 1' olarak ayarlandığında dahili renklendirme paletini seçer."
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_TR "PixelShift 01 - Arktik Yeşili"
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_TR NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_TR "PixelShift 03 - BGB 0.3 Emülator"
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_TR "PixelShift 04 - Kamuflaj"
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_TR "PixelShift 05 - Çikolata Barı"
#define OPTION_VAL_PIXELSHIFT_06_CMYK_TR NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_TR "PixelShift 07 - Pamuk Şeker"
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_TR "PixelShift 08 - Basit Yeşil"
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_TR NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_TR NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_TR NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_TR NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_TR NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_TR NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_TR "PixelShift 15 - GB Mavi Arka Işık"
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_TR "PixelShift 16 - GB Soluk Arka Işık"
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_TR "PixelShift 17 - GB Turuncu Arka Işık"
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__TR "PixelShift 18 - GB Beyaz Arka Işık"
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_TR "PixelShift 19 - GB Sarı Siyah Arka Işık"
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_TR NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_TR "PixelShift 21 - GB Avcı"
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_TR NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_TR NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_TR "PixelShift 24 - GB Yeni"
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_TR NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_TR "PixelShift 26 - GB Eski"
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_TR NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_TR "PixelShift 28 - GB Soluk Sarı Arka Işık"
#define OPTION_VAL_PIXELSHIFT_29_GHOST_TR NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_TR NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_TR NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_TR NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_TR NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_TR NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_TR NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_TR "PixelShift 36 - Gazate"
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_TR NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_TR NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_TR NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_TR NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_TR NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_TR NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_TR NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_TR NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_TR NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_TR "Renk Düzeltmesi"
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_TR "Oyun renklerini gerçek Game Boy Color donanımının görüntüsüne uyacak şekilde ayarlar. 'Sadece GBC' düzeltmenin yalnızca Game Boy Color oyunları oynarken veya bir Game Boy oyununu renklendirmek için Game Boy Color paleti kullanırken uygulanmasını sağlar. 'Her Zaman' tüm içeriğe renk düzeltmesi uygular ve 'GB' veya 'SGB' dahili renk paletlerini kullanırken beklenmeyen/yetersiz sonuçlar üretebilir."
#define OPTION_VAL_GBC_ONLY_TR "Sadece GBC"
#define OPTION_VAL_ALWAYS_TR "Daima"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_TR "Renk Düzeltme Türü"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_TR "Renk düzeltmesi yapılırken kullanılan yöntemi belirtir. 'Kesin', gerçek bir Game Boy Renkli LCD panelinden neredeyse ayırt edilemeyen çıktılar üretir. 'Hızlı' yalnızca renkleri koyulaştırır ve doygunluğu azaltır ve 'Kesin' yöntemi çok yavaşsa düşük kaliteli donanımlarda kullanılabilir."
#define OPTION_VAL_ACCURATE_TR "Kesin"
#define OPTION_VAL_FAST_TR "Hızlı"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_TR "Renk Düzeltmesi - Ön Işık Konumu"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_TR "Game Boy Color LCD panelinin farklı açılardan aydınlatıldığında verdiği fiziksel tepkiyi taklit eder. 'Merkez' standart renk üretimini temsil eder. 'Ekran Üstü' parlaklığı artırır. 'Ekran Altı' parlaklığı azaltır. Bu ayar yalnızca 'Renk Düzeltme Türü', 'Kesin' olarak ayarlandığında geçerlidir."
#define OPTION_VAL_CENTRAL_TR "Merkez"
#define OPTION_VAL_ABOVE_SCREEN_TR "Ekran Üstü"
#define OPTION_VAL_BELOW_SCREEN_TR "Ekran Altı"
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_TR "Koyu Filtre Seviyesi (%)"
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_TR "Parlaklık azaltmayı etkinleştirin. Arkadan aydınlatmalı olmayan Game Boy Color üstünde görüntülenmesi amaçlanan beyaz arka plana sahip oyunlar oynarken parlamayı/göz yorgunluğunu önlemek için kullanılabilir, modern arkadan aydınlatmalı ekranda görüntülendiğinde rahatsız edici derecede parlak görünebilir."
#define GAMBATTE_MIX_FRAMES_LABEL_TR "Çerçeveler Arası Karıştırma"
#define GAMBATTE_MIX_FRAMES_INFO_0_TR "LCD gölgelenme efektlerini taklit eder. 'Basit', mevcut ve önceki karelerin 50:50'lik bir karışımını gerçekleştirir. 'LCD Gölgelenme', birden çok arabelleğe alınmış çerçeveyi birleştirerek doğal LCD yanıt sürelerini taklit eder. Saydamlık efektleri için LCD gölgelenmesine dayanan oyunlar oynarken (Wave Race, Ballistic, Chikyuu Kaihou Gun ZAS...). 'Basit' karıştırma gereklidir."
#define OPTION_VAL_MIX_TR "Basit"
#define OPTION_VAL_LCD_GHOSTING_TR "LCD Gölgeleme (Tam)"
#define OPTION_VAL_LCD_GHOSTING_FAST_TR "LCD Gölgeleme (Hızlı)"
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_TR "Ses Yeniden Örnekleyici"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_TR "Oluşturulan sesi yeniden örneklendirirken hangi algoritmanın kullanılacağını belirtin (Game Boy ses hızı yalnızca CPU yazma hızıyla sınırlıdır, öyle ki 'yerel' frekanslar modern ses cihazlarında pratik değildir ve alt örnekleme yapılmalıdır). 'Sinc' en yüksek kaliteyi üretir. \"Cosine\", düşük kaliteli donanımlarda performansı artırır."
#define OPTION_VAL_SINC_TR NULL
#define OPTION_VAL_CC_TR NULL
#define GAMBATTE_GB_HWMODE_LABEL_TR "Taklit Edilmiş Donanım (Yeniden Başlatılmalı)"
#define GAMBATTE_GB_HWMODE_INFO_0_TR "Hangi tür donanımın taklit edileceğini belirtin. 'Otomatik' önerilir. 'GBA'yı seçmek, belirli 'GBA ile geliştirilmiş' Game Boy Color oyunlarında (Shantae, Wendy - Every Witch Way, Legend of Zelda: Oracle of Seasons/Ages...) ekstra özelliklerin kilidini açar."
#define OPTION_VAL_GB_TR NULL
#define OPTION_VAL_GBA_TR NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_TR "Resmi Önyükleyici Kullan (Yeniden Başlatılmalı)"
#define GAMBATTE_GB_BOOTLOADER_INFO_0_TR "Başlangıç ​​logosu animasyonlarıyla resmi Game Boy ve Game Boy Color ön yükleyiciler için desteği etkinleştirir."
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_TR "Karşı Yönlere İzin Ver"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_TR "Bunun etkinleştirilmesi, aynı anda hem sol hem de sağ (veya yukarı ve aşağı) yönlere basılmasına/hızlı bir şekilde değiştirilmesine/basılı tutulmasına olanak tanır. Bu, hareket tabanlı aksaklıklara neden olabilir."
#define GAMBATTE_TURBO_PERIOD_LABEL_TR "Turbo Düğme Süresi"
#define GAMBATTE_TURBO_PERIOD_INFO_0_TR "Turbo A/B düğmelerini basılı tutarken tekrar aralığını (kare cinsinden) belirtin."
#define GAMBATTE_RUMBLE_LEVEL_LABEL_TR "Kontrolcü Titreşim Gücü"
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_TR "Desteklenen oyunlar için titreşim efektlerini etkinleştirir (Pokemon Pinball, Perfect Dark...)."
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_TR "Game Link Ayarlarını Göster"
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_TR "Ağa bağlı 'Game Link' (çok oyunculu) seçeneklerinin yapılandırmasını etkinleştirin. NOT: Bu ayarın etkili olması için Hızlı Menü üstünden değiştirilmesi gerekir."
#define GAMBATTE_GB_LINK_MODE_LABEL_TR "Game Link Kipi"
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_TR "Link Kipi"
#define GAMBATTE_GB_LINK_MODE_INFO_0_TR "Ağa bağlı Game Link işlevini etkinleştirirken, mevcut örneğin sunucu mu yoksa istemci olarak mı çalışacağını belirtin."
#define OPTION_VAL_NOT_CONNECTED_TR "Bağlı Değil"
#define OPTION_VAL_NETWORK_SERVER_TR "Ağ Sunucusu"
#define OPTION_VAL_NETWORK_CLIENT_TR "Ağ İstemcisi"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_TR "Ağ Link Port"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_TR NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_TR "Game Link ağ iletişimi için kullanılan port numarasını belirtin."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_TR "Ağ Link Sunucu Adresi Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_TR "Sunucu Adres Pt. 01: x__.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 1. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 1. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_TR "Ağ Link Sunucu Adresi Pt. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_TR "Sunucu Adresi Pt. 02: _x_.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 2. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 2. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_TR "Ağ Link Sunucu Adresi Pt. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_TR "Sunucu Adresi Pt. 03: __x.___.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 3. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 3. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_TR "Ağ Link Sunucu Adresi Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_TR "Sunucu Adresi Pt. 04: ___.x__.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 4. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 4. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_TR "Ağ Link Sunucu Adresi Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_TR "Sunucu Adresi Pt. 05: ___._x_.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 5. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 5. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_TR "Ağ Link Sunucu Adresi Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_TR "Sunucu Adresi Pt. 06: ___.__x.___.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 6. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 6. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_TR "Ağ Link Sunucu Adresi Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_TR "Sunucu Adresi Pt. 07: ___.___.x__.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 7. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 7. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_TR "Ağ Link Sunucu Adresi Pt. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_TR "Sunucu Adresi Pt. 08: ___.___._x_.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 8. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 8. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_TR "Ağ Link Sunucu Adresi Pt. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_TR "Sunucu Adresi Pt. 09: ___.___.__x.___"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 9. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 9. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_TR "Ağ Link Sunucu Adresi Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_TR "Sunucu Adresi Pt. 10: ___.___.___.x__"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 10. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 10. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_TR "Ağ Link Sunucu Adresi Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_TR "Sunucu Adresi Pt. 11: ___.___.___._x_"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 11. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 11. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_TR "Ağ Link Sunucu Adresi Pt. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_TR "Sunucu Adresi Pt. 12: ___.___.___.__x"
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_TR "Uzak Game Link ağ sunucusu IP adresinin 12. hanesi. Yalnızca 'Game Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_TR "Uzak Game Link ağ sunucusu IP adresinin 12. hanesi. Yalnızca 'Link Kipi', 'Ağ İstemcisi' olarak ayarlandığında kullanılır."

struct retro_core_option_v2_category option_cats_tr[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_TR,
      CATEGORY_GB_LINK_INFO_0_TR
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_tr[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_TR,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_TR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_TR },
         { "GBC",      OPTION_VAL_GBC_TR },
         { "SGB",      OPTION_VAL_SGB_TR },
         { "internal", OPTION_VAL_INTERNAL_TR },
         { "custom",   OPTION_VAL_CUSTOM_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_TR,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_TR,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_TR },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_TR },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_TR },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_TR },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_TR },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_TR },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_TR },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_TR },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_TR },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_TR },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_TR },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_TR },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_TR },
         { "GBC - Red",                OPTION_VAL_GBC_RED_TR },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_TR },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_TR },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_TR },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_TR },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_TR },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_TR },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_TR },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_TR },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_TR },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_TR },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_TR },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_TR },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_TR },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_TR },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_TR },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_TR },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_TR },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_TR },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_TR },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_TR },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_TR },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_TR },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_TR },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_TR },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_TR },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_TR },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_TR },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_TR },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_TR },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_TR },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_TR },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_TR },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_TR },
         { "Special 1",                OPTION_VAL_SPECIAL_1_TR },
         { "Special 2",                OPTION_VAL_SPECIAL_2_TR },
         { "Special 3",                OPTION_VAL_SPECIAL_3_TR },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_TR },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_TR },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_TR },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_TR },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_TR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_TR,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_TR },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_TR },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_TR },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_TR },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_TR },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_TR },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_TR },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_TR },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_TR },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_TR },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_TR },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_TR },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_TR },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_TR },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_TR },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_TR },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_TR },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_TR },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_TR },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_TR },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_TR },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_TR },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_TR },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_TR },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_TR },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_TR },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_TR },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_TR },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_TR },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_TR },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_TR },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_TR },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_TR },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_TR },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_TR },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_TR },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_TR },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_TR },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_TR },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_TR },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_TR },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_TR },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_TR },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_TR },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_TR },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_TR },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_TR },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_TR },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_TR },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_TR },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_TR },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_TR },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_TR },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_TR },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_TR },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_TR },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_TR },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_TR },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_TR },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_TR },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_TR },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_TR },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_TR },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_TR },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_TR },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_TR },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_TR },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_TR },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_TR },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_TR },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_TR },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_TR },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_TR },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_TR },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_TR },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_TR },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_TR },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_TR },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_TR },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_TR },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_TR },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_TR },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_TR },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_TR },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_TR },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_TR },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_TR },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_TR },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_TR },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_TR },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_TR },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_TR },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_TR },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_TR },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_TR },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_TR },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_TR },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_TR },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_TR },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_TR },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_TR,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_TR,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_TR },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_TR },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_TR },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_TR },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_TR },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_TR },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_TR },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_TR },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_TR },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_TR },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_TR },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_TR },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_TR },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_TR },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_TR },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_TR },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_TR },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_TR },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_TR },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_TR },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_TR },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_TR },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_TR },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_TR },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_TR },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_TR },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_TR },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_TR },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_TR },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_TR },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_TR },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_TR },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_TR },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_TR },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_TR },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_TR },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_TR },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_TR },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_TR },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_TR },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_TR },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_TR },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_TR },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_TR },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_TR },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_TR },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_TR },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_TR },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_TR },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_TR },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_TR },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_TR },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_TR },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_TR },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_TR },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_TR },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_TR },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_TR },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_TR },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_TR },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_TR },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_TR },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_TR },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_TR },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_TR },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_TR },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_TR },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_TR },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_TR },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_TR },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_TR },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_TR },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_TR },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_TR },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_TR },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_TR },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_TR },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_TR },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_TR },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_TR },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_TR },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_TR },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_TR },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_TR },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_TR },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_TR },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_TR },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_TR },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_TR },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_TR },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_TR },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_TR },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_TR },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_TR },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_TR },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_TR },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_TR },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_TR },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_TR },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_TR },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_TR,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_TR,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_TR },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_TR },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_TR },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_TR },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_TR },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_TR },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_TR },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_TR },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_TR },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_TR },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_TR },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_TR },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_TR },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_TR },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_TR },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_TR },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_TR },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__TR },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_TR },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_TR },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_TR },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_TR },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_TR },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_TR },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_TR },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_TR },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_TR },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_TR },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_TR },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_TR },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_TR },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_TR },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_TR },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_TR },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_TR },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_TR },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_TR },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_TR },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_TR },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_TR },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_TR },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_TR },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_TR },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_TR },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_TR },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_TR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_TR,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_TR },
         { "always",   OPTION_VAL_ALWAYS_TR },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_TR,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_TR,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_TR },
         { "fast",     OPTION_VAL_FAST_TR },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_TR,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_TR,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_TR },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_TR },
         { "below screen", OPTION_VAL_BELOW_SCREEN_TR },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_TR,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_TR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_TR,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_TR,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_TR },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_TR },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_TR },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_TR,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_TR,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_TR },
         { "cc",   OPTION_VAL_CC_TR },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_TR,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_TR,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_TR },
         { "GB",   OPTION_VAL_GB_TR },
         { "GBC",  OPTION_VAL_GBC_TR },
         { "GBA",  OPTION_VAL_GBA_TR },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_TR,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_TR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_TR,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_TR,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_TR,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_TR,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_TR,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_TR,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_TR,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_TR,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_TR,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_MODE_INFO_0_TR,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_TR },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_TR },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_TR },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_TR,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_TR,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_TR,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_tr = {
   option_cats_tr,
   option_defs_tr
};

/* RETRO_LANGUAGE_UK */

#define CATEGORY_GB_LINK_LABEL_UK NULL
#define CATEGORY_GB_LINK_INFO_0_UK NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_UK NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_UK NULL
#define OPTION_VAL_AUTO_UK "Автоматично"
#define OPTION_VAL_GBC_UK NULL
#define OPTION_VAL_SGB_UK NULL
#define OPTION_VAL_INTERNAL_UK NULL
#define OPTION_VAL_CUSTOM_UK "Користувацька"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_UK NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_UK NULL
#define OPTION_VAL_GB_DMG_UK NULL
#define OPTION_VAL_GB_POCKET_UK NULL
#define OPTION_VAL_GB_LIGHT_UK NULL
#define OPTION_VAL_GBC_BLUE_UK NULL
#define OPTION_VAL_GBC_BROWN_UK NULL
#define OPTION_VAL_GBC_DARK_BLUE_UK NULL
#define OPTION_VAL_GBC_DARK_BROWN_UK NULL
#define OPTION_VAL_GBC_DARK_GREEN_UK NULL
#define OPTION_VAL_GBC_GRAYSCALE_UK NULL
#define OPTION_VAL_GBC_GREEN_UK NULL
#define OPTION_VAL_GBC_INVERTED_UK NULL
#define OPTION_VAL_GBC_ORANGE_UK NULL
#define OPTION_VAL_GBC_PASTEL_MIX_UK NULL
#define OPTION_VAL_GBC_RED_UK NULL
#define OPTION_VAL_GBC_YELLOW_UK NULL
#define OPTION_VAL_SGB_1A_UK NULL
#define OPTION_VAL_SGB_1B_UK NULL
#define OPTION_VAL_SGB_1C_UK NULL
#define OPTION_VAL_SGB_1D_UK NULL
#define OPTION_VAL_SGB_1E_UK NULL
#define OPTION_VAL_SGB_1F_UK NULL
#define OPTION_VAL_SGB_1G_UK NULL
#define OPTION_VAL_SGB_1H_UK NULL
#define OPTION_VAL_SGB_2A_UK NULL
#define OPTION_VAL_SGB_2B_UK NULL
#define OPTION_VAL_SGB_2C_UK NULL
#define OPTION_VAL_SGB_2D_UK NULL
#define OPTION_VAL_SGB_2E_UK NULL
#define OPTION_VAL_SGB_2F_UK NULL
#define OPTION_VAL_SGB_2G_UK NULL
#define OPTION_VAL_SGB_2H_UK NULL
#define OPTION_VAL_SGB_3A_UK NULL
#define OPTION_VAL_SGB_3B_UK NULL
#define OPTION_VAL_SGB_3C_UK NULL
#define OPTION_VAL_SGB_3D_UK NULL
#define OPTION_VAL_SGB_3E_UK NULL
#define OPTION_VAL_SGB_3F_UK NULL
#define OPTION_VAL_SGB_3G_UK NULL
#define OPTION_VAL_SGB_3H_UK NULL
#define OPTION_VAL_SGB_4A_UK NULL
#define OPTION_VAL_SGB_4B_UK NULL
#define OPTION_VAL_SGB_4C_UK NULL
#define OPTION_VAL_SGB_4D_UK NULL
#define OPTION_VAL_SGB_4E_UK NULL
#define OPTION_VAL_SGB_4F_UK NULL
#define OPTION_VAL_SGB_4G_UK NULL
#define OPTION_VAL_SGB_4H_UK NULL
#define OPTION_VAL_SPECIAL_1_UK NULL
#define OPTION_VAL_SPECIAL_2_UK NULL
#define OPTION_VAL_SPECIAL_3_UK NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_UK NULL
#define OPTION_VAL_TWB64_PACK_1_UK NULL
#define OPTION_VAL_TWB64_PACK_2_UK NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_UK NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_UK NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_UK NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_UK NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_UK NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_UK NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_UK NULL
#define OPTION_VAL_TWB64_005_NEON_RED_UK NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_UK NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_UK NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_UK NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_UK NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_UK NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_UK NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_UK NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_UK NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_UK NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_UK NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_UK NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_UK NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_UK NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_UK NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_UK NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_UK NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_UK NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_UK NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_UK NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_UK NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_UK NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_UK NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_UK NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_UK NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_UK NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_UK NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_UK NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_UK NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_UK NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_UK NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_UK NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_UK NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_UK NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_UK NULL
#define OPTION_VAL_TWB64_040_DMG_VER_UK NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_UK NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_UK NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_UK NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_UK NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_UK NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_UK NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_UK NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_UK NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_UK NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_UK NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_UK NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_UK NULL
#define OPTION_VAL_TWB64_053_VMU_VER_UK NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_UK NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_UK NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_UK NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_UK NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_UK NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_UK NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_UK NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_UK NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_UK NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_UK NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_UK NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_UK NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_UK NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_UK NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_UK NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_UK NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_UK NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_UK NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_UK NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_UK NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_UK NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_UK NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_UK NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_UK NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_UK NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_UK NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_UK NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_UK NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_UK NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_UK NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_UK NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_UK NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_UK NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_UK NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_UK NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_UK NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_UK NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_UK NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_UK NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_UK NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_UK NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_UK NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_UK NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_UK NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_UK NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_UK NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_UK NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_UK NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_UK NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_UK NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_UK NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_UK NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_UK NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_UK NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_UK NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_UK NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_UK NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_UK NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_UK NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_UK NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_UK NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_UK NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_UK NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_UK NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_UK NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_UK NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_UK NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_UK NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_UK NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_UK NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_UK NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_UK NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_UK NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_UK NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_UK NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_UK NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_UK NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_UK NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_UK NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_UK NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_UK NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_UK NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_UK NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_UK NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_UK NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_UK NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_UK NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_UK NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_UK NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_UK NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_UK NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_UK NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_UK NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_UK NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_UK NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_UK NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_UK NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_UK NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_UK NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_UK NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_UK NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_UK NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_UK NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_UK NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_UK NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_UK NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_UK NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_UK NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_UK NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_UK NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_UK NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_UK NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_UK NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_UK NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_UK NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_UK NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_UK NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_UK NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_UK NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_UK NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_UK NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_UK NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_UK NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_UK NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_UK NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_UK NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_UK NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_UK NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_UK NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_UK NULL
#define OPTION_VAL_TWB64_182_PINK109_UK NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_UK NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_UK NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_UK NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_UK NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_UK NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_UK NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_UK NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_UK NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_UK NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_UK NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_UK NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_UK NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_UK NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_UK NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_UK NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_UK NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_UK NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_UK NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_UK NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_UK NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_UK NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_UK NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_UK NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_UK NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_UK NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_UK NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_UK NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_UK NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_UK NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_UK NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_UK NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_UK NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_UK NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_UK NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_UK NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_UK NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_UK NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__UK NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_UK NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_UK NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_UK NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_UK NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_UK NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_UK NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_UK NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_UK NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_UK NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_UK NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_UK NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_UK NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_UK NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_UK NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_UK NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_UK NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_UK NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_UK NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_UK NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_UK NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_UK NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_UK NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_UK NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_UK NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_UK NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_UK NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_UK NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_UK NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_UK NULL
#define OPTION_VAL_GBC_ONLY_UK NULL
#define OPTION_VAL_ALWAYS_UK "Завжди"
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_UK NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_UK NULL
#define OPTION_VAL_ACCURATE_UK NULL
#define OPTION_VAL_FAST_UK "Швидко"
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_UK NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_UK NULL
#define OPTION_VAL_CENTRAL_UK NULL
#define OPTION_VAL_ABOVE_SCREEN_UK NULL
#define OPTION_VAL_BELOW_SCREEN_UK NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_UK NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_UK NULL
#define GAMBATTE_MIX_FRAMES_LABEL_UK NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_UK NULL
#define OPTION_VAL_MIX_UK NULL
#define OPTION_VAL_LCD_GHOSTING_UK NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_UK NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_UK "Перетворювач частоти"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_UK NULL
#define OPTION_VAL_SINC_UK NULL
#define OPTION_VAL_CC_UK NULL
#define GAMBATTE_GB_HWMODE_LABEL_UK NULL
#define GAMBATTE_GB_HWMODE_INFO_0_UK NULL
#define OPTION_VAL_GB_UK NULL
#define OPTION_VAL_GBA_UK NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_UK NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_UK NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_UK "Дозволити протилежні напрямки"
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_UK NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_UK NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_UK NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_UK NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_UK NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_UK NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_UK NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_UK NULL
#define OPTION_VAL_NOT_CONNECTED_UK NULL
#define OPTION_VAL_NETWORK_SERVER_UK NULL
#define OPTION_VAL_NETWORK_CLIENT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_UK "Порт"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_UK NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_UK NULL

struct retro_core_option_v2_category option_cats_uk[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_UK,
      CATEGORY_GB_LINK_INFO_0_UK
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_uk[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_UK,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_UK,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_UK },
         { "GBC",      OPTION_VAL_GBC_UK },
         { "SGB",      OPTION_VAL_SGB_UK },
         { "internal", OPTION_VAL_INTERNAL_UK },
         { "custom",   OPTION_VAL_CUSTOM_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_UK,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_UK,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_UK },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_UK },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_UK },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_UK },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_UK },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_UK },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_UK },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_UK },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_UK },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_UK },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_UK },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_UK },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_UK },
         { "GBC - Red",                OPTION_VAL_GBC_RED_UK },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_UK },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_UK },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_UK },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_UK },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_UK },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_UK },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_UK },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_UK },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_UK },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_UK },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_UK },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_UK },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_UK },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_UK },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_UK },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_UK },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_UK },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_UK },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_UK },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_UK },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_UK },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_UK },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_UK },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_UK },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_UK },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_UK },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_UK },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_UK },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_UK },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_UK },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_UK },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_UK },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_UK },
         { "Special 1",                OPTION_VAL_SPECIAL_1_UK },
         { "Special 2",                OPTION_VAL_SPECIAL_2_UK },
         { "Special 3",                OPTION_VAL_SPECIAL_3_UK },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_UK },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_UK },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_UK },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_UK },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_UK,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_UK,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_UK },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_UK },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_UK },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_UK },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_UK },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_UK },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_UK },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_UK },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_UK },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_UK },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_UK },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_UK },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_UK },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_UK },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_UK },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_UK },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_UK },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_UK },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_UK },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_UK },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_UK },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_UK },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_UK },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_UK },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_UK },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_UK },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_UK },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_UK },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_UK },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_UK },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_UK },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_UK },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_UK },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_UK },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_UK },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_UK },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_UK },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_UK },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_UK },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_UK },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_UK },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_UK },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_UK },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_UK },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_UK },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_UK },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_UK },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_UK },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_UK },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_UK },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_UK },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_UK },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_UK },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_UK },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_UK },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_UK },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_UK },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_UK },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_UK },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_UK },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_UK },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_UK },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_UK },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_UK },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_UK },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_UK },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_UK },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_UK },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_UK },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_UK },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_UK },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_UK },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_UK },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_UK },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_UK },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_UK },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_UK },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_UK },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_UK },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_UK },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_UK },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_UK },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_UK },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_UK },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_UK },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_UK },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_UK },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_UK },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_UK },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_UK },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_UK },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_UK },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_UK },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_UK },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_UK },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_UK },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_UK },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_UK },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_UK },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_UK },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_UK,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_UK,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_UK },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_UK },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_UK },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_UK },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_UK },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_UK },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_UK },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_UK },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_UK },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_UK },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_UK },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_UK },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_UK },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_UK },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_UK },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_UK },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_UK },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_UK },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_UK },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_UK },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_UK },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_UK },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_UK },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_UK },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_UK },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_UK },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_UK },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_UK },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_UK },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_UK },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_UK },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_UK },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_UK },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_UK },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_UK },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_UK },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_UK },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_UK },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_UK },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_UK },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_UK },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_UK },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_UK },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_UK },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_UK },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_UK },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_UK },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_UK },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_UK },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_UK },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_UK },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_UK },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_UK },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_UK },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_UK },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_UK },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_UK },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_UK },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_UK },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_UK },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_UK },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_UK },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_UK },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_UK },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_UK },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_UK },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_UK },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_UK },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_UK },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_UK },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_UK },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_UK },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_UK },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_UK },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_UK },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_UK },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_UK },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_UK },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_UK },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_UK },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_UK },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_UK },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_UK },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_UK },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_UK },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_UK },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_UK },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_UK },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_UK },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_UK },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_UK },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_UK },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_UK },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_UK },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_UK },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_UK },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_UK },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_UK },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_UK },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_UK },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_UK,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_UK,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_UK },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_UK },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_UK },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_UK },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_UK },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_UK },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_UK },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_UK },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_UK },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_UK },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_UK },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_UK },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_UK },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_UK },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_UK },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_UK },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_UK },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__UK },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_UK },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_UK },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_UK },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_UK },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_UK },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_UK },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_UK },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_UK },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_UK },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_UK },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_UK },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_UK },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_UK },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_UK },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_UK },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_UK },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_UK },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_UK },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_UK },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_UK },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_UK },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_UK },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_UK },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_UK },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_UK },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_UK },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_UK },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_UK,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_UK,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_UK },
         { "always",   OPTION_VAL_ALWAYS_UK },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_UK,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_UK,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_UK },
         { "fast",     OPTION_VAL_FAST_UK },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_UK,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_UK,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_UK },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_UK },
         { "below screen", OPTION_VAL_BELOW_SCREEN_UK },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_UK,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_UK,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_UK,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_UK,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_UK },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_UK },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_UK },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_UK,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_UK,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_UK },
         { "cc",   OPTION_VAL_CC_UK },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_UK,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_UK,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_UK },
         { "GB",   OPTION_VAL_GB_UK },
         { "GBC",  OPTION_VAL_GBC_UK },
         { "GBA",  OPTION_VAL_GBA_UK },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_UK,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_UK,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_UK,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_UK,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_UK,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_UK,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_UK,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_UK,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_UK,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_UK,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_UK,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_MODE_INFO_0_UK,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_UK },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_UK },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_UK },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_UK,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_UK,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_UK,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_uk = {
   option_cats_uk,
   option_defs_uk
};

/* RETRO_LANGUAGE_VAL */

#define CATEGORY_GB_LINK_LABEL_VAL NULL
#define CATEGORY_GB_LINK_INFO_0_VAL NULL
#define GAMBATTE_GB_COLORIZATION_LABEL_VAL NULL
#define GAMBATTE_GB_COLORIZATION_INFO_0_VAL NULL
#define OPTION_VAL_AUTO_VAL "Selecció automàtica"
#define OPTION_VAL_GBC_VAL NULL
#define OPTION_VAL_SGB_VAL NULL
#define OPTION_VAL_INTERNAL_VAL NULL
#define OPTION_VAL_CUSTOM_VAL NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_VAL NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_VAL NULL
#define OPTION_VAL_GB_DMG_VAL NULL
#define OPTION_VAL_GB_POCKET_VAL NULL
#define OPTION_VAL_GB_LIGHT_VAL NULL
#define OPTION_VAL_GBC_BLUE_VAL NULL
#define OPTION_VAL_GBC_BROWN_VAL NULL
#define OPTION_VAL_GBC_DARK_BLUE_VAL NULL
#define OPTION_VAL_GBC_DARK_BROWN_VAL NULL
#define OPTION_VAL_GBC_DARK_GREEN_VAL NULL
#define OPTION_VAL_GBC_GRAYSCALE_VAL NULL
#define OPTION_VAL_GBC_GREEN_VAL NULL
#define OPTION_VAL_GBC_INVERTED_VAL NULL
#define OPTION_VAL_GBC_ORANGE_VAL NULL
#define OPTION_VAL_GBC_PASTEL_MIX_VAL NULL
#define OPTION_VAL_GBC_RED_VAL NULL
#define OPTION_VAL_GBC_YELLOW_VAL NULL
#define OPTION_VAL_SGB_1A_VAL NULL
#define OPTION_VAL_SGB_1B_VAL NULL
#define OPTION_VAL_SGB_1C_VAL NULL
#define OPTION_VAL_SGB_1D_VAL NULL
#define OPTION_VAL_SGB_1E_VAL NULL
#define OPTION_VAL_SGB_1F_VAL NULL
#define OPTION_VAL_SGB_1G_VAL NULL
#define OPTION_VAL_SGB_1H_VAL NULL
#define OPTION_VAL_SGB_2A_VAL NULL
#define OPTION_VAL_SGB_2B_VAL NULL
#define OPTION_VAL_SGB_2C_VAL NULL
#define OPTION_VAL_SGB_2D_VAL NULL
#define OPTION_VAL_SGB_2E_VAL NULL
#define OPTION_VAL_SGB_2F_VAL NULL
#define OPTION_VAL_SGB_2G_VAL NULL
#define OPTION_VAL_SGB_2H_VAL NULL
#define OPTION_VAL_SGB_3A_VAL NULL
#define OPTION_VAL_SGB_3B_VAL NULL
#define OPTION_VAL_SGB_3C_VAL NULL
#define OPTION_VAL_SGB_3D_VAL NULL
#define OPTION_VAL_SGB_3E_VAL NULL
#define OPTION_VAL_SGB_3F_VAL NULL
#define OPTION_VAL_SGB_3G_VAL NULL
#define OPTION_VAL_SGB_3H_VAL NULL
#define OPTION_VAL_SGB_4A_VAL NULL
#define OPTION_VAL_SGB_4B_VAL NULL
#define OPTION_VAL_SGB_4C_VAL NULL
#define OPTION_VAL_SGB_4D_VAL NULL
#define OPTION_VAL_SGB_4E_VAL NULL
#define OPTION_VAL_SGB_4F_VAL NULL
#define OPTION_VAL_SGB_4G_VAL NULL
#define OPTION_VAL_SGB_4H_VAL NULL
#define OPTION_VAL_SPECIAL_1_VAL NULL
#define OPTION_VAL_SPECIAL_2_VAL NULL
#define OPTION_VAL_SPECIAL_3_VAL NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_VAL NULL
#define OPTION_VAL_TWB64_PACK_1_VAL NULL
#define OPTION_VAL_TWB64_PACK_2_VAL NULL
#define OPTION_VAL_PIXELSHIFT_PACK_1_VAL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_VAL NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_VAL NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_VAL NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_VAL NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_VAL NULL
#define OPTION_VAL_TWB64_005_NEON_RED_VAL NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_VAL NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_VAL NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_VAL NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_VAL NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_VAL NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_VAL NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_VAL NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_VAL NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_VAL NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_VAL NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_VAL NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_VAL NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_VAL NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_VAL NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_VAL NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_VAL NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_VAL NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_VAL NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_VAL NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_VAL NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_VAL NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_VAL NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_VAL NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_VAL NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_VAL NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_VAL NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_VAL NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_VAL NULL
#define OPTION_VAL_TWB64_040_DMG_VER_VAL NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_VAL NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_VAL NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_VAL NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_VAL NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_VAL NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_VAL NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_VAL NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_VAL NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_VAL NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_VAL NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_VAL NULL
#define OPTION_VAL_TWB64_053_VMU_VER_VAL NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_VAL NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_VAL NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_VAL NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_VAL NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_VAL NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_VAL NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_VAL NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_VAL NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_VAL NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_VAL NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_VAL NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_VAL NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_VAL NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_VAL NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_VAL NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_VAL NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_VAL NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_VAL NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_VAL NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_VAL NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_VAL NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_VAL NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_VAL NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_VAL NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_VAL NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_VAL NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_VAL NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_VAL NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_VAL NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_VAL NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_VAL NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_VAL NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_VAL NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_VAL NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_VAL NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_VAL NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_VAL NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_VAL NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_VAL NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_VAL NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_VAL NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_VAL NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_VAL NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_VAL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_VAL NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_VAL NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_VAL NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_VAL NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_VAL NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_VAL NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_VAL NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_VAL NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_VAL NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_VAL NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_VAL NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_VAL NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_VAL NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_VAL NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_VAL NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_VAL NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_VAL NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_VAL NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_VAL NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_VAL NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_VAL NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_VAL NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_VAL NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_VAL NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_VAL NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_VAL NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_VAL NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_VAL NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_VAL NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_VAL NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_VAL NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_VAL NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_VAL NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_VAL NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_VAL NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_VAL NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_VAL NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_VAL NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_VAL NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_VAL NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_VAL NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_VAL NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_VAL NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_VAL NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_VAL NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_VAL NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_VAL NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_VAL NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_VAL NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_VAL NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_VAL NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_VAL NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_VAL NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_VAL NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_VAL NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_VAL NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_VAL NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_VAL NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_VAL NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_VAL NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_VAL NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_VAL NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_VAL NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_VAL NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_VAL NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_VAL NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_VAL NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_VAL NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_VAL NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_VAL NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_VAL NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_VAL NULL
#define OPTION_VAL_TWB64_182_PINK109_VAL NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_VAL NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_VAL NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_VAL NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_VAL NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_VAL NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_VAL NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_VAL NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_VAL NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_VAL NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_VAL NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_VAL NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_VAL NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_VAL NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_VAL NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_VAL NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_VAL NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_VAL NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_VAL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_VAL NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_VAL NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_VAL NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_VAL NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_VAL NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_VAL NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_VAL NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_VAL NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_VAL NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_VAL NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_VAL NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_VAL NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_VAL NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_VAL NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_VAL NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_VAL NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_VAL NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_VAL NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_VAL NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__VAL NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_VAL NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_VAL NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_VAL NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_VAL NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_VAL NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_VAL NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_VAL NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_VAL NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_VAL NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_VAL NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_VAL NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_VAL NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_VAL NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_VAL NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_VAL NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_VAL NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_VAL NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_VAL NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_VAL NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_VAL NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_VAL NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_VAL NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_VAL NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_VAL NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_VAL NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_VAL NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_VAL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_VAL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_VAL NULL
#define OPTION_VAL_GBC_ONLY_VAL NULL
#define OPTION_VAL_ALWAYS_VAL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_VAL NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_VAL NULL
#define OPTION_VAL_ACCURATE_VAL NULL
#define OPTION_VAL_FAST_VAL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_VAL NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_VAL NULL
#define OPTION_VAL_CENTRAL_VAL NULL
#define OPTION_VAL_ABOVE_SCREEN_VAL NULL
#define OPTION_VAL_BELOW_SCREEN_VAL NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_VAL NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_VAL NULL
#define GAMBATTE_MIX_FRAMES_LABEL_VAL NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_VAL NULL
#define OPTION_VAL_MIX_VAL NULL
#define OPTION_VAL_LCD_GHOSTING_VAL NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_VAL NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_VAL "Remostreig d'àudio"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_VAL NULL
#define OPTION_VAL_SINC_VAL NULL
#define OPTION_VAL_CC_VAL NULL
#define GAMBATTE_GB_HWMODE_LABEL_VAL NULL
#define GAMBATTE_GB_HWMODE_INFO_0_VAL NULL
#define OPTION_VAL_GB_VAL NULL
#define OPTION_VAL_GBA_VAL NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_VAL NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_VAL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_VAL NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_VAL NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_VAL NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_VAL NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_VAL NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_VAL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_VAL NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_VAL NULL
#define OPTION_VAL_NOT_CONNECTED_VAL NULL
#define OPTION_VAL_NETWORK_SERVER_VAL NULL
#define OPTION_VAL_NETWORK_CLIENT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_VAL NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_VAL NULL

struct retro_core_option_v2_category option_cats_val[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_VAL,
      CATEGORY_GB_LINK_INFO_0_VAL
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_val[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_VAL,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_VAL },
         { "GBC",      OPTION_VAL_GBC_VAL },
         { "SGB",      OPTION_VAL_SGB_VAL },
         { "internal", OPTION_VAL_INTERNAL_VAL },
         { "custom",   OPTION_VAL_CUSTOM_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_VAL,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_VAL },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_VAL },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_VAL },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_VAL },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_VAL },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_VAL },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_VAL },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_VAL },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_VAL },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_VAL },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_VAL },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_VAL },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_VAL },
         { "GBC - Red",                OPTION_VAL_GBC_RED_VAL },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_VAL },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_VAL },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_VAL },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_VAL },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_VAL },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_VAL },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_VAL },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_VAL },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_VAL },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_VAL },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_VAL },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_VAL },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_VAL },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_VAL },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_VAL },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_VAL },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_VAL },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_VAL },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_VAL },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_VAL },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_VAL },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_VAL },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_VAL },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_VAL },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_VAL },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_VAL },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_VAL },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_VAL },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_VAL },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_VAL },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_VAL },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_VAL },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_VAL },
         { "Special 1",                OPTION_VAL_SPECIAL_1_VAL },
         { "Special 2",                OPTION_VAL_SPECIAL_2_VAL },
         { "Special 3",                OPTION_VAL_SPECIAL_3_VAL },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_VAL },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_VAL },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_VAL },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_VAL },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_VAL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_VAL },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_VAL },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_VAL },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_VAL },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_VAL },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_VAL },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_VAL },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_VAL },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_VAL },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_VAL },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_VAL },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_VAL },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_VAL },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_VAL },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_VAL },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_VAL },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_VAL },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_VAL },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_VAL },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_VAL },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_VAL },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_VAL },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_VAL },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_VAL },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_VAL },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_VAL },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_VAL },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_VAL },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_VAL },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_VAL },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_VAL },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_VAL },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_VAL },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_VAL },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_VAL },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_VAL },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_VAL },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_VAL },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_VAL },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_VAL },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_VAL },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_VAL },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_VAL },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_VAL },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_VAL },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_VAL },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_VAL },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_VAL },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_VAL },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_VAL },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_VAL },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_VAL },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_VAL },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_VAL },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_VAL },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_VAL },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_VAL },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_VAL },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_VAL },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_VAL },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_VAL },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_VAL },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_VAL },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_VAL },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_VAL },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_VAL },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_VAL },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_VAL },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_VAL },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_VAL },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_VAL },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_VAL },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_VAL },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_VAL },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_VAL },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_VAL },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_VAL },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_VAL },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_VAL },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_VAL },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_VAL },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_VAL },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_VAL },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_VAL },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_VAL },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_VAL },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_VAL },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_VAL },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_VAL },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_VAL },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_VAL },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_VAL },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_VAL },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_VAL },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_VAL },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_VAL },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_VAL },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_VAL },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_VAL },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_VAL },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_VAL,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_VAL },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_VAL },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_VAL },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_VAL },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_VAL },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_VAL },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_VAL },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_VAL },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_VAL },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_VAL },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_VAL },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_VAL },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_VAL },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_VAL },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_VAL },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_VAL },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_VAL },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_VAL },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_VAL },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_VAL },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_VAL },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_VAL },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_VAL },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_VAL },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_VAL },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_VAL },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_VAL },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_VAL },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_VAL },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_VAL },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_VAL },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_VAL },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_VAL },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_VAL },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_VAL },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_VAL },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_VAL },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_VAL },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_VAL },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_VAL },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_VAL },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_VAL },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_VAL },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_VAL },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_VAL },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_VAL },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_VAL },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_VAL },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_VAL },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_VAL },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_VAL },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_VAL },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_VAL },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_VAL },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_VAL },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_VAL },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_VAL },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_VAL },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_VAL },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_VAL },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_VAL },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_VAL },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_VAL },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_VAL },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_VAL },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_VAL },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_VAL },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_VAL },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_VAL },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_VAL },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_VAL },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_VAL },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_VAL },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_VAL },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_VAL },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_VAL },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_VAL },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_VAL },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_VAL },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_VAL },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_VAL },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_VAL },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_VAL },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_VAL },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_VAL },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_VAL },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_VAL },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_VAL },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_VAL },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_VAL },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_VAL },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_VAL },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_VAL },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_VAL },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_VAL },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_VAL },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_VAL },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_VAL },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_VAL },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_VAL },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_VAL,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_VAL },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_VAL },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_VAL },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_VAL },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_VAL },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_VAL },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_VAL },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_VAL },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_VAL },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_VAL },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_VAL },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_VAL },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_VAL },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_VAL },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_VAL },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_VAL },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_VAL },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__VAL },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_VAL },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_VAL },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_VAL },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_VAL },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_VAL },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_VAL },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_VAL },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_VAL },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_VAL },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_VAL },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_VAL },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_VAL },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_VAL },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_VAL },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_VAL },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_VAL },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_VAL },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_VAL },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_VAL },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_VAL },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_VAL },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_VAL },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_VAL },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_VAL },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_VAL },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_VAL },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_VAL },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_VAL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_VAL },
         { "always",   OPTION_VAL_ALWAYS_VAL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_VAL,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_VAL },
         { "fast",     OPTION_VAL_FAST_VAL },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_VAL,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_VAL },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_VAL },
         { "below screen", OPTION_VAL_BELOW_SCREEN_VAL },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_VAL,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_VAL,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_VAL },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_VAL },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_VAL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_VAL,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_VAL },
         { "cc",   OPTION_VAL_CC_VAL },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_VAL,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_VAL },
         { "GB",   OPTION_VAL_GB_VAL },
         { "GBC",  OPTION_VAL_GBC_VAL },
         { "GBA",  OPTION_VAL_GBA_VAL },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_VAL,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_VAL,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_VAL,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_VAL,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_VAL,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_VAL,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_VAL,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_MODE_INFO_0_VAL,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_VAL },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_VAL },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_VAL },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_VAL,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_VAL,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_VAL,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_val = {
   option_cats_val,
   option_defs_val
};

/* RETRO_LANGUAGE_VN */

#define CATEGORY_GB_LINK_LABEL_VN NULL
#define CATEGORY_GB_LINK_INFO_0_VN "Thay đổi cài đặt mạng Game Link (chơi nhiều người)."
#define GAMBATTE_GB_COLORIZATION_LABEL_VN "Chỉnh màu GB"
#define GAMBATTE_GB_COLORIZATION_INFO_0_VN NULL
#define OPTION_VAL_AUTO_VN "Tự động"
#define OPTION_VAL_GBC_VN NULL
#define OPTION_VAL_SGB_VN NULL
#define OPTION_VAL_INTERNAL_VN NULL
#define OPTION_VAL_CUSTOM_VN "Tùy chỉnh"
#define GAMBATTE_GB_INTERNAL_PALETTE_LABEL_VN NULL
#define GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_VN NULL
#define OPTION_VAL_GB_DMG_VN NULL
#define OPTION_VAL_GB_POCKET_VN NULL
#define OPTION_VAL_GB_LIGHT_VN NULL
#define OPTION_VAL_GBC_BLUE_VN NULL
#define OPTION_VAL_GBC_BROWN_VN NULL
#define OPTION_VAL_GBC_DARK_BLUE_VN NULL
#define OPTION_VAL_GBC_DARK_BROWN_VN NULL
#define OPTION_VAL_GBC_DARK_GREEN_VN NULL
#define OPTION_VAL_GBC_GRAYSCALE_VN NULL
#define OPTION_VAL_GBC_GREEN_VN NULL
#define OPTION_VAL_GBC_INVERTED_VN NULL
#define OPTION_VAL_GBC_ORANGE_VN NULL
#define OPTION_VAL_GBC_PASTEL_MIX_VN NULL
#define OPTION_VAL_GBC_RED_VN NULL
#define OPTION_VAL_GBC_YELLOW_VN NULL
#define OPTION_VAL_SGB_1A_VN NULL
#define OPTION_VAL_SGB_1B_VN NULL
#define OPTION_VAL_SGB_1C_VN NULL
#define OPTION_VAL_SGB_1D_VN NULL
#define OPTION_VAL_SGB_1E_VN NULL
#define OPTION_VAL_SGB_1F_VN NULL
#define OPTION_VAL_SGB_1G_VN NULL
#define OPTION_VAL_SGB_1H_VN NULL
#define OPTION_VAL_SGB_2A_VN NULL
#define OPTION_VAL_SGB_2B_VN NULL
#define OPTION_VAL_SGB_2C_VN NULL
#define OPTION_VAL_SGB_2D_VN NULL
#define OPTION_VAL_SGB_2E_VN NULL
#define OPTION_VAL_SGB_2F_VN NULL
#define OPTION_VAL_SGB_2G_VN NULL
#define OPTION_VAL_SGB_2H_VN NULL
#define OPTION_VAL_SGB_3A_VN NULL
#define OPTION_VAL_SGB_3B_VN NULL
#define OPTION_VAL_SGB_3C_VN NULL
#define OPTION_VAL_SGB_3D_VN NULL
#define OPTION_VAL_SGB_3E_VN NULL
#define OPTION_VAL_SGB_3F_VN NULL
#define OPTION_VAL_SGB_3G_VN NULL
#define OPTION_VAL_SGB_3H_VN NULL
#define OPTION_VAL_SGB_4A_VN NULL
#define OPTION_VAL_SGB_4B_VN NULL
#define OPTION_VAL_SGB_4C_VN NULL
#define OPTION_VAL_SGB_4D_VN NULL
#define OPTION_VAL_SGB_4E_VN NULL
#define OPTION_VAL_SGB_4F_VN NULL
#define OPTION_VAL_SGB_4G_VN NULL
#define OPTION_VAL_SGB_4H_VN NULL
#define OPTION_VAL_SPECIAL_1_VN NULL
#define OPTION_VAL_SPECIAL_2_VN NULL
#define OPTION_VAL_SPECIAL_3_VN NULL
#define OPTION_VAL_SPECIAL_4_TI_83_LEGACY_VN NULL
#define OPTION_VAL_TWB64_PACK_1_VN "TWB64 - Gói 1"
#define OPTION_VAL_TWB64_PACK_2_VN "TWB64 - Gói 2"
#define OPTION_VAL_PIXELSHIFT_PACK_1_VN NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_LABEL_VN NULL
#define GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_VN NULL
#define OPTION_VAL_TWB64_001_AQOURS_BLUE_VN NULL
#define OPTION_VAL_TWB64_002_ANIME_EXPO_VER_VN NULL
#define OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_VN NULL
#define OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_VN NULL
#define OPTION_VAL_TWB64_005_NEON_RED_VN NULL
#define OPTION_VAL_TWB64_006_NEON_BLUE_VN NULL
#define OPTION_VAL_TWB64_007_NEON_YELLOW_VN NULL
#define OPTION_VAL_TWB64_008_NEON_GREEN_VN NULL
#define OPTION_VAL_TWB64_009_NEON_PINK_VN NULL
#define OPTION_VAL_TWB64_010_MARIO_RED_VN NULL
#define OPTION_VAL_TWB64_011_NICK_ORANGE_VN NULL
#define OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_VN NULL
#define OPTION_VAL_TWB64_013_GOLDEN_WILD_VN NULL
#define OPTION_VAL_TWB64_014_BUILDER_YELLOW_VN NULL
#define OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_VN NULL
#define OPTION_VAL_TWB64_016_765_PRODUCTION_VER_VN NULL
#define OPTION_VAL_TWB64_017_SUPERBALL_IVORY_VN NULL
#define OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_VN NULL
#define OPTION_VAL_TWB64_019_MUSE_PINK_VN NULL
#define OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_VN NULL
#define OPTION_VAL_TWB64_021_GAMATE_VER_VN NULL
#define OPTION_VAL_TWB64_022_GREENSCALE_VER_VN NULL
#define OPTION_VAL_TWB64_023_ODYSSEY_GOLD_VN NULL
#define OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_VN NULL
#define OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_VN NULL
#define OPTION_VAL_TWB64_026_BIZARRE_PINK_VN NULL
#define OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_VN NULL
#define OPTION_VAL_TWB64_028_GAME_COM_VER_VN NULL
#define OPTION_VAL_TWB64_029_SANRIO_PINK_VN NULL
#define OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_VN NULL
#define OPTION_VAL_TWB64_031_COSMO_GREEN_VN NULL
#define OPTION_VAL_TWB64_032_WANDA_PINK_VN NULL
#define OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_VN NULL
#define OPTION_VAL_TWB64_034_TRAVEL_WOOD_VN NULL
#define OPTION_VAL_TWB64_035_POKEMON_VER_VN NULL
#define OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_VN NULL
#define OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_VN NULL
#define OPTION_VAL_TWB64_038_POKEMON_MINI_VER_VN NULL
#define OPTION_VAL_TWB64_039_SUPERVISION_VER_VN NULL
#define OPTION_VAL_TWB64_040_DMG_VER_VN NULL
#define OPTION_VAL_TWB64_041_POCKET_VER_VN NULL
#define OPTION_VAL_TWB64_042_LIGHT_VER_VN NULL
#define OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_VN NULL
#define OPTION_VAL_TWB64_044_SOMEITY_PINK_VN NULL
#define OPTION_VAL_TWB64_045_PIKACHU_YELLOW_VN NULL
#define OPTION_VAL_TWB64_046_EEVEE_BROWN_VN NULL
#define OPTION_VAL_TWB64_047_MICROVISION_VER_VN NULL
#define OPTION_VAL_TWB64_048_TI_83_VER_VN NULL
#define OPTION_VAL_TWB64_049_AEGIS_CHERRY_VN NULL
#define OPTION_VAL_TWB64_050_LABO_FAWN_VN NULL
#define OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_VN NULL
#define OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_VN NULL
#define OPTION_VAL_TWB64_053_VMU_VER_VN NULL
#define OPTION_VAL_TWB64_054_GAME_MASTER_VER_VN NULL
#define OPTION_VAL_TWB64_055_ANDROID_GREEN_VN NULL
#define OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_VN NULL
#define OPTION_VAL_TWB64_057_GOOGLE_RED_VN NULL
#define OPTION_VAL_TWB64_058_GOOGLE_BLUE_VN NULL
#define OPTION_VAL_TWB64_059_GOOGLE_YELLOW_VN NULL
#define OPTION_VAL_TWB64_060_GOOGLE_GREEN_VN NULL
#define OPTION_VAL_TWB64_061_WONDERSWAN_VER_VN NULL
#define OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_VN NULL
#define OPTION_VAL_TWB64_063_DEW_GREEN_VN NULL
#define OPTION_VAL_TWB64_064_COCA_COLA_RED_VN NULL
#define OPTION_VAL_TWB64_065_GAMEKING_VER_VN NULL
#define OPTION_VAL_TWB64_066_DO_THE_DEW_VER_VN NULL
#define OPTION_VAL_TWB64_067_DIGIVICE_VER_VN NULL
#define OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_VN NULL
#define OPTION_VAL_TWB64_069_BLOSSOM_PINK_VN NULL
#define OPTION_VAL_TWB64_070_BUBBLES_BLUE_VN NULL
#define OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_VN NULL
#define OPTION_VAL_TWB64_072_NASCAR_VER_VN NULL
#define OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_VN NULL
#define OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_VN NULL
#define OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_VN NULL
#define OPTION_VAL_TWB64_076_PHANTOM_RED_VN NULL
#define OPTION_VAL_TWB64_077_HALLOWEEN_VER_VN NULL
#define OPTION_VAL_TWB64_078_CHRISTMAS_VER_VN NULL
#define OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_VN NULL
#define OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_VN NULL
#define OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_VN NULL
#define OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_VN NULL
#define OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_VN NULL
#define OPTION_VAL_TWB64_084_SUPER_SAIYAN_VN NULL
#define OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_VN NULL
#define OPTION_VAL_TWB64_086_SAINT_SNOW_RED_VN NULL
#define OPTION_VAL_TWB64_087_YELLOW_BANANA_VN NULL
#define OPTION_VAL_TWB64_088_GREEN_BANANA_VN NULL
#define OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_VN NULL
#define OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_VN NULL
#define OPTION_VAL_TWB64_091_POCKET_TALES_VER_VN NULL
#define OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_VN NULL
#define OPTION_VAL_TWB64_093_S_E_E_S_BLUE_VN NULL
#define OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_VN NULL
#define OPTION_VAL_TWB64_095_HOKAGE_ORANGE_VN NULL
#define OPTION_VAL_TWB64_096_STRAW_HAT_RED_VN NULL
#define OPTION_VAL_TWB64_097_SWORD_ART_CYAN_VN NULL
#define OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_VN NULL
#define OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_VN NULL
#define OPTION_VAL_TWB64_100_STONE_ORANGE_VN NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_LABEL_VN NULL
#define GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_VN NULL
#define OPTION_VAL_TWB64_101_765PRO_PINK_VN NULL
#define OPTION_VAL_TWB64_102_CINDERELLA_BLUE_VN NULL
#define OPTION_VAL_TWB64_103_MILLION_YELLOW_VN NULL
#define OPTION_VAL_TWB64_104_SIDEM_GREEN_VN NULL
#define OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_VN NULL
#define OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_VN NULL
#define OPTION_VAL_TWB64_107_YO_KAI_PINK_VN NULL
#define OPTION_VAL_TWB64_108_YO_KAI_GREEN_VN NULL
#define OPTION_VAL_TWB64_109_YO_KAI_BLUE_VN NULL
#define OPTION_VAL_TWB64_110_YO_KAI_PURPLE_VN NULL
#define OPTION_VAL_TWB64_111_AQUATIC_IRO_VN NULL
#define OPTION_VAL_TWB64_112_TEA_MIDORI_VN NULL
#define OPTION_VAL_TWB64_113_SAKURA_PINK_VN NULL
#define OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_VN NULL
#define OPTION_VAL_TWB64_115_ONI_AKA_VN NULL
#define OPTION_VAL_TWB64_116_GOLDEN_KIIRO_VN NULL
#define OPTION_VAL_TWB64_117_SILVER_SHIRO_VN NULL
#define OPTION_VAL_TWB64_118_FRUITY_ORANGE_VN NULL
#define OPTION_VAL_TWB64_119_AKB48_PINK_VN NULL
#define OPTION_VAL_TWB64_120_MIKU_BLUE_VN NULL
#define OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_VN NULL
#define OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_VN NULL
#define OPTION_VAL_TWB64_123_ISLAND_GREEN_VN NULL
#define OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_VN NULL
#define OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_VN NULL
#define OPTION_VAL_TWB64_126_SLIME_BLUE_VN NULL
#define OPTION_VAL_TWB64_127_LIME_MIDORI_VN NULL
#define OPTION_VAL_TWB64_128_GHOSTLY_AOI_VN NULL
#define OPTION_VAL_TWB64_129_RETRO_BOGEDA_VN NULL
#define OPTION_VAL_TWB64_130_ROYAL_BLUE_VN NULL
#define OPTION_VAL_TWB64_131_NEON_PURPLE_VN NULL
#define OPTION_VAL_TWB64_132_NEON_ORANGE_VN NULL
#define OPTION_VAL_TWB64_133_MOONLIGHT_VISION_VN NULL
#define OPTION_VAL_TWB64_134_TOKYO_RED_VN NULL
#define OPTION_VAL_TWB64_135_PARIS_GOLD_VN NULL
#define OPTION_VAL_TWB64_136_BEIJING_BLUE_VN NULL
#define OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_VN NULL
#define OPTION_VAL_TWB64_138_IRISH_GREEN_VN NULL
#define OPTION_VAL_TWB64_139_KAKAROT_ORANGE_VN NULL
#define OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_VN NULL
#define OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_VN NULL
#define OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_VN NULL
#define OPTION_VAL_TWB64_143_BUBBLUN_GREEN_VN NULL
#define OPTION_VAL_TWB64_144_BOBBLUN_BLUE_VN NULL
#define OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_VN NULL
#define OPTION_VAL_TWB64_146_OLYMPIC_GOLD_VN NULL
#define OPTION_VAL_TWB64_147_VALUE_ORANGE_VN NULL
#define OPTION_VAL_TWB64_148_LIELLA_PURPLE_VN NULL
#define OPTION_VAL_TWB64_149_OLYMPIC_SILVER_VN NULL
#define OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_VN NULL
#define OPTION_VAL_TWB64_151_ANA_SKY_BLUE_VN NULL
#define OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_VN NULL
#define OPTION_VAL_TWB64_153_HOLOBLUE_VN NULL
#define OPTION_VAL_TWB64_154_WRESTLING_RED_VN NULL
#define OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_VN NULL
#define OPTION_VAL_TWB64_156_POKEDEX_RED_VN NULL
#define OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_VN NULL
#define OPTION_VAL_TWB64_158_XBOX_GREEN_VN NULL
#define OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_VN NULL
#define OPTION_VAL_TWB64_160_G4_ORANGE_VN NULL
#define OPTION_VAL_TWB64_161_SCARLETT_GREEN_VN NULL
#define OPTION_VAL_TWB64_162_GLITCHY_BLUE_VN NULL
#define OPTION_VAL_TWB64_163_CLASSIC_LCD_VN NULL
#define OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_VN NULL
#define OPTION_VAL_TWB64_165_POCKETSTATION_VER_VN NULL
#define OPTION_VAL_TWB64_166_GAME_AND_GOLD_VN NULL
#define OPTION_VAL_TWB64_167_SMURFY_BLUE_VN NULL
#define OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_VN NULL
#define OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_VN NULL
#define OPTION_VAL_TWB64_170_SHENRON_GREEN_VN NULL
#define OPTION_VAL_TWB64_171_BERSERK_BLOOD_VN NULL
#define OPTION_VAL_TWB64_172_SUPER_STAR_PINK_VN NULL
#define OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_VN NULL
#define OPTION_VAL_TWB64_174_BARBIE_PINK_VN NULL
#define OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_VN NULL
#define OPTION_VAL_TWB64_176_NOKIA_3310_VER_VN NULL
#define OPTION_VAL_TWB64_177_CLOVER_GREEN_VN NULL
#define OPTION_VAL_TWB64_178_CRASH_ORANGE_VN NULL
#define OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_VN NULL
#define OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_VN NULL
#define OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_VN NULL
#define OPTION_VAL_TWB64_182_PINK109_VN NULL
#define OPTION_VAL_TWB64_183_DORAEMON_BLUE_VN NULL
#define OPTION_VAL_TWB64_184_FURY_BLUE_VN NULL
#define OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_VN NULL
#define OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_VN NULL
#define OPTION_VAL_TWB64_187_SUSAN_G_PINK_VN NULL
#define OPTION_VAL_TWB64_188_PIZZA_HUT_RED_VN NULL
#define OPTION_VAL_TWB64_189_PLUMBOB_GREEN_VN NULL
#define OPTION_VAL_TWB64_190_GRAND_IVORY_VN NULL
#define OPTION_VAL_TWB64_191_DEMON_S_GOLD_VN NULL
#define OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_VN NULL
#define OPTION_VAL_TWB64_193_CHAMPION_BLUE_VN NULL
#define OPTION_VAL_TWB64_194_DK_BARREL_BROWN_VN NULL
#define OPTION_VAL_TWB64_195_EVANGELION_GREEN_VN NULL
#define OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_VN NULL
#define OPTION_VAL_TWB64_197_AUTOBOT_RED_VN NULL
#define OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_VN NULL
#define OPTION_VAL_TWB64_199_DURACELL_COPPER_VN NULL
#define OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_VN NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_VN NULL
#define GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_VN NULL
#define OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_VN NULL
#define OPTION_VAL_PIXELSHIFT_02_ARDUBOY_VN NULL
#define OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_VN NULL
#define OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_VN NULL
#define OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_VN NULL
#define OPTION_VAL_PIXELSHIFT_06_CMYK_VN NULL
#define OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_VN NULL
#define OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_VN NULL
#define OPTION_VAL_PIXELSHIFT_09_GAMATE_VN NULL
#define OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_VN NULL
#define OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_VN NULL
#define OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_VN NULL
#define OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_VN NULL
#define OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_VN NULL
#define OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_VN NULL
#define OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_VN NULL
#define OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_VN NULL
#define OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__VN NULL
#define OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_VN NULL
#define OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_VN NULL
#define OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_VN NULL
#define OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_VN NULL
#define OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_VN NULL
#define OPTION_VAL_PIXELSHIFT_24_GB_NEW_VN NULL
#define OPTION_VAL_PIXELSHIFT_25_GB_NUKED_VN NULL
#define OPTION_VAL_PIXELSHIFT_26_GB_OLD_VN NULL
#define OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_VN NULL
#define OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_VN NULL
#define OPTION_VAL_PIXELSHIFT_29_GHOST_VN NULL
#define OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_VN NULL
#define OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_VN NULL
#define OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_VN NULL
#define OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_VN NULL
#define OPTION_VAL_PIXELSHIFT_34_MISSINGNO_VN NULL
#define OPTION_VAL_PIXELSHIFT_35_MS_DOS_VN NULL
#define OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_VN NULL
#define OPTION_VAL_PIXELSHIFT_37_PIP_BOY_VN NULL
#define OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_VN NULL
#define OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_VN NULL
#define OPTION_VAL_PIXELSHIFT_40_SUNBURST_VN NULL
#define OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_VN NULL
#define OPTION_VAL_PIXELSHIFT_42_TRON_VN NULL
#define OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_VN NULL
#define OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_VN NULL
#define OPTION_VAL_PIXELSHIFT_45_WISH_VN NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_LABEL_VN NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_VN NULL
#define OPTION_VAL_GBC_ONLY_VN NULL
#define OPTION_VAL_ALWAYS_VN NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_VN NULL
#define GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_VN NULL
#define OPTION_VAL_ACCURATE_VN NULL
#define OPTION_VAL_FAST_VN NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_VN NULL
#define GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_VN NULL
#define OPTION_VAL_CENTRAL_VN NULL
#define OPTION_VAL_ABOVE_SCREEN_VN NULL
#define OPTION_VAL_BELOW_SCREEN_VN NULL
#define GAMBATTE_DARK_FILTER_LEVEL_LABEL_VN NULL
#define GAMBATTE_DARK_FILTER_LEVEL_INFO_0_VN NULL
#define GAMBATTE_MIX_FRAMES_LABEL_VN NULL
#define GAMBATTE_MIX_FRAMES_INFO_0_VN NULL
#define OPTION_VAL_MIX_VN "Đơn giản"
#define OPTION_VAL_LCD_GHOSTING_VN NULL
#define OPTION_VAL_LCD_GHOSTING_FAST_VN NULL
#define GAMBATTE_AUDIO_RESAMPLER_LABEL_VN "Âm thanh Resampler Driver"
#define GAMBATTE_AUDIO_RESAMPLER_INFO_0_VN NULL
#define OPTION_VAL_SINC_VN NULL
#define OPTION_VAL_CC_VN NULL
#define GAMBATTE_GB_HWMODE_LABEL_VN NULL
#define GAMBATTE_GB_HWMODE_INFO_0_VN NULL
#define OPTION_VAL_GB_VN NULL
#define OPTION_VAL_GBA_VN NULL
#define GAMBATTE_GB_BOOTLOADER_LABEL_VN NULL
#define GAMBATTE_GB_BOOTLOADER_INFO_0_VN NULL
#define GAMBATTE_UP_DOWN_ALLOWED_LABEL_VN NULL
#define GAMBATTE_UP_DOWN_ALLOWED_INFO_0_VN NULL
#define GAMBATTE_TURBO_PERIOD_LABEL_VN NULL
#define GAMBATTE_TURBO_PERIOD_INFO_0_VN NULL
#define GAMBATTE_RUMBLE_LEVEL_LABEL_VN NULL
#define GAMBATTE_RUMBLE_LEVEL_INFO_0_VN NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_VN NULL
#define GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_VN NULL
#define GAMBATTE_GB_LINK_MODE_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_MODE_INFO_0_VN NULL
#define OPTION_VAL_NOT_CONNECTED_VN "Chưa kết nối"
#define OPTION_VAL_NETWORK_SERVER_VN "Mạng máy chủ"
#define OPTION_VAL_NETWORK_CLIENT_VN "Mạng máy khách"
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_VN "Cổng"
#define GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_VN NULL
#define GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_VN NULL

struct retro_core_option_v2_category option_cats_vn[] = {
   {
      "gb_link",
      CATEGORY_GB_LINK_LABEL_VN,
      CATEGORY_GB_LINK_INFO_0_VN
   },
   { NULL, NULL, NULL },
};
struct retro_core_option_v2_definition option_defs_vn[] = {
   {
      "gambatte_gb_colorization",
      GAMBATTE_GB_COLORIZATION_LABEL_VN,
      NULL,
      GAMBATTE_GB_COLORIZATION_INFO_0_VN,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "auto",     OPTION_VAL_AUTO_VN },
         { "GBC",      OPTION_VAL_GBC_VN },
         { "SGB",      OPTION_VAL_SGB_VN },
         { "internal", OPTION_VAL_INTERNAL_VN },
         { "custom",   OPTION_VAL_CUSTOM_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_internal_palette",
      GAMBATTE_GB_INTERNAL_PALETTE_LABEL_VN,
      NULL,
      GAMBATTE_GB_INTERNAL_PALETTE_INFO_0_VN,
      NULL,
      NULL,
      {
         { "GB - DMG",                 OPTION_VAL_GB_DMG_VN },
         { "GB - Pocket",              OPTION_VAL_GB_POCKET_VN },
         { "GB - Light",               OPTION_VAL_GB_LIGHT_VN },
         { "GBC - Blue",               OPTION_VAL_GBC_BLUE_VN },
         { "GBC - Brown",              OPTION_VAL_GBC_BROWN_VN },
         { "GBC - Dark Blue",          OPTION_VAL_GBC_DARK_BLUE_VN },
         { "GBC - Dark Brown",         OPTION_VAL_GBC_DARK_BROWN_VN },
         { "GBC - Dark Green",         OPTION_VAL_GBC_DARK_GREEN_VN },
         { "GBC - Grayscale",          OPTION_VAL_GBC_GRAYSCALE_VN },
         { "GBC - Green",              OPTION_VAL_GBC_GREEN_VN },
         { "GBC - Inverted",           OPTION_VAL_GBC_INVERTED_VN },
         { "GBC - Orange",             OPTION_VAL_GBC_ORANGE_VN },
         { "GBC - Pastel Mix",         OPTION_VAL_GBC_PASTEL_MIX_VN },
         { "GBC - Red",                OPTION_VAL_GBC_RED_VN },
         { "GBC - Yellow",             OPTION_VAL_GBC_YELLOW_VN },
         { "SGB - 1A",                 OPTION_VAL_SGB_1A_VN },
         { "SGB - 1B",                 OPTION_VAL_SGB_1B_VN },
         { "SGB - 1C",                 OPTION_VAL_SGB_1C_VN },
         { "SGB - 1D",                 OPTION_VAL_SGB_1D_VN },
         { "SGB - 1E",                 OPTION_VAL_SGB_1E_VN },
         { "SGB - 1F",                 OPTION_VAL_SGB_1F_VN },
         { "SGB - 1G",                 OPTION_VAL_SGB_1G_VN },
         { "SGB - 1H",                 OPTION_VAL_SGB_1H_VN },
         { "SGB - 2A",                 OPTION_VAL_SGB_2A_VN },
         { "SGB - 2B",                 OPTION_VAL_SGB_2B_VN },
         { "SGB - 2C",                 OPTION_VAL_SGB_2C_VN },
         { "SGB - 2D",                 OPTION_VAL_SGB_2D_VN },
         { "SGB - 2E",                 OPTION_VAL_SGB_2E_VN },
         { "SGB - 2F",                 OPTION_VAL_SGB_2F_VN },
         { "SGB - 2G",                 OPTION_VAL_SGB_2G_VN },
         { "SGB - 2H",                 OPTION_VAL_SGB_2H_VN },
         { "SGB - 3A",                 OPTION_VAL_SGB_3A_VN },
         { "SGB - 3B",                 OPTION_VAL_SGB_3B_VN },
         { "SGB - 3C",                 OPTION_VAL_SGB_3C_VN },
         { "SGB - 3D",                 OPTION_VAL_SGB_3D_VN },
         { "SGB - 3E",                 OPTION_VAL_SGB_3E_VN },
         { "SGB - 3F",                 OPTION_VAL_SGB_3F_VN },
         { "SGB - 3G",                 OPTION_VAL_SGB_3G_VN },
         { "SGB - 3H",                 OPTION_VAL_SGB_3H_VN },
         { "SGB - 4A",                 OPTION_VAL_SGB_4A_VN },
         { "SGB - 4B",                 OPTION_VAL_SGB_4B_VN },
         { "SGB - 4C",                 OPTION_VAL_SGB_4C_VN },
         { "SGB - 4D",                 OPTION_VAL_SGB_4D_VN },
         { "SGB - 4E",                 OPTION_VAL_SGB_4E_VN },
         { "SGB - 4F",                 OPTION_VAL_SGB_4F_VN },
         { "SGB - 4G",                 OPTION_VAL_SGB_4G_VN },
         { "SGB - 4H",                 OPTION_VAL_SGB_4H_VN },
         { "Special 1",                OPTION_VAL_SPECIAL_1_VN },
         { "Special 2",                OPTION_VAL_SPECIAL_2_VN },
         { "Special 3",                OPTION_VAL_SPECIAL_3_VN },
         { "Special 4 (TI-83 Legacy)", OPTION_VAL_SPECIAL_4_TI_83_LEGACY_VN },
         { "TWB64 - Pack 1",           OPTION_VAL_TWB64_PACK_1_VN },
         { "TWB64 - Pack 2",           OPTION_VAL_TWB64_PACK_2_VN },
         { "PixelShift - Pack 1",      OPTION_VAL_PIXELSHIFT_PACK_1_VN },
         { NULL, NULL },
      },
      "GB - DMG"
   },
   {
      "gambatte_gb_palette_twb64_1",
      GAMBATTE_GB_PALETTE_TWB64_1_LABEL_VN,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_1_INFO_0_VN,
      NULL,
      NULL,
      {
         { "TWB64 001 - Aqours Blue",               OPTION_VAL_TWB64_001_AQOURS_BLUE_VN },
         { "TWB64 002 - Anime Expo Ver.",           OPTION_VAL_TWB64_002_ANIME_EXPO_VER_VN },
         { "TWB64 003 - SpongeBob Yellow",          OPTION_VAL_TWB64_003_SPONGEBOB_YELLOW_VN },
         { "TWB64 004 - Patrick Star Pink",         OPTION_VAL_TWB64_004_PATRICK_STAR_PINK_VN },
         { "TWB64 005 - Neon Red",                  OPTION_VAL_TWB64_005_NEON_RED_VN },
         { "TWB64 006 - Neon Blue",                 OPTION_VAL_TWB64_006_NEON_BLUE_VN },
         { "TWB64 007 - Neon Yellow",               OPTION_VAL_TWB64_007_NEON_YELLOW_VN },
         { "TWB64 008 - Neon Green",                OPTION_VAL_TWB64_008_NEON_GREEN_VN },
         { "TWB64 009 - Neon Pink",                 OPTION_VAL_TWB64_009_NEON_PINK_VN },
         { "TWB64 010 - Mario Red",                 OPTION_VAL_TWB64_010_MARIO_RED_VN },
         { "TWB64 011 - Nick Orange",               OPTION_VAL_TWB64_011_NICK_ORANGE_VN },
         { "TWB64 012 - Virtual Boy Ver.",          OPTION_VAL_TWB64_012_VIRTUAL_BOY_VER_VN },
         { "TWB64 013 - Golden Wild",               OPTION_VAL_TWB64_013_GOLDEN_WILD_VN },
         { "TWB64 014 - Builder Yellow",            OPTION_VAL_TWB64_014_BUILDER_YELLOW_VN },
         { "TWB64 015 - Classic Blurple",           OPTION_VAL_TWB64_015_CLASSIC_BLURPLE_VN },
         { "TWB64 016 - 765 Production Ver.",       OPTION_VAL_TWB64_016_765_PRODUCTION_VER_VN },
         { "TWB64 017 - Superball Ivory",           OPTION_VAL_TWB64_017_SUPERBALL_IVORY_VN },
         { "TWB64 018 - Crunchyroll Orange",        OPTION_VAL_TWB64_018_CRUNCHYROLL_ORANGE_VN },
         { "TWB64 019 - Muse Pink",                 OPTION_VAL_TWB64_019_MUSE_PINK_VN },
         { "TWB64 020 - Nijigasaki Yellow",         OPTION_VAL_TWB64_020_NIJIGASAKI_YELLOW_VN },
         { "TWB64 021 - Gamate Ver.",               OPTION_VAL_TWB64_021_GAMATE_VER_VN },
         { "TWB64 022 - Greenscale Ver.",           OPTION_VAL_TWB64_022_GREENSCALE_VER_VN },
         { "TWB64 023 - Odyssey Gold",              OPTION_VAL_TWB64_023_ODYSSEY_GOLD_VN },
         { "TWB64 024 - Super Saiyan God",          OPTION_VAL_TWB64_024_SUPER_SAIYAN_GOD_VN },
         { "TWB64 025 - Super Saiyan Blue",         OPTION_VAL_TWB64_025_SUPER_SAIYAN_BLUE_VN },
         { "TWB64 026 - Bizarre Pink",              OPTION_VAL_TWB64_026_BIZARRE_PINK_VN },
         { "TWB64 027 - Nintendo Switch Lite Ver.", OPTION_VAL_TWB64_027_NINTENDO_SWITCH_LITE_VER_VN },
         { "TWB64 028 - Game.com Ver.",             OPTION_VAL_TWB64_028_GAME_COM_VER_VN },
         { "TWB64 029 - Sanrio Pink",               OPTION_VAL_TWB64_029_SANRIO_PINK_VN },
         { "TWB64 030 - BANDAI NAMCO Ver.",         OPTION_VAL_TWB64_030_BANDAI_NAMCO_VER_VN },
         { "TWB64 031 - Cosmo Green",               OPTION_VAL_TWB64_031_COSMO_GREEN_VN },
         { "TWB64 032 - Wanda Pink",                OPTION_VAL_TWB64_032_WANDA_PINK_VN },
         { "TWB64 033 - Link's Awakening DX Ver.",  OPTION_VAL_TWB64_033_LINK_S_AWAKENING_DX_VER_VN },
         { "TWB64 034 - Travel Wood",               OPTION_VAL_TWB64_034_TRAVEL_WOOD_VN },
         { "TWB64 035 - Pokemon Ver.",              OPTION_VAL_TWB64_035_POKEMON_VER_VN },
         { "TWB64 036 - Game Grump Orange",         OPTION_VAL_TWB64_036_GAME_GRUMP_ORANGE_VN },
         { "TWB64 037 - Scooby-Doo Mystery Ver.",   OPTION_VAL_TWB64_037_SCOOBY_DOO_MYSTERY_VER_VN },
         { "TWB64 038 - Pokemon mini Ver.",         OPTION_VAL_TWB64_038_POKEMON_MINI_VER_VN },
         { "TWB64 039 - Supervision Ver.",          OPTION_VAL_TWB64_039_SUPERVISION_VER_VN },
         { "TWB64 040 - DMG Ver.",                  OPTION_VAL_TWB64_040_DMG_VER_VN },
         { "TWB64 041 - Pocket Ver.",               OPTION_VAL_TWB64_041_POCKET_VER_VN },
         { "TWB64 042 - Light Ver.",                OPTION_VAL_TWB64_042_LIGHT_VER_VN },
         { "TWB64 043 - Miraitowa Blue",            OPTION_VAL_TWB64_043_MIRAITOWA_BLUE_VN },
         { "TWB64 044 - Someity Pink",              OPTION_VAL_TWB64_044_SOMEITY_PINK_VN },
         { "TWB64 045 - Pikachu Yellow",            OPTION_VAL_TWB64_045_PIKACHU_YELLOW_VN },
         { "TWB64 046 - Eevee Brown",               OPTION_VAL_TWB64_046_EEVEE_BROWN_VN },
         { "TWB64 047 - Microvision Ver.",          OPTION_VAL_TWB64_047_MICROVISION_VER_VN },
         { "TWB64 048 - TI-83 Ver.",                OPTION_VAL_TWB64_048_TI_83_VER_VN },
         { "TWB64 049 - Aegis Cherry",              OPTION_VAL_TWB64_049_AEGIS_CHERRY_VN },
         { "TWB64 050 - Labo Fawn",                 OPTION_VAL_TWB64_050_LABO_FAWN_VN },
         { "TWB64 051 - MILLION LIVE GOLD!",        OPTION_VAL_TWB64_051_MILLION_LIVE_GOLD_VN },
         { "TWB64 052 - Tokyo Midtown Ver.",        OPTION_VAL_TWB64_052_TOKYO_MIDTOWN_VER_VN },
         { "TWB64 053 - VMU Ver.",                  OPTION_VAL_TWB64_053_VMU_VER_VN },
         { "TWB64 054 - Game Master Ver.",          OPTION_VAL_TWB64_054_GAME_MASTER_VER_VN },
         { "TWB64 055 - Android Green",             OPTION_VAL_TWB64_055_ANDROID_GREEN_VN },
         { "TWB64 056 - Ticketmaster Azure",        OPTION_VAL_TWB64_056_TICKETMASTER_AZURE_VN },
         { "TWB64 057 - Google Red",                OPTION_VAL_TWB64_057_GOOGLE_RED_VN },
         { "TWB64 058 - Google Blue",               OPTION_VAL_TWB64_058_GOOGLE_BLUE_VN },
         { "TWB64 059 - Google Yellow",             OPTION_VAL_TWB64_059_GOOGLE_YELLOW_VN },
         { "TWB64 060 - Google Green",              OPTION_VAL_TWB64_060_GOOGLE_GREEN_VN },
         { "TWB64 061 - WonderSwan Ver.",           OPTION_VAL_TWB64_061_WONDERSWAN_VER_VN },
         { "TWB64 062 - Neo Geo Pocket Ver.",       OPTION_VAL_TWB64_062_NEO_GEO_POCKET_VER_VN },
         { "TWB64 063 - Dew Green",                 OPTION_VAL_TWB64_063_DEW_GREEN_VN },
         { "TWB64 064 - Coca-Cola Red",             OPTION_VAL_TWB64_064_COCA_COLA_RED_VN },
         { "TWB64 065 - GameKing Ver.",             OPTION_VAL_TWB64_065_GAMEKING_VER_VN },
         { "TWB64 066 - Do The Dew Ver.",           OPTION_VAL_TWB64_066_DO_THE_DEW_VER_VN },
         { "TWB64 067 - Digivice Ver.",             OPTION_VAL_TWB64_067_DIGIVICE_VER_VN },
         { "TWB64 068 - Bikini Bottom Ver.",        OPTION_VAL_TWB64_068_BIKINI_BOTTOM_VER_VN },
         { "TWB64 069 - Blossom Pink",              OPTION_VAL_TWB64_069_BLOSSOM_PINK_VN },
         { "TWB64 070 - Bubbles Blue",              OPTION_VAL_TWB64_070_BUBBLES_BLUE_VN },
         { "TWB64 071 - Buttercup Green",           OPTION_VAL_TWB64_071_BUTTERCUP_GREEN_VN },
         { "TWB64 072 - NASCAR Ver.",               OPTION_VAL_TWB64_072_NASCAR_VER_VN },
         { "TWB64 073 - Lemon-Lime Green",          OPTION_VAL_TWB64_073_LEMON_LIME_GREEN_VN },
         { "TWB64 074 - Mega Man V Ver.",           OPTION_VAL_TWB64_074_MEGA_MAN_V_VER_VN },
         { "TWB64 075 - Tamagotchi Ver.",           OPTION_VAL_TWB64_075_TAMAGOTCHI_VER_VN },
         { "TWB64 076 - Phantom Red",               OPTION_VAL_TWB64_076_PHANTOM_RED_VN },
         { "TWB64 077 - Halloween Ver.",            OPTION_VAL_TWB64_077_HALLOWEEN_VER_VN },
         { "TWB64 078 - Christmas Ver.",            OPTION_VAL_TWB64_078_CHRISTMAS_VER_VN },
         { "TWB64 079 - Cardcaptor Pink",           OPTION_VAL_TWB64_079_CARDCAPTOR_PINK_VN },
         { "TWB64 080 - Pretty Guardian Gold",      OPTION_VAL_TWB64_080_PRETTY_GUARDIAN_GOLD_VN },
         { "TWB64 081 - Camouflage Ver.",           OPTION_VAL_TWB64_081_CAMOUFLAGE_VER_VN },
         { "TWB64 082 - Legendary Super Saiyan",    OPTION_VAL_TWB64_082_LEGENDARY_SUPER_SAIYAN_VN },
         { "TWB64 083 - Super Saiyan Rose",         OPTION_VAL_TWB64_083_SUPER_SAIYAN_ROSE_VN },
         { "TWB64 084 - Super Saiyan",              OPTION_VAL_TWB64_084_SUPER_SAIYAN_VN },
         { "TWB64 085 - Perfected Ultra Instinct",  OPTION_VAL_TWB64_085_PERFECTED_ULTRA_INSTINCT_VN },
         { "TWB64 086 - Saint Snow Red",            OPTION_VAL_TWB64_086_SAINT_SNOW_RED_VN },
         { "TWB64 087 - Yellow Banana",             OPTION_VAL_TWB64_087_YELLOW_BANANA_VN },
         { "TWB64 088 - Green Banana",              OPTION_VAL_TWB64_088_GREEN_BANANA_VN },
         { "TWB64 089 - Super Saiyan 3",            OPTION_VAL_TWB64_089_SUPER_SAIYAN_3_VN },
         { "TWB64 090 - Super Saiyan Blue Evolved", OPTION_VAL_TWB64_090_SUPER_SAIYAN_BLUE_EVOLVED_VN },
         { "TWB64 091 - Pocket Tales Ver.",         OPTION_VAL_TWB64_091_POCKET_TALES_VER_VN },
         { "TWB64 092 - Investigation Yellow",      OPTION_VAL_TWB64_092_INVESTIGATION_YELLOW_VN },
         { "TWB64 093 - S.E.E.S. Blue",             OPTION_VAL_TWB64_093_S_E_E_S_BLUE_VN },
         { "TWB64 094 - Game Awards Cyan",          OPTION_VAL_TWB64_094_GAME_AWARDS_CYAN_VN },
         { "TWB64 095 - Hokage Orange",             OPTION_VAL_TWB64_095_HOKAGE_ORANGE_VN },
         { "TWB64 096 - Straw Hat Red",             OPTION_VAL_TWB64_096_STRAW_HAT_RED_VN },
         { "TWB64 097 - Sword Art Cyan",            OPTION_VAL_TWB64_097_SWORD_ART_CYAN_VN },
         { "TWB64 098 - Deku Alpha Emerald",        OPTION_VAL_TWB64_098_DEKU_ALPHA_EMERALD_VN },
         { "TWB64 099 - Blue Stripes Ver.",         OPTION_VAL_TWB64_099_BLUE_STRIPES_VER_VN },
         { "TWB64 100 - Stone Orange",              OPTION_VAL_TWB64_100_STONE_ORANGE_VN },
         { NULL, NULL },
      },
      "TWB64 001 - Aqours Blue"
   },
   {
      "gambatte_gb_palette_twb64_2",
      GAMBATTE_GB_PALETTE_TWB64_2_LABEL_VN,
      NULL,
      GAMBATTE_GB_PALETTE_TWB64_2_INFO_0_VN,
      NULL,
      NULL,
      {
         { "TWB64 101 - 765PRO Pink",               OPTION_VAL_TWB64_101_765PRO_PINK_VN },
         { "TWB64 102 - CINDERELLA Blue",           OPTION_VAL_TWB64_102_CINDERELLA_BLUE_VN },
         { "TWB64 103 - MILLION Yellow!",           OPTION_VAL_TWB64_103_MILLION_YELLOW_VN },
         { "TWB64 104 - SideM Green",               OPTION_VAL_TWB64_104_SIDEM_GREEN_VN },
         { "TWB64 105 - SHINY Sky Blue",            OPTION_VAL_TWB64_105_SHINY_SKY_BLUE_VN },
         { "TWB64 106 - Angry Volcano Ver.",        OPTION_VAL_TWB64_106_ANGRY_VOLCANO_VER_VN },
         { "TWB64 107 - Yo-kai Pink",               OPTION_VAL_TWB64_107_YO_KAI_PINK_VN },
         { "TWB64 108 - Yo-kai Green",              OPTION_VAL_TWB64_108_YO_KAI_GREEN_VN },
         { "TWB64 109 - Yo-kai Blue",               OPTION_VAL_TWB64_109_YO_KAI_BLUE_VN },
         { "TWB64 110 - Yo-kai Purple",             OPTION_VAL_TWB64_110_YO_KAI_PURPLE_VN },
         { "TWB64 111 - Aquatic Iro",               OPTION_VAL_TWB64_111_AQUATIC_IRO_VN },
         { "TWB64 112 - Tea Midori",                OPTION_VAL_TWB64_112_TEA_MIDORI_VN },
         { "TWB64 113 - Sakura Pink",               OPTION_VAL_TWB64_113_SAKURA_PINK_VN },
         { "TWB64 114 - Wisteria Murasaki",         OPTION_VAL_TWB64_114_WISTERIA_MURASAKI_VN },
         { "TWB64 115 - Oni Aka",                   OPTION_VAL_TWB64_115_ONI_AKA_VN },
         { "TWB64 116 - Golden Kiiro",              OPTION_VAL_TWB64_116_GOLDEN_KIIRO_VN },
         { "TWB64 117 - Silver Shiro",              OPTION_VAL_TWB64_117_SILVER_SHIRO_VN },
         { "TWB64 118 - Fruity Orange",             OPTION_VAL_TWB64_118_FRUITY_ORANGE_VN },
         { "TWB64 119 - AKB48 Pink",                OPTION_VAL_TWB64_119_AKB48_PINK_VN },
         { "TWB64 120 - Miku Blue",                 OPTION_VAL_TWB64_120_MIKU_BLUE_VN },
         { "TWB64 121 - Fairy Tail Red",            OPTION_VAL_TWB64_121_FAIRY_TAIL_RED_VN },
         { "TWB64 122 - Survey Corps Brown",        OPTION_VAL_TWB64_122_SURVEY_CORPS_BROWN_VN },
         { "TWB64 123 - Island Green",              OPTION_VAL_TWB64_123_ISLAND_GREEN_VN },
         { "TWB64 124 - Mania Plus Green",          OPTION_VAL_TWB64_124_MANIA_PLUS_GREEN_VN },
         { "TWB64 125 - Ninja Turtle Green",        OPTION_VAL_TWB64_125_NINJA_TURTLE_GREEN_VN },
         { "TWB64 126 - Slime Blue",                OPTION_VAL_TWB64_126_SLIME_BLUE_VN },
         { "TWB64 127 - Lime Midori",               OPTION_VAL_TWB64_127_LIME_MIDORI_VN },
         { "TWB64 128 - Ghostly Aoi",               OPTION_VAL_TWB64_128_GHOSTLY_AOI_VN },
         { "TWB64 129 - Retro Bogeda",              OPTION_VAL_TWB64_129_RETRO_BOGEDA_VN },
         { "TWB64 130 - Royal Blue",                OPTION_VAL_TWB64_130_ROYAL_BLUE_VN },
         { "TWB64 131 - Neon Purple",               OPTION_VAL_TWB64_131_NEON_PURPLE_VN },
         { "TWB64 132 - Neon Orange",               OPTION_VAL_TWB64_132_NEON_ORANGE_VN },
         { "TWB64 133 - Moonlight Vision",          OPTION_VAL_TWB64_133_MOONLIGHT_VISION_VN },
         { "TWB64 134 - Tokyo Red",                 OPTION_VAL_TWB64_134_TOKYO_RED_VN },
         { "TWB64 135 - Paris Gold",                OPTION_VAL_TWB64_135_PARIS_GOLD_VN },
         { "TWB64 136 - Beijing Blue",              OPTION_VAL_TWB64_136_BEIJING_BLUE_VN },
         { "TWB64 137 - Pac-Man Yellow",            OPTION_VAL_TWB64_137_PAC_MAN_YELLOW_VN },
         { "TWB64 138 - Irish Green",               OPTION_VAL_TWB64_138_IRISH_GREEN_VN },
         { "TWB64 139 - Kakarot Orange",            OPTION_VAL_TWB64_139_KAKAROT_ORANGE_VN },
         { "TWB64 140 - Dragon Ball Orange",        OPTION_VAL_TWB64_140_DRAGON_BALL_ORANGE_VN },
         { "TWB64 141 - Christmas Gold",            OPTION_VAL_TWB64_141_CHRISTMAS_GOLD_VN },
         { "TWB64 142 - Pepsi-Cola Blue",           OPTION_VAL_TWB64_142_PEPSI_COLA_BLUE_VN },
         { "TWB64 143 - Bubblun Green",             OPTION_VAL_TWB64_143_BUBBLUN_GREEN_VN },
         { "TWB64 144 - Bobblun Blue",              OPTION_VAL_TWB64_144_BOBBLUN_BLUE_VN },
         { "TWB64 145 - Baja Blast Storm",          OPTION_VAL_TWB64_145_BAJA_BLAST_STORM_VN },
         { "TWB64 146 - Olympic Gold",              OPTION_VAL_TWB64_146_OLYMPIC_GOLD_VN },
         { "TWB64 147 - Value Orange",              OPTION_VAL_TWB64_147_VALUE_ORANGE_VN },
         { "TWB64 148 - Liella Purple!",            OPTION_VAL_TWB64_148_LIELLA_PURPLE_VN },
         { "TWB64 149 - Olympic Silver",            OPTION_VAL_TWB64_149_OLYMPIC_SILVER_VN },
         { "TWB64 150 - Olympic Bronze",            OPTION_VAL_TWB64_150_OLYMPIC_BRONZE_VN },
         { "TWB64 151 - ANA Sky Blue",              OPTION_VAL_TWB64_151_ANA_SKY_BLUE_VN },
         { "TWB64 152 - Nijigasaki Orange",         OPTION_VAL_TWB64_152_NIJIGASAKI_ORANGE_VN },
         { "TWB64 153 - HoloBlue",                  OPTION_VAL_TWB64_153_HOLOBLUE_VN },
         { "TWB64 154 - Wrestling Red",             OPTION_VAL_TWB64_154_WRESTLING_RED_VN },
         { "TWB64 155 - Yoshi Egg Green",           OPTION_VAL_TWB64_155_YOSHI_EGG_GREEN_VN },
         { "TWB64 156 - Pokedex Red",               OPTION_VAL_TWB64_156_POKEDEX_RED_VN },
         { "TWB64 157 - Disney Dream Blue",         OPTION_VAL_TWB64_157_DISNEY_DREAM_BLUE_VN },
         { "TWB64 158 - Xbox Green",                OPTION_VAL_TWB64_158_XBOX_GREEN_VN },
         { "TWB64 159 - Sonic Mega Blue",           OPTION_VAL_TWB64_159_SONIC_MEGA_BLUE_VN },
         { "TWB64 160 - G4 Orange",                 OPTION_VAL_TWB64_160_G4_ORANGE_VN },
         { "TWB64 161 - Scarlett Green",            OPTION_VAL_TWB64_161_SCARLETT_GREEN_VN },
         { "TWB64 162 - Glitchy Blue",              OPTION_VAL_TWB64_162_GLITCHY_BLUE_VN },
         { "TWB64 163 - Classic LCD",               OPTION_VAL_TWB64_163_CLASSIC_LCD_VN },
         { "TWB64 164 - 3DS Virtual Console Ver.",  OPTION_VAL_TWB64_164_3DS_VIRTUAL_CONSOLE_VER_VN },
         { "TWB64 165 - PocketStation Ver.",        OPTION_VAL_TWB64_165_POCKETSTATION_VER_VN },
         { "TWB64 166 - Game and Gold",             OPTION_VAL_TWB64_166_GAME_AND_GOLD_VN },
         { "TWB64 167 - Smurfy Blue",               OPTION_VAL_TWB64_167_SMURFY_BLUE_VN },
         { "TWB64 168 - Swampy Ogre Green",         OPTION_VAL_TWB64_168_SWAMPY_OGRE_GREEN_VN },
         { "TWB64 169 - Sailor Spinach Green",      OPTION_VAL_TWB64_169_SAILOR_SPINACH_GREEN_VN },
         { "TWB64 170 - Shenron Green",             OPTION_VAL_TWB64_170_SHENRON_GREEN_VN },
         { "TWB64 171 - Berserk Blood",             OPTION_VAL_TWB64_171_BERSERK_BLOOD_VN },
         { "TWB64 172 - Super Star Pink",           OPTION_VAL_TWB64_172_SUPER_STAR_PINK_VN },
         { "TWB64 173 - Gamebuino Classic Ver.",    OPTION_VAL_TWB64_173_GAMEBUINO_CLASSIC_VER_VN },
         { "TWB64 174 - Barbie Pink",               OPTION_VAL_TWB64_174_BARBIE_PINK_VN },
         { "TWB64 175 - Star Command Green",        OPTION_VAL_TWB64_175_STAR_COMMAND_GREEN_VN },
         { "TWB64 176 - Nokia 3310 Ver.",           OPTION_VAL_TWB64_176_NOKIA_3310_VER_VN },
         { "TWB64 177 - Clover Green",              OPTION_VAL_TWB64_177_CLOVER_GREEN_VN },
         { "TWB64 178 - Crash Orange",              OPTION_VAL_TWB64_178_CRASH_ORANGE_VN },
         { "TWB64 179 - Famicom Disk Yellow",       OPTION_VAL_TWB64_179_FAMICOM_DISK_YELLOW_VN },
         { "TWB64 180 - Team Rocket Red",           OPTION_VAL_TWB64_180_TEAM_ROCKET_RED_VN },
         { "TWB64 181 - SEIKO Timer Yellow",        OPTION_VAL_TWB64_181_SEIKO_TIMER_YELLOW_VN },
         { "TWB64 182 - PINK109",                   OPTION_VAL_TWB64_182_PINK109_VN },
         { "TWB64 183 - Doraemon Blue",             OPTION_VAL_TWB64_183_DORAEMON_BLUE_VN },
         { "TWB64 184 - Fury Blue",                 OPTION_VAL_TWB64_184_FURY_BLUE_VN },
         { "TWB64 185 - Rockstar Orange",           OPTION_VAL_TWB64_185_ROCKSTAR_ORANGE_VN },
         { "TWB64 186 - Puyo Puyo Green",           OPTION_VAL_TWB64_186_PUYO_PUYO_GREEN_VN },
         { "TWB64 187 - Susan G. Pink",             OPTION_VAL_TWB64_187_SUSAN_G_PINK_VN },
         { "TWB64 188 - Pizza Hut Red",             OPTION_VAL_TWB64_188_PIZZA_HUT_RED_VN },
         { "TWB64 189 - Plumbob Green",             OPTION_VAL_TWB64_189_PLUMBOB_GREEN_VN },
         { "TWB64 190 - Grand Ivory",               OPTION_VAL_TWB64_190_GRAND_IVORY_VN },
         { "TWB64 191 - Demon's Gold",              OPTION_VAL_TWB64_191_DEMON_S_GOLD_VN },
         { "TWB64 192 - SEGA Tokyo Blue",           OPTION_VAL_TWB64_192_SEGA_TOKYO_BLUE_VN },
         { "TWB64 193 - Champion Blue",             OPTION_VAL_TWB64_193_CHAMPION_BLUE_VN },
         { "TWB64 194 - DK Barrel Brown",           OPTION_VAL_TWB64_194_DK_BARREL_BROWN_VN },
         { "TWB64 195 - Evangelion Green",          OPTION_VAL_TWB64_195_EVANGELION_GREEN_VN },
         { "TWB64 196 - Equestrian Purple",         OPTION_VAL_TWB64_196_EQUESTRIAN_PURPLE_VN },
         { "TWB64 197 - Autobot Red",               OPTION_VAL_TWB64_197_AUTOBOT_RED_VN },
         { "TWB64 198 - Niconico Sea Green",        OPTION_VAL_TWB64_198_NICONICO_SEA_GREEN_VN },
         { "TWB64 199 - Duracell Copper",           OPTION_VAL_TWB64_199_DURACELL_COPPER_VN },
         { "TWB64 200 - TOKYO SKYTREE CLOUDY BLUE", OPTION_VAL_TWB64_200_TOKYO_SKYTREE_CLOUDY_BLUE_VN },
         { NULL, NULL },
      },
      "TWB64 101 - 765PRO Pink"
   },
   {
      "gambatte_gb_palette_pixelshift_1",
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_LABEL_VN,
      NULL,
      GAMBATTE_GB_PALETTE_PIXELSHIFT_1_INFO_0_VN,
      NULL,
      NULL,
      {
         { "PixelShift 01 - Arctic Green",               OPTION_VAL_PIXELSHIFT_01_ARCTIC_GREEN_VN },
         { "PixelShift 02 - Arduboy",                    OPTION_VAL_PIXELSHIFT_02_ARDUBOY_VN },
         { "PixelShift 03 - BGB 0.3 Emulator",           OPTION_VAL_PIXELSHIFT_03_BGB_0_3_EMULATOR_VN },
         { "PixelShift 04 - Camouflage",                 OPTION_VAL_PIXELSHIFT_04_CAMOUFLAGE_VN },
         { "PixelShift 05 - Chocolate Bar",              OPTION_VAL_PIXELSHIFT_05_CHOCOLATE_BAR_VN },
         { "PixelShift 06 - CMYK",                       OPTION_VAL_PIXELSHIFT_06_CMYK_VN },
         { "PixelShift 07 - Cotton Candy",               OPTION_VAL_PIXELSHIFT_07_COTTON_CANDY_VN },
         { "PixelShift 08 - Easy Greens",                OPTION_VAL_PIXELSHIFT_08_EASY_GREENS_VN },
         { "PixelShift 09 - Gamate",                     OPTION_VAL_PIXELSHIFT_09_GAMATE_VN },
         { "PixelShift 10 - Game Boy Light",             OPTION_VAL_PIXELSHIFT_10_GAME_BOY_LIGHT_VN },
         { "PixelShift 11 - Game Boy Pocket",            OPTION_VAL_PIXELSHIFT_11_GAME_BOY_POCKET_VN },
         { "PixelShift 12 - Game Boy Pocket Alt",        OPTION_VAL_PIXELSHIFT_12_GAME_BOY_POCKET_ALT_VN },
         { "PixelShift 13 - Game Pocket Computer",       OPTION_VAL_PIXELSHIFT_13_GAME_POCKET_COMPUTER_VN },
         { "PixelShift 14 - Game & Watch Ball",          OPTION_VAL_PIXELSHIFT_14_GAME_WATCH_BALL_VN },
         { "PixelShift 15 - GB Backlight Blue",          OPTION_VAL_PIXELSHIFT_15_GB_BACKLIGHT_BLUE_VN },
         { "PixelShift 16 - GB Backlight Faded",         OPTION_VAL_PIXELSHIFT_16_GB_BACKLIGHT_FADED_VN },
         { "PixelShift 17 - GB Backlight Orange",        OPTION_VAL_PIXELSHIFT_17_GB_BACKLIGHT_ORANGE_VN },
         { "PixelShift 18 - GB Backlight White ",        OPTION_VAL_PIXELSHIFT_18_GB_BACKLIGHT_WHITE__VN },
         { "PixelShift 19 - GB Backlight Yellow Dark",   OPTION_VAL_PIXELSHIFT_19_GB_BACKLIGHT_YELLOW_DARK_VN },
         { "PixelShift 20 - GB Bootleg",                 OPTION_VAL_PIXELSHIFT_20_GB_BOOTLEG_VN },
         { "PixelShift 21 - GB Hunter",                  OPTION_VAL_PIXELSHIFT_21_GB_HUNTER_VN },
         { "PixelShift 22 - GB Kiosk",                   OPTION_VAL_PIXELSHIFT_22_GB_KIOSK_VN },
         { "PixelShift 23 - GB Kiosk 2",                 OPTION_VAL_PIXELSHIFT_23_GB_KIOSK_2_VN },
         { "PixelShift 24 - GB New",                     OPTION_VAL_PIXELSHIFT_24_GB_NEW_VN },
         { "PixelShift 25 - GB Nuked",                   OPTION_VAL_PIXELSHIFT_25_GB_NUKED_VN },
         { "PixelShift 26 - GB Old",                     OPTION_VAL_PIXELSHIFT_26_GB_OLD_VN },
         { "PixelShift 27 - GBP Bivert",                 OPTION_VAL_PIXELSHIFT_27_GBP_BIVERT_VN },
         { "PixelShift 28 - GB Washed Yellow Backlight", OPTION_VAL_PIXELSHIFT_28_GB_WASHED_YELLOW_BACKLIGHT_VN },
         { "PixelShift 29 - Ghost",                      OPTION_VAL_PIXELSHIFT_29_GHOST_VN },
         { "PixelShift 30 - Glow In The Dark",           OPTION_VAL_PIXELSHIFT_30_GLOW_IN_THE_DARK_VN },
         { "PixelShift 31 - Gold Bar",                   OPTION_VAL_PIXELSHIFT_31_GOLD_BAR_VN },
         { "PixelShift 32 - Grapefruit",                 OPTION_VAL_PIXELSHIFT_32_GRAPEFRUIT_VN },
         { "PixelShift 33 - Gray Green Mix",             OPTION_VAL_PIXELSHIFT_33_GRAY_GREEN_MIX_VN },
         { "PixelShift 34 - Missingno",                  OPTION_VAL_PIXELSHIFT_34_MISSINGNO_VN },
         { "PixelShift 35 - MS-Dos",                     OPTION_VAL_PIXELSHIFT_35_MS_DOS_VN },
         { "PixelShift 36 - Newspaper",                  OPTION_VAL_PIXELSHIFT_36_NEWSPAPER_VN },
         { "PixelShift 37 - Pip-Boy",                    OPTION_VAL_PIXELSHIFT_37_PIP_BOY_VN },
         { "PixelShift 38 - Pocket Girl",                OPTION_VAL_PIXELSHIFT_38_POCKET_GIRL_VN },
         { "PixelShift 39 - Silhouette",                 OPTION_VAL_PIXELSHIFT_39_SILHOUETTE_VN },
         { "PixelShift 40 - Sunburst",                   OPTION_VAL_PIXELSHIFT_40_SUNBURST_VN },
         { "PixelShift 41 - Technicolor",                OPTION_VAL_PIXELSHIFT_41_TECHNICOLOR_VN },
         { "PixelShift 42 - Tron",                       OPTION_VAL_PIXELSHIFT_42_TRON_VN },
         { "PixelShift 43 - Vaporwave",                  OPTION_VAL_PIXELSHIFT_43_VAPORWAVE_VN },
         { "PixelShift 44 - Virtual Boy",                OPTION_VAL_PIXELSHIFT_44_VIRTUAL_BOY_VN },
         { "PixelShift 45 - Wish",                       OPTION_VAL_PIXELSHIFT_45_WISH_VN },
         { NULL, NULL },
      },
      "PixelShift 01 - Arctic Green"
   },
   {
      "gambatte_gbc_color_correction",
      GAMBATTE_GBC_COLOR_CORRECTION_LABEL_VN,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_INFO_0_VN,
      NULL,
      NULL,
      {
         { "GBC only", OPTION_VAL_GBC_ONLY_VN },
         { "always",   OPTION_VAL_ALWAYS_VN },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "GBC only"
   },
   {
      "gambatte_gbc_color_correction_mode",
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_LABEL_VN,
      NULL,
      GAMBATTE_GBC_COLOR_CORRECTION_MODE_INFO_0_VN,
      NULL,
      NULL,
      {
         { "accurate", OPTION_VAL_ACCURATE_VN },
         { "fast",     OPTION_VAL_FAST_VN },
         { NULL, NULL },
      },
      "accurate"
   },
   {
      "gambatte_gbc_frontlight_position",
      GAMBATTE_GBC_FRONTLIGHT_POSITION_LABEL_VN,
      NULL,
      GAMBATTE_GBC_FRONTLIGHT_POSITION_INFO_0_VN,
      NULL,
      NULL,
      {
         { "central",      OPTION_VAL_CENTRAL_VN },
         { "above screen", OPTION_VAL_ABOVE_SCREEN_VN },
         { "below screen", OPTION_VAL_BELOW_SCREEN_VN },
         { NULL, NULL },
      },
      "central"
   },
   {
      "gambatte_dark_filter_level",
      GAMBATTE_DARK_FILTER_LEVEL_LABEL_VN,
      NULL,
      GAMBATTE_DARK_FILTER_LEVEL_INFO_0_VN,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "5",  NULL },
         { "10", NULL },
         { "15", NULL },
         { "20", NULL },
         { "25", NULL },
         { "30", NULL },
         { "35", NULL },
         { "40", NULL },
         { "45", NULL },
         { "50", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_mix_frames",
      GAMBATTE_MIX_FRAMES_LABEL_VN,
      NULL,
      GAMBATTE_MIX_FRAMES_INFO_0_VN,
      NULL,
      NULL,
      {
         { "disabled",          NULL },
         { "mix",               OPTION_VAL_MIX_VN },
         { "lcd_ghosting",      OPTION_VAL_LCD_GHOSTING_VN },
         { "lcd_ghosting_fast", OPTION_VAL_LCD_GHOSTING_FAST_VN },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_audio_resampler",
      GAMBATTE_AUDIO_RESAMPLER_LABEL_VN,
      NULL,
      GAMBATTE_AUDIO_RESAMPLER_INFO_0_VN,
      NULL,
      NULL,
      {
         { "sinc", OPTION_VAL_SINC_VN },
         { "cc",   OPTION_VAL_CC_VN },
         { NULL, NULL },
      },
#if (defined(PS2) || defined(PSP) || defined(VITA) || defined(_3DS) || defined(DINGUX))
      "cc"
#else
      "sinc"
#endif
   },
   {
      "gambatte_gb_hwmode",
      GAMBATTE_GB_HWMODE_LABEL_VN,
      NULL,
      GAMBATTE_GB_HWMODE_INFO_0_VN,
      NULL,
      NULL,
      {
         { "Auto", OPTION_VAL_AUTO_VN },
         { "GB",   OPTION_VAL_GB_VN },
         { "GBC",  OPTION_VAL_GBC_VN },
         { "GBA",  OPTION_VAL_GBA_VN },
         { NULL, NULL },
      },
      "Auto"
   },
   {
      "gambatte_gb_bootloader",
      GAMBATTE_GB_BOOTLOADER_LABEL_VN,
      NULL,
      GAMBATTE_GB_BOOTLOADER_INFO_0_VN,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "enabled"
   },
   {
      "gambatte_up_down_allowed",
      GAMBATTE_UP_DOWN_ALLOWED_LABEL_VN,
      NULL,
      GAMBATTE_UP_DOWN_ALLOWED_INFO_0_VN,
      NULL,
      NULL,
      {
         { "disabled", NULL },
         { "enabled",  NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_turbo_period",
      GAMBATTE_TURBO_PERIOD_LABEL_VN,
      NULL,
      GAMBATTE_TURBO_PERIOD_INFO_0_VN,
      NULL,
      NULL,
      {
         { "4",   NULL },
         { "5",   NULL },
         { "6",   NULL },
         { "7",   NULL },
         { "8",   NULL },
         { "9",   NULL },
         { "10",  NULL },
         { "11",  NULL },
         { "12",  NULL },
         { "13",  NULL },
         { "14",  NULL },
         { "15",  NULL },
         { "16",  NULL },
         { "17",  NULL },
         { "18",  NULL },
         { "19",  NULL },
         { "20",  NULL },
         { "21",  NULL },
         { "22",  NULL },
         { "23",  NULL },
         { "24",  NULL },
         { "25",  NULL },
         { "26",  NULL },
         { "27",  NULL },
         { "28",  NULL },
         { "29",  NULL },
         { "30",  NULL },
         { "31",  NULL },
         { "32",  NULL },
         { "33",  NULL },
         { "34",  NULL },
         { "35",  NULL },
         { "36",  NULL },
         { "37",  NULL },
         { "38",  NULL },
         { "39",  NULL },
         { "40",  NULL },
         { "41",  NULL },
         { "42",  NULL },
         { "43",  NULL },
         { "44",  NULL },
         { "45",  NULL },
         { "46",  NULL },
         { "47",  NULL },
         { "48",  NULL },
         { "49",  NULL },
         { "50",  NULL },
         { "51",  NULL },
         { "52",  NULL },
         { "53",  NULL },
         { "54",  NULL },
         { "55",  NULL },
         { "56",  NULL },
         { "57",  NULL },
         { "58",  NULL },
         { "59",  NULL },
         { "60",  NULL },
         { "61",  NULL },
         { "62",  NULL },
         { "63",  NULL },
         { "64",  NULL },
         { "65",  NULL },
         { "66",  NULL },
         { "67",  NULL },
         { "68",  NULL },
         { "69",  NULL },
         { "70",  NULL },
         { "71",  NULL },
         { "72",  NULL },
         { "73",  NULL },
         { "74",  NULL },
         { "75",  NULL },
         { "76",  NULL },
         { "77",  NULL },
         { "78",  NULL },
         { "79",  NULL },
         { "80",  NULL },
         { "81",  NULL },
         { "82",  NULL },
         { "83",  NULL },
         { "84",  NULL },
         { "85",  NULL },
         { "86",  NULL },
         { "87",  NULL },
         { "88",  NULL },
         { "89",  NULL },
         { "90",  NULL },
         { "91",  NULL },
         { "92",  NULL },
         { "93",  NULL },
         { "94",  NULL },
         { "95",  NULL },
         { "96",  NULL },
         { "97",  NULL },
         { "98",  NULL },
         { "99",  NULL },
         { "100", NULL },
         { "101", NULL },
         { "102", NULL },
         { "103", NULL },
         { "104", NULL },
         { "105", NULL },
         { "106", NULL },
         { "107", NULL },
         { "108", NULL },
         { "109", NULL },
         { "110", NULL },
         { "111", NULL },
         { "112", NULL },
         { "113", NULL },
         { "114", NULL },
         { "115", NULL },
         { "116", NULL },
         { "117", NULL },
         { "118", NULL },
         { "119", NULL },
         { "120", NULL },
         { NULL, NULL },
      },
      "4"
   },
   {
      "gambatte_rumble_level",
      GAMBATTE_RUMBLE_LEVEL_LABEL_VN,
      NULL,
      GAMBATTE_RUMBLE_LEVEL_INFO_0_VN,
      NULL,
      NULL,
      {
         { "0",  NULL },
         { "1",  NULL },
         { "2",  NULL },
         { "3",  NULL },
         { "4",  NULL },
         { "5",  NULL },
         { "6",  NULL },
         { "7",  NULL },
         { "8",  NULL },
         { "9",  NULL },
         { "10", NULL },
         { NULL, NULL },
      },
      "10"
   },
#ifdef HAVE_NETWORK
   {
      "gambatte_show_gb_link_settings",
      GAMBATTE_SHOW_GB_LINK_SETTINGS_LABEL_VN,
      NULL,
      GAMBATTE_SHOW_GB_LINK_SETTINGS_INFO_0_VN,
      NULL,
      NULL,
      {
         { "enabled",  NULL },
         { "disabled", NULL },
         { NULL, NULL },
      },
      "disabled"
   },
   {
      "gambatte_gb_link_mode",
      GAMBATTE_GB_LINK_MODE_LABEL_VN,
      GAMBATTE_GB_LINK_MODE_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_MODE_INFO_0_VN,
      NULL,
      "gb_link",
      {
         { "Not Connected",  OPTION_VAL_NOT_CONNECTED_VN },
         { "Network Server", OPTION_VAL_NETWORK_SERVER_VN },
         { "Network Client", OPTION_VAL_NETWORK_CLIENT_VN },
         { NULL, NULL },
      },
      "Not Connected"
   },
   {
      "gambatte_gb_link_network_port",
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_PORT_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_PORT_INFO_0_VN,
      NULL,
      "gb_link",
      {
         { "56400", NULL },
         { "56401", NULL },
         { "56402", NULL },
         { "56403", NULL },
         { "56404", NULL },
         { "56405", NULL },
         { "56406", NULL },
         { "56407", NULL },
         { "56408", NULL },
         { "56409", NULL },
         { "56410", NULL },
         { "56411", NULL },
         { "56412", NULL },
         { "56413", NULL },
         { "56414", NULL },
         { "56415", NULL },
         { "56416", NULL },
         { "56417", NULL },
         { "56418", NULL },
         { "56419", NULL },
         { "56420", NULL },
         { NULL, NULL },
      },
      "56400"
   },
   {
      "gambatte_gb_link_network_server_ip_1",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_1_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_2",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_2_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_3",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_3_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_4",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_4_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_5",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_5_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_6",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_6_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_7",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_7_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_8",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_8_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_9",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_9_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_10",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_10_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_11",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_11_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
   {
      "gambatte_gb_link_network_server_ip_12",
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_LABEL_CAT_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_0_VN,
      GAMBATTE_GB_LINK_NETWORK_SERVER_IP_12_INFO_1_VN,
      "gb_link",
      {
         { "0", NULL },
         { "1", NULL },
         { "2", NULL },
         { "3", NULL },
         { "4", NULL },
         { "5", NULL },
         { "6", NULL },
         { "7", NULL },
         { "8", NULL },
         { "9", NULL },
         { NULL, NULL },
      },
      "0"
   },
#endif
   { NULL, NULL, NULL, NULL, NULL, NULL, {{0}}, NULL },
};
struct retro_core_options_v2 options_vn = {
   option_cats_vn,
   option_defs_vn
};


#ifdef __cplusplus
}
#endif

#endif